<?php
ini_set('session.gc_maxlifetime', 3600);
$cookieParams = session_get_cookie_params();
session_set_cookie_params([
    'lifetime' => 3600,
    'path' => $cookieParams['path'],
    'domain' => $cookieParams['domain'],
    'secure' => $cookieParams['secure'],
    'httponly' => true
]);

session_start();
if (!isset($_SESSION['email'])) {
    header("Location: login.php");
    exit();
}

$email = $_SESSION["email"];


$db = new mysqli('localhost','siteyajof24_questuser','@tourquests#2024','siteyajof24_questdb') or die("Could not connect to mysql" . mysqli_error($db));

if (isset($_POST['save'])) {
    $username = $email; // You need to define $email somewhere
    $days = $_POST['no_of_days'];
    $title = $db->real_escape_string($_POST['title']);
    $ovtitle = $db->real_escape_string($_POST['overview_title']);
    $description = $db->real_escape_string($_POST['description']);
    $meta = $db->real_escape_string($_POST['meta']);
    $focus = $_POST['focus'];
    
    // Handle checkboxes for mountain, activity, and routes
    $mountain = isset($_POST['mountains2']) ? $_POST['mountains2'] : 'NIL';
    $routes = isset($_POST['routes']) ? $_POST['routes'] : 'NIL';
    $activity = isset($_POST['activity']) ? $_POST['activity'] : 'NIL';
    
    $c = $_POST['country'];
    $country = implode(",", $c);
    $banner = "NIL";
    $cover = "NIL";
    $status = "inactive";
    $reviews = 0;
    
    if ($days > 1) {
        $package = "$days Days $title";
        $overview = "$days Days $ovtitle";
    } else {
        $package = "$days Day $title";
        $overview = "$days Day $ovtitle";
    }
    
    $package = $db->real_escape_string($package);
    $overview = $db->real_escape_string($overview);

    if (!$db) {
        die("Connection failed: " . mysqli_connect_error());
    }
    
    $sql = "INSERT INTO tour (username,tour_day,tour_title,overview_title,tour_description,meta_description,tour_country,tour_focus,mountain,routes,activity,tour_banner,tour_cover,status,reviews) VALUES ('$username','$days','$package','$overview','$description','$meta','$country','$focus','$mountain','$routes','$activity','$banner','$cover','$status','$reviews')";

    if ($db->query($sql)) {
        $encoded_title = urlencode($package);
        header("location: Daydescription.php?title=$encoded_title&day=$days");
    } else {
        echo "Error: " . $sql . "<br>" . $db->error;
    }

    $db->close();
}
?>

</style>
<!DOCTYPE html>
<html lang="en" class=" computer production ">
  <head>
    <meta name="csrf-token" content="qpD4mEQUJ5ClYZ1IQOu9CeETBJrBuBLilKg3D4VW" />
    <meta name="token_refresh" content="200" />
    
    <title>Add a Tour | Africatourbase Tour Operator Admin</title>
    <meta name="robots" content="noindex, nofollow, noodp">
    <script>
    var IE6lower = false;
    </script>
    <link href="css/tourbase.min.css" media="all" rel="stylesheet" type="text/css"/>
    <link href="css/glyphicons-halflings.css" media="all" rel="stylesheet" type="text/css" />
    <link href="css/shadowbox.css" media="all" rel="stylesheet" type="text/css"/>
    <link href="css/jqueryui.1.8.4.green.css" media="all" rel="stylesheet" type="text/css"/>
    <link href="css/reveal.css" media="all" rel="stylesheet" type="text/css"/>
    <link rel="stylesheet" href="css/backend.min.css">
    
    <script type="text/javascript" src="js/moment.2.24.0.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.1/jquery.min.js"></script>
    <script type="text/javascript" src="js/jqueryui.1.10.3.min.js"></script>
    <script type="text/javascript" src="js/validation.js"></script>
    <script type="text/javascript" src="js/jquery.metadata.js"></script>
    <script type="text/javascript" src="js/jquery.validate.js"></script>
    <script type="text/javascript" src="js/jquery.browser.min.js"></script>
    <script type="text/javascript" src="js/jquery.tinymce.js"></script>
    <script type="text/javascript" src="js/shadowbox.js"></script>
    <script type="text/javascript" src="js/jquery.uploadifive.min.js"></script>
    <script type="text/javascript" src="js/problem-box.js"></script>
    <script type="text/javascript" src="js/jquery.accordion.js"></script>
    <script type="text/javascript" src="js/jquery.radio.js"></script>
    <script type="text/javascript" src="js/jquery.remodal.min.js"></script>
    <script type="text/javascript" src="js/jquery.balloon.js"></script>
    <script type="text/javascript" src="js/daterangepicker.js"></script>
    <script type="text/javascript" src="js/foundation.min.js"></script>
    <script type="text/javascript" src="js/sb.js"></script>
    <script type="text/javascript" src="js/autocomplete.js"></script>
    <script type="text/javascript" src="js/tourbase.js"></script>
    <script type="text/javascript" src="js/safari.js"></script>
    <script type="text/javascript" src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAqZO4KmgfblsNZl4mj_3aJilBsVFZ0Rco"></script>
    <script type="text/javascript" src="js/chosen.jquery.js"></script>
    <script type="text/javascript" src="js/chosenImage.jquery.js"></script>
    <script type="text/javascript" src="js/availability.js"></script>
    <script type="text/javascript" src="js/svg.js"></script>
    <script type="text/javascript" src="css/validation.js"></script>
    <style type="text/css">
          .navbar {
    background-color: #fbfbfb;
    position: sticky;
    top: 0;
    width: 100%;
    z-index: 9999;
    }
    .navbar ul {
    list-style: none;
    margin: 0;
    padding: 0;
    display: flex;
    justify-content: space-around;
    }
    .navbar li {
    padding: 10px;
    }
    .navbar li a {
    
    text-decoration: none;
    }
    .navbar li a:hover {
    text-decoration: underline;
    }
    #preview {
    background-color: #ad2322;
    color: white;
    padding: 10px;
    margin-top: 20px;
    border: 1px solid #ddd;
    }

    .navbar {
  height: 80px;
  margin-top: 10px;
  margin-bottom: 10px;
  display: flex;
  justify-content: center;
  align-items: center;
  border: 1px dashed #000;
}

    </style>
<script>
    window.onload = function() {
      var id = <?php echo json_encode($id); ?>;
      history.replaceState(null, null, location.href + '?id=' + id);

      window.addEventListener('popstate', function(event) {
        history.replaceState(null, null, location.href + '?id=' + id);
      });
    };
  </script>
  </head>
  <?php
  include('includes/header.php');
  ?>
  <body class="">
    <div id="surface">
      <div id="page" class="">
        <div id="Wrapper">
          <div id="Middle">
            <div id="Right">
              
              
              
              
              <div class="Yourinfo">
                
                
                
<nav class="navbar">
    <ul>
<li><a href="general_info.php">General Information</a></li>
        <li><a href="#">Private/Group</a></li>
        <li><a href="#">Activities</a></li>
        <li><a href="#">Getting There</a></li>
        <li><a href="#">Day-by-Day</a></li>
        <li><a href="#">Dates &amp; Rates</a></li>
        <li><a href="#">Inclusions</a></li>
        <li><a href="#">Tour Photo</a></li>
        <li><a href="#" id="preview">Tour Preview</a></li>
</nav>
                <noscript>Javascript must be enabled for the correct page display</noscript>

                <form class="tour-form" method="POST" action="" enctype="multipart/form-data" id="top">
                  <h4>All requested info and <a href="guidelines" target="_blank">editorial guidelines</a> are required</h4>
                  <h4>It is not allowed to include contact details or links in the information and images you add.</h4>
                  <fieldset id="title">
                    <h2><strong>Tour title </strong></h2>
                    <div>
                      <div class="guidelines">
                        <h4>Guidelines</h4>
                        <ul>
                          <li>The title should be at least 10 and max. 50 characters long.</li>
                          <li>Don't mention the number of days in the text box (e.g. 5-Day). Our system adds it automatically when you select the number of days.</li>
                        </ul>
                      </div>
                      <select name="no_of_days" id="tourLength" required>
                        <option value="" selected="selected">-- Select days --</option>
                        <option value="0">&frac12;-Day</option>
                        <option value="1">1-Day</option>
                        <option value="2">2-Day</option>
                        <option value="3">3-Day</option>
                        <option value="4">4-Day</option>
                        <option value="5">5-Day</option>
                        <option value="6">6-Day</option>
                        <option value="7">7-Day</option>
                        <option value="8">8-Day</option>
                        <option value="9">9-Day</option>
                        <option value="10">10-Day</option>
                        <option value="11">11-Day</option>
                        <option value="12">12-Day</option>
                        <option value="13">13-Day</option>
                        <option value="14">14-Day</option>
                        <option value="15">15-Day</option>
                        <option value="16">16-Day</option>
                        <option value="17">17-Day</option>
                        <option value="18">18-Day</option>
                        <option value="19">19-Day</option>
                        <option value="20">20-Day</option>
                        <option value="21">21-Day</option>
                        <option value="22">22-Day</option>
                        <option value="23">23-Day</option>
                        <option value="24">24-Day</option>
                        <option value="25">25-Day</option>
                        <option value="26">26-Day</option>
                        <option value="27">27-Day</option>
                        <option value="28">28-Day</option>
                        <option value="29">29-Day</option>
                        <option value="30">30-Day</option>
                        <option value="31">31-Day</option>
                        <option value="32">32-Day</option>
                        <option value="33">33-Day</option>
                        <option value="34">34-Day</option>
                        <option value="35">35-Day</option>
                        <option value="36">36-Day</option>
                        <option value="37">37-Day</option>
                        <option value="38">38-Day</option>
                        <option value="39">39-Day</option>
                        <option value="40">40-Day</option>
                        <option value="41">41-Day</option>
                        <option value="42">42-Day</option>
                        <option value="43">43-Day</option>
                        <option value="44">44-Day</option>
                        <option value="45">45-Day</option>
                        <option value="46">46-Day</option>
                        <option value="47">47-Day</option>
                        <option value="48">48-Day</option>
                        <option value="49">49-Day</option>
                        <option value="50">50-Day</option>
                        <option value="51">51-Day</option>
                        <option value="52">52-Day</option>
                        <option value="53">53-Day</option>
                        <option value="54">54-Day</option>
                        <option value="55">55-Day</option>
                        <option value="56">56-Day</option>
                        <option value="57">57-Day</option>
                        <option value="58">58-Day</option>
                        <option value="59">59-Day</option>
                        <option value="60">60-Day</option>
                        <option value="61">61-Day</option>
                        <option value="62">62-Day</option>
                        <option value="63">63-Day</option>
                        <option value="64">64-Day</option>
                        <option value="65">65-Day</option>
                        <option value="66">66-Day</option>
                        <option value="67">67-Day</option>
                        <option value="68">68-Day</option>
                        <option value="69">69-Day</option>
                        <option value="70">70-Day</option>
                        <option value="71">71-Day</option>
                        <option value="72">72-Day</option>
                        <option value="73">73-Day</option>
                        <option value="74">74-Day</option>
                        <option value="75">75-Day</option>
                      </select>
                      
                      <input type="text" autocorrect="off" autocomplete="off" name="title" value="" data-inuse-addition="" data-min="10" data-max="50" data-mask="[a-zA-Z0-9\u00C0-\u017F\-\+\–\,\&\|\/\(\)\'\~\│\; ]+" data-trim="1" data-enter="1" class="title" />
                      <span class="title-preview">Title preview: <b></b></span>
                    </div>
                  </fieldset>


                    <fieldset id="title">
                    <h2><strong>Overview title</strong></h2>
                    <div>
                      <div class="guidelines">
                        <h4>Guidelines</h4>
                        <ul>
                          <li>The title should be at least 60 and max. 70 characters long.</li>
                          <li>Don't mention the number of days in the box (e.g. 5-Day). Our system adds it automatically.</li>
                        </ul>
                      </div>
                      <input type="text" autocorrect="off" autocomplete="off" name="overview_title" value="" data-inuse-addition="" data-min="60" data-max="70" data-mask="[a-zA-Z0-9\u00C0-\u017F\-\+\–\,\&\|\/\(\)\'\~\│\; ]+" data-trim="1" data-enter="1" class="title"  style="margin-left: 8%;" required=/>
                      
                    </div>
                  </fieldset>
                  <fieldset id="description">
                    <h2><strong>Short tour overview</strong></h2>
                    <div>
                      <div class="guidelines">
                        <h4 class="special-h4">Special Guidelines <a href="#" class="help info" title="Special guidelines are dependent on other selections in this form and only applicable to this short tour description.">help</a></h4>
                        <ul class="special-list vis">
                          <li>As you've selected <b>guided self drive</b> as main focus, this description should explain that clients drive their own 4x4 (rental) vehicle.</li>
                        </ul>
                        <h4 class="default-h4"><span>Guidelines</span> <a href="#" class="help info" title="Default guidelines are applicable to the short tour descriptions, regardless of other selections in this form.">help</a></h4>
                        <ul>
                          <li>The description should be at least 250 and max. 500 characters long.</li>
                          <li>Don't include contact details or links.</li>
                          <li>Write correct English: if English is not your first language we strongly recommend installing the free <a href="https://support.grammarly.com/hc/en-us/articles/115000091552-Install-the-Grammarly-browser-extension" target="_blank" tabindex="-1">Grammarly browser extension</a> and restarting your web browser. Once installed, Grammarly will check the text that you type in the tours form and offer suggestions to fix any errors.</li>
                        </ul>
                      </div>
                      <textarea name="description" data-min="250" data-max="500" data-mask="[^]+" data-trim="1" data-enter="1" class="description"></textarea>
                    </div>
                  </fieldset>
                  <fieldset id="description">
                    <h2><strong>Short Meta description</strong></h2>
                    <div>
                      <div class="guidelines">
                        <h4 class="default-h4"><span>Guidelines</span></h4>
                        <ul>
                          <li>The description should be at least 136 and max. 150 characters long.</li>
                          <li>Write correct English: if English is not your first language we strongly recommend installing the free <a href="https://support.grammarly.com/hc/en-us/articles/115000091552-Install-the-Grammarly-browser-extension" target="_blank" tabindex="-1">Grammarly browser extension</a> and restarting your web browser. Once installed, Grammarly will check the text that you type in the tours form and offer suggestions to fix any errors.</li>
                        </ul>
                      </div>
                      <textarea name="meta" data-min="136" data-max="150" data-mask="[^]+" data-trim="1" data-enter="1" class="description"></textarea>
                    </div>
                  </fieldset>
                  <fieldset id="countries">
                    <h2>What <strong>countries</strong> will be visited on this tour</h2>
                    <div>
                      <div class="guidelines">
                        <h4>Guidelines</h4>
                        <ul>
                          <li>We only accept tours if most of the itinerary takes place in one or more of these countries: Angola, Botswana, Burundi, Comoros, Congo (Brazzaville), Congo (DRC), Djibouti, Eswatini (Swaziland), Ethiopia, Kenya, Lesotho, Madagascar, Malawi, Mauritius, Mayotte, Mozambique, Namibia, Réunion, Rwanda, Seychelles, South Africa, Tanzania, Uganda, Zambia and/or Zimbabwe.</li>
                        </ul>
                      </div>
                      <ul>
                        <li>
                          <input type="checkbox" class="default-country" name="country[]" value="Botswana" id="BW" data-id="1"><label for="BW">Botswana</label><br />
                          <input type="checkbox" class="default-country" name="country[]" value="Congo (DRC)" id="CD" data-id="20"><label for="CD">Congo (DRC)</label><br />
                          <input type="checkbox" class="default-country" name="country[]" value="Eswatini" id="SZ" data-id="16"><label for="SZ">Eswatini</label><br />
                          <input type="checkbox" class="default-country" name="country[]" value="Ethiopia" id="ET" data-id="23"><label for="ET">Ethiopia</label><br />
                          <input type="checkbox" class="default-country" name="country[]" value="Kenya" id="KE" data-id="2"><label for="KE">Kenya</label><br />
                        </li>
                        <li>
                          <input type="checkbox" class="default-country" name="country[]" value="Madagascar"  id="MG" data-id="17"><label for="MG">Madagascar</label><br />
                          <input type="checkbox" class="default-country" name="country[]" value="Malawi" id="MW" data-id="9"><label for="MW">Malawi</label><br />
                          <input type="checkbox" class="default-country" name="country[]" value="Mozambique" id="MZ" data-id="12"><label for="MZ">Mozambique</label><br />
                          <input type="checkbox" class="default-country" name="country[]" value="Namibia" id="NA" data-id="3"><label for="NA">Namibia</label><br />
                          <input type="checkbox" class="default-country" name="country[]" value="Rwanda" id="RW" data-id="10"><label for="RW">Rwanda</label><br />
                        </li>
                        <li>
                          <input type="checkbox" class="default-country" name="country[]" value="South Africa" id="ZA" data-id="4"><label for="ZA">South Africa</label><br />
                          <input type="checkbox" class="default-country" name="country[]" value="Tanzania" id="TZ" data-id="5"><label for="TZ">Tanzania</label><br />
                          <input type="checkbox" class="default-country" name="country[]" value="Uganda" id="UG" data-id="6"><label for="UG">Uganda</label><br />
                          <input type="checkbox" class="default-country" name="country[]" value="Zambia" id="ZM" data-id="7"><label for="ZM">Zambia</label><br />
                          <input type="checkbox" class="default-country" name="country[]" value="Zimbabwe" id="ZW" data-id="8"><label for="ZW">Zimbabwe</label><br />
                        </li>
                        <li>
                        </li>
                      </ul>
                    </div>
                  </fieldset>
                  <fieldset id="focus">
                    <h2>What is the <strong>main focus</strong> of this tour</h2>
                    <div>
                      <div class="guidelines">
                        <h4>Guidelines</h4>
                        <ul>
                          <li>Please read all options before making your selection.</li>
                          <li>If more than one option applies, you should select the one that is most distinctive for this tour.</li>
                          <li>The 'main focus' won't be visible on the AfricaGoTrips website, we only use it to let our system categorize tours.</li>
                        </ul>
                      </div>
                      <div id="gamedrive-div"><input type="radio" name="focus" value="gamedrive" id="game-drive-safari" checked><label for="game-drive-safari">Game drive safari</label></div>
                      <div id="fly_in-div"><input type="radio" name="focus" value="fly_in" id="fly-in-safari"><label for="fly-in-safari">Fly-in safari</label></div>
                      <div id="overland-div"><input type="radio" name="focus" value="overland" id="overland-truck-safari"><label for="overland-truck-safari">Overland truck safari</label></div>
                      <div id="walking-div"><input type="radio" name="focus" value="walking" id="walking-safari"><label for="walking-safari">Walking safari <span>with an armed guide or ranger (and a focus on some or all of the Big Five animals)</span></label></div>
                      <div id="canoe-div"><input type="radio" name="focus" value="canoe" id="canoe-mokoro-safari"><label for="canoe-mokoro-safari">Canoe/Mokoro safari</label></div>
                      <div id="horseback-div"><input type="radio" name="focus" value="horseback" id="horseback-safari"><label for="horseback-safari">Horseback safari</label></div>
                      <div id="mountain_bike-div"><input type="radio" name="focus" value="mountain_bike" id="mountain-bike-safari"><label for="mountain-bike-safari">Cycling safari</label></div>
                      <div id="selfdrive-div"><input type="radio" name="focus" value="selfdrive" id="self-drive-ung"><label for="self-drive-ung">Self drive <span>(unguided)</span></label></div>
                      <div id="guided_selfdrive-div"><input type="radio" name="focus" value="guided_selfdrive" id="self-drive-g"><label for="self-drive-g">Guided self drive <span>(clients drive their own 4x4 vehicle in convoy)</span></label></div>
                      <div id="golf_wildlife-div"><input type="radio" name="focus" value="golf_wildlife" id="golf-wildlife-viewing"><label for="golf-wildlife-viewing">Golf & wildlife viewing</label></div>
                      <div id="photography-div"><input type="radio" name="focus" value="photography" id="wildlife-photography"><label for="wildlife-photography">Photo safari <span>guided by a professional wildlife photographer</span></label></div>
                      <div id="birding-div"><input type="radio" name="focus" value="birding" id="birdwatching"><label for="birdwatching">Birdwatching <span>(tour must include a professional birding guide)</span></label></div>
                      <div id="scenic-div"><input type="radio" name="focus" value="scenic" id="scenic-cultural-tour"><label for="scenic-cultural-tour">Scenic and/or Cultural tour <span>(without a wildlife viewing safari)</span></label></div>
                      <div id="disabled-div"><input type="radio" name="focus" value="disabled" id="tour-disabled-travelers"><label for="tour-disabled-travelers">Accessible safari <span>designed specifically for travelers with a disability</span></label></div>
                      <div id="beach_safari-div"><input type="radio" name="focus" value="beach_safari" id="beach-and-game-drive"><label for="beach-and-game-drive">Beach holiday & game drive safari</label></div>
                      <div id="beach_other-div"><input type="radio" name="focus" value="beach_other" id="beach-and-other-wildlife"><label for="beach-and-other-wildlife">Beach holiday & other type of wildlife-viewing safari <span>(select this option if game drives are not the primary way that wildlife is viewed)</span></label></div>
                      <div id="beach-div"><input type="radio" name="focus" value="beach" id="beach-holiday"><label for="beach-holiday">Beach holiday only <span>(without a game drive safari before or after)</span></label></div>
                      <div id="tracking_safari-div"><input type="radio" name="focus" value="tracking_safari" id="gorilla-and-game-drive"><label for="gorilla-and-game-drive">Gorilla and/or chimp trekking & game drive safari</label></div>
                      <div id="tracking_climbing-div"><input type="radio" name="focus" value="tracking_climbing" id="gorilla-and-climbing"><label for="gorilla-and-climbing">Gorilla and/or chimp trekking & mountain climbing</label></div>
                      <ul id="mountains3-div" class="mountains">
                        <li><span class="grey">Please select the applicable mountain or mountains</span></li>
                        <li><input type="checkbox" name="mountains3[kilimanjaro]" id="mountains3_kilimanjaro"><label for="mountains3_kilimanjaro">Mt. Kilimanjaro <span class="grey">(Tanzania)</span></label></li>
                        <li><input type="checkbox" name="mountains3[kenya]" id="mountains3_kenya"><label for="mountains3_kenya">Mt. Kenya <span class="grey">(Kenya)</span></label></li>
                        <li><input type="checkbox" name="mountains3[meru]" id="mountains3_meru"><label for="mountains3_meru">Mt. Meru <span class="grey">(Tanzania)</span></label></li>
                        <li><input type="checkbox" name="mountains3[other]" id="mountains3_other"><label for="mountains3_other">Other mountain or mountain range</label></li>
                      </ul>
                      <div id="tracking-div"><input type="radio" name="focus" value="tracking" id="gorilla-only"><label for="gorilla-only">Gorilla and/or chimp trekking only <span>(without a game drive safari before or after)</span></label></div>
                      <div id="climb_safari-div"><input type="radio" name="focus" value="climb_safari" id="climbing-and-game-drive"><label for="climbing-and-game-drive">Mountain climbing & game drive safari</label></div>
                      <ul id="mountains1-div" class="mountains">
                        <li><span class="grey">Please select the applicable mountain or mountains</span></li>
                        <li><input type="checkbox" name="mountains1[kilimanjaro]" id="mountains1_kilimanjaro"><label for="mountains1_kilimanjaro">Mt. Kilimanjaro <span class="grey">(Tanzania)</span></label></li>
                        <li><input type="checkbox" name="mountains1[kenya]" id="mountains1_kenya"><label for="mountains1_kenya">Mt. Kenya <span class="grey">(Kenya)</span></label></li>
                        <li><input type="checkbox" name="mountains1[meru]" id="mountains1_meru"><label for="mountains1_meru">Mt. Meru <span class="grey">(Tanzania)</span></label></li>
                        <li><input type="checkbox" name="mountains1[other]" id="mountains1_other"><label for="mountains1_other">Other mountain or mountain range</label></li>
                      </ul>

                      <div id="climb-div"><input type="radio" name="focus" value="climb" id="climbing-only"><label for="climbing-only">Mountain climbing only <span>(without a safari before or after the climb)</span></label></div>

<ul id="mountains2-div" class="mountains">
  <li><span class="grey">Please select the applicable mountain or mountains</span></li>
  <li>
    <input type="checkbox" name="mountains2" id="mountains2_kilimanjaro" value="Mt. Kilimanjaro">
    <label for="mountains2_kilimanjaro">Mt. Kilimanjaro <span class="grey">(Tanzania)</span></label>
    <ul id="kilimanjaro-routes" style="display: none;">
         <li><span class="grey">Please select the applicable Route For Mt Kilimanjaro</span></li>
      <li>
        <input type="radio" name="routes" id="routes_kilimanjaro_marangu" value="Marangu Route">
        <label for="routes_kilimanjaro_marangu">Marangu Route</label>
      </li>
      <li>
        <input type="radio" name="routes" id="routes_kilimanjaro_machame" value="Machame Route">
        <label for="routes_kilimanjaro_machame">Machame Route</label>
      </li>
      <li>
        <input type="radio" name="routes" id="routes_kilimanjaro_lemosho" value="Lemosho Route">
        <label for="routes_kilimanjaro_lemosho">Lemosho Route</label>
      </li>
      <li>
        <input type="radio" name="routes" id="routes_kilimanjaro_umbwe" value="Umbwe Route">
        <label for="routes_kilimanjaro_umbwe">Umbwe Route</label>
      </li>
      <li>
        <input type="radio" name="routes" id="routes_kilimanjaro_rongai" value="Umbwe Route">
        <label for="routes_kilimanjaro_rongai">Rongai Route</label>
      </li>
      <li>
        <input type="radio" name="routes" id="routes_kilimanjaro_rongai" value="Rongai Route">
        <label for="routes_kilimanjaro_rongai">Rongai Route</label>
      </li>
      <li>
        <input type="radio" name="routes" id="routes_kilimanjaro_rongai" value="Northern Circuit Route">
        <label for="routes_kilimanjaro_rongai">Northern Circuit Route</label>
      </li>
      <li>
        <input type="radio" name="routes" id="routes_kilimanjaro_rongai" value="Londorossi Route">
        <label for="routes_kilimanjaro_rongai">Londorossi Route</label>
      </li>
      <li>
        <input type="radio" name="routes" id="routes_kilimanjaro_rongai" value="Kilema Route">
        <label for="routes_kilimanjaro_rongai">Kilema Route</label>
      </li>
    </ul>
  </li>
  <li>
    <input type="checkbox" name="mountains2" id="mountains2_kenya" value="Mt. Kenya">
    <label for="mountains2_kenya">Mt. Kenya <span class="grey">(Kenya)</span></label>
  </li>
  <li>
    <input type="checkbox" name="mountains2" id="mountains2_meru" value="Mt. Meru">
    <label for="mountains2_meru">Mt. Meru <span class="grey">(Tanzania)</span></label>
  </li>
  <li>
    <input type="checkbox" name="mountains2" id="mountains2_other" value="Other mountain or mountain range">
    <label for="mountains2_other">Other mountain or mountain range</label>
  </li>
  <li><span class="grey">Please select the applicable Activies</span></li>
        <li>
        <input type="radio" name="activity" id="climb" value="Climbing">
        <label for="climb">Climbing</label>
      </li>

      <li>
        <input type="radio" name="activity" id="hike" value="Hiking">
        <label for="hike">Hiking</label>
      </li>

      <li>
        <input type="radio" name="activity" id="trek" value="Trekking">
        <label for="trek">Trekking</label>
      </li>

</ul>




                      <div id="yoga-div"><input type="radio" name="focus" value="yoga" id="yoga"><label for="yoga">Yoga</label></div>
                      <div id="other-div"><input type="radio" name="focus" value="other" id="other-wildlife-safari"><label for="other-wildlife-safari">Other type of wildlife-viewing safari <span>(select this option if the main focus of this tour is wildlife viewing, but none of the options above apply)</span></label></div>
                    </div>
                  </fieldset>
                  <input type="submit" name="save" value="Continue" class="sb-button large button1652012 bottom-submit-btn" />
                  
                </form>
                <script type="text/javascript">
                var safari_id = '0';
                var operator_id = '5067';
                </script>
              </div>
            </div>
          </div>
        </div>
      </div>
    </body>
    <script>
    var sb_version='1.0.85';
    var cookie_domain='AfricaGoTrips.com';
    var mvcAction = '';
    var function_avail_uncertain = true;
    mvcAction = "add";
    Shadowbox.init({
    players:  [ 'html'],
    onOpen: onShOpen,
    onClose: onShClose,
    modal: true
    });
    function onShOpen() {
    document.body.style.overflow = "hidden";
    return true;
    }
    function onShClose() {
    document.body.style.overflow = "auto";
    return true;
    }
    </script>
    <script>
    (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
    (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
    m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
    })(window,document,'script','//www.google-analytics.com/analytics.js','ga');
    ga('create', 'UA-23211223-2', 'auto');
    ga('set', 'anonymizeIp', true);
    ga('send', 'pageview');
    </script>
   <script>
  const kilimanjaroCheckbox = document.getElementById('mountains2_kilimanjaro');
  const kilimanjaroRoutes = document.getElementById('kilimanjaro-routes');
  kilimanjaroCheckbox.addEventListener('change', function() {
    kilimanjaroRoutes.style.display = this.checked ? 'block' : 'none';
  });
</script>
<script>
  document.querySelector('form').addEventListener('submit', function(event) {
    const selectedValue = document.getElementById('tourLength').value;
    if (selectedValue === '') {
      event.preventDefault();
      alert('Please select the tour length.');
    }
  });
</script>
  </html>