var availability_available = {};
var availability_limited = {};
var availability_uncertain = {};
var availability_unavailable = {};
var availability_shortnoticeblock = {};
var date_counter = 0;
var limited_numbers = {};
var uncertain_numbers = {};
var availability_selected_from = false;
var availability_selected_to = false;
var availability_internal_note = false;
var availability_showing = false;

function fillAvailabilityCalendarVars() {
    availability_unavailable = {};
    availability_limited = {};
    availability_uncertain = {};
    availability_available = {};
    availability_shortnoticeblock = {};
    date_counter = 0;
    limited_numbers = {};
    uncertain_numbers = {};

    var today = new Date();
    today.setHours(0,0,0,0);

    $(".availability-options li").each(function() {
        if ($(this).find(".availability-date-picker-from").length && $(this).find(".availability-date-picker-from").data('val') != null && $(this).find(".availability-date-picker-from").data('val') != '' && $(this).find(".availability-date-picker-to").data('val') != '') {
            var start = new Date($(this).find(".availability-date-picker-from").data('val'));
            var end = new Date($(this).find(".availability-date-picker-to").data('val'));

            while (dateToYYMMDD(start) <= dateToYYMMDD(end)) {

                if (dateToYYMMDD(start) >= dateToYYMMDD(today)) {
                    if ($(this).find('select').val() == '0') {
                        availability_unavailable[dateToYYMMDD(start)] = $(this).find('select').val();
                    } else if ($(this).find('select').val() == '-1') {
                        availability_uncertain[dateToYYMMDD(start)] = $(this).find('select').val();
                    } else if ($(this).find('select').val() != '99') {
                        availability_limited[dateToYYMMDD(start)] = $(this).find('select').val();
                    }
                }

                var newDate = start.setDate(start.getDate() + 1);
                start = new Date(newDate);
            }
        }
    });

    if ($(".company-form").length) {
        year_str1 = new Date().getFullYear();
        var start = new Date(year_str1 + '-01-01');
        var end = new Date((year_str1 + 3) + '-12-31');

        while (dateToYYMMDD(start) <= dateToYYMMDD(end)) {
            if (dateToYYMMDD(start) >= dateToYYMMDD(today)) {
                availability_available[dateToYYMMDD(start)] = 1;
            }

            var newDate = start.setDate(start.getDate() + 1);
            start = new Date(newDate);
        }

        year_str1 = new Date().getFullYear() + 1;
        var start = new Date(year_str1 + '-01-01');
        var end = new Date(year_str1 + '-12-31');

        while (dateToYYMMDD(start) <= dateToYYMMDD(end)) {
            if (dateToYYMMDD(start) >= dateToYYMMDD(today)) {
                availability_available[dateToYYMMDD(start)] = 1;
            }

            var newDate = start.setDate(start.getDate() + 1);
            start = new Date(newDate);
        }

    } else {
        var fixedDates = ($("#datesrates input[name='rates[fixeddates]']:checked").val() == 'yes') ? true : false;
        var seasonDates = ($("#datesrates input[name='rates[fixedrates]']:checked").val() == 'yes' && fixedDates == false) ? true : false;
        var yearDates = ($("#datesrates input[name='rates[fixedrates]']:checked").val() == 'no' && fixedDates == false) ? true : false;

        if (fixedDates || seasonDates || yearDates) {
            var count = 0;
            if ($("#datesrates .rate-blocks ul.rate-block:visible").length) {
                $("#datesrates .rate-blocks ul.rate-block:visible").each(function () {
                    if (fixedDates) {
                        var date_str = $("#datesrates .fixeddates-options input[data-val]:eq(" + count + ")").attr('data-val');
                        var d = new Date(date_str);
                        if (d >= today) {
                            availability_available[dateToYYMMDD(d)] = 1;
                        }
                    } else if (seasonDates) {
                        var start = new Date($("#datesrates .fixedrates-options input.date-picker-from[data-val]:eq(" + count + ")").attr('data-val'));
                        var end = new Date($("#datesrates .fixedrates-options input.date-picker-to[data-val]:eq(" + count + ")").attr('data-val'));

                        while (dateToYYMMDD(start) <= dateToYYMMDD(end)) {

                            if (dateToYYMMDD(start) >= dateToYYMMDD(today)) {
                                availability_available[dateToYYMMDD(start)] = 1;
                            }

                            var newDate = start.setDate(start.getDate() + 1);
                            start = new Date(newDate);
                        }
                    } else if (yearDates) {
                        var year_str1 = $("#datesrates .fixedyears-options input:checked:eq(" + count + ")").attr('data-val');
                        var start = new Date(year_str1 + '-01-01');
                        var end = new Date(year_str1 + '-12-31');

                        while (start <= end) {
                            if (start >= today) {
                                availability_available[dateToYYMMDD(start)] = 1;
                            }

                            var newDate = start.setDate(start.getDate() + 1);
                            start = new Date(newDate);
                        }
                    }
                    count++;
                });
            }
        }
    }

    if ($("#shortnotice-no").is(":checked") && $("select[name='rates[shortnoticeperiod]']").length && $("select[name='rates[shortnoticeperiod]']").val() != '0') {

        var now = moment();
        var shortnotice_vals = $("select[name='rates[shortnoticeperiod]']").val().split(' ');
        now.add(parseInt(shortnotice_vals[0]), shortnotice_vals[1]);

        var s = moment();
        var end = now;

        s = s.toDate();
        end = end.toDate();

        s.setHours(0,0,0,0);
        end.setHours(0,0,0,0);

        while(s <= end) {
            delete availability_unavailable[dateToYYMMDD(s)];
            delete availability_limited[dateToYYMMDD(s)];
            delete availability_uncertain[dateToYYMMDD(s)];
            delete availability_available[dateToYYMMDD(s)];

            availability_shortnoticeblock[dateToYYMMDD(s)] = 1;

            var nd = s.setDate(s.getDate() + 1);
            s = new Date(nd);
        }

    }

    if ($("#shortnotice-no").is(":checked") && $("select[name='rates_shortnoticeperiod']").length && $("select[name='rates_shortnoticeperiod']").val() != '0' && $("select[name='rates_shortnoticeperiod']").val() != '') {

        var now = moment();
        var shortnotice_vals = $("select[name='rates_shortnoticeperiod']").val().split(' ');
        now.add(parseInt(shortnotice_vals[0]), shortnotice_vals[1]);

        var s = moment();
        var end = now;

        s = s.toDate();
        end = end.toDate();

        s.setHours(0,0,0,0);
        end.setHours(0,0,0,0);

        while(s <= end) {
            delete availability_unavailable[dateToYYMMDD(s)];
            delete availability_limited[dateToYYMMDD(s)];
            delete availability_uncertain[dateToYYMMDD(s)];
            delete availability_available[dateToYYMMDD(s)];

            availability_shortnoticeblock[dateToYYMMDD(s)] = 1;

            var nd = s.setDate(s.getDate() + 1);
            s = new Date(nd);
        }

    }

    if ($(".company-form").length || $('.tour-form #group input[type=radio]:checked').val() != 'group') {
        $(".date-range-picker-legend").find('.limited').parent().hide();
    } else {
        $(".date-range-picker-legend").find('.limited').parent().show();
    }
}

function handleAvailabilityInternalNote(event) {
    if (availability_internal_note) {
        // Show

        if ($(".availability-tool").length && availability_internal_note.length < 20) {
            return false;
        }

        if (!$(".availability-internalnote").length) {
            if ($(".availability-tool").length) {
                $(".availability-tool").append("<div class='availability-internalnote balloon-outer attop'><div class='balloon-inner'></div></div>");
            } else {
                $(".date-range-picker-holder").append("<div class='availability-internalnote balloon-outer'><div class='balloon-inner'></div></div>");
            }
        }
        if ($(".availability-internalnote div").text() != availability_internal_note) {
            $(".availability-internalnote div").html(availability_internal_note);
        }

        if (typeof event != 'undefined' && typeof event.pageX != 'undefined') {
            var mousex = event.pageX;
            var mousey = event.pageY;
            if ($(".availability-tool").length) {
                mousex -= $(".availability-tool").offset().left;
                mousey -= $(".availability-tool").offset().top;

                $(".availability-internalnote").css('top', mousey);
                $(".availability-internalnote").css('left', mousex);

                $(".availability-internalnote").css('top', '-=' + (parseInt($(".availability-internalnote").outerHeight()) + 20));

                var diff = 407 - parseInt($(".availability-internalnote").outerWidth());
                if (diff > 0) {
                    $(".availability-internalnote").css('left', '+=' + diff);
                }

                if (mousex < 300) {
                    $(".availability-internalnote").addClass('left');
                    $(".availability-internalnote").css('left', '-=103');
                    $(".availability-internalnote").css('left', '-=' + diff);
                } else {
                    $(".availability-internalnote").removeClass('left');
                    $(".availability-internalnote").css('left', '-=296');
                }
            } else {
                mousex -= $(".date-range-picker-holder").offset().left;
                mousey -= $(".date-range-picker-holder").offset().top;

                $(".availability-internalnote").css('top', mousey);
                $(".availability-internalnote").css('left', mousex);

                // Create a left correction based on 407
                var diff = 407 - parseInt($(".availability-internalnote").outerWidth());
                if (diff > 0) {
                    $(".availability-internalnote").css('left', '+=' + diff);
                }

                $(".availability-internalnote").css('top', '+=17');

                if (mousex < 300) {
                    $(".availability-internalnote").addClass('left');
                    $(".availability-internalnote").css('left', '-=103');
                    $(".availability-internalnote").css('left', '-=' + diff);
                } else {
                    $(".availability-internalnote").removeClass('left');
                    $(".availability-internalnote").css('left', '-=296');
                }
            }
        } else {

            if ($(".availability-tool").length) {
                $(".availability-internalnote").css('top', parseInt($(".day div.hover").first().offset().top) - 40 - (parseInt($(".availability-internalnote").outerHeight()) - 25) + 'px');
                $(".availability-internalnote").css('left', parseInt($(".day div.hover").first().offset().left) - (parseInt($(".availability-internalnote").outerWidth()) - 250) + 'px');

                if ($(".day div.hover").first().attr('data-index').indexOf('1-') == 0) {
                    $(".availability-internalnote").addClass('left');
                    $(".availability-internalnote").css('left', parseInt($(".day div.hover").first().offset().left) + 35 + 'px');
                } else {
                    $(".availability-internalnote").removeClass('left');
                }

            } else {

                $(".availability-internalnote").css('top', parseInt($(".date-range-picker-holder .ui-datepicker-calendar td.dp-highlight").last().position().top) + 'px');
                $(".availability-internalnote").css('left', parseInt($(".date-range-picker-holder .ui-datepicker-calendar td.dp-highlight").last().position().left) + parseInt($(".date-range-picker-holder .ui-datepicker-calendar td.dp-highlight").last().closest('.ui-datepicker-group').position().left) + 'px');

                // Create a left correction based on 407
                var diff = 407 - parseInt($(".availability-internalnote").outerWidth());
                if (diff > 0) {
                    $(".availability-internalnote").css('left', '+=' + diff);
                }

                $(".availability-internalnote").css('top', '+=77');

                if ($(".date-range-picker-holder .ui-datepicker-calendar td.dp-highlight").last().closest('.ui-datepicker-group').hasClass('ui-datepicker-group-first')) {
                    $(".availability-internalnote").addClass('left');
                    $(".availability-internalnote").css('left', '-=82');
                    $(".availability-internalnote").css('left', '-=' + diff);
                } else {
                    $(".availability-internalnote").removeClass('left');
                    $(".availability-internalnote").css('left', '-=275');
                }

            }
        }

    } else {
        // Hide
        $(".availability-internalnote").remove();
    }
}

function showAvailabilityPopup(range) {
    availability_internal_note = false;
    handleAvailabilityInternalNote(false);

    availability_showing = true;

    $(".availability-popup").remove();

    if ($(".availability-tool").length) {
        $(".availability-tool").append("<div class='availability-popup'></div>");
    } else {
        $(".date-range-picker-holder").append("<div class='availability-popup'></div>");
    }

    $("body").append('<div class="load-layer"></div>');

    if ($(".availability-tool").length) {
        $(".availability-popup").removeClass('left').removeClass('above');

        if ($(".calendar .day div.hover").length) {
            $(".availability-popup").css('top', parseInt($(".calendar .day div.hover").first().offset().top) + 'px');
            $(".availability-popup").css('left', parseInt($(".calendar .day div.hover").first().offset().left) + 'px');
        } else if ($(".calendar .day div.selected").length) {
            $(".availability-popup").css('top', (parseInt($(".calendar .day div.selected").first().offset().top) - parseInt($(window).scrollTop())) + 'px');
            $(".availability-popup").css('left', parseInt($(".calendar .day div.selected").first().offset().left) + 'px');
        }
        $(".availability-popup").css('top', '+=33');
        $(".availability-popup").css('left', '-=170');
        $(".availability-popup").css('position', 'absolute');

        $(".availability-popup").css('left', '-=' + parseInt($(window).scrollLeft()));

        if ( parseInt($(".availability-popup").css('left')) < 20 ) {
            $(".availability-popup").addClass('left');
            $(".availability-popup").css('left', '+=200');
        }
    } else {
        $(".availability-popup").css('top', parseInt($(".date-range-picker-holder .ui-datepicker-calendar td.dp-highlight").last().position().top) + 'px');
        $(".availability-popup").css('left', parseInt($(".date-range-picker-holder .ui-datepicker-calendar td.dp-highlight").last().position().left) + parseInt($(".date-range-picker-holder .ui-datepicker-calendar td.dp-highlight").last().closest('.ui-datepicker-group').position().left) + 'px');
        $(".availability-popup").css('top', '+=77');
        if ($(".date-range-picker-holder .ui-datepicker-calendar td.dp-highlight").last().closest('.ui-datepicker-group').hasClass('ui-datepicker-group-first')) {
            $(".availability-popup").addClass('left');
            $(".availability-popup").css('left', '-=82');
        } else {
            $(".availability-popup").removeClass('left');
            $(".availability-popup").css('left', '-=275');
        }

        if (typeof range !== 'undefined') {
            availability_selected_from = $(".availability-options li:eq(" + range + ")").find(".availability-date-picker-from").val();
            availability_selected_to = $(".availability-options li:eq(" + range + ")").find(".availability-date-picker-to").val();
        }
    }

    $(".availability-popup").append("<h3>Set Availability</h3>");

    var show_delete_btn = false;
    var block = false;
    var tour_id = false;
    var group_or_private = false;
    var solo = false;

    if (typeof range !== 'undefined') {
        var day1 = $(".availability-options li:eq(" + range + ")").find(".availability-date-picker-from").val();
        var day2 = $(".availability-options li:eq(" + range + ")").find(".availability-date-picker-to").val();
    } else if ($(".availability-tool").length) {
        var i = $(".calendar .day div.hover").first().index();
        if (i <= -1) {
            i = $(".calendar .day div:hover").first().index();
        }
        var tour_id = $(".tours div:eq(" + i + ")").attr('data-id');
        var tour_index = (i - 1);
        if (tour_id > 0)
            var group_or_private = $(".tours div:eq(" + i + ")").attr('data-gp');

        if (group_or_private == 'group' && $(".tours div:eq(" + i + ")").attr('data-solo') == '1') {
            solo = true;
        }

        if (availabilitytool.selection1) {
            var selection1_parts = availabilitytool.selection1.split('-');
            var selection2_parts = availabilitytool.selection2.split('-');
            var day1_dt = new Date(availabilitytool.currentYear + '-' + ((parseInt(availabilitytool.currentMonth) < 10) ? '0' + String(availabilitytool.currentMonth) : availabilitytool.currentMonth) + '-' + (parseInt(selection1_parts[1]) < 10 ? '0' + String(selection1_parts[1]) : selection1_parts[1]));
            var day1 = dateToDateText(day1_dt);
            var day2_dt = new Date(availabilitytool.currentYear + '-' + ((parseInt(availabilitytool.currentMonth) < 10) ? '0' + String(availabilitytool.currentMonth) : availabilitytool.currentMonth) + '-' + (parseInt(selection2_parts[1]) < 10 ? '0' + String(selection2_parts[1]) : selection2_parts[1]));
            var day2 = dateToDateText(day2_dt);

            if (day1_dt > day2_dt) {
                var day2_tmp = day2;
                day2 = day1;
                day1 = day2_tmp;
            }
        } else {
            var day1 = dateToDateText(new Date(av[tour_index][$(".calendar .day div.hover").first().attr('data-block')].startdate));
            var day2 = dateToDateText(new Date(av[tour_index][$(".calendar .day div.hover").first().attr('data-block')].enddate));

            show_delete_btn = true;
            block = $(".calendar .day div.hover").first().attr('data-block');
        }
    } else {
        var day1 = $("#date-input1").val();
        var day2 = $("#date-input2").val();
    }

    var ranges = [];

    var single_day = false;
    if (ranges.length == 0 && day1 == day2) {
        var start = dateToYYMMDD(new Date(day1));
        $(".availability-popup").append("<div class='date'>Start on <em>" + dateToDateText(new Date(start)) + "</em>.</div>");
        ranges.push([start, start]);
        single_day = true;
    } else {
        var start = new Date(day1);
        var end = new Date(day2);

        var range_started = false;
        var this_range = [];
        while(start <= end) {
            var start_str = dateToYYMMDD(start);
            if ($(".availability-tool").length || availability_available[start_str]) {
                if (!range_started) {
                    range_started = true;
                    this_range.push(start_str);
                } else {
                    this_range.push(start_str);
                }
            } else {
                if (range_started) {
                    ranges.push(this_range);
                    this_range = [];
                    range_started = false;
                }
            }

            var newDate = start.setDate(start.getDate() + 1);
            start = new Date(newDate);
        }

        if (range_started) {
            ranges.push(this_range);
            this_range = [];
            range_started = false;
        }

        if (ranges.length == 1) {
            $(".availability-popup").append("<div class='date'>Start dates between <em>" + day1 + "</em> and <em>" + day2 + "</em>.</div>");
        } else {
            $(".availability-popup").append("<div class='date'>Start dates between:<ul></ul></div>");
            $.each(ranges, function(key, val) {
                $(".availability-popup ul").append("<li><em>" + dateToDateText(new Date(val[0])) + "</em> and <em>" + dateToDateText(new Date(val[val.length-1])) + "</em></li>");
            });
        }
    }

    if ($('.tour-form #group input[type=radio]:checked').val() != 'group' && group_or_private != 'group') {
        // Radio

        var default_checked = 'av';
        if ($(".availability-tool").length) {
            default_checked = 'av';
        }

        if (typeof range !== 'undefined' || block) {
            if (block) {
                if (block && av[tour_index][block].persons == 0) {
                    default_checked = 'un';
                } else if (block && av[tour_index][block].persons == -1) {
                    default_checked = 'unc';
                }
            } else if (typeof range !== 'undefined') {
                var range_val = $(".availability-options li:eq(" + range + ")").find("select").val();
                if (range_val == 0) {
                    default_checked = 'un';
                } else if (range_val == -1) {
                    default_checked = 'unc';
                }
            }
        }

        $(".availability-popup").append('<input type="radio" ' + (default_checked == 'av' ? 'checked' : '') + ' name="availability-popup-radio" id="availability-popup-av" value="99"><label for="availability-popup-av">Available</label>');
        if (function_avail_uncertain) {
            show_unc = true;
            if (show_unc) {
                $(".availability-popup").append('<input type="radio" ' + (default_checked == 'unc' ? 'checked' : '') + ' name="availability-popup-radio" id="availability-popup-unc" value="-1"><label for="availability-popup-unc">Uncertain</label>');
            }
        }
        $(".availability-popup").append('<input type="radio" ' + (default_checked == 'un' ? 'checked' : '') + ' name="availability-popup-radio" id="availability-popup-un" value="0"><label for="availability-popup-un">Not Available</label>');

        $(".availability-popup").on('change', 'input[name=availability-popup-radio]', function() {
            var bulb_class = 'option1';
            if ($('input[name=availability-popup-radio]:checked').val() == 1 || $('input[name=availability-popup-radio]:checked').val() == 99) {
                var txt = 'This status is selected by default and should be used for start dates when it is (almost) certain that you’ll have availability for a group of 7 or more people. Clients are able to request quotes for ‘available’ start dates. You are not allowed to decline these requests if it turns out that you haven’t got availability.';
            } else if ($('input[name=availability-popup-radio]:checked').val() == -1) {
                var txt = 'This status should be selected for start dates when availability is uncertain. Clients are able to request quotes for ‘uncertain’ start dates and when it turns out that you haven’t got availability, you are allowed to decline these requests. The downside, however, is that we won’t show your tour (or rank it lower) on start dates where we have sufficient ‘available’ tours.';
                bulb_class = 'option2';
            } else {
                var txt = 'This status should be used for start dates when the chance of being not available is substantially greater than being available. Clients won’t be able to request a quote for ‘not available’ start dates.';
                if (function_avail_uncertain) {
                    bulb_class = 'option3';
                } else {
                    bulb_class = 'option2';
                }
            }
            var msg_html = "<div class='bulb'>" + txt + "</div>";
            var diff = 0;
            if ($(".availability-popup").find('.bulb').length && $(".availability-popup").find('.bulb').is(":visible")) {
                diff += $(".availability-popup").find('.bulb').outerHeight();
            }
            $(".availability-popup").find('.bulb').remove();
            $(".availability-popup .internal-note").before(msg_html);

            $(".availability-popup .bulb").removeClass('option1 option2 option3').addClass(bulb_class);

            $(".availability-popup .bulb").slideDown(300, function() {
                if ($(".availability-popup").hasClass('above')) {
                    $(".availability-popup").animate({'top': '-=' + (parseInt($(".availability-popup .bulb").outerHeight()) - diff) + 'px'});
                }
            });
        });

    } else {
        $(".availability-popup").append("<div class='avselect'><span>Availability:</span> </div>");
        if (function_avail_uncertain) {
            if (!$("#solo-yes").is(":checked") && !solo) {
                $(".availability-popup").find("div").last().append('<select><option value="">-- Select --</option><option value="99">Available</option><option value="6">6 people</option><option value="5">5 people</option><option value="4">4 people</option><option value="3">3 people</option><option value="2">2 people</option><option value="-1">Uncertain</option><option value="0">Not Available</option></select>');
            } else {
                $(".availability-popup").find("div").last().append('<select><option value="">-- Select --</option><option value="99">Available</option><option value="6">6 people</option><option value="5">5 people</option><option value="4">4 people</option><option value="3">3 people</option><option value="2">2 people</option><option value="1">1 person</option><option value="-1">Uncertain</option><option value="0">Not Available</option></select>');
            }
        } else {
            if (!$("#solo-yes").is(":checked") && !solo) {
                $(".availability-popup").find("div").last().append('<select><option value="">-- Select --</option><option value="99">Available</option><option value="6">6 people</option><option value="5">5 people</option><option value="4">4 people</option><option value="3">3 people</option><option value="2">2 people</option><option value="0">Not Available</option></select>');
            } else {
                $(".availability-popup").find("div").last().append('<select><option value="">-- Select --</option><option value="99">Available</option><option value="6">6 people</option><option value="5">5 people</option><option value="4">4 people</option><option value="3">3 people</option><option value="2">2 people</option><option value="1">1 person</option><option value="0">Not Available</option></select>');
            }
        }
        if (typeof range !== 'undefined' || block) {
            $(".availability-popup").find("option[value='']").remove();

            var add_available = true;

            if (block && $(".tours div[data-id='" + tour_id + "']").attr('data-type') == 'fixed_dates') {
                add_available = false;
            }

            if (add_available) {
                $(".availability-popup").find('select option[value=99]').remove();
                $(".availability-popup").find('select').prepend('<option value="99">Available</option>');
            }
            if (block) {
                $(".availability-popup").find('select').val(av[tour_index][block].persons);
            } else {
                $(".availability-popup").find('select').val($(".availability-options li:eq(" + range + ")").find("select").val());
            }
        }
    }

    var show_warning = false;
    if ($('.tour-form').length) {
        //if ($('.tour-form #group input[type=radio]:checked').val() == 'group' && !single_day) {
        show_warning = true;
        //}
    } else if ($('.availability-tool').length) {
        show_warning = true;
    }

    if (show_warning) {

        if (day1 != day2) {
            var range_txt = '';
            if (ranges.length == 1) {
                range_txt = "<nobr>" + day1 + "</nobr> and <nobr>" + day2 + "</nobr>";
            } else {
                $.each(ranges, function (key, val) {
                    if (range_txt != '') {
                        range_txt += ', ';
                    }
                    range_txt += "<nobr>" + dateToDateText(new Date(val[0])) + "</nobr> and <nobr>" + dateToDateText(new Date(val[val.length - 1])) + "</nobr>";
                });
            }

            var day_after_day1 = dateToDateText(moment(day1).add(1, 'day').toDate());

            var msg_html = "<div class='bulb'><strong>Limited:</strong> You are about to indicate that the availability is limited to max <span>1 person</span> on any start day between " + range_txt + ".";
            msg_html += "<br /><br /><strong>This would mean that this tour can start on any day between " + range_txt + ".</strong><br /><br />Is that correct?<br />";
            msg_html += "<ul style='margin-left:15px'><li><strong>If so</strong>, please ignore this message.</li>";
            if (day_after_day1 == day2) {
                msg_html += "<li><strong>If not</strong>, and clients can only join this shared group tour on <nobr>" + day1 + "</nobr> (and not on " + day2 + "), then you should set the availability to <span>1 person</span> on <nobr>" + day1 + "</nobr> only, and mark " + day2 + " as not available.</li></ul>";
            } else {
                msg_html += "<li><strong>If not</strong>, and clients can only join this shared group tour on <nobr>" + day1 + "</nobr> (and not on " + day_after_day1 + " to " + day2 + "), then you should set the availability to <span>1 person</span> on <nobr>" + day1 + "</nobr> only, and mark " + day_after_day1 + " to " + day2 + " as not available.</li></ul>";
            }
            msg_html += "</div>";
        } else {
            msg_html = "<div class='bulb'></div>";
        }

        $(".availability-popup").append(msg_html);

        if (typeof range !== 'undefined') {
            var bulb_class = 'option1';
            var v = $(".availability-options li:eq(" + range + ")").find("select").val();

            if (v >= 8) {
                var txt = 'This status is selected by default and should be used for start dates when it is (almost) certain that you’ll have availability for a group of 7 or more people. Clients are able to request quotes for ‘available’ start dates. You are not allowed to decline these requests if it turns out that you haven’t got availability.';
                $(".availability-popup .bulb").html(txt);
            } else if (v == -1) {
                var txt = 'This status should be selected for start dates when availability is uncertain. Clients are able to request quotes for ‘uncertain’ start dates and when it turns out that you haven’t got availability, you are allowed to decline these requests. The downside, however, is that we won’t show your tour (or rank it lower) on start dates where we have sufficient ‘available’ tours.';
                bulb_class = 'option2';
                $(".availability-popup .bulb").html(txt);
            } else if (v == 0) {
                var txt = 'This status should be used for start dates when the chance of being not available is substantially greater than being available. Clients won’t be able to request a quote for ‘not available’ start dates.';
                if (function_avail_uncertain) {
                    bulb_class = 'option3';
                } else {
                    bulb_class = 'option2';
                }
                $(".availability-popup .bulb").html(txt);
            }

            if (v >= 2 && v <= 6) {
                $(".availability-popup .bulb span").html(v + ' people');
            } else if (v == 1) {
                $(".availability-popup .bulb span").html('1 person');
            } else {
                //$(".availability-popup .bulb").hide();
            }

            $(".availability-popup .bulb").removeClass('option1 option2 option3').addClass(bulb_class);
        } else {
            $(".availability-popup .bulb").hide();
        }

        $(".availability-popup").on('change', 'select', function() {
            var v = parseInt($(this).val());
            if (v >= 2 && v <= 6) {
                if (day1 == day2) {
                    if ($(".availability-popup").hasClass('above') && $(".availability-popup .bulb").is(":visible")) {
                        $(".availability-popup").animate({'top': '+=' + parseInt($(".availability-popup .bulb").outerHeight()) + 'px'});
                    }
                    $(".availability-popup .bulb").slideUp();
                } else {
                    var bulb_height = 0;
                    if ($(".availability-popup").hasClass('above') && $(".availability-popup .bulb").is(":visible")) {
                        bulb_height = parseInt($(".availability-popup .bulb").outerHeight());
                    }
                    $(".availability-popup .bulb").replaceWith(msg_html);
                    $(".availability-popup .bulb span").html(v + ' people');
                    $(".availability-popup .bulb").slideDown(300, function () {
                        if ($(".availability-popup").hasClass('above')) {
                            $(".availability-popup").animate({'top': '-=' + (parseInt($(".availability-popup .bulb").outerHeight()) - bulb_height) + 'px'});
                        }
                    });
                }
            } else if (v == 1) {
                var bulb_height = 0;
                if ($(".availability-popup").hasClass('above') && $(".availability-popup .bulb").is(":visible")) {
                    bulb_height = parseInt($(".availability-popup .bulb").outerHeight());
                }
                $(".availability-popup .bulb").replaceWith(msg_html);
                $(".availability-popup .bulb span").html('1 person');
                $(".availability-popup .bulb").slideDown(300, function() {
                    if ($(".availability-popup").hasClass('above')) {
                        $(".availability-popup").animate({'top': '-=' + (parseInt($(".availability-popup .bulb").outerHeight()) - bulb_height) + 'px'});
                    }
                });
            } else {
                if ($(this).val() == '') {
                    if ($(".availability-popup").hasClass('above') && $(".availability-popup .bulb").is(":visible")) {
                        $(".availability-popup").animate({'top': '+=' + parseInt($(".availability-popup .bulb").outerHeight()) + 'px'});
                    }
                    $(".availability-popup .bulb").slideUp();
                } else {
                    var bulb_height = 0;
                    if ($(".availability-popup").hasClass('above') && $(".availability-popup .bulb").is(":visible")) {
                        bulb_height = parseInt($(".availability-popup .bulb").outerHeight());
                    }
                    if (v >= 8) {
                        var txt = 'This status is selected by default and should be used for start dates when it is (almost) certain that you’ll have availability for a group of 7 or more people. Clients are able to request quotes for ‘available’ start dates. You are not allowed to decline these requests if it turns out that you haven’t got availability.';
                        $(".availability-popup .bulb").html(txt);
                    } else if (v == -1) {
                        var txt = 'This status should be selected for start dates when availability is uncertain. Clients are able to request quotes for ‘uncertain’ start dates and when it turns out that you haven’t got availability, you are allowed to decline these requests. The downside, however, is that we won’t show your tour (or rank it lower) on start dates where we have sufficient ‘available’ tours.';
                        $(".availability-popup .bulb").html(txt);
                    } else if (v == 0) {
                        var txt = 'This status should be used for start dates when the chance of being not available is substantially greater than being available. Clients won’t be able to request a quote for ‘not available’ start dates.';
                        $(".availability-popup .bulb").html(txt);
                    }
                    $(".availability-popup .bulb").slideDown(300, function () {
                        if ($(".availability-popup").hasClass('above')) {
                            $(".availability-popup").animate({'top': '-=' + (parseInt($(".availability-popup .bulb").outerHeight()) - bulb_height) + 'px'});
                        }
                    });
                }
            }
        });

    } else {
        $(".availability-popup").off('change', 'select');
    }

    var show_note = true;
    if ($(".availability-tool").length && $(".tours div[data-id='" + tour_id + "']").attr('data-ratefields')) {
        show_note = false;
    }
    if (show_note)
        $(".availability-popup").append("<div class='internal-note'><span>Note <i>(optional)</i>:</span> <input type='text' value='' class='note' /><em>For internal use only; won't be shown to clients.</em></div>");

    if (typeof range !== 'undefined') {
        $(".availability-popup").find('input[type=text].note').val($(".availability-options li:eq(" + range + ")").find("select").next().val());
    } else if (block) {
        $(".availability-popup").find('input[type=text].note').val($(".calendar .day div.hover").first().find('span.note').text());
    }

    if ($(".availability-tool").length) {

        if ($(".tours div[data-id='" + tour_id + "']").attr('data-ratefields')) {
            var rf = $.parseJSON($(".tours div[data-id='" + tour_id + "']").attr('data-ratefields'));

            if (!(typeof range !== 'undefined' || show_delete_btn)) {
                $(".availability-popup h3").text("Add Start Date");
            } else {
                $(".availability-popup h3").text("Set Availability");
            }

            var copy_from = false;
            var copy_from_prevnext = false;
            if (block && block > 0) {
                copy_from = av[tour_index][(block - 1)].startdate;
                copy_from_prevnext = 'prev';
            } else if (block && block == 0) {
                if (typeof av[tour_index][1] != 'undefined') {
                    copy_from = av[tour_index][1].startdate;
                    copy_from_prevnext = 'next';
                }
            } else if (!block) {
                var single_date = dateToYYMMDD(new Date(day1));

                if (typeof av[tour_index] != 'undefined' && av[tour_index].length > 0) {
                    $.each(av[tour_index], function(key, val) {
                        if (val.startdate < single_date && (copy_from == false || copy_from < val.startdate)) {
                            copy_from = val.startdate;
                            copy_from_prevnext = 'prev';
                        }

                        if (val.startdate >= single_date && copy_from == false) {
                            copy_from = val.startdate;
                            copy_from_prevnext = 'next';
                        }
                    });
                }
            }

            if (copy_from !== false) {
                if (copy_from_prevnext == 'prev') {
                    $(".availability-popup").append("<a href='#' class='copy_rates' data-from='" + copy_from + "'>Copy rates from previous date</a>");
                } else {
                    $(".availability-popup").append("<a href='#' class='copy_rates' data-from='" + copy_from + "'>Copy rates from next date</a>");
                }
            }
            $(".availability-popup").append("<div class='rates'></div>");

            $.each(rf.persons, function(key, val) {
                var per_lbl = '';
                if (val == 1) {
                    per_lbl = 'Solo traveler (1 room)';
                } else if (val == 2) {
                    per_lbl = '2 people (1 room)';
                } else if (val == 3 || val == 4) {
                    per_lbl = val + ' people (2 rooms)';
                } else {
                    per_lbl = val + ' people (3 rooms)';
                }
                var content = "<div class='ratesrow'><span>" + per_lbl + "</span> <b>" + rf.currency + "</b> <input type='text' value='' id='ratep" + val + "' name='ratep" + val + "' data-persons='" + val + "' class='amount mainamount' autocorrect='off' autocomplete='off' value='' data-mask='[0-9]+' maxlength='8' /> per person";
                if (typeof rf.local_currency != 'undefined') {
                    content += "<span class='local'> + Local payment of </span><b>" + rf.local_currency + "</b> <input type='text' value='' id='lratep" + val + "' name='lratep" + val + "' class='amount' autocorrect='off' autocomplete='off' value='' data-mask='[0-9]+' maxlength='8' /> per person";
                }

                content += "</div>";
                $(".availability-popup .rates").append(content);

            });

            $(".availability-popup").on('blur', '.mainamount', function() {

                if ($(".availability-popup .mainamount").length >= 2) {
                    var comparerates = [-1, -1, -1, -1, -1, -1, -1, -1];

                    $(".availability-popup .mainamount").each(function() {
                        var people = parseInt($(this).attr('data-persons'));
                        if ($(this).val() != '') {
                            comparerates[people - 1] = Math.round($(this).val());
                        }
                    });

                    var mainFocus = $(".tours div[data-id='" + tour_id + "']").attr('data-mainfocus');
                    showHideError(( (comparerates[0] > -1 && comparerates[1] > -1 && comparerates[0] < comparerates[1]) && !(mainFocus == 'tracking_safari' || mainFocus == 'tracking') ), $(this).parent().parent(), 'The solo traveler rate may not be lower than the rate for 2 people sharing. The solo traveler rate should include both the regular rate and the single supplement.', 'rates03');
                }
            });

            $(".availability-popup").on('blur', '.amount', function() {
                if ($(".availability-popup").find('.amount').length) {
                    var empty = 0;
                    $(".availability-popup").find('.amount').each(function() {
                        if ($(this).val() == '') {
                            empty++;
                        }
                    });

                    if (empty == 0) {
                        hideError($(".availability-popup .rates"), 'Please enter all rates', 'rates99');
                    }
                }
            });

            if (block) {
                // Get rates for this date block
                var single_date = dateToYYMMDD(new Date(day1));
                $(".availability-popup").append("<div class='overlay'><div><img src='/images/load.gif' alt='' /></div></div>");
                $.ajax({
                    type: "POST",
                    url: backend_url("tool/availability" + location.search),
                    data: { 'getrates': 1, 'safari_id': tour_id, 'startdate': single_date },
                    dataType: 'json'
                }).done(function(return_data) {
                    $.each(return_data, function(key, subdata) {
                        $(".availability-popup").find("#ratep" + subdata.persons).val(Math.round(subdata.rate));
                        $(".availability-popup").find("#lratep" + subdata.persons).val(Math.round(subdata.local_rate));
                    });

                    limitedInputs();

                    $(".availability-popup").find('.overlay').remove();
                });

            }

            $(".availability-popup .copy_rates").unbind('click').bind('click', function(e) {
                e.preventDefault();
                var copy_from_date = $(this).data('from');
                $(".availability-popup").append("<div class='overlay'><div><img src='/images/load.gif' alt='' /></div></div>");
                $.ajax({
                    type: "POST",
                    url: backend_url("tool/availability" + location.search),
                    data: { 'getrates': 1, 'safari_id': tour_id, 'startdate': copy_from_date },
                    dataType: 'json'
                }).done(function(return_data) {
                    $.each(return_data, function(key, subdata) {
                        $(".availability-popup").find("#ratep" + subdata.persons).val(Math.round(subdata.rate));
                        $(".availability-popup").find("#lratep" + subdata.persons).val(Math.round(subdata.local_rate));
                    });

                    limitedInputs();

                    setTimeout(function() {
                        $(".availability-popup").find('.overlay').remove();
                    }, 300);
                });
            });
        }
    }

    $(".availability-popup").append("<div class='buttons'></div>");

    $(".availability-popup").find('.buttons').append("<input type='submit' class='sb-button narrow red apply' value='Apply'>");
    $(".availability-popup").find('.buttons').append("<input type='submit' class='sb-button narrow grey cancel' value='Cancel'>");
    if (typeof range !== 'undefined' || show_delete_btn) {
        $(".availability-popup").find('.buttons').append("<input type='submit' class='sb-button narrow grey align-right delete' value='Delete'>");
    }

    if ($(".availability-tool").length) {
        if (( parseInt($(".availability-popup").offset().top) + (parseInt($(".availability-popup").outerHeight()) + 12) - parseInt($(window).scrollTop()) ) > parseInt($(window).height())) {
            // (Partly) out of screen, show above selection instead of below.
            $(".availability-popup").css('top', '-=' + ($(".availability-popup").outerHeight() + 57)).addClass('above');

            if (parseInt($(".availability-popup").css('top')) < 10) {
                $(".availability-popup").css('top', '10px');
            }
        }
    }

    $(".availability-popup .apply").bind('click', function(e) {
        e.preventDefault();

        var error = false;

        if ($(".availability-popup").find('.amount').length) {
            var empty = 0;
            $(".availability-popup").find('.amount').each(function() {
                if ($(this).val() == '') {
                    empty++;
                }
            });

            showHideError( empty > 0 , $(".availability-popup .rates"), 'Please enter all rates', 'rates99');

            if (empty > 0) {
                error = true;
            }
        }

        if ($(".availability-popup").find('select').length) {
            if ($(".availability-popup").find('select').val() == '') {
                showError($(".availability-popup .avselect"), 'Please select the availability', 'av99');

                $(".availability-popup").find('select').unbind('change').bind('change', function() {
                    hideError($(".availability-popup .avselect"), 'Please select the availability', 'av99');
                });

                error = true;
            }
        }

        if (error) {
            return false;
        }

        if ($(".availability-popup").find('.error li:not(.removing)').length) {
            alert("You should fix the problem in the Availability settings first before you can save them.");
            return false;
        }

        if (typeof range === 'undefined' && !block) {
            if ($('.tour-form #group input[type=radio]:checked').val() != 'group' && group_or_private != 'group') {
                if ($(".availability-tool").length) {
                    if ($(".tours div[data-id='" + tour_id + "']").attr('data-type') != 'fixed_dates') {
                        if ($("#availability-popup-av").is(":checked")) {
                            $(".availability-popup .cancel").trigger('click');
                            return false;
                        }
                    }
                } else {
                    if ($("#availability-popup-av").is(":checked")) {
                        $(".availability-popup .cancel").trigger('click');
                        return false;
                    }
                }
            } else {
                if ($(".availability-popup").find('select').val() == '' || $(".availability-popup").find('select').val() == '99') {
                    $(".availability-popup .cancel").trigger('click');
                    return false;
                }
            }

            if ($(".availability-tool").length) {
                var data = false;

                $.each(ranges, function (key, val) {
                    // Check if there is an overlap with any other ranges. If so, we need to break that up, or even remove it.
                    var this_start = new Date(val[0]);
                    var this_end = new Date(val[val.length - 1]);

                    $.each(av[tour_index], function(av_key, av_val) {
                        var start = new Date(av_val.startdate);
                        var end = new Date(av_val.enddate);

                        if (start >= this_start && end <= this_end) {
                            availabilitytool.deleteBlock(tour_index, av_key, av_val.startdate, av_val.enddate);
                        } else if (start <= this_start && end >= this_start) {
                            var d = this_start;
                            d.setDate(d.getDate() - 1);

                            var new_enddate = dateToYYMMDD(d);
                            av[tour_index][av_key].enddate = new_enddate;
                            availabilitytool.updateBlock(tour_index, av_key, {'enddate': new_enddate, 'orgstartdate': dateToYYMMDD(start), 'orgenddate': dateToYYMMDD(end)});
                            d.setDate(d.getDate() + 1);

                        } else if (start <= this_end && end >= this_end) {
                            var d = this_end;
                            d.setDate(d.getDate() + 1);

                            var new_startdate = dateToYYMMDD(d);
                            av[tour_index][av_key].startdate = new_startdate;
                            availabilitytool.updateBlock(tour_index, av_key, {'startdate': new_startdate, 'orgstartdate': dateToYYMMDD(start), 'orgenddate': dateToYYMMDD(end)});
                            d.setDate(d.getDate() - 1);
                        }
                    });

                    if (tour_id == 0) {
                        if ($("#availability-popup-unc").length && $("#availability-popup-unc").is(":checked")) {
                            persons = -1;
                        } else {
                            persons = 0;
                        }
                        data = {'operator_id': $("div[data-id='0']").attr('data-oid'), 'startdate': val[0], 'enddate': val[val.length - 1], 'persons': persons, 'internal_note': $(".availability-popup").find('input[type=text].note').val() };
                    } else {
                        if ($(".availability-popup").find("input[type=text].amount").length) {
                            var rates = $(".availability-popup").find("input[type=text].amount").serializeArray();
                        } else {
                            var rates = false;
                        }
                        var persons = (group_or_private == 'group') ? $(".availability-popup").find('select').val() : '0';

                        if (group_or_private == 'private') {
                            if ($("#availability-popup-av").is(":checked")) {
                                persons = 99;
                            }
                            if ($("#availability-popup-unc").length && $("#availability-popup-unc").is(":checked")) {
                                persons = -1;
                            }

                        }

                        data = {
                            'safari_id': tour_id,
                            'startdate': val[0],
                            'enddate': val[val.length - 1],
                            'persons': persons,
                            'internal_note': $(".availability-popup").find('input[type=text].note').val(),
                            'rates': rates
                        };

                    }

                    availabilitytool.addBlock(tour_index, data);


                });

                if (typeof data != 'undefined' && data != false) {
                    av[tour_index].push(data);
                    av[tour_index].sort(function(a,b) {return (a.startdate > b.startdate) ? 1 : ((b.startdate > a.startdate) ? -1 : 0);} );
                }
                availabilitytool.setCurrentData();

            } else {
                $.each(ranges, function (key, val) {
                    // Check if there is an overlap with any other ranges. If so, we need to break that up, or even remove it.
                    var this_start = new Date(val[0]);
                    var this_end = new Date(val[val.length - 1]);

                    $(".availability-options li").each(function () {
                        var row = $(this);
                        if ($(row).find(".availability-date-picker-from").length && $(row).find(".availability-date-picker-from").data('val') != '' && $(row).find(".availability-date-picker-to").data('val') != '') {
                            var start = new Date($(row).find(".availability-date-picker-from").data('val'));
                            var end = new Date($(row).find(".availability-date-picker-to").data('val'));

                            if (start >= this_start && end <= this_end) {
                                // Complete remove
                                if ($(".availability-options li:not(.add-row)").length > 1) {
                                    $(row).remove();
                                } else {
                                    $(row).find('select').val('');
                                    $(row).find('.availability-date-picker-from').val('').data('val', '');
                                    $(row).find('.availability-date-picker-to').val('').data('val', '');
                                }
                            } else if (start <= this_start && end >= this_start) {
                                var d = this_start;
                                d.setDate(d.getDate() - 1);

                                $(row).find('.availability-date-picker-to').val(dateToDateText(d)).data('val', dateTexttoDate(dateToDateText(d)));
                                d.setDate(d.getDate() + 1);
                            } else if (start <= this_end && end >= this_end) {
                                var d = this_end;
                                d.setDate(d.getDate() + 1);

                                $(row).find('.availability-date-picker-from').val(dateToDateText(d)).data('val', dateTexttoDate(dateToDateText(d)));
                                d.setDate(d.getDate() - 1);
                            }
                        }
                    });

                    if ($(".availability-options li:not(.add-row)").last().find('.availability-date-picker-from').val() != '') {
                        $(".availability-options .add-row a").trigger('click');
                    }

                    if ($('.tour-form #group input[type=radio]:checked').val() != 'group') {
                        if ($("#availability-popup-unc").length && $("#availability-popup-unc").is(":checked")) {
                            $(".availability-options li:not(.add-row)").last().find('select').val('-1');
                        } else {
                            $(".availability-options li:not(.add-row)").last().find('select').val('0');
                        }
                    } else {
                        $(".availability-options li:not(.add-row)").last().find('select').val($(".availability-popup").find('select').val());
                    }

                    $(".availability-options li:not(.add-row)").last().find('select').next().val($(".availability-popup").find('input[type=text].note').val());

                    $(".availability-options li:not(.add-row)").last().find('.availability-date-picker-from').val(dateToDateText(this_start)).data('val', dateTexttoDate(dateToDateText(this_start)));
                    $(".availability-options li:not(.add-row)").last().find('.availability-date-picker-to').val(dateToDateText(this_end)).data('val', dateTexttoDate(dateToDateText(this_end)));
                });
            }
        } else {
            if (block) {
                if (group_or_private != 'group') {
                    if ($("#availability-popup-av").is(":checked")) {
                        if ($(".availability-tool").length && $(".tours div[data-id='" + tour_id + "']").attr('data-type') == 'fixed_dates') {
                            if ($(".availability-popup").find("input[type=text].amount").length) {
                                var rates = $(".availability-popup").find("input[type=text].amount").serializeArray();
                            } else {
                                var rates = false;
                            }

                            availabilitytool.updateBlock(tour_index, block, {
                                'internal_note': '',
                                'persons': '1',
                                'rates': rates
                            });
                            $(".availability-popup .cancel").trigger('click');

                            availabilitytool.setCurrentData();
                        } else {
                            $(".availability-popup .delete").trigger('click');
                        }
                    } else if ($("#availability-popup-unc").is(":checked")) {
                        if ($(".availability-tool").length) {
                            if ($(".availability-popup").find("input[type=text].amount").length) {
                                var rates = $(".availability-popup").find("input[type=text].amount").serializeArray();
                            } else {
                                var rates = false;
                            }

                            availabilitytool.updateBlock(tour_index, block, {
                                'internal_note': $(".availability-popup").find('input[type=text].note').val(),
                                'persons': '-1',
                                'rates': rates
                            });
                            $(".availability-popup .cancel").trigger('click');

                            availabilitytool.setCurrentData();
                        } else {
                            $(".availability-popup .delete").trigger('click');
                        }
                    } else {
                        $(".calendar .day div.hover[data-block='" + block + "'] .note").html($(".availability-popup").find('input[type=text].note').val());
                        if ($(".availability-popup").find("input[type=text].amount").length) {
                            var rates = $(".availability-popup").find("input[type=text].amount").serializeArray();
                        } else {
                            var rates = false;
                        }
                        availabilitytool.updateBlock(tour_index, block, {
                            'internal_note': $(".availability-popup").find('input[type=text].note').val(),
                            'persons': (group_or_private == 'group') ? $(".availability-popup").find('select').val() : '0',
                            'rates': rates
                        });
                        $(".availability-popup .cancel").trigger('click');

                        availabilitytool.setCurrentData();
                    }
                    return false;
                } else {
                    if ($(".availability-popup").find('select').val() == '99' && $(".tours div[data-id='" + tour_id + "']").attr('data-type') != 'fixed_dates') {
                        $(".availability-popup .delete").trigger('click');
                        return false;
                    } else {
                        $(".calendar .day div.hover[data-block='" + block + "'] .note").html($(".availability-popup").find('input[type=text].note').val());
                        if ($(".availability-popup").find("input[type=text].amount").length) {
                            var rates = $(".availability-popup").find("input[type=text].amount").serializeArray();
                        } else {
                            var rates = false;
                        }
                        availabilitytool.updateBlock(tour_index, block, {
                            'internal_note': $(".availability-popup").find('input[type=text].note').val(),
                            'persons': (group_or_private == 'group') ? $(".availability-popup").find('select').val() : '0',
                            'rates': rates
                        });
                        $(".availability-popup .cancel").trigger('click');

                        availabilitytool.setCurrentData();
                    }
                }
            } else {
                if ($('.tour-form #group input[type=radio]:checked').val() != 'group') {
                    if ($("#availability-popup-av").is(":checked")) {
                        $(".availability-popup .delete").trigger('click');
                    } else {
                        $(".availability-options li:eq(" + range + ")").find('select').next().val($(".availability-popup").find('input[type=text].note').val());
                        if ($("#availability-popup-unc").is(":checked")) {
                            $(".availability-options li:eq(" + range + ")").find('select').val(-1);
                        } else {
                            $(".availability-options li:eq(" + range + ")").find('select').val(0);
                        }
                        $(".availability-popup .cancel").trigger('click');
                    }
                } else {
                    if ($(".availability-popup").find('select').val() == '99') {
                        $(".availability-popup .delete").trigger('click');
                        return false;
                    } else {
                        $(".availability-options li:eq(" + range + ")").find('select').val($(".availability-popup").find('select').val());
                        $(".availability-options li:eq(" + range + ")").find('select').next().val($(".availability-popup").find('input[type=text].note').val());
                    }
                }
            }
        }

        hideAvailabilityPopup();
        fillAvailabilityCalendarVars();
        $("#date-input1").val('');
        $("#date-input2").val('');

        availability_selected_from = false;
        availability_selected_to = false;

        $(".date-range-picker-holder").datepicker("refresh");
    });
    $(".availability-popup .cancel").bind('click', function(e) {

        e.preventDefault();
        hideAvailabilityPopup();
        $("#date-input1").val('');
        $("#date-input2").val('');

        availability_selected_from = false;
        availability_selected_to = false;

        $(".calendar .day div.hover").removeClass('hover');

        $(".date-range-picker-holder").datepicker("refresh");
    });
    $(".availability-popup .delete").bind('click', function(e) {

        e.preventDefault();
        var refresh = false;
        if (typeof range !== 'undefined') {
            hideAvailabilityPopup();
            if ($(".availability-options li:not(.add-row)").length > 1) {
                $(".availability-options li:eq(" + range + ")").remove();
            } else {
                $(".availability-options li:eq(" + range + ")").find('select').val('');
                $(".availability-options li:eq(" + range + ")").find('.availability-date-picker-from').val('').data('val', '');
                $(".availability-options li:eq(" + range + ")").find('.availability-date-picker-to').val('').data('val', '');
            }
            fillAvailabilityCalendarVars();
            refresh = true;
        } else if ($(".availability-tool").length && block) {

            if ($(".availability-tool").length && $(".tours div[data-id='" + tour_id + "']").attr('data-type') == 'fixed_dates') {

                confirm('Are you sure you want to delete this availability? It also deletes the rates for this date.', function(result) {
                    if (result) {
                        hideAvailabilityPopup();

                        availabilitytool.deleteBlock(tour_index, block);

                        availabilitytool.setCurrentData();

                        if (block && $(".tours div[data-id='" + tour_id + "']").attr('data-type') == 'fixed_dates') {
                            $(".calendar .day div.hover[data-block='" + block + "']").removeClass('unavailable uncertain limited hover').addClass('unavailable').removeAttr('data-block').html('<span class="note"></span>');
                        } else {
                            $(".calendar .day div.hover[data-block='" + block + "']").removeClass('unavailable uncertain limited hover').removeAttr('data-block').html('<span class="note"></span>');
                        }
                    }
                });
            } else {
                hideAvailabilityPopup();

                availabilitytool.deleteBlock(tour_index, block);

                availabilitytool.setCurrentData();

                if (block && $(".tours div[data-id='" + tour_id + "']").attr('data-type') == 'fixed_dates') {
                    $(".calendar .day div.hover[data-block='" + block + "']").removeClass('unavailable uncertain limited hover').addClass('unavailable').removeAttr('data-block').html('<span class="note"></span>');
                } else {
                    $(".calendar .day div.hover[data-block='" + block + "']").removeClass('unavailable uncertain limited hover').removeAttr('data-block').html('<span class="note"></span>');
                }
            }

        }

        $("#date-input1").val('');
        $("#date-input2").val('');

        availability_selected_from = false;
        availability_selected_to = false;

        if (refresh) {
            $(".date-range-picker-holder").datepicker("refresh");
        } else {
            $(".date-range-picker-holder").datepicker();
        }
    });

    setTimeout(function() {
        availability_showing = false;

    }, 300);
    $(".availability-popup input[name=availability-popup-radio]:checked").trigger('change');
    $(".availability-popup select").trigger('change');
}

function hideAvailabilityPopup() {
    $("body").find('.load-layer').fadeOut('fast', function() {
        $("body").find('.load-layer').remove();
    });
    $(".availability-popup").fadeOut('fast', function() {
        availability_showing = false;
    });
}

function initAvailabilityCalendar() {

    fillAvailabilityCalendarVars();

    if ($(".company-form").length) {

        $("input[name='shortnotice']").unbind('change').bind('change', function() {
            fillAvailabilityCalendarVars();
            $(".date-range-picker-holder").datepicker("refresh");
        });
        $(".shortnotice-settings select").unbind('change').bind('change', function() {
            $("input[name='shortnotice']:eq(1)").trigger('click');
            fillAvailabilityCalendarVars();
            $(".date-range-picker-holder").datepicker("refresh");
        });
    }

    $.datepicker._updateDatepicker_original = $.datepicker._updateDatepicker;
    $.datepicker._updateDatepicker = function(inst) {
        $.datepicker._updateDatepicker_original(inst);
        var afterShow = this._get(inst, 'afterShow');
        if (afterShow)
            afterShow.apply((inst.input ? inst.input[0] : null));  // trigger custom callback
    }

    $(".date-range-picker-holder").datepicker({
        numberOfMonths: 3,
        dateFormat: "M d, yy",
        defaultDate: null,
        firstDay: 1,
        maxDate: new Date(new Date().getFullYear() + 3, 11, 31),
        minDate: new Date(new Date().getFullYear(), new Date().getMonth(), 1),

        beforeShowDay: function(date) {
            var date1 = $.datepicker.parseDate("M d, yy", $("#date-input1").val());
            var date2 = $.datepicker.parseDate("M d, yy", $("#date-input2").val());
            var selectable = false;
            var dt = dateToYYMMDD(date);

            var today = new Date();
            today.setHours(0,0,0,0);

            if (availability_available[dt]) {
                selectable = true;
            }

            var isHightlight =
                date1 && ((date.getTime() == date1.getTime()) || (date2 && date >= date1 && date <= date2));

            var limited = false;
            var uncertain = false;
            var cssclass="";
            if (selectable) {
                if (availability_unavailable[dt]) {
                    cssclass="dp-unavailable";
                } else if (availability_uncertain[dt]) {
                    cssclass="dp-uncertain";
                    uncertain = true;
                } else if (availability_limited[dt]) {
                    cssclass="dp-limited";
                    limited = true;
                }
                if (isHightlight) {
                    cssclass+=" dp-highlight";
                } else {
                    if (availability_selected_from && availability_selected_to && $(".availability-popup").is(":visible")) {
                        var date1_tmp = $.datepicker.parseDate("M d, yy", availability_selected_from);
                        var date2_tmp = $.datepicker.parseDate("M d, yy", availability_selected_to);

                        if (date >= date1_tmp && date <= date2_tmp) {
                            cssclass+=" dp-highlight";
                        }
                    }
                }
            }

            if (availability_shortnoticeblock[dt]) {
                cssclass += " sn-blocked";
            }

            if (date < today) {
                cssclass += " past";
            }

            date_counter++;

            if (limited) {
                limited_numbers[date_counter] = availability_limited[dt];
            }
            if (uncertain) {
                uncertain_numbers[date_counter] = 1;
            }

            return [selectable, cssclass];
        },
        afterShow: function() {
            $(".date-range-picker-holder").find(".ui-datepicker-today").find('a').removeClass('ui-state-highlight ui-state-active ui-state-hover');
            $(".date-range-picker-holder").find(".ui-datepicker-today").removeClass('ui-datepicker-days-cell-over ui-datepicker-current-day ui-datepicker-today');

            $(".date-range-picker-holder td").find("div").remove();
            $.each(limited_numbers, function(key, val) {
                if (val == 7) {
                    val = '7+';
                }
                $(".date-range-picker-holder").find("td:eq(" + (key - 1) + "):not(.ui-datepicker-other-month)").append('<div>' + val + '</div>');
            });
            $.each(uncertain_numbers, function(key, val) {
                $(".date-range-picker-holder").find("td:eq(" + (key - 1) + "):not(.ui-datepicker-other-month)").append('<div>?</div>');
            });
        },
        onSelect: function(dateText, inst) {
            var clicked_date = $.datepicker.parseDate("M d, yy", dateText);

            var found_range = false;
            $(".availability-options li").each(function() {
                var row = $(this);
                if ($(row).find(".availability-date-picker-from").length && $(row).find(".availability-date-picker-from").val() != '' && $(row).find(".availability-date-picker-to").val() != '') {
                    var date1 = $.datepicker.parseDate("M d, yy", $(this).find(".availability-date-picker-from").val());
                    var date2 = $.datepicker.parseDate("M d, yy", $(this).find(".availability-date-picker-to").val());

                    if (clicked_date >= date1 && clicked_date <= date2) {

                        $(".date-range-picker-holder").find('.ui-datepicker').find('td[data-handler="selectDay"]').each(function() {
                            var dt = $.datepicker.parseDate("d-m-yy", $(this).find('a').text() + '-' + (parseInt($(this).data('month')) + 1) + '-' + $(this).data('year'));
                            if ((dt >= date1 && dt <= date2) || (dt <= date1 && dt >= date2)) {
                                found_range = $(row).index();
                            }
                        });

                    }
                }
            });

            if (found_range !== false && $("#date-input1").val() == '') {
                showAvailabilityPopup(found_range);
            } else {
                var date1 = $.datepicker.parseDate("M d, yy", $("#date-input1").val());
                var date2 = $.datepicker.parseDate("M d, yy", $("#date-input2").val());
                var selectedDate = $.datepicker.parseDate("M d, yy", dateText);

                if (!date1 || date2) {
                    $("#date-input1").val(dateText);
                    $("#date-input2").val("");
                } else if (selectedDate < date1) {
                    $("#date-input2").val($("#date-input1").val());
                    $("#date-input1").val(dateText);
                } else {
                    $("#date-input2").val(dateText);
                }

                if ($("#date-input1").val() != '' && $("#date-input2").val() == '') {
                    $(document).on('keyup', function(e) {
                        if (e.keyCode === 27) {
                            if ($("#date-input1").val() != '' && $("#date-input2").val() == '') {
                                $("#date-input1").val('');
                                $(".date-range-picker-holder td.dp-highlight").removeClass('dp-highlight');
                            }
                        }
                    });
                }

                if ($("#date-input1").val() != '' && $("#date-input2").val() != '') {
                    showAvailabilityPopup();
                }

                $(this).datepicker();
            }
        },
        onChangeMonthYear: function() {
            date_counter = 0;
            limited_numbers = {};
            uncertain_numbers = {};

            availability_internal_note = false;
            handleAvailabilityInternalNote(false);
        }
    });

    $(".date-range-picker-holder").find(".ui-datepicker").addClass('ll-skin-cangas');
    $(".date-range-picker-holder").find(".ui-datepicker-current-day").removeClass('ui-datepicker-current-day');

    $(".date-range-picker-holder").find(".ui-datepicker-today").find('a').removeClass('ui-state-highlight ui-state-active ui-state-hover');

    $(".date-range-picker-holder").on('mousemove', 'td[data-handler="selectDay"] a', function(e){
        if ($("#date-input1").val() != '' && $("#date-input2").val() == '') {
            var date1 = $.datepicker.parseDate("M d, yy", $("#date-input1").val());
            var date2 = $.datepicker.parseDate("d-m-yy", $(this).text() + '-' + (parseInt($(this).closest('td').data('month')) + 1) + '-' + $(this).closest('td').data('year'));

            $(this).closest('.ui-datepicker').find('td[data-handler="selectDay"]').each(function() {
                var dt = $.datepicker.parseDate("d-m-yy", $(this).find('a').text() + '-' + (parseInt($(this).data('month')) + 1) + '-' + $(this).data('year'));
                if ((dt >= date1 && dt <= date2) || (dt <= date1 && dt >= date2)) {
                    $(this).addClass('dp-highlight');
                } else {
                    $(this).removeClass('dp-highlight');
                }
            });
        } else {
            var date = $.datepicker.parseDate("d-m-yy", $(this).text() + '-' + (parseInt($(this).closest('td').data('month')) + 1) + '-' + $(this).closest('td').data('year'));
            $(".date-range-picker-holder").find('.ui-datepicker').find('td[data-handler="selectDay"]').removeClass('dp-highlight');
            var found_range = false;
            $(".availability-options li").each(function() {
                var row = $(this);
                if ($(this).find(".availability-date-picker-from").length && $(this).find(".availability-date-picker-from").val() != '' && $(this).find(".availability-date-picker-to").val() != '') {
                    var date1 = $.datepicker.parseDate("M d, yy", $(this).find(".availability-date-picker-from").val());
                    var date2 = $.datepicker.parseDate("M d, yy", $(this).find(".availability-date-picker-to").val());

                    if (date >= date1 && date <= date2) {

                        availability_internal_note = $(this).find("select").next().val();
                        found_range = true;
                        $(".date-range-picker-holder").find('.ui-datepicker').find('td[data-handler="selectDay"]').each(function() {
                            var dt = $.datepicker.parseDate("d-m-yy", $(this).find('a').text() + '-' + (parseInt($(this).data('month')) + 1) + '-' + $(this).data('year'));
                            if ((dt >= date1 && dt <= date2) || (dt <= date1 && dt >= date2)) {
                                $(this).addClass('dp-highlight').addClass('dp-range');
                            } else {
                                $(this).removeClass('dp-highlight').addClass('dp-range');
                            }
                        });
                    }
                }
            });

            if (!found_range) {
                availability_internal_note = false;
            }
            handleAvailabilityInternalNote(e);

        }
    });

    $(".date-range-picker-holder").on('mousemove', '.ui-datepicker-unselectable:not(.ui-datepicker-other-month)', function(e) {
        if ($(this).hasClass('past')) {
            availability_internal_note = 'Blocked because this date is in the past';
        } else if ($(this).hasClass('sn-blocked')) {
            if ($("select[name='rates[shortnoticeperiod]']").length) {
                availability_internal_note = 'Blocked by the short-notice settings (you have blocked all start dates within ' + $("select[name='rates[shortnoticeperiod]']").val().replace('1 weeks', '1 week').replace('1 days', '1 day') + ' from today)';
            } else {
                availability_internal_note = 'Blocked by the short-notice settings (you have blocked all start dates within ' + $("select[name='rates_shortnoticeperiod']").val().replace('1 weeks', '1 week').replace('1 days', '1 day') + ' from today)';
            }
        } else {
            availability_internal_note = 'Blocked because you haven\'t provided rates for this start date';
        }

        handleAvailabilityInternalNote(e);
    });

    $(".date-range-picker-holder").on('mouseleave', '.ui-datepicker-unselectable:not(.ui-datepicker-other-month)', function(e) {
        availability_internal_note = false;

        handleAvailabilityInternalNote(e);
    });

    $(".date-range-picker-holder").on('mouseleave', '.ui-datepicker', function(e) {
        if ($("#date-input2").val() == '') {
            $(".date-range-picker-holder").find('td[data-handler="selectDay"]').each(function() {
                if (!$(this).find('a').hasClass('ui-state-active')) {
                    $(this).removeClass('dp-highlight');
                }
            });

            availability_internal_note = false;

            handleAvailabilityInternalNote(e);
        }
    });


    if ($(".company-form").length) {
        $(".availability-options .add-row a").unbind('click').bind('click', function () {
            $("#datesrates .availability-options li:nth-last-child(2)").clone().insertAfter("#datesrates .availability-options li:nth-last-child(2)");
            $("#datesrates .availability-options li:nth-last-child(2) a").removeClass('inactive');
            $("#datesrates .availability-options li:nth-last-child(2) input").removeClass('hasDatepicker').removeAttr('id').removeAttr('data-val').val('');
            $("#datesrates .availability-options li:nth-last-child(2)").removeClass('disabled');
            $("#datesrates .availability-options li:nth-last-child(2)").removeClass('expired');
            $("#datesrates .availability-options li:nth-last-child(2) span.expired").remove();
            if ($("#datesrates .availability-options li").length > 2) {
                $("#datesrates .availability-options li .remove-new").removeClass('inactive');
            }
        });
    }

}

function dateToYYMMDD(date) {
    var returnVal = '';
    returnVal = date.getFullYear();
    returnVal += '-';
    var m = date.getMonth();
    m = m + 1;
    if (m < 10) {
        m = '0' + m;
    }
    returnVal += m;
    var d = date.getDate();
    if (d < 10) {
        d = '0'+ d;
    }
    returnVal += '-';
    returnVal += d;

    return returnVal;
}

function dateToDateText(date) {
    var returnVal = '';
    var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];

    returnVal = months[date.getMonth()];
    returnVal += ' ' + date.getDate() + ', ' + date.getFullYear();

    return returnVal;
}

function dateTexttoDate(dateText) {
    var returnVal = '';
    var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
    if (dateText != '') {
        var parts = dateText.split(' ');
        if (parts.length >= 3) {
            var month = parts[0].substring(0, 3);
            var month_index = months.indexOf(month);
            if (month_index !== -1) {
                month_index++;
                if (month_index < 10) {
                    month_index = '0' + month_index;
                }
                var day = parts[1];
                day = day.replace(',', '');
                if (day < 10) {
                    day = '0' + day;
                }
                returnVal = parts[2];
                returnVal += '-' + month_index;
                returnVal += '-' + day;
            }
        }
    }
    return returnVal;
}