
	(function($){


		var Defaults = {
			default_first_open: true,
			multiple_open: false,
			use_hash: true,
			panel_selector: '.panel',
			title_selector: '.title',
			content_selector: '.content',
			slide_speed: 500
		}

		var AccordionApi = {

			extend: function(name, method) {
	            AccordionApi[name] = method;
	            return this;
	        },

	        init: function(PublicOptions){

	        	AccordionApi.opts = $.extend( {}, Defaults, PublicOptions );
	        	AccordionApi.parent = $(this);
	        	 return this.each(function() {
	        	 	if (!$(this).data("accordion_activated") == '1')
	        	 	{
	        	 		AccordionApi.createBindings();

						$(this).data("accordion_activated", "1");
	        	 	}
	        	 	// close all panels
					AccordionApi.initialClose();
	        	 });

	        },

	        createBindings: function(){
				var self = this;

				AccordionApi.parent.find(AccordionApi.opts.title_selector).on("click", function(e){

					// disable default link behavior if wanted
					if (!AccordionApi.use_hash)
						e.preventDefault();


					if (!$(this).parents(AccordionApi.opts.panel_selector).hasClass('inactive'))
					{
						if ($(this).parents(AccordionApi.opts.panel_selector).hasClass('open')){
							// panel is already open
							console.log("close");
							self.close($(this).parents(AccordionApi.opts.panel_selector));
						}
						else
						{
							// panel is closed
							self.close(AccordionApi.parent.find('.open'));
							self.open($(this).parents(AccordionApi.opts.panel_selector));
						}
					}
				});
			},

			initialClose: function(){
				var self = this;
				window.setTimeout(function(){
					AccordionApi.parent.find(AccordionApi.opts.content_selector).each(function(){
						$(this).data('orgheight', $(this).outerHeight());
						$(this).hide().parents(AccordionApi.opts.panel_selector).removeClass('open');
					});
					if (AccordionApi.default_first_open){
						// open first panel
						self.open(AccordionApi.parent.find(AccordionApi.opts.panel_selector).first());
					}
				},1);
			},

			calculateHeights: function(){
				var self = this;
				window.setTimeout(function(){
					AccordionApi.parent.find(AccordionApi.opts.content_selector).each(function(){
						if ($(this).outerHeight() > 10)
							$(this).data('orgheight', $(this).outerHeight());
					});
				},1);
			},

			open: function(el){
				var content = el.find(AccordionApi.opts.content_selector);
				el.addClass('open');
				AccordionApi.calculateHeights();
				content.slideDown(AccordionApi.opts.slide_speed);
				// content.animate({
				// 	'height': content.data('orgheight')
				// }, {duration: AccordionApi.opts.slide_speed});
			},

			close: function(el){
				var content = el.find(AccordionApi.opts.content_selector);
				el.removeClass('open');
				AccordionApi.calculateHeights();
				content.slideUp(AccordionApi.opts.slide_speed);
				// content.animate({
				// 	'height': '0px'
				// }, {duration: AccordionApi.opts.slide_speed});
			}

		}

		var pluginName = 'accordion';

		$.fn.accordion = function(method) {



	        if (AccordionApi[method]) {
	            return AccordionApi[method].apply(this, Array.prototype.slice.call(arguments, 1));
	        } 
	        else if (typeof method === 'object' || !method) {
	            return AccordionApi.init.apply(this, arguments);
	        } 
	        else {
	            $.error('Method ' + method + 'does not exist');
	        }
	    };





















	    /*
		$.fn.accordion = function(options){

			var opts = $.extend( {}, $.fn.accordion.defaults, options );

			return this.each(function(){
				var parent = $(this);

				var plugin = {
					init: function(){
						this.createBindings();
							// close all panels
							this.initialClose();
					},

					createBindings: function(){
						var self = this;

						parent.find(opts.title_selector).on("click", function(e){

							// disable default link behavior if wanted
							if (!opts.use_hash)
								e.preventDefault();

							if (!$(this).parents(opts.panel_selector).hasClass('inactive'))
							{
								if ($(this).parents(opts.panel_selector).hasClass('open')){
									// panel is already open
									self.close($(this).parents(opts.panel_selector));
								}
								else
								{
									// panel is closed
									self.close(parent.find('.open'));
									self.open($(this).parents(opts.panel_selector));
								}
							}
						});
					},

					initialClose: function(){
						var self = this;
						window.setTimeout(function(){
							parent.find(opts.content_selector).each(function(){
								$(this).data('orgheight', $(this).outerHeight());
								$(this).css({
									'height': '0px'
								}).parents(opts.panel_selector).removeClass('open');
							});
							if (opts.default_first_open){
								// open first panel
								self.open(parent.find(opts.panel_selector).first());
							}
						},1);
					},

					calculateHeights: function(){
						var self = this;
						window.setTimeout(function(){
							parent.find(opts.content_selector).each(function(){
								if ($(this).outerHeight() > 10)
									$(this).data('orgheight', $(this).outerHeight());
							});
						},1);
					},

					open: function(el){
						var content = el.find(opts.content_selector);
						el.addClass('open');
						this.calculateHeights();
						content.animate({
							'height': content.data('orgheight')
						}, {duration: opts.slide_speed});
					},

					close: function(el){
						var content = el.find(opts.content_selector)
						el.removeClass('open');
						this.calculateHeights();
						content.animate({
							'height': '0px'
						}, {duration: opts.slide_speed});
					}
				}

				plugin.init();

			});

		};

		$.fn.accordion.defaults = {
			default_first_open: true,
			multiple_open: false,
			use_hash: true,
			panel_selector: '.panel',
			title_selector: '.title',
			content_selector: '.content',
			slide_speed: 500
		}
		*/

		$(document).ready(function(){

			$(".accordion").data('plugin_scope', $(".accordion").accordion({
					use_hash: false,
					slide_speed: 250,
					default_first_open: false
				}));
		});


	})(jQuery)