	/*************************************************
	*	
	*
	*	<script type="text/javascript">
	*		$(document).ready(function(){
	*			$(".icon.info").balloon({
	*				max_height: 300
	*			});
	*
	*			$(".helper-link").balloon({
	*				max_height: 300
	*			});
	*		});
	*	</script>
	*
	*
	*
	*
	*************************************************/

	// Plugin definition.
	$.fn.balloon = function( options ) {
	 
	    // Extend our default options with those provided.
	    // Note that the first argument to extend is an empty
	    // object – this is to keep from overriding our "defaults" object.
	    var opts = $.extend( {}, $.fn.balloon.defaults, options );
	    // Our plugin implementation code goes here.

	    return this.each(function() {
	    	
	    	var plugin = {
		    	config: {

		    	},

		    	init: function(el){
		    		this.el = $(el);

		    		var self = this;
		    		
		    		$( document ).on( "mousemove", function( event ) {
		    			self.config.mousex = event.pageX;
						self.config.mousey = event.pageY;
					});


		    		// check if parent contains multiple words
		    		if (this.el.text().split(" ").length -1)
		    		{
		    			self.config.MultipleWords = true;
		    		}
		    		else
		    		{
		    			self.config.MultipleWords = false;
		    		}

		    		if (self.el.attr('initialized')) {
    		    		return;
		    		}
                    self.el.attr('initialized', 1);		    		

		    		self.handlePopupHover();
		    		
		    		// save default values
		    		self.config.content = self.el.data(opts.content_attr);

		    		// title fallback
		    		if (typeof self.config.content === 'undefined') 
	    			{
	    				self.config.content = self.el.prop('title');
	    				self.el.attr('data-content', self.config.content);
	    			}

	    			self.el.attr('title', '');
	    			
		    		self.config.hasTouch = !!('ontouchstart' in window);
		    		
		    		// handle Hover

		    		self.el
		    				.on('mouseover', function(e){
		    					if (self.el.hasClass('help')) {
                                    clearTimeout(self.timerRemove);
                                    self.set_dimensions();
                                    self.show();
                                }
		    				})
		    				.on('mouseleave', function(){
		    					self.remove();
		    					clearTimeout(self.timerShow);
		    				})
		    				.on('click', function(e){
                                if (self.el.hasClass('help')) {
                                    e.stopPropagation();
                                    e.preventDefault();
                                    clearTimeout(self.timerRemove);
                                    self.set_dimensions();
                                    self.show();
                                }
		    				});

		    		if (self.config.hasTouch)
		    		{
		    			self.el
	    					.on('touchstart', function(){
                                if (self.el.hasClass('help')) {
                                    clearTimeout(self.timerRemove);
                                    self.set_dimensions();
                                    self.show();
                                }
	    					});
		    		}

		    		

		    	},

		    	handlePopupHover: function(){
		    		var self = this;
		    		$("body")
		    				.on("mouseenter", ".balloon-outer", function(){
				    			clearTimeout(self.timerRemove);
				    		})
				    		.on("mouseleave", ".balloon-outer", function(){
				    			self.remove();
				    		});
		    	},

		    	show: function(){

		    		var self = this;

		    		if (self.status != 'showing' && self.el.attr('initialized'))
		    		{
		    			if (opts.show_delay)
		    			{
		    				self.timerShow = setTimeout(function(){
		    					self.show_now();
		    				}, opts.show_delay);
		    			}
		    			else
		    			{
		    				self.show_now();
		    			}
		    		}
		    	},

		    	show_now: function(){

		    		var self = this;
		    		if (self.status != 'showing')
		    		{
		    			$(".balloon-outer").remove();
		    			self.tooltip = $('<div class="balloon-outer opening" style="background: #ccc; position: absolute; left: 0; top: 0; display: none;"><div class="balloon-content clearfix">'+self.config.content+'</div></div>');
		    			self.tooltip.addClass('opening');
		    			$("body").append(self.tooltip);
		    			self.calc_counter = 0;
		    			self.set_dimensions();
		    			self.set_positions();
		    			self.tooltip.show();
		    			self.tooltip.removeClass('opening');
		    			self.status = 'showing';
		    			
		    		}
		    	},

		    	remove: function(){

		    		var self = this;
		    		if (self.status == 'showing')
					{
						if (opts.hide_delay)
						{
							self.timerRemove = setTimeout(function(){
		    					self.remove_now();
		    				}, opts.hide_delay);
						}
					}
		    	},

		    	remove_now: function(){

		    		var self = this;

		    		if (self.status == 'showing')
					{
						self.tooltip.remove();
						self.status = 'removed';
					}
		    	},

		    	set_dimensions: function(){
		    		// calculate dimensions and stre in config object
		    		var self = this;

		    		// get scrolltop
		    		self.config.dimensions = {
		    			page_height: $("body").height(),
		    			page_width: $("body").width(),
		    			screenwidth: $(document).width(),
		    			screenheight: $(document).height(),
		    			parent_width: self.el.width(),
		    			parent_height: self.el.height(),
		    			parent_offset_top: self.el.offset().top,
		    			parent_offset_left: self.el.offset().left,
		    			scrolltop: $(window).scrollTop(),
		    			scrollleft: $(window).scrollLeft()
		    		};

		    		if (self.config.MultipleWords)
		    		{
		    			// position balloon relative to mouse position
		    			self.config.dimensions.space_above = self.config.mousey - self.config.dimensions.scrolltop;
			    		self.config.dimensions.space_below = self.config.dimensions.page_height - self.config.dimensions.space_above - self.el.height();
			    		self.config.dimensions.space_left = self.config.mousex - self.config.dimensions.scrollleft;
			    		self.config.dimensions.space_right = self.config.dimensions.page_width - self.config.dimensions.space_left - self.el.width();

			    		self.config.dimensions.parent_offset_left = self.config.mousex;
			    		self.config.dimensions.parent_width = 0;

			    		self.config.dimensions.parent_offset_top = self.config.mousey;
			    		self.config.dimensions.parent_height = 0;
		    		}
		    		else
		    		{
		    			// position balloon relative to parent
		    			self.config.dimensions.space_above = self.config.dimensions.parent_offset_top - self.config.dimensions.scrolltop;
			    		self.config.dimensions.space_below = self.config.dimensions.page_height - self.config.dimensions.space_above - self.el.height();
			    		self.config.dimensions.space_left = self.config.dimensions.parent_offset_left - self.config.dimensions.scrollleft;
			    		self.config.dimensions.space_right = self.config.dimensions.page_width - self.config.dimensions.space_left - self.el.width();
		    		}

		    		

		    	},

		    	set_positions: function(){
		    		var self = this;

		    		// check if width is bigger then 400, if so set width to 400
		    		if (self.tooltip.width() > 400)
		    		{
		    			self.tooltip.width(400);
		    		}
		    		if (self.tooltip.height() > 100)
		    		{
		    			self.tooltip.width(400);
		    		}

		    		if (typeof self.el.data('balloon-width') !== 'undefined')
		    		{
		    			self.tooltip.width(self.el.data('balloon-width'));
		    		}

		    		var width = self.tooltip.width();
		    		var height = self.tooltip.height();

		    		// horizontal
		    		if (width < self.config.dimensions.space_right)
		    		{
		    			// toon rechts van parent
		    			self.tooltip.css({
		    				'left': self.config.dimensions.parent_offset_left + self.config.dimensions.parent_width + opts.pos.left+'px'
		    			});
		    		}
		    		else if (width < self.config.dimensions.space_left)
		    		{
		    			// toon links van parent
		    			self.tooltip.css({
		    				'left': self.config.dimensions.parent_offset_left - self.tooltip.width() - opts.pos.left +'px'
		    			});
		    		}
		    		else
		    		{
		    			// toon links van scherm met marge van 10px
		    			self.tooltip.css({
		    				'left': self.config.dimensions.scrollleft+ 10 +'px'
		    			});
		    		}


		    		// vertical
		    		if (height < self.config.dimensions.space_below)
		    		{
		    			self.tooltip.css({
		    				'top': self.config.dimensions.parent_offset_top + self.config.dimensions.parent_height + opts.pos.top+'px'
		    			});
		    		}
		    		else if (height < self.config.dimensions.space_above)
		    		{
		    			self.tooltip.css({
		    				'top': self.config.dimensions.parent_offset_top - self.tooltip.height() - opts.pos.top+'px'
		    			});
		    		}
		    		else
		    		{
		    			self.tooltip.css({
		    				'top': self.config.dimensions.scrolltop + 10 + 'px'
		    			});	
		    		}

		    	}

		    };


	    	plugin.init(this);
	    });
	 
	};
	 
	// Plugin defaults – added as a property on our plugin function.
	$.fn.balloon.defaults = {
	    content_attr: 'content',
	    step: 100,
	    max_height: 1200,
	    max_column_width: 400,
	    pos: {
	    	abs_left: 20,
	    	left: 3,
	    	top: 3
	    },
	    show_delay: 500,
	    hide_delay: 500
	};