
	var Problembox = function(){

		var problem_box;
		var problem_box_holder;
		var open_button;
		var send_button;
		var close_button;
		var cancel_button;
		var form_close_button;
		var form;
		var errors;
		var isPosting = false;

		return {
			init: function(){
				problem_box = $(".problem-box");
				problem_box_holder = $(".problem-box-holder");
				open_button = problem_box.find(".open-button");
				close_button = problem_box.find(".btn-close");
				cancel_button = problem_box.find(".btn-cancel");
				send_button = problem_box.find(".sb-button.submit");
				form_close_button = problem_box.find(".btn-close-form");
				form = problem_box.find(".form form");
				name_input = problem_box.find('input[type=text]').eq(0);
				mail_input = problem_box.find('input[type=text]').eq(1);
				message_input = problem_box.find('textarea');
				this.handleButtons();
				this.handleFields();
				this.handlePrefills();
			},
			handleError: function() {
    			if (problem_box.hasClass('mail-operator')) {
        			return;
    			}
    			Problembox.errors = false;
    			if (problem_box.find('.error').length) {
        			Problembox.errors = true;
        			if (!send_button.parent().find('div').length) {
            			send_button.parent().prepend('<div class="overall-error-msg">Please fix the errors above by providing or correcting the requested information</div>');
                    } else {
                        send_button.parent().find('div').show();
                    }
                    send_button.addClass('inactive');
    			} else {
        		    if (send_button.parent().find('div').length) {
            		    send_button.parent().find('div').slideUp('fast', function() {
                            send_button.parent().find('div').remove();
            		    });
        		    }	
                    send_button.removeClass('inactive');
    			}
			},
			handleFields: function(){
    			if (problem_box.hasClass('mail-operator')) {
        			return;
    			}
    			name_input.bind('blur', function() {
        			if (name_input.val() == '') {
            		    name_input.next().html('Please provide your name').removeClass('solved').addClass('error').show();
            		    name_input.addClass('error');
        			} else {
            		    name_input.removeClass('error');
            			if (name_input.next().html() != '') {
                		    name_input.next().html('Solved').removeClass('error').addClass('solved');
                		    setTimeout(function() {
                                name_input.next().fadeOut('normal', function() {
                                    name_input.next().html('').removeClass('error').removeClass('solved');
                                });
                		    }, 3000);
            			}
        			}
        		    Problembox.handleError();
    			}).bind('keyup', function() {
        			if (name_input.next().hasClass('error')) {
            		    if (name_input.val() != '') {
                		    name_input.removeClass('error');
                			if (name_input.next().html() != '') {
                    		    name_input.next().html('Solved').removeClass('error').addClass('solved');
                    		    setTimeout(function() {
                                    name_input.next().fadeOut('normal', function() {
                                        name_input.next().html('').removeClass('error').removeClass('solved');
                                    });
                    		    }, 3000);
                			}
            		    }	
                        Problembox.handleError();
                    }
    			});
    			mail_input.bind('blur', function() {
        			var mailval = mail_input.val();
        			var mailtest = /^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))$/i.test(mailval);
        			
        			if (mail_input.val() == '') {
            		    mail_input.next().html('Please provide your email').removeClass('solved').addClass('error').show();
            		    mail_input.addClass('error');
        			} else if (!mailtest) {
            		    mail_input.next().html('Invalid email address').removeClass('solved').addClass('error').show();
            		    mail_input.addClass('error');
        			} else {
            		    mail_input.removeClass('error');
            			if (mail_input.next().html() != '') {
                		    mail_input.next().html('Solved').removeClass('error').addClass('solved');
                		    setTimeout(function() {
                                mail_input.next().fadeOut('normal', function() {
                                    mail_input.next().html('').removeClass('error').removeClass('solved');
                                });
                		    }, 3000);
            			}
        			}
                    Problembox.handleError();
    			}).bind('keyup', function() {
        			if (mail_input.next().hasClass('error')) {
            			var mailval = mail_input.val();
            			var mailtest = /^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))$/i.test(mailval);
            			if (mailtest) {
                		    mail_input.removeClass('error');
                			if (mail_input.next().html() != '') {
                    		    mail_input.next().html('Solved').removeClass('error').addClass('solved');
                    		    setTimeout(function() {
                                    mail_input.next().fadeOut('normal', function() {
                                        mail_input.next().html('').removeClass('error').removeClass('solved');
                                    });
                    		    }, 3000);
                			}
            			}
                        Problembox.handleError();
        			}
    			});
    			message_input.bind('blur', function() {
        			if (message_input.val() == '') {
            		    message_input.parent().parent().find('span').html('Please provide a message').removeClass('solved').addClass('error').show();
            		    message_input.addClass('error');
        			} else {
            		    message_input.removeClass('error');
            			if (message_input.parent().parent().find('span').html() != '') {
                		    message_input.parent().parent().find('span').html('Solved').removeClass('error').addClass('solved');
                		    setTimeout(function() {
                                message_input.parent().parent().find('span').fadeOut('normal', function() {
                                    message_input.parent().parent().find('span').html('').removeClass('error').removeClass('solved');
                                });
                		    }, 3000);
            			}
        			}
                    Problembox.handleError();
    			}).bind('keyup', function() {
        			if (message_input.parent().parent().find('span').hasClass('error')) {
            		    if (message_input.val() != '') {
                		    message_input.removeClass('error');
                			if (message_input.parent().parent().find('span').html() != '') {
                    		    message_input.parent().parent().find('span').html('Solved').removeClass('error').addClass('solved');
                    		    setTimeout(function() {
                                    message_input.parent().parent().find('span').fadeOut('normal', function() {
                                        message_input.parent().parent().find('span').html('').removeClass('error').removeClass('solved');
                                    });
                    		    }, 3000);
                			}
            		    }	
                        Problembox.handleError();
                    }
    			});
			},
			handlePrefills: function() {
    			if (!problem_box.hasClass('mail-operator')) {
        			return;
    			}
    			problem_box.on('click', 'input[name=email_all]', function() {
					var mailRowHeightBefore;
					var mailRowHeightAfter;
    				if($(this).is(":checked")) {
						mailRowHeightBefore = $("div.row.mail-operator-contacts").outerHeight();
    					$("div.row.mail-operator-contacts").hide();
						$("div.row.mail-operator-contacts-all").show();
						mailRowHeightAfter = $("div.row.mail-operator-contacts-all").outerHeight();
					} else {
						mailRowHeightBefore = $("div.row.mail-operator-contacts-all").outerHeight();
						$("div.row.mail-operator-contacts").show();
						$("div.row.mail-operator-contacts-all").hide();
						mailRowHeightAfter = $("div.row.mail-operator-contacts").outerHeight();
					}
					if(mailRowHeightBefore !== mailRowHeightAfter) {
						$('#mail-operator-txt').css('height', $('#mail-operator-txt').height()+mailRowHeightBefore-mailRowHeightAfter);
						$('#mail-operator-txt_lbl').css('height', $('#mail-operator-txt_lbl').height()+mailRowHeightBefore-mailRowHeightAfter);
						$('#mail-operator-txt_ifr').css('height', $('#mail-operator-txt_ifr').height()+mailRowHeightBefore-mailRowHeightAfter);
					}
				});
    			problem_box.find('.inserts a').bind('click', function() {


    				var operator_top_location = function() {
    					var loc = top.location.href;
    					if (loc.indexOf("#")>=0)
    						loc = loc.split("#")[0];
						if (loc.indexOf("?")>=0)
							loc = loc.split("?")[0];
						return loc;
					}


    				var $tab_page_title_strong = $(".tab_page_title strong");

    				$signup_status = $("#signup_status");
    				if (!$signup_status.length)
						$signup_status = null

					if ($signup_status)
						$signup_status.val("");

					$canned_response = $("#canned_response");
					if (!$canned_response.length)
						$canned_response = null

					if ($canned_response)
						$canned_response.val("");

					tinyMCE.activeEditor.setContent('');

    				var names = problem_box.find('form').attr('data-val1');
    				if($("input[name=email_all]").is(":checked")) {
						names = problem_box.find('form').attr('data-val3');
					}
        			if ($(this).hasClass('mail-declined')) {
            		    $("#mail-operator-subject").val('Tour declined: ' + $tab_page_title_strong.text() + ' (' + Problembox.getOperatorName() + ')');
            		    tinyMCE.activeEditor.setContent('Hi ' + names + ',<br /><br />We\'ve just checked your tour: <b>' + $tab_page_title_strong.text() + '</b>. We\'re sorry, but we\'ve had to decline it. The issues that need to be fixed in order to get the tour approved are:<br /><br /><ul><li>&nbsp;</li></ul><br />You can edit and resubmit your tour by opening this link:<br /><a style="color: #015580;" href="' + operator_top_location() + '" target="_blank" style="color: #015580; text-decoration: underline;">' + operator_top_location() + '</a><br /><br />If you have questions or feedback, please let me know.<br /><br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />' + tinyMCE.activeEditor.getContent());
        			}
        			if ($(this).hasClass('mail-approved')) {
            		    $("#mail-operator-subject").val('Tour checked: ' + $tab_page_title_strong.text() + ' (' + Problembox.getOperatorName() + ')');
            		    tinyMCE.activeEditor.setContent('Hi ' + names + ',<br /><br />We\'ve just checked your tour: <b><a style="color: #015580;" href="' + $(".tab_page_title a.open_on_AfricaGoTrips").attr('href') + '" target="_blank" style="color: #015580; text-decoration: underline;">' + $tab_page_title_strong.text() + '</a></b>. Although we approved it, we have some tips that will improve the ranking of your tour in our directory: <br /><br /><ul><li>&nbsp;</li></ul><br />You can edit and resubmit your tour by opening this link:<br /><a style="color: #015580;" href="' + operator_top_location() + '" target="_blank" style="color: #015580; text-decoration: underline;">' + operator_top_location() + '</a><br /><br />If you have questions or feedback, please let me know.<br /><br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />' + tinyMCE.activeEditor.getContent());
        			}
        			if ($(this).hasClass('mail-deactivated')) {
            		    $("#mail-operator-subject").val('Tour deactivated: ' + $tab_page_title_strong.text() + ' (' + Problembox.getOperatorName() + ')');
            		    tinyMCE.activeEditor.setContent('Hi ' + names + ',<br /><br />We\'ve just deactivated your tour: <b>' + $tab_page_title_strong.text() + '</b>.<br /> <br /> You can manage your tours at: <a style="color: #015580;" href="'+$sb.url_root+'" target="_blank" style="color: #015580; text-decoration: underline;">'+$sb.url_root+'</a><br /><br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />' + tinyMCE.activeEditor.getContent());
        			}
        			if ($(this).hasClass('mail-deleted')) {
            		    $("#mail-operator-subject").val('Tour deleted: ' + $tab_page_title_strong.text() + ' (' + Problembox.getOperatorName() + ')');
            		    tinyMCE.activeEditor.setContent('Hi ' + names + ',<br /><br />We\'ve just deleted this tour: <b>' + $tab_page_title_strong.text() + '</b>.<br /><br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />' + tinyMCE.activeEditor.getContent());
        			}
        			if ($(this).hasClass('mail-websiteoffline')) {
            		    $("#mail-operator-subject").val('[PRIO] We\'ve temporarily suspended your AfricaGoTrips account - ' + Problembox.getOperatorName());
						var website = '';
						if($('input[name=company_url]').length) {
							website = $('input[name=company_url]').val();
						} else if($('output[name=website]').length) {
							website = $('output[name=website]').val();
						}
						if (website != '' && website.substring(0, 4) != 'http') {
							website = 'http://' + website;
						}
            		    tinyMCE.activeEditor.setContent('Dear ' + names + ',<br /><br />We\'ve temporarily suspended your AfricaGoTrips account.<br /><br /><b>Why has your account been suspended?</b><br />We\'ve suspended your account because your website is offline (' + website + ') This could be an indicator that you\'re not operational and won\'t be able to respond to new quote requests.<br /><br /><b>How to reactivate your account?</b><br />Reactivating your account is easy. Just email me when your website is up and running again and we\'ll reactivate your account.<br /><br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />' + tinyMCE.activeEditor.getContent());
        			}
        			if ($(this).hasClass('mail-backlink')) {
            		    $("#mail-operator-subject").val('[PRIO] We have temporarily suspended your AfricaGoTrips account - ' + Problembox.getOperatorName());
            		    tinyMCE.activeEditor.setContent('Dear ' + names + ',<br /><br />We have temporarily suspended your AfricaGoTrips account.<br /><br /><b>Why has your account been suspended?</b><br />At the time you applied for an account, you agreed to include a link to AfricaGoTrips.com on the \'About Us\' page of your website (or a similar page). We periodically check to see if the link is still there, and currently it\'s not.<br /><br />We emailed you regarding this a couple of weeks ago, but, unfortunately, we didn\'t hear back from you. Therefore, we\'ve temporarily suspended your AfricaGoTrips account.<br /><br /><b>We would appreciate it if you would add the link again.</b><br />You can, for example, add the link by mentioning you are represented on AfricaGoTrips.com and make the word \'AfricaGoTrips.com\' a working link that opens our homepage. Please let me know when you\'ve done this.<br /><br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />' + tinyMCE.activeEditor.getContent());
        			}
        			if ($(this).hasClass('mail-backlinkwarning')) {
            		    $("#mail-operator-subject").val('[SB] Your link to AfricaGoTrips.com - ' + Problembox.getOperatorName());
            		    tinyMCE.activeEditor.setContent('Dear ' + names + ',<br /><br />At the time you applied for an account, you agreed to include a link to AfricaGoTrips.com on the \'About Us\' page of your website (or a similar page).<br /><br />We periodically check to see if the link is still there, and currently it\'s not. Would you please be so kind to add the link back to your \'About Us\' page? Also, can you please do so within two weeks from today?<br /><br />You can, for example, add the link by mentioning you are represented on AfricaGoTrips.com and make the word \'AfricaGoTrips.com\' a working link that opens our homepage.<br /><br />If you need more time than two weeks to add the link, please let me know.<br /><br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />' + tinyMCE.activeEditor.getContent());
        			}
        			if ($(this).hasClass('mail-office')) {
            		    $("#mail-operator-subject").val('[SB] Question about your offices - ' + Problembox.getOperatorName());
            		    tinyMCE.activeEditor.setContent('Dear ' + names + ',<br /><br />We noticed that in your company profile you listed a <strong>#ENTER COUNTRY HERE#</strong> office. We would like to verify this office meets our requirements for listing additional offices on AfricaGoTrips.<br /><br />The requirements are:<br /><ul><li>Independent/freelance representatives, who also work for other operators, may not be listed as an office.</li><li>The office must be fully registered and under the same company name (or a very similar name). </li><li>The office must have people working there who either handle enquiries or are part of your ground operations for running tours.</li><li>Clients must be able to contact the additional office directly through email, phone AND postal mail.</li></ul><br />If your office qualifies, we would kindly ask you to send us an email in which you confirm your office meets the requirements listed above and provide the following information:<br /><ul><li>A certificate of incorporation (or equivalent) for your additional office.</li><li><strong>#REMOVE THIS BULLET FOR NON-WESTERN COUNTRIES#</strong> A link to the web page of the government\'s company register (or similar online resource) where we can verify your incorporation.</li></ul><br />Once we\'ve received your confirmation and requested info, we\'ll add your office to your company profile again.<br /><br />You can edit your company profile by opening this link:<br /><a style="color: #015580;" href="'+backend_url('company/edit', null, true)+'" target="_blank" style="color: #015580; text-decoration: underline;">'+backend_url('company/edit', null, true)+'</a><br /><br />If you have any questions or feedback, please let me know.<br /><br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />' + tinyMCE.activeEditor.getContent());
        			}
					if ($(this).hasClass('address-incomplete')) {
						$("#mail-operator-subject").val('[SB] Question about your company profile - ' + Problembox.getOperatorName());
						tinyMCE.activeEditor.setContent('Dear ' + names + ',<br /><br />I was going through your company profile and noticed that the address information for your office(s) is incomplete. Could you please provide a complete address for your company profile on AfricaGoTrips.com?<br /><br />You can edit your company profile by opening this link:<br /><a style="color: #015580;" href="'+backend_url('company/edit', null, true)+'" target="_blank" style="color: #015580; text-decoration: underline;">'+backend_url('company/edit', null, true)+'</a><br /><br />If you have any questions or feedback, please let me know.<br /><br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />' + tinyMCE.activeEditor.getContent());
					}
                    if ($(this).hasClass('mail-companyphoto')) {
                        $("#mail-operator-subject").val('[SB] Question about your company photo - ' + Problembox.getOperatorName());
                        tinyMCE.activeEditor.setContent('Dear ' + names + ',<br /><br />I was going through your company profile and noticed that the photo you have used does not meet our requirements. Photos that show clients or only animals/scenery are not allowed because the photo should visually represent your company. For example, a photo of the owners or your team in (or in front of) your office, the bush, city park, garden, or in front of one or all of your safari vehicles. It works best if everybody in the photo is smiling, wears the same outfit, and the photo should be taken when the sunlight is not too strong.<br /><br />We highly recommend hiring a professional photographer because a professional photo will increase the credibility of your company. The photo can also be used for your own website and we believe is well worth the investment.<br />Examples of professional photos:<br /><a style="color: #015580;" href="'+backend_url('good-company-profile-photos',null, true)+'" target="_blank" style="color: #015580; text-decoration: underline;">'+backend_url('good-company-profile-photos', null, true)+'</a><br /><br />We have removed your photo from your company profile, and we would appreciate you uploading a new photo that meets the criteria explained above, as soon as possible.<br /><br />You can edit your company profile by opening the following link:<br /><a style="color: #015580;" href="'+backend_url('company/edit', null, true)+'" target="_blank" style="color: #015580; text-decoration: underline;">https://operators.AfricaGoTrips.com/company/edit</a><br /><br />If you have any questions or feedback, please let me know.<br /><br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />' + tinyMCE.activeEditor.getContent());
                    }
        			if ($(this).hasClass('mail-priceranges')) {
            		    $("#mail-operator-subject").val('[SB] Question about your price ranges - ' + Problembox.getOperatorName());
            		    tinyMCE.activeEditor.setContent('Dear ' + names + ',<br /><br />I was going through your company profile information and noticed the amounts you added into your price ranges were inconsistent and possibly wrong:<br /><br /><ul><li>.</li></ul><br />Can you please check your price ranges? You can edit your company profile by opening this link:<br /><a style="color: #015580;" href="'+backend_url('company/edit', null, true)+'" target="_blank" style="color: #015580; text-decoration: underline;">'+backend_url('company/edit', null, true)+'</a><br /><br />If you have any questions or feedback, please let me know.<br /><br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />' + tinyMCE.activeEditor.getContent());
        			}
        			if ($(this).hasClass('mail-general')) {
						$("#mail-operator-subject").val('[SB] Question about your company profile - ' + Problembox.getOperatorName());
						tinyMCE.activeEditor.setContent('Dear ' + names + ',<br /><br />I was going through your company profile information and noticed ...<br /><br />You can edit your company profile by opening this link:<br /><a style="color: #015580;" href="'+backend_url('company/edit', null, true)+'" target="_blank" style="color: #015580; text-decoration: underline;">'+backend_url('company/edit', null, true)+'</a><br /><br />If you have any questions or feedback, please let me know.<br /><br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />' + tinyMCE.activeEditor.getContent());
					}
					if ($(this).hasClass('mail-noafricatours')) {
						$("#mail-operator-subject").val('[SB] Regarding Your Application ('+ Problembox.getOperatorName()+')');
						tinyMCE.activeEditor.setContent(
							'Dear '+Problembox.getFirstName()+",<br /><br />" +
							'Thank you for your interest in partnering with AfricaGoTrips. Unfortunately, we cannot proceed with your application for a AfricaGoTrips account because we are not active in your beautiful country.<br />'+
							'<br />'+
							'We only accept tour operators who offer tours to at least one of the countries below:<br />'+
							'<ul><li>Botswana</li><li>Comoros</li><li>Congo (Brazzaville)</li><li>Congo (DRC)</li><li>Djibouti</li><li>Eswatini (formerly Swaziland)</li><li>Ethiopia</li><li>Kenya</li><li>Lesotho</li><li>Madagascar</li><li>Malawi</li><li>Mauritius</li>'+
							'<li>Mayotte</li><li>Mozambique</li><li>Namibia</li><li>Réunion</li><li>Rwanda</li><li>Seychelles</li><li>South Africa</li><li>Tanzania</li><li>Uganda</li><li>Zambia</li><li>Zimbabwe</li></ul>'+
							'<br />'+
							'We wish you and your company all the best for the future.<br />'+
							'<br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />'+tinyMCE.activeEditor.getContent());
					}
					if ($(this).hasClass('mail-accommodation')) {
						$("#mail-operator-subject").val('[SB] Regarding Your Application ('+ Problembox.getOperatorName()+')');
						tinyMCE.activeEditor.setContent(
							'Dear '+Problembox.getFirstName()+",<br /><br />" +
							'Thank you for your interest in partnering with AfricaGoTrips. Please be advised that we only accept accommodations for listing on our website if they qualify as tour operators. Your accommodation must be able to offer complete tour packages. Offering complete tour packages means that you should be able to take care of clients from the moment they arrive at the international airport to the moment they are dropped off at the airport for their flight back home. This means that you should be able to arrange the following services:<br />'+
							'<ol><li>Round-trip airport transfer from the international airport which is used as an entry point to your country</li><li>Overnight accommodation in/near the international airport where clients enter/leave the country</li><li>All connecting road and air transfers during the tour</li></ol>'+
							'If you are able to offer complete tour packages, we welcome you to add your accommodation as a tour operator to AfricaGoTrips. Please let me know if you offer the services mentioned above.<br />'+
							'<br /><b>List your accommodation</b><br />'+
							'Besides being listed as a tour operator, we also offer the option to list your accommodation separately on AfricaGoTrips. You can upload additional information and pictures for your accommodation. If you are interested in that option, please email <a style="color: #015580;" href="mailto:accommodations@AfricaGoTrips.com">accommodations@AfricaGoTrips.com</a>.<br />'+
							'<br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />'+tinyMCE.activeEditor.getContent());
					}
					if ($(this).hasClass('mail-website')) {
						$("#mail-operator-subject").val('[SB] Regarding Your Application ('+ Problembox.getOperatorName()+')');
						tinyMCE.activeEditor.setContent(
							'Dear '+Problembox.getFirstName()+",<br /><br />" +
							'Thank you for your interest in partnering with AfricaGoTrips. We are sorry but we cannot proceed with your application because your website appears to be offline (or incomplete).<br />'+
							'<br />'+
							'We have rejected your application but you can apply again via our <a style="color: #015580;" href="https://www.AfricaGoTrips.com/partner-options">partner options page</a> once your website is up and running.<br />'+
							'<br />We hope to hear from you soon.<br />'+
							'<br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />'+tinyMCE.activeEditor.getContent());
					}
					if ($(this).hasClass('mail-missinginfo')) {

						if ($signup_status)
							$signup_status.val("Waiting");

						if ($canned_response)
							$canned_response.val("missinginfo");

						$("#mail-operator-subject").val('[SB] Regarding Your Application ('+ Problembox.getOperatorName()+')');
						tinyMCE.activeEditor.setContent(
							'Dear '+Problembox.getFirstName()+",<br /><br />" +
							'I am sorry to inform you that we cannot proceed with your application because the following documents were not included in your application:<br />'+
							'<br />'+
							'<ul><li>The passport of the company owner</li><li>Your tour operator license</li><li>Your business registration papers</li><li>Your tax authority registration papers</li></ul>'+
							'<br />Can you please email me a digital copy of these documents in JPEG or PDF format?<br /><br />'+
							'<br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />'+tinyMCE.activeEditor.getContent());
					}
					if ($(this).hasClass('address-linkmissing')) {

						if ($signup_status)
							$signup_status.val("Waiting");

						if ($canned_response)
							$canned_response.val("linkmissing");

						$("#mail-operator-subject").val('[SB] Regarding Your Application ('+ Problembox.getOperatorName()+')');
						tinyMCE.activeEditor.setContent(
							'Dear '+Problembox.getFirstName()+",<br /><br />" +
							'Thank you for the documents provided. We noticed that you have not yet completed the second step (adding a link to https://www.AfricaGoTrips.com on your website). The link is an important confirmation that you have partnered with AfricaGoTrips and that your presence on our platform is legitimate. This is important because most clients that you will receive through us, will also check your website.<br />'+
							'<br />'+
							'<b>Instructions for including the link</b><br />'+
							'<br /><ul>'+
							'<li>' +
								'<li>You could include the link by mentioning that you are represented on AfricaGoTrips.com or that your company can be found on AfricaGoTrips.com. You could, for example, add the link to this page: <a href="' + Problembox.getWebsite() + '">' + Problembox.getWebsite() + '</a>.</li>'+
								'<li>Please include the link as a text link and not by linking an image, such as our logo.</li>'+
								'<li>The link should be added to only one page and not to all your website pages (a so-called site-wide link). For example, do not place a link in the footer of your website because a link in the footer will appear on all pages of your website.</li>'+
								'<li>If you can edit the contents of your website, you can add the link yourself. Otherwise, you can ask your website person to add the link.</li>'+
								'<li>Examples of how other tour operators have included the link:<br />' +
									'<br /><ul><li><a style="color: #015580;" href="https://pasatrailssafaris.com/about-us/">https://pasatrailssafaris.com/about-us/</a></li>' +
									'<li><a style="color: #015580;" href="https://www.touritesafaris.com/about-us/">https://www.touritesafaris.com/about-us/</a></li>' +
									'<li><a style="color: #015580;" href="https://www.borderlesstours.com/about-us/">https://www.borderlesstours.com/about-us/</a></li>' +
									'<li><a style="color: #015580;" href="https://www.getawayafrica.com/about-us/">https://www.getawayafrica.com/about-us/</a></li></ul>'+
								'</li>'+
							'</ul><br />'+
							'<br />'+
							'Please email <a style="color: #015580;" href="mailto:partners@AfricaGoTrips.com">partners@AfricaGoTrips.com</a> once you\'ve added the link. We will review your information and link within 10 working days after receiving your email. If all is in order, we will email you the username and password for your AfricaGoTrips account.<br />'+
							'<br />'+
							'Please contact us if you have any questions.<br />'+
							'<br />With kind regards,<br /><br />' + problem_box.find('form').attr('data-val2') + '<br /><br />AfricaGoTrips.com<br />'+tinyMCE.activeEditor.getContent());
					}

					return false;
    			});

				problem_box.find('.snippets a').bind('click', function() {
					if ($(this).hasClass('snip-not-in-list')) {
						tinymce.activeEditor.execCommand('mceInsertContent', false, 'Day X - Description - On ' + '<b>day X</b>' +', you mentioned ' + '<b>activity Y</b>' + '. Please include this activity in the list of activities section or mention that it is an optional activity if it is not included in the tour’s base rate.');
					}
					if ($(this).hasClass('snip-not-in-desc')) {
						tinymce.activeEditor.execCommand('mceInsertContent', false, 'Activity X in your list - You have included ' + '<b>&#39;Activity X&#39;</b>' + ' in your Wildlife Viewing Activities section but do not mention this in any of the day-by-day descriptions. Please mention the activity in the day-by-day description(s) where the client will be participating in this activity or remove it from your list of activities.');
					}
					if ($(this).hasClass('snip-collection-unclear')) {
						tinymce.activeEditor.execCommand('mceInsertContent', false, 'Start/end of your tour - You do not mention the specifics of how your clients will be picked up or dropped off at the end of your tour. Please mention where and when you will pick up/drop off your clients on the first and last day of your tour.');
					}
					if ($(this).hasClass('snip-air-transfer')) {
						tinymce.activeEditor.execCommand('mceInsertContent', false, 'Air transfer - On day ' + '<b>X</b>' + ' of your day-by-day description you mention a flight. Therefore, please add &#39;air transfer&#39; to the list of transportation types.');
					}
					if ($(this).hasClass('snip-identical-desc')) {
						tinymce.activeEditor.execCommand('mceInsertContent', false, 'Identical descriptions - The day descriptions for Day ' + '<b>X</b>' + ' and ' + '<b>Y</b>' + ' are the same. You can combine these days by indicating &#39;Day &#39;' + '<b>X-Y</b>' + '&#39; in the day-by-day section. Please do so to avoid clutter and inconvenience for your potential clients.');
					}
					if ($(this).hasClass('snip-main-focus')) {
						tinymce.activeEditor.execCommand('mceInsertContent', false, 'Main focus - There is no ' + '<b>activity X</b>' + ' mentioned in this tour, therefore, please adjust your tour&#39;s main focus. We suggest changing it to &#39;' + '<b>activity Y</b>' + '&#39;. Additionally, please remove ' + '<b>activity X</b>' + ' from your list of activities.');
					}
					if ($(this).hasClass('snip-tour-title')) {
						tinymce.activeEditor.execCommand('mceInsertContent', false, 'Tour Title - We have noticed that you have used the term &#39;' + '<b>luxury/mid-range</b>' + '&#39; in your tour&#39;s title. However, our AfricaGoTrips&#39; System has classified this tour as ' + '<b>mid-range/budget</b>' + '. Please adjust your tour&#39;s title accordingly or send me a message if you disagree with us.');
					}
					if ($(this).hasClass('snip-invalid-link')) {
						tinymce.activeEditor.execCommand('mceInsertContent', false, 'Accommodation website - The accommodation link you have submitted is invalid as it does not lead to the accommodation itself. We think the following link is the correct link for your accommodation. Please add it to your tour: ' + '<b>*link*</b>' + '.');
					}
					if ($(this).hasClass('snip-evening-game-drive')) {
						tinymce.activeEditor.execCommand('mceInsertContent', false, 'Evening game drives - You have added evening/night game drives to your list of activities, but do not mention these specifically in your itinerary. Please note that we only consider drives to be evening/night game drives when they specifically take place when it is evening and usually dark. They are separate activities from normal game drives. If you are going on these game drives, please mention this in the correct day-by-day description(s) of your tour.');
					}
					if ($(this).hasClass('snip-no-airport-transfer')) {
						tinymce.activeEditor.execCommand('mceInsertContent', false, 'Start/end of your tour: You do not mention specifically how your clients will be picked up or dropped off at the end of your tour. Please mention where and when you will pick up/drop off your clients on the first and last day of your tour, or include an airport transfer in your tour.');
					}

					return false;
				});

			},
			getOperatorName: function() {
				if ($("#company_name").length) {
					return $("#company_name").text();
				}
				else
                if ($("input[name=company_name]").length) {
					return $("input[name=company_name]").val();
				} else if ($(".operator_link.operator_link_name").length) {
                    return $(".operator_link.operator_link_name").text();
                }
			},
			getFirstName: function() {
				if ($("#firstname").length) {
					return $("#firstname").text();
				}
				return "";
			},
			getWebsite: function() {
				if ($("a#sug_loc").length) {
					return $("a#sug_loc").text();
				}
				if ($("#website a").length) {
					return $("#website a").attr("href") + "/about.html";
				}
				return "";
			},
			handleButtons: function(){
				var self = this;
				open_button.click(function(e){
					e.preventDefault();
					
					if (!problem_box.hasClass('open')) {
    					
						if (problem_box.hasClass('mail-operator')) {
    						var new_height = parseInt($(window).height()) - 155;
    						if (new_height < 482) {
        						new_height = 482;
    						}
    						var textarea_height_diff = new_height - 445;
							var before_message_elements = $( "#mail-operator-txt" ).prevAll();
							var before_message_height = 0;
							before_message_elements.each(function() {
								if($(this).is(':visible')) {
									before_message_height += $(this).outerHeight();
								}
							});
    						$("#mail-operator-txt").css('height', 384 - before_message_height + textarea_height_diff);
    						$("#mail-operator-txt_tbl").css('height', 391 - before_message_height + textarea_height_diff);
    						$("#mail-operator-txt_lbl").css('height', 384 - before_message_height + textarea_height_diff);
    						$("#mail-operator-txt_ifr").css('height', 361 - before_message_height + textarea_height_diff);
    						problem_box.find('.form').css('height', new_height);
                        }
    					
                        problem_box_holder.stop().animate({
    						bottom: 0
    					}, 300, function(){
    						problem_box.addClass("open").removeClass("close");
    					});
    				} else {
        				var new_bottom = -524;
						if (problem_box.hasClass('mail-operator')) {
    						var form_height = parseInt(problem_box.find('.form').css('height'));
    						if (form_height > 482) {
        						new_bottom -= (form_height - 482);
    						}
                        }
                        problem_box_holder.stop().animate({
    						bottom: new_bottom + 'px'
    					}, 300, function(){
    						problem_box.addClass("close").removeClass("open");
    					});
    				}
				});
				close_button.click(function(e){
    				open_button.trigger('click');
    				return false;
				});
				send_button.click(function(e){
        			if (problem_box.hasClass('mail-operator')) {
            			self.sendData();
                        $(this).addClass("loading").disabled = true;
                        return false;
                    }
					name_input.trigger('blur');
					mail_input.trigger('blur');
					message_input.trigger('blur');

					if (!$('input[name=issue]:checked').length) {
						$(".problem-box .input-radio span:last-child").html('<nobr>Please select issue type</nobr>').removeClass('solved').addClass('error').show();
						$(".problem-box .input-radio input[type=radio]").unbind('change').bind('change', function() {
							if ($(".problem-box .input-radio span:last-child").html() != '') {
								$(".problem-box .input-radio span:last-child").html('Solved').removeClass('error').addClass('solved');
								setTimeout(function() {
									$(".problem-box .input-radio span:last-child").fadeOut('normal', function() {
										$(".problem-box .input-radio span:last-child").html('').removeClass('error').removeClass('solved');
									});
								}, 3000);
							}
							Problembox.handleError();
						});
						Problembox.errors = true;
					}
					
					if (Problembox.errors == true) {
    					return false;
					}
					$(this).addClass("loading").disabled = true;
					cancel_button.hide();
					self.sendData();
    				return false;
				});
				form_close_button.click(function(e){
					e.preventDefault();
					open_button.trigger('click');
					window.setTimeout(function(){
						self.resetForm();
					},1000);
					return false;
				});
			},
			
			sendData: function(){
				var self = this;
				var posturl = form.prop("action");
				var data = form.serialize();

				var $signup_id = $("#signup_id");
				var $signup_status = $("#signup_status");

				var signup = $signup_id.length;
				if (signup) {
					data += "&signup_id="+$signup_id.text();
					data += "&signup_status="+$signup_status.val();
				}

				Problembox.isPosting = true;

				$.ajax({
					type: "POST",
					url: posturl,
					data: data
				})
				.done(function(result){

					if(result.substr(0,5) == "ERROR") {
						alert("There was an error: " + result);
					}


					if (signup && $signup_status.val()!="") {
						var $frmStatus = $("#view-new-operator #status");
						if ($frmStatus.length) {

							var addition = "";
							if ($signup_status.val()== 'Waiting' && $canned_response.length) {
								switch($canned_response.val()) {
									case "missinginfo":
										addition = " for info";
										break;
									case "linkmissing":
										addition = " for link";
										break;
								}
							}


							$frmStatus.text($signup_status.val()+addition);
						}
					}

					// hide form
					//show success state
					if (problem_box.hasClass('mail-operator')) {
    					problem_box.find('.open-button').html('<span style="color:#266426;">Sent Successfully</span>');
    					problem_box.find('textarea').val('');
    					problem_box.find('input[type=text]').val('');
						problem_box.find('input[type=radio]').prop('checked', false);
    					setTimeout(function() {
        				    problem_box.find('.open-button').html('Email Operator');	
    					}, 3000);
    					
                        send_button.removeClass("loading");
    					open_button.trigger('click');

						if ($("#signup_id").length) {
							loadHistoryLog();
						}

						Problembox.isPosting = false;

    				    return;	
    				}
					if (!problem_box.hasClass('mail-operator')) {
						if (problem_box.find('input[name=issue]:checked').val() == 'other') {
							problem_box.find(".state.success").find('a').attr('href', 'mailto:contact@AfricaGoTrips.com').text('contact@AfricaGoTrips.com');
						} else {
							problem_box.find(".state.success").find('a').attr('href', 'mailto:support@AfricaGoTrips.com').text('support@AfricaGoTrips.com');
						}
					}
					problem_box.find(".state.success").fadeIn();
					problem_box.find(".form form").fadeOut();
					name_input.val('');
					mail_input.val('');
					message_input.val('');
					problem_box.find('input[type=radio]').prop('checked', false);
					send_button.removeClass("loading");

					Problembox.isPosting = false;

				})
				.fail(function(result){
					// @todo: revalidate form
					send_button.removeClass("loading");
				});
			},
			
			resetForm: function(){
				problem_box.find(".state.success").fadeOut();
				problem_box.find(".form form").fadeIn();
				send_button.removeClass("loading");
				cancel_button.show();
			}
		}
	}();


	$(document).ready(function(){
		Problembox.init();
	});