function uncacheAjaxCalls(url) {
    var uts = new Date().getTime();
    if (url.indexOf('?') !== -1) {
        url += "&uts=" + uts;
    } else {
        url += "?uts=" + uts;
    }
    return url;
}

// add additional string type properties/methods

if (!String.prototype.capitalize) {
    Object.defineProperty(String.prototype, 'capitalize', {
        value: function () {
            return this.charAt(0).toUpperCase() + this.slice(1);
        },
        enumerable: false
    });
}


$.fn.reselect = function() {
    return $(this.selector);
};


$sb = {

    "_op" : 0,
    "operator_id" : 0,
    "signup_id" : 0,
    "url_root" : "",
    "front_root" : "",

    // init general jquery events
    "initEvents" : function () {
    },

    // init sb backend
    "init" : function(root, front) {

        var self = this;

        this.url_root = root;
        this.front_root = front;

        this.operator_id = $("#pre_selected_oid").val();
        if (this.operator_id === "" || this.operator_id <= 1)
            this.operator_id = null;

        this.signup_id = $("#pre_selected_sid").val();
        if (this.signup_id === "" || this.signup_id <= 0)
            this.signup_id = null;

        window.setTimeout(function() {
            self.initEvents();
        }, 10);

    },

    "backend_url" : function(path = null, parameters = null, no_op = false) {

        if (path!=null && path.indexOf($funcs.url_root)===0)
            path = path.split($funcs.url_root)[1];


        if (path!=null && path.indexOf("/")!==0)
            path = "/"+path;

        var _url = $funcs.url_root+((path==null)?"":path);
        if (parameters!=null) {
            if (typeof parameters === "string") {
                _url += "/"+parameters;
            }
            else
            if (parameters.forEach) {
                parameters.forEach(function(p) {
                    _url += "/"+p;
                })
            }
        }

        var _hash = "";
        if (_url.indexOf("#")>=0) {
            var ha = _url.split("#");
            _url = ha[0];
            _hash = "#"+ha[1];
        }

        if (!no_op && $sb._op > 1) {
            _url += ((_url.indexOf("?")>=0)?"&":"?")+"_op="+$sb._op+_hash;
        }

        return _url;
    },

    "windowLocation" : function(o, strip_params = []) {

        var loc = window.location.href;
        var hash = window.location.hash;
        var sep = "?";

        strip_params.push("utm_source");
        strip_params.push("utm_medium");

        if (loc.indexOf("?")>=0) {
            var qr = loc.split("?")[1];
            var qra = qr.split("&");

            loc = loc.split("?")[0];
            var qf = [];

            qra.forEach(function(q) {

                sep = (qf.length === 0)?"?":"&";

                if (q.indexOf("=")>=0) {
                    var qp = q.split("=");
                    if (strip_params.indexOf(qp[0]) === -1) {
                        qf.push(qp[0]);
                        if (o[qp[0]]) {
                            loc += (""+sep+qp[0]+"="+o[qp[0]]);
                        }
                        else
                            loc += (""+sep+q);
                    }
                }
                else {
                    if (strip_params.indexOf(q) === -1) {
                        qf.push(qp[0]);
                        loc += ("" + sep + q + "=" + qra);
                    }
                }

                sep = "&";
            });

            for(q in o) {
                if (qf.indexOf(q) === -1)
                    loc += ((loc.indexOf("?")!==-1)?"&":"?")+q+'='+o[q];
            }

        }
        else {
            for(q in o) {
                loc += (""+sep+q+"="+o[q]);
                sep = "&";
            }
        }
        return loc+hash;
    },

    "ajaxCall" : function(url, pData, onSuccess, dataType, opener, options) {

        opener = (typeof opener === 'undefined') ? false : opener;

        if (opener)
        {
            if (typeof opener.before !== 'undefined')
                opener.before.call(opener.element);
        }

        var self = this;
        if (dataType == null)
            dataType = "text";


        var ajaxOptions = {
            data : pData,
            url: uncacheAjaxCalls(url),
            success: function(data) {
                if (onSuccess!=null)
                {
                    onSuccess(data);
                    if (opener)
                    {
                        if (typeof opener.after !== 'undefined')
                            opener.after.call(opener.element);
                    }
                }
            },
            statusCode: {
                404: function() {
                    if (opener)
                    {
                        if (typeof opener.after !== 'undefined')
                            opener.after.call(opener.element);
                    }
                }
            },
            dataType: dataType
        };

        if (options!=null) {
            for(o in options) {
                ajaxOptions[o] = options[o];
            }
        }

        $.ajax(ajaxOptions);
    },
    "jsonCall" : function(url, pData, onSuccess, opener, options) {
        opener = (typeof opener === 'undefined') ? false : opener;

        var self = this;
        this.ajaxCall(url,pData,onSuccess,"json", opener, options);
    },
    "jsonData" : function(cmd, data, onData, onError, options) {
        data.cmd = cmd;
        this.jsonCall("/billing/data", data , function(data) {
            if (data.status == "error" && onError!=null)
                onError(data);
            else
            if (onData!=null)
                onData(data)
        }, null, options);
    },
    "openModal" : function(url, data, options) {

        var modalId = "#reveal_modal";
        if (options.modalId) {
            modalId = (options.modalId.indexOf("#")==0)?options.modalId:("#" + options.modalId);
        }

        var tmp_token = $.ajaxSettings.headers["X-CSRF-TOKEN"];
        delete $.ajaxSettings.headers["X-CSRF-TOKEN"];

        $(modalId).foundation('reveal', 'open', {
            url: url,
            data : data,
            success: function(data) {

                if (options.onSuccess!=null)
                    options.onSuccess();

                $(".load-layer").css('z-index',989); $(".load-layer > div").hide();

                },
            error: function() { }
        });

        $.ajaxSettings.headers["X-CSRF-TOKEN"] = tmp_token;

        $(".close-reveal-modal").remove();
        $(".reveal-modal-bg").hide();

        var overflow;

        $(document).off('closed.fndtn.reveal', modalId);
        $(document).on('closed.fndtn.reveal', modalId, function () {
            handleCloseRevealModal();
            if (options.onClose!=null)
                options.onClose();

            if (options.overflow)
                $("body").css({
                    'overflow': overflow
                });

        });

        $(document).off('opened.fndtn.reveal', modalId);
        $(document).on('opened.fndtn.reveal', modalId, function () {
            handleOpenRevealModal();

            overflow = $("body").css("overflow");

            if (options.overflow)
                $("body").css({
                    'overflow': options.overflow
                });


            if (options.onOpen!=null)
                options.onOpen();


        });

    }
}

var backend_url = $sb.backend_url;
var $funcs = $sb;   // old naming
