const svg = {

    "requested": [],

    "init": function () {

        $('img.svg').each(function () {

            var $img = $(this);
            var imgID = $img.attr('id');
            var imgClass = $img.attr('class');
            var imgURL = $img.attr('src');
            var replaceAttr = 'src';
            if (imgURL == null) {
                imgURL = $img.attr('data-src');
                var replaceAttr = 'data-src';
            }
            var imgStyle = $img.attr('style');

            svg.requested.push(imgURL);

            if (imgURL == null) {
                return;
            }

            $.get(imgURL, function (data) {
                // Get the SVG tag, ignore the rest
                var $svg = $(data).find('svg');
                //                 var $style = $(data).find('style');

                // Add replaced image's ID to the new SVG
                if (typeof imgID !== 'undefined') {
                    $svg = $svg.attr('id', imgID);
                }
                // Add replaced image's classes to the new SVG
                if (typeof imgClass !== 'undefined') {
                    if (typeof $svg.attr('class') != 'undefined') {
                        $svg = $svg.attr('class', $svg.attr('class') + ' ' + imgClass + ' replaced-svg');
                    } else {
                        $svg = $svg.attr('class', imgClass + ' replaced-svg');
                    }
                }
                if (typeof imgStyle !== 'undefined') {
                    $svg = $svg.attr('style', imgStyle);
                }

                // Remove any invalid XML tags as per http://validator.w3.org
                $svg = $svg.removeAttr('xmlns:a');

                // Check if the viewport is set, if the viewport is not set the SVG wont't scale.
                if (!$svg.attr('viewBox') && $svg.attr('height') && $svg.attr('width')) {
                    $svg.attr('viewBox', '0 0 ' + $svg.attr('height') + ' ' + $svg.attr('width'))
                }

                var set_actives = false;
                if ($img.data('active')) {
                    var actives = $img.data('active').split(',');
                    set_actives = true;
                }

                // Replace image with new SVG
                if (!$img.data('active') && !$img.data('nocache')) {
                    $("img.svg[" + replaceAttr + "='" + imgURL + "']").replaceWith($svg);
                } else {
                    $img.replaceWith($svg);
                }

                if (set_actives) {
                    $.each(actives, function (key, active) {
                        if (document.getElementById(active)) {
                            document.getElementById(active).classList.add('active');
                        }
                    });
                }

            }, 'xml');
        });
    }
};