<?php
ini_set('session.gc_maxlifetime', 3600);
$cookieParams = session_get_cookie_params();
session_set_cookie_params([
    'lifetime' => 3600,
    'path' => $cookieParams['path'],
    'domain' => $cookieParams['domain'],
    'secure' => $cookieParams['secure'],
    'httponly' => true
]);

session_start();
if (!isset($_SESSION['email'])) {
    header("Location: login.php");
    exit();
}

$email = $_SESSION["email"];

$id=$_GET['id'];

$conn = new mysqli('localhost', 'packthetripaz_packuser', '@trippacks#2024', 'packthetripaz_packdb') or die("Could not connect to mysql" . mysqli_error($conn));

if (!$conn) {
  die("Connection failed: " . mysqli_connect_error());
}

if (isset($_POST['save'])) {
    $stmt = mysqli_prepare($conn, "INSERT INTO notes (title_id, notes_id, visible, message) VALUES (?, ?, ?, ?)");

    // Bind the parameters
    mysqli_stmt_bind_param($stmt, "ssss", $id, $notes_id, $visible, $message);

    // Set the parameters and execute the statement for each note
    $notes = array(
        array(303, $_POST['notes'][303], 'The exact order, contents and rates of this tour is subject to availability.'),
        array(304, $_POST['notes'][304], 'If an accommodation is fully booked we\'ll suggest a comparable alternative.'),
        array(305, $_POST['notes'][305], 'We reserve the right to change the rates advertised on AfricaGoTrips without prior notice.'),
        array(306, $_POST['notes'][306], 'Rates include a fixed budget for flights during this tour. If flights cost more, your quote will reflect this.')
    );

    foreach ($notes as $note) {
        $notes_id = $note[0];
        $visible = 1;
        $message = $note[1];

        mysqli_stmt_execute($stmt);
    }

    // Close the statement and the database connection
    mysqli_stmt_close($stmt);
    mysqli_close($conn);

    header('location: preview/preview.php?&id=' . $id);
    exit();
}


?>
</style>
<!DOCTYPE html>
<html lang="en" class=" computer production ">
  <head>
    <meta name="csrf-token" content="qpD4mEQUJ5ClYZ1IQOu9CeETBJrBuBLilKg3D4VW" />
    <meta name="token_refresh" content="200" />
    
    <title>Add a Tour | Africatourbase Tour Operator Admin</title>
    <meta name="robots" content="noindex, nofollow, noodp">
    <script>
    var IE6lower = false;
    </script>
    <link href="css/tourbase.min.css" media="all" rel="stylesheet" type="text/css"/>
    <link href="css/glyphicons-halflings.css" media="all" rel="stylesheet" type="text/css" />
    <link href="css/shadowbox.css" media="all" rel="stylesheet" type="text/css"/>
    <link href="css/jqueryui.1.8.4.green.css" media="all" rel="stylesheet" type="text/css"/>
    <link href="css/reveal.css" media="all" rel="stylesheet" type="text/css"/>
    <link rel="stylesheet" href="css/backend.min.css">
    
    <script type="text/javascript" src="js/moment.2.24.0.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.1/jquery.min.js"></script>
    <script type="text/javascript" src="js/jqueryui.1.10.3.min.js"></script>
    <script type="text/javascript" src="js/validation.js"></script>
    <script type="text/javascript" src="js/jquery.metadata.js"></script>
    <script type="text/javascript" src="js/jquery.validate.js"></script>
    <script type="text/javascript" src="js/jquery.browser.min.js"></script>
    <script type="text/javascript" src="js/jquery.tinymce.js"></script>
    <script type="text/javascript" src="js/shadowbox.js"></script>
    <script type="text/javascript" src="js/jquery.uploadifive.min.js"></script>
    <script type="text/javascript" src="js/problem-box.js"></script>
    <script type="text/javascript" src="js/jquery.accordion.js"></script>
    <script type="text/javascript" src="js/jquery.radio.js"></script>
    <script type="text/javascript" src="js/jquery.remodal.min.js"></script>
    <script type="text/javascript" src="js/jquery.balloon.js"></script>
    <script type="text/javascript" src="js/daterangepicker.js"></script>
    <script type="text/javascript" src="js/foundation.min.js"></script>
    <script type="text/javascript" src="js/sb.js"></script>
    <script type="text/javascript" src="js/autocomplete.js"></script>
    <script type="text/javascript" src="js/tourbase.js"></script>
    <script type="text/javascript" src="js/safari.js"></script>
    
    <!--<script type="text/javascript">
    $sb.init("https://operators.AfricaGoTrips.com","https://www.AfricaGoTrips.com");
    </script>
    -->
    
    <script type="text/javascript" src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAqZO4KmgfblsNZl4mj_3aJilBsVFZ0Rco"></script>
    <script type="text/javascript" src="js/chosen.jquery.js"></script>
    <script type="text/javascript" src="js/chosenImage.jquery.js"></script>
    <script type="text/javascript" src="js/availability.js"></script>
    <script type="text/javascript" src="js/svg.js"></script>
    <script type="text/javascript" src="css/validation.js"></script>
    
    
    <style>
    .navbar {
    background-color: #fbfbfb;
    position: sticky;
    top: 0;
    width: 100%;
    z-index: 9999;
    }
    .navbar ul {
    list-style: none;
    margin: 0;
    padding: 0;
    display: flex;
    justify-content: space-around;
    }
    .navbar li {
    padding: 10px;
    }
    .navbar li a {
    
    text-decoration: none;
    }
    .navbar li a:hover {
    text-decoration: underline;
    }
    #preview {
    background-color: #ad2322;
    color: white;
    padding: 10px;
    margin-top: 20px;
    border: 1px solid #ddd;
    }
    .navbar {
    height: 80px;
    margin-top: 10px;
    margin-bottom: 10px;
    display: flex;
    justify-content: center;
    align-items: center;
    border: 1px dashed #000;
    }
    .sticky-container {
  position: sticky;
  top: 0;
  z-index: 999; 
}
    </style>
    
  </head>
  <?php
  include('includes/header.php');
  ?>
  <body class="    ">
    <div class="reveal-modal admin" id="reveal_modal" data-reveal></div>
    <div class="reveal-modal admin" id="reveal_modal_center" data-reveal></div>
    <div class="reveal-modal admin" id="reveal_modal_enquiry" data-reveal></div>
    <script language="JavaScript">
    processModalReveal();
    </script>
    <div id="surface">
      <div id="page" class="">
        <div id="Wrapper">
          <div id="Middle">
            <div id="Right">
              
              
              
              
              <div class="Yourinfo">
                <nav class="navbar">
    <ul>
        <?php
        echo'<li><a href="general_info.php?&id='.$id.'">General Information</a></li>
        <li><a href="private_group.php?&id='.$id.'">Private/Group</a></li>
        <li><a href="activities.php?&id='.$id.'">Activities</a></li>
        <li><a href="getting_there.php?&id='.$id.'">Getting There</a></li>
        <li><a href="Daydescription.php?&id='.$id.'">Day-by-Day</a></li>
        <li><a href="dates_rates.php?&id='.$id.'">Dates &amp; Rates</a></li>
        <li><a href="inclusions.php?&id='.$id.'">Inclusions</a></li>
        <li><a href="photo.php?&id='.$id.'">Tour Photo</a></li>
        <li><a href="preview/preview.php?&id='.$id.'" id="preview">Tour Preview</a></li>';?>
    </ul>
</nav>
                <noscript>Javascript must be enabled for the correct page display</noscript>
                <form class="tour-form" method="POST" action="" enctype="multipart/form-data" id="top" data-val="/tours/t-preview"  >
                  <fieldset id="notes">
                    <h2><strong>Notes & disclaimers</strong></h2>
                    <div>
                      <div class="guidelines">
                        <h4>Guidelines</h4>
                        <ul>
                          <li>Select 'No' if you don't want these notes to be visible to people who view your tour page on AfricaGoTrips.</li>
                        </ul>
                      </div>
                      <ul>
                        <li>
                          <input type="radio" name="notes[303]" value="yes" id="subjectavailability-yes" checked><label for="subjectavailability-yes">Yes</label>
                          <input type="radio" name="notes[303]" value="no" id="subjectavailability-no"><label for="subjectavailability-no">No</label>
                          <span>The exact order, contents and rates of this tour is subject to availability.</span>
                        </li>
                        <li class="note-fullalter">
                          <input type="radio" name="notes[304]" value="yes" id="fullalter-yes" checked><label for="fullalter-yes">Yes</label>
                          <input type="radio" name="notes[304]" value="no" id="fullalter-no"><label for="fullalter-no">No</label>
                          <span>If an accommodation is fully booked we'll suggest a comparable alternative.</span>
                        </li>
                        <li>
                          <input type="radio" name="notes[305]" value="yes" id="ratechanges-yes" checked><label for="ratechanges-yes">Yes</label>
                          <input type="radio" name="notes[305]" value="no" id="ratechanges-no"><label for="ratechanges-no">No</label>
                          <span>We reserve the right to change the rates advertised on AfricaGoTrips without prior notice.</span>
                        </li>
                        <li class="fixedflightbudget-active">
                          <input type="radio" name="notes[306]" value="yes" id="fixedflightbudget-yes" ><label for="fixedflightbudget-yes">Yes</label>
                          <input type="radio" name="notes[306]" value="no" id="fixedflightbudget-no" checked><label for="fixedflightbudget-no">No</label>
                          <span>Rates include a fixed budget for flights during this tour. If flights cost more, your quote will reflect this.</span>
                        </li>
                      </ul>
                    </div>
                  </fieldset>
                  <input type="submit" name="save" value="Continue" class="sb-button large button1652012 bottom-submit-btn" />
                  
                </form>
                <script type="text/javascript">
                var safari_id = '0';
                var operator_id = '5067';
                </script>
              </div>
            </div>
          </div>
          <div id="confirmbox" style="display:none"></div>
          <div class="clr"></div>
        </div>
        <div class="row-container footer-container">
          <div class="footer">
            <ul class="links">
              <li>
                <span>&copy; 2023 AfricaGoTrips</span>
                <span class="sep"> - </span>
              </li>
              <li>
                <a href="" target="_blank" class="editorial">
                  Editorial Guidelines
                </a>
                <span class="sep"> - </span>
              </li>
              <li>
                <a href="" target="_blank" class="partnership">
                  Partnership Agreement
                </a>
              </li>
            </ul>
          </div>
        </div>
      </div>
      <div class="problem-box-holder">
        <div class="problem-box">
          <div class="form">
            <a href="#" class="open-button">
              Report a problem
            </a>
            <div class="row collapsed">
              <h3>
              Report a Problem
              <em>*All fields are required</em>
              </h3>
            </div>
            <form action="" method="post">
              <input type="hidden" name="operator_id" value="5067" />
              <input type="hidden" name="operator_name" value="Burigi Chato Safaris" />
              <input type="hidden" name="useragent" value="Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/109.0.0.0 Safari/537.36" />
              <input type="hidden" name="ipaddress" value="41.59.43.125" />
              <input type="hidden" name="url" value="https://operators.AfricaGoTrips.com/safari/add" />
              <legend>
                Report a problem
              </legend>
              <div class="row clearfix">
                <label class="field-label inline">
                  Name
                </label>
                <div class="input-container input-text">
                  <input type="text" name="Name" /><span></span>
                </div>
              </div>
              <div class="row clearfix">
                <label class="field-label inline">
                  Email
                </label>
                <div class="input-container input-text">
                  <input type="text" name="Email" /><span></span>
                </div>
              </div>
              <div class="row clearfix">
                <label class="field-label inline">
                  Issue
                </label>
                <div class="input-container input-radio">
                  <span>
                    <input class="checklabel" type="radio" name="issue" id="issue-bug" value="bug">
                    <label for="issue-bug">Technical/Bug</label>
                  </span>
                  <span>
                    <input class="checklabel" type="radio" name="issue" id="issue-accommodation" value="accommodation">
                    <label for="issue-accommodation">Accommodation</label>
                  </span>
                  <span>
                    <input class="checklabel" type="radio" name="issue" id="issue-other" value="other">
                    <label for="issue-other">Other</label>
                  </span>
                  <span></span>
                </div>
              </div>
              <div class="row clearfix no-padding-top">
                <label class="field-label">
                  Message<span></span>
                </label>
                <div class="input-container input-text">
                  <textarea name="Message"></textarea>
                </div>
              </div>
              <div class="row">
                <button type="submit" class="sb-button submit">
                <span>
                  Send
                </span>
                </button>
                <button class="sb-button grey btn-close btn-cancel small">
                <span>
                  Cancel
                </span>
                </button>
              </div>
            </form>
            <div class="state success hidden">
              <h3><img src="/images/check-success.png" />Your message has been sent</h3>
              <p>
                Thank you for reporting a problem. We're sorry if it resulted in any inconvenience and will get back
                to you as soon as possible. If you have additional questions or remarks, you can contact us at <a href="mailto:support@AfricaGoTrips.com">support@AfricaGoTrips.com</a>.
              </p>
              <button class="sb-button btn-close-form">
              <span>
                Close
              </span>
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </body>
  <script>
  var sb_version='1.0.85';
  var cookie_domain='AfricaGoTrips.com';
  var mvcAction = '';
  var function_avail_uncertain = true;
  mvcAction = "add";
  Shadowbox.init({
  // let's skip the automatic setup because we don't have any
  // properly configured link elements on the page
  //skipSetup: true
  players:  [ 'html'],
  onOpen: onShOpen,
  onClose: onShClose,
  modal: true
  });
  function onShOpen() {
  document.body.style.overflow = "hidden";
  return true;
  }
  function onShClose() {
  document.body.style.overflow = "auto";
  return true;
  }
  </script>
  <script>
  (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
  })(window,document,'script','//www.google-analytics.com/analytics.js','ga');
  ga('create', 'UA-23211223-2', 'auto');
  ga('set', 'anonymizeIp', true);
  ga('send', 'pageview');
  </script>
  <!-- 0.22282290458679 / 33 q / 23 ch / 5 cm / sb-eu-web1 -->
</html>