var loaded_parts = 0;
var admin_continue = false;
var at_load = true;
var setting_existing_data = false;
var start_time = false;
var tour_form_finished = false;
var is_tour_form = true;
var destination_libraries = [];
var destination_countries = [];
var free_countries = [];
var paid_countries = [];

$(function() {
    start_time = new Date().getTime();

    $("#add-tour-button").off();
    $("#add-tour-button").on("click", function() {
	    $(this).addClass("loading");
	    setTimeout(function() {
    	    window.location.href = $("#add-tour-button").attr("href");
	    }, 200);
	    return false;
	});

	// Only for tour form
    if (!$('.tour-form').length) {
        // Not the tour form, but init help marks
        if(!$(".tour-table-div").length) {
            initTourformHelpMarks();
        }
    	if($(".tour-table-div").length) {
	        initChangePayment();
	        initTourStats();
    	}
        return;
    }

    addLoadLayer();
    initAutocomplete();

    $("input, textarea").focus(function() {

        if ($(this).closest('.actions-box').length)
            return;

        if ($(this).closest('.admin-panel').length == 0 && $(this).closest('.history-box-holder').length == 0) {
        	window.onbeforeunload = unloadPage;
        }
    });

    setTimeout(function() {
        updateOpened();
    }, (60000 * 2));

    if ($("#admin-panel").length) {
        $(".jump-admin").show();
        $(".jump-top").hide();
        $("#admin-panel").find('input[type=checkbox]').bind('change', function() {
            if ($(this).is(":checked")) {
                $("#admin-panel input[type=checkbox][value!='" + $(this).val() + "']").attr('checked', false);
            }
        });
        $(".changes a").bind('click', function() {
            $(".changes > div").stop().slideToggle();
            if ($(".changes a").html() == 'Hide') {
                $(".changes a").html('Show');
            } else {
                $(".changes a").html('Hide');
            }
            return false;
        });

        if ($(".tour-form").attr('data-opened-warning')) {
            alert('Attention!', 'The operator opened this tour less than 4 hours ago (' + $(".tour-form").attr('data-opened-warning') + ') and might be editing the tour.');
        } else {
            checkOpened();
        }

        $(".save-notes").bind('click', function() {
            $.post( backend_url("safari/savenotes"), {
                "id": safari_id,
                "badenglish_penalty": $("#badenglish_1").is(":checked") ? 1 : ($("#badenglish_2").is(":checked") ? 2 : 0),
                "manual_penalty": $("input[name=manual_penalty]").val(),
                "ignore_cheap_tours_trigger": $("#ignore_cheap_tour_trigger").is(":checked") ? 1 : 0,
                "badenglish": $("input[name=badenglish]").length
            }, function(data) {
                if (data == 'OK') {
                    $(".save-notes").next().stop().animate({'opacity': 1}).delay(10000).animate({'opacity': 0});
                    loadHistoryLog();
                }
            });
            return false;
        });
    }

    if (typeof current_data != 'undefined') {
        setting_existing_data = true;
        var end_time = new Date().getTime();
        var time = end_time - start_time;
        setExistingData();

        setting_existing_data = false;
        var end_time = new Date().getTime();
        var time = end_time - start_time;
    }

    // Show form when Javascript is enabled, otherwise only show 'no javascript' message
    $(".tour-form").show();
    $(".tour-form-jump").show();

    if (!$("#paymentperenquiry").length) {
        $(".tour-form-jump a[href='#paymentperenquiry']").hide();
        $(".tour-form-jump a[href='#paymentperenquiry']").next().hide();
    }

    loaded_parts++;
    removeLoadLayer();
    $(".page-title").addClass('safari-page-title');

    $( window ).scroll(function() {
        positionJumpTo();
    });

    if ($(".overall-errors").length) {
        $(".jump-errors").show();
        $(".jump-admin").hide();
        $(".jump-top").hide();
        handleErrors();
    }

    $(".tour-form-jump a").bind('click', function() {
        if (!$(this).hasClass('inactive')) {
            jumpTo($(this).attr('href'));
        }
        return false;
    });
    $(".overall-errors a").bind('click', function() {
        jumpTo($(this).attr('href'));
        return false;
    });

    buildTitlePreview(true);

    handleBlockTitle();
    handleBlockDescription();
    handleBlockFocus();
    handleBlockCountries();
    handleBlockGroup();
    handleBlockActivities();
    handleBlockTransportation();
    handleBlockGettingthere();
    handleBlockDaybyday(true);
    handleBlockDaybyday(false);
    handleBlockCustomization();
    handleBlockDatesrates();
    handleBlockInclusions();
    handleBlockPhoto();
    handleBlockThumbnailPhotos();
    handleBlockNotes();
    handleBlocks();

    initTourformHelpMarks();

    $("#lowerrates_disp_pers").text($("#solo-no").is(":checked")?"2-6":"1-6");

    setTimeout(function() {
        if ($(".thumbpreviews").length) {
            handleCustomTourPhotoDrag();
        }
    }, 200);

    if (typeof current_data != 'undefined') {
        triggerAtLoad();
    }
    at_load = false;

    tour_form_finished = true;
    limitedInputs();
    handleBlockDatesratesRates();

    $(".tour-form").bind('s', function() {

        fillHiddenPaymentFields();

        if ($(".mail-operator").length) {
            var confirm_lbl = 'save';
            if ($( ".tour-form" ).find("input[name=status]").val() == 'live') {
                confirm_lbl = 'approve';
            } else if ($( ".tour-form" ).find("input[name=status]").val() == 'declined') {
                confirm_lbl = 'decline';
            } else if ($( ".tour-form" ).find("input[name=status]").val() == 'inactive') {
                confirm_lbl = 'deactivate';
            } else if ($( ".tour-form" ).find("input[name=status]").val() == 'delete') {
                confirm_lbl = 'delete';
            }
            if ($(".mail-operator").hasClass('open')) {
                confirm('The ‘Email Operator’ form is open. Are you sure you want to ' + confirm_lbl + '?', function(result) {
                    if (result) {
                        $(".problem-box .open-button").trigger('click');
                        $(".mail-operator").removeClass('open');
                        $("input[type=s]").removeClass('loading');
                        $('.bottom-s-btn').trigger('click');
                    } else {
                        setTimeout(function() {
                            $( ".tour-form" ).find("input[name=status]").remove();
                            $( ".tour-form" ).find("input[name=approved]").remove();
                            $("input[type=s]").removeClass('loading');
                        }, 100);
                    }
                });
                return false;
            } else if ($("#mail-operator-txt").val() != '') {
                confirm('The ‘Email Operator’ form contains input. Are you sure you want to ' + confirm_lbl + '?', function(result) {
                    if (result) {
                        $("#mail-operator-txt").val('');
                        $("input[type=s]").removeClass('loading');
                        $('.bottom-s-btn').trigger('click');
                    } else {
                        setTimeout(function() {
                            $( ".tour-form" ).find("input[name=status]").remove();
                            $( ".tour-form" ).find("input[name=approved]").remove();
                            $("input[type=s]").removeClass('loading');
                        }, 100);
                    }
                });
                return false;
            }
        }

        if ($( ".tour-form" ).find("input[name=status]").length == 1 && $( ".tour-form" ).find("input[name=status]").val() == 'delete') {
            window.onbeforeunload = null;
            top.location.href=backend_url('safari/delete/' + safari_id);
            return false;
        }
        if ($( ".tour-form" ).find("input[name=status]").length == 1 && ($( ".tour-form" ).find("input[name=status]").val() == 'draft' || $( ".tour-form" ).find("input[name=status]").val() == 'inactive')) {
            addSaveLayer();
            prepareForm("tour-form", "save");
            window.onbeforeunload = null;
            return true;
        }

        if (safari_id == 0 || $(".tour-form .old-form-attention").length || $(".tour-form").attr('data-img-warning')) {
            if ($(".PhotosList img").length < 10) {
                var attr = $(".tour-form").attr('data-ignore-photos');
                if (typeof attr == 'undefined' || !attr) {
                    setTimeout(function() {
                        photowarningBox();
                    }, 500);
                    return false;
                }
            }
        }

        if (safari_id > 0 && $("#admin-panel").length && $(".tour-form").attr('data-modified') && !admin_continue) {
            $.ajax({
                url: backend_url('safari/edit/' + safari_id),
                type: 'GET',
                async: false,
                cache: false,
                data: { 'modified': $(".tour-form").attr('data-modified'), 'check_modified': '1' },
                timeout: 30000,
                error: function(){
                    admin_continue = true;
                    $("input[type=s]").removeClass('loading');
                    $('.bottom-s-btn').trigger('click');
                },
                success: function(data){
                    if (data != '0') {
                        // Modified in between
                        alert('Can\'t s the tour', 'The operator sted a more recent version of this tour ' + data + '. Please save your changes somewhere (if any), close the tour and wait at least 4 hours before you edit this tour again.');
                        $("input[type=s]").removeClass('loading');
                        admin_continue = false;
                    } else {
                        admin_continue = true;
                        $("input[type=s]").removeClass('loading');
                        $(".tour-form").s();
                    }
                }
            });

            return false;
        } else {
            var returnval = handles();
            if (returnval) {
                $(".save-form").remove();
                prepareForm("tour-form", "save");
                window.onbeforeunload = null;
            }

            return returnval;
        }
    });

    $(".preview").bind('click', function(e) {
        if ($(this).hasClass('busy')) {
            return false;
        }
        e.preventDefault();
        handlePreview('preview');
        $(this).addClass('busy');
        return false;
    });

    $(".open-info-page").bind('click', function(e) {
        window.open($(this).attr("href"), 'Check info page', 'resizable=1, scrollbars=1, fullscreen=1, screenX=0 , left=1280, toolbar=0, menubar=0, status=1');
        e.preventDefault();
        return false;
    });

    var end_time = new Date().getTime();
    var time = end_time - start_time;

    if(getCookie("jumpto")) {
        setTimeout(function() {
            jumpTo("#" + getCookie("jumpto"));
        }, 500);
    }

    if(window.location.hash) {
        setTimeout(function(){ jumpTo(window.location.hash); }, 500);
    }

    coronaNotice();

});

function coronaNotice() {
    if($("input[name=free-countries]").length == 0 || $("input[name=paid-countries]").length == 0) {
        return false;
    }
    if(free_countries.length == 0) {
        free_countries = $.map($("input[name=free-countries]").val().split(","), function(value){
            return parseInt(value, 10);
        });
    }
    if(paid_countries.length == 0) {
        paid_countries = $.map($("input[name=paid-countries]").val().split(","), function(value){
            return parseInt(value, 10);
        });
    }
    
    var free_countries_arr = [];
    var paid_countries_arr = [];
    var free_countries_string = "";
    var paid_countries_string = "";
    var corona_notice_el = $("#paymentperenquiry").find(".default-payment").find(".alert-box");

    var hide_notice = true;
    $("input[type=checkbox].default-country:checked").each(function() {
        if($(this).data('id') != 2 && $(this).data('id') != 5) {
            hide_notice = false;
        }
        if(free_countries.indexOf(parseInt($(this).attr("data-id"))) !== -1) {
            free_countries_arr.push($(this).parent().find("label[for=" + $(this).attr("id") + "]").text());
        }
        if(paid_countries.indexOf(parseInt($(this).attr("data-id"))) !== -1) {
            paid_countries_arr.push($(this).parent().find("label[for=" + $(this).attr("id") + "]").text());
        }
    });

    if(hide_notice) {
        corona_notice_el.hide();
        return;
    }

    var type = "both";
    if(free_countries_arr.length > 0 && paid_countries_arr.length > 0) {
        // both free and paid countries
        free_countries_string = list_countries(free_countries_arr);
        paid_countries_string = list_countries(paid_countries_arr);
    } else if(free_countries_arr.length > 0) {
        // only free countries
        free_countries_string = list_countries(free_countries_arr);
        type = "free";
    } else if(paid_countries_arr.length > 0) {
        // only paid countries
        paid_countries_string = list_countries(paid_countries_arr);
        type = "paid";
    } else {
        type = "none";
    }

    var free_countries_is_are = "are";
    if(free_countries_arr.length == 1) {
        free_countries_is_are = "is";
    }

    var paid_countries_is_are = "are";
    if(paid_countries_arr.length == 1) {
        paid_countries_is_are = "is";
    }

    corona_notice_el.show();
    $("#additional-info").find("li.additional-free").addClass("hide");
    $("#additional-info").find("li.additional-higher-perc").removeClass("hide");
    $("#additional-info").find("li.additional-payments-in-eur").removeClass("hide");

    //Discount on paid quote requests</b><br />During the pandemic tour operators have needed more quote requests to generate a booking. To ensure quote requests remain great value for operators, we currently provide a discount on paid quote requests. For more information please see: https://operators.AfricaGoTrips.com/covid-discount
    if(type == 'none') {
        corona_notice_el.hide();
    } else {
        corona_notice_el.find(".corona-notice-title").text("Discount on paid quote requests");
        corona_notice_el.find(".corona-notice-text").html("During the pandemic tour operators have needed more quote requests to generate a booking. To ensure quote requests remain great value for operators, we currently provide a discount on paid quote requests. For more information please see: <a href='https://operators.AfricaGoTrips.com/covid-discount' target='_blank'>https://operators.AfricaGoTrips.com/covid-discount</a>");
    }

    /*
    switch(type) {
        case "both":
            corona_notice_el.find(".corona-notice-title").text("Important! Some quote requests are free and others require payment");
            corona_notice_el.find(".corona-notice-text").html("<ul>\n" +
                "<li>Quote requests for tours to " + free_countries_string + " are free until the end of 2021 because " + ((free_countries_arr.length == 1) ? (free_countries_string + " " + free_countries_is_are) : "these countries are") + " part of the <a href=\"#\" class=\"help textual\" title=\"<ul>" + $("input[type=hidden][name=free-countries-ul]").val() + "</ul>\">17 'free' countries</a>.</li>\n" +
                "<li>Quote requests for tours to " + paid_countries_string + " require a payment.</li>\n" +
                "<li>During the pandemic tour operators have needed twice as many quote requests to generate a booking. To ensure quote requests remain great value, we will give a 50% discount on all paid quote requests in January and February. By mid-February we will decide whether a discount will apply for March.</li>\n" +
                "<li>In order to receive quote requests, you will have to offer a payment that is higher than 0.0%. If the quote request is free, the payment percentage offered will be ignored and your account will not be charged.</li>\n" +
                "</ul>");
            initHelpMarks();
            break;
        case "free":
            corona_notice_el.find(".corona-notice-title").text("Free quote requests until the end of 2021");
            corona_notice_el.find(".corona-notice-text").html("Quote requests for tours to " + free_countries_string + " are free until the end of 2021 because " + ((free_countries_arr.length == 1) ? (free_countries_string + " " + free_countries_is_are) : "these countries are") + " part of the <a href=\"#\" class=\"help textual\" title=\"<ul>" + $("input[type=hidden][name=free-countries-ul]").val() + "</ul>\">17 'free' countries</a>. In order to receive free quote requests, you will have to offer a payment that is higher than 0.0%. When you receive a quote request, the payment percentage offered will be ignored and your account will not be charged. We recommend setting the payment percentage that you want to use after 2021.");
            $("#additional-info").find("li.additional-free").removeClass("hide");
            $("#additional-info").find("li.additional-free").find(".selected-free-countries").text(free_countries_string);
            $("#additional-info").find("li.additional-higher-perc").addClass("hide");
            $("#additional-info").find("li.additional-payments-in-eur").addClass("hide");
            initHelpMarks();
            break;
        case "paid":
            corona_notice_el.find(".corona-notice-title").text("COVID-19 measure: 50% Discount until February 28, 2021");
            corona_notice_el.find(".corona-notice-text").html("During the pandemic tour operators have needed twice as many quote requests to generate a booking. To ensure quote requests remain great value, we will give a 50% discount on all paid quote requests in January and February. By mid-February we will decide whether a discount will apply for March.");
            break;
        case "none":
            corona_notice_el.hide();
    }*/
}


function list_countries(countries){
    const finalCountry = countries.pop();
    var ret = countries.length
        ? countries.join(', ') + ' & ' + finalCountry
        : finalCountry;
    countries.push(finalCountry);
    return ret;
}

var sted = 0;

var monthNames = [ "", "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" ];
var fullMonthNames = [ "", "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" ];
var dayNames = [ "", "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" ];
var ISOdayNames = [ "", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday" ];



function updateOpened() {
    if ($("#admin-panel").length) {
        return;
    }
    if (safari_id == '' || safari_id <= 0) {
        return;
    }

    $.get(backend_url('safari/edit/' + safari_id + '?update_opened=1'));

    setTimeout(function() {
        updateOpened();
    }, (60000 * 2));
}

function checkOpened() {
    if (!$("#admin-panel").length) {
        return;
    }
    if (safari_id == '' || safari_id <= 0) {
        return;
    }

    $.get(backend_url('safari/edit/' + safari_id + '?get_opened=1'), function(data) {
        if (data && data != '') {
            alert('Attention!', 'The operator opened this tour less than 4 hours ago (' + data + ') and might be editing the tour.');
        } else {
            setTimeout(function() {
                checkOpened();
            }, (60000 * 2));
        }
    });
}



function sWithStatus(new_status, approved) {
    $( ".tour-form" ).find("input[name=status]").remove();
    $( ".tour-form" ).find("input[name=approved]").remove();
    $( ".tour-form" ).append('<input type="text" style="visibility: hidden;" name="status" value="' + new_status + '" />');
    $( ".tour-form" ).append('<input type="text" style="visibility: hidden;" name="approved" value="' + approved + '" />');

    $('.bottom-s-btn').trigger('click');
}

function saveAndClose() {
    $( ".tour-form" ).find("input[name=close]").remove();
    $( ".tour-form" ).append('<input type="text" style="visibility: hidden;" name="close" value="1" />');
    $('.bottom-s-btn').trigger('click');
}

function saveAndTourCheck() {
    $( ".tour-form" ).find("input[name=close]").remove();
    $( ".tour-form" ).append('<input type="text" style="visibility: hidden;" name="close" value="2" />');
    $('.bottom-s-btn').trigger('click');
}

function positionJumpTo() {
    if (!$(".tour-form-jump").length) {
        return;
    }
    if (($("#Wrapper").offset().top) < $(window).scrollTop() - 88) {
        $("body").addClass('fixed-tour-form-jump');
    } else {
        $("body").removeClass('fixed-tour-form-jump');
    }
}

function getDatestrPart(date_str, part) {
    if (typeof part == 'undefined') {
        return false;
    }

    var dateReg = /^\d{4}[./-]\d{1,2}[./-]\d{1,2}$/
    if (!date_str.match(dateReg)) {
        return false;
    }

    var parts = date_str.split('-');
    if (part == 'year') {
        return parseInt(parts[0]);
    }
    if (part == 'month') {
        return parseInt(parts[1]);
    }
    if (part == 'day') {
        return parseInt(parts[2]);
    }
    if (part == 'weekday') {
        var m = moment([parseInt(parts[0]), parseInt(parts[1]) - 1, parseInt(parts[2])]);
        return m.format('E');
    }
}

function setExistingData() {
    var data = $.parseJSON(current_data);
    var country_block_handled = false;
    $.each(data, function(key, val) {
        if ($.isPlainObject(val)) {
            $.each(val, function(subkey, subval) {

                if (key == 'rates' && subkey == 'local_currency') {
                    $("input[id=local-currency]").attr('checked', true);
                }

                if ($("input[name='" + key + "[" + subkey + "]']").length) {
                    if ($("input[name='" + key + "[" + subkey + "]']").is("input[type=radio]")) {
                        if (!$("input[name='" + key + "[" + subkey + "]'][value=" + subval + "]").hasClass('inactive')) {
                            $("input[name='" + key + "[" + subkey + "]'][value=" + subval + "]").attr('checked', true);
                        }
                    }
                    if ($("input[name='" + key + "[" + subkey + "]']").is("input[type=checkbox]")) {
                        $("input[name='" + key + "[" + subkey + "]'][value=" + subval + "]").attr('checked', true);
                    }
                    if ($("input[name='" + key + "[" + subkey + "_duplicate]']").is("input[type=radio]")) {
                        if (!$("input[name='" + key + "[" + subkey + "_duplicate]'][value=" + subval + "]").hasClass('inactive')) {
                            $("input[name='" + key + "[" + subkey + "_duplicate]'][value=" + subval + "]").attr('checked', true);
                        }
                    }
                    if ($("input[name='" + key + "[" + subkey + "]']").is("input[type=text]")) {
                        $("input[name='" + key + "[" + subkey + "]']").val(subval);
                    }
                }
                if ($("select[name='" + key + "[" + subkey + "]']").length) {
                    $("select[name='" + key + "[" + subkey + "]']").val(subval);
                }
                if (key == 'rates' && subkey == 'currency') {
                    $(".rate-block-currency").html(subval);
                }
                if (key == 'rates' && subkey == 'local_currency') {
                    $(".rate-block-local-currency").html(subval);
                }
                if (key == 'rates' && subkey == 'lowerrates_persons') {
                    $.each(subval, function(subsubkey, subsubval) {
                        $("input[name='rates[lowerrates_option][" + subsubkey + "]']").attr('checked', true);
                    });
                }
                if (key == 'rates' && subkey == 'availability_set') {
                    if (subval == 'yes' && val.fixeddates == 'yes') {
                    } else if (val.fixeddates == 'no') {

                        if (typeof val.unavailability != 'undefined') {
                            var subcounter = 0;
                            $.each(val.unavailability, function(una_key, una_val) {
                                var dates = una_key.split('|');

                                if (!$(".availability-options li[class!=add-row]").eq(subcounter).length) {
                                    $(".tour-form #datesrates .availability-options li:nth-last-child(2)").clone().insertAfter(".tour-form #datesrates .availability-options li:nth-last-child(2)");
                                    $(".tour-form #datesrates .availability-options li:nth-last-child(2) a").removeClass('inactive');
                                    $(".tour-form #datesrates .availability-options li:nth-last-child(2) input").removeClass('hasDatepicker').removeAttr('id').removeAttr('data-val').val('');
                                    $(".tour-form #datesrates .availability-options li:nth-last-child(2)").removeClass('disabled');
                                    $(".tour-form #datesrates .availability-options li:nth-last-child(2)").removeClass('expired');
                                    $(".tour-form #datesrates .availability-options li:nth-last-child(2) span.expired").remove();
                                    if ($(".tour-form #datesrates .availability-options li").length > 2) {
                                        $(".tour-form #datesrates .availability-options li .remove-new").removeClass('inactive');
                                    }
                                }

                                $(".availability-options li[class!=add-row]:eq(" + subcounter + ") .availability-date-picker-from").val(monthNames[getDatestrPart(dates[0], 'month')] + ' ' + getDatestrPart(dates[0], 'day') + ', ' + getDatestrPart(dates[0], 'year')).attr('data-val', dates[0]);
                                $(".availability-options li[class!=add-row]:eq(" + subcounter + ") .availability-date-picker-to").val(monthNames[getDatestrPart(dates[1], 'month')] + ' ' + getDatestrPart(dates[1], 'day') + ', ' + getDatestrPart(dates[1], 'year')).attr('data-val', dates[1]);
                                var una_val_parts = una_val.split('|##|');
                                $(".availability-options li[class!=add-row]:eq(" + subcounter + ") .availability select").val(una_val_parts[0]);
                                $(".availability-options li[class!=add-row]:eq(" + subcounter + ") .availability select").next().val(una_val_parts[1]);
                                subcounter++;
                            });
                        }
                    }
                }
                if (key == 'rates' && subkey == 'dateranges') {
                    var subcounter = 0;
                    //handleBlockDatesrates();
                    $.each(subval, function(subsubkey, subsubval) {
                        var dates = subsubkey.split('|');
                        if (data.rates.fixedrates == 'no') {
                            var year = getDatestrPart(dates[0], 'year');
                            if (!isNaN(year)) {
                                if ($(".fixedyears-options input[data-val='" + year + "']").length) {
                                    $(".fixedyears-options input[data-val='" + year + "']").attr('checked', true);
                                } else {
                                    var before_nth = 0;
                                    if ($(".fixedyears-options li").length > 2) {
                                        before_nth += ($(".fixedyears-options li").length - 2);
                                    }
                                    $("<li><input type='checkbox' data-val='" + year + "' name='rates[years][" + year + "]' value='1' id='year-" + year + "' checked><label for='year-" + year + "'>" + year + "</label></li>").insertBefore(".fixedyears-options li:eq(" + before_nth + ")");
                                }

                                var current_year = new Date().getFullYear();
                                if (parseInt(year) < parseInt(current_year)) {
                                    $("#year-" + year).parent().append('<span class="expired">(Expired, please unselect)</span>');
                                    $("#year-" + year).parent().addClass('expired');
                                }
                            }
                        } else {
                            if (!$(".fixedrates-options li[class!=add-row]").eq(subcounter).length) {
                                $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2)").clone().insertAfter(".tour-form #datesrates .fixedrates-options li:nth-last-child(2)");
                                $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2) a").removeClass('inactive');
                                $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2) input").removeClass('hasDatepicker').removeAttr('id').removeAttr('data-val').val('');
                                $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2)").removeClass('with-gap');
                                $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2) .gap").remove();
                                $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2)").removeClass('disabled');
                                $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2)").removeClass('expired');
                                $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2) span.expired").remove();
                                if ($(".tour-form #datesrates .fixedrates-options li").length > 2) {
                                    $(".tour-form #datesrates .fixedrates-options li .remove-new").removeClass('inactive');
                                }
                            }
                            $(".fixedrates-options li[class!=add-row]:eq(" + subcounter + ") .date-picker-from").val(monthNames[getDatestrPart(dates[0], 'month')] + ' ' + getDatestrPart(dates[0], 'day') + ', ' + getDatestrPart(dates[0], 'year')).attr('data-val', dates[0]);
                            $(".fixedrates-options li[class!=add-row]:eq(" + subcounter + ") .date-picker-to").val(monthNames[getDatestrPart(dates[1], 'month')] + ' ' + getDatestrPart(dates[1], 'day') + ', ' + getDatestrPart(dates[1], 'year')).attr('data-val', dates[1]);
                            var to_date = new Date(new Date(dates[1]).toUTCString());
                            var yesterday = new Date();
                            yesterday = yesterday.setDate(yesterday.getDate() - 1);
                            if (to_date <= yesterday) {
                                $(".fixedrates-options li[class!=add-row]:eq(" + subcounter + ") .date-picker-to").parent().append('<span class="expired">(Expired, please remove)</span>');
                                $(".fixedrates-options li[class!=add-row]:eq(" + subcounter + ") .date-picker-to").parent().addClass('expired');
                            }
                        }
                        subcounter++;
                    });
                    showSeasonGaps();
                }
                if (key == 'rates' && subkey == 'singledates') {
                    var counter = 0;
                    //handleBlockDatesrates();
                    $.each(subval, function(subsubkey, subsubval) {
                        if (subsubkey != '0000-00-00') {
                            var date = new Date(new Date(subsubkey).toUTCString());
                            if (!$(".tour-form #datesrates .fixeddates-options .date-picker").eq(counter).length) {
                                $(".tour-form #datesrates .fixeddates-options li:nth-last-child(2)").clone().insertAfter(".tour-form #datesrates .fixeddates-options li:nth-last-child(2)");
                                $(".tour-form #datesrates .fixeddates-options li:nth-last-child(2) span").eq(0).html(($(".tour-form #datesrates .fixeddates-options li").length - 1) + ".");
                                $(".tour-form #datesrates .fixeddates-options li:nth-last-child(2) span.expired").remove();
                                $(".tour-form #datesrates .fixeddates-options li:nth-last-child(2)").removeClass('expired');
                                $(".tour-form #datesrates .fixeddates-options li:nth-last-child(2) a").removeClass('inactive');
                                $(".tour-form #datesrates .fixeddates-options li:nth-last-child(2) input").removeClass('hasDatepicker').removeAttr('id').removeAttr('data-val').val('');
                                $(".tour-form #datesrates .fixeddates-options li:nth-last-child(2)").removeClass('disabled');
                                if ($(".tour-form #datesrates .fixeddates-options li").length > 2) {
                                    $(".tour-form #datesrates .fixeddates-options li .remove-new").removeClass('inactive');
                                }
                            }
                            $(".tour-form #datesrates .fixeddates-options .date-picker").eq(counter).val(monthNames[getDatestrPart(subsubkey, 'month')] + ' ' + getDatestrPart(subsubkey, 'day') + ', ' + getDatestrPart(subsubkey, 'year') + ' (' + ISOdayNames[getDatestrPart(subsubkey, 'weekday')] + ')').attr('data-val', subsubkey);
                            subsubval = String(subsubval);
                            if (subsubval.indexOf('|##|') >= 0) {
                                var subsubval_parts = subsubval.split('|##|');
                                $(".tour-form #datesrates .fixeddates-options .availability select").eq(counter).val(subsubval_parts[0]);
                            } else {
                                $(".tour-form #datesrates .fixeddates-options .availability select").eq(counter).val(7);
                            }
                            var yesterday = new Date();
                            yesterday = yesterday.setDate(yesterday.getDate() - 1);
                            if (date <= yesterday) {
                                // Expired date
                                $(".tour-form #datesrates .fixeddates-options .date-picker").eq(counter).parent().append('<span class="expired">(Expired, please remove)</span>');
                                $(".tour-form #datesrates .fixeddates-options .date-picker").eq(counter).parent().addClass('expired');
                            }
                            counter++;
                        }
                    });
                }
                if (key == 'rates' && subkey == 'valid_until') {
                    $("input[name='rates[" + subkey + "]']").attr('data-val', subval);
                }
                if (subkey == 'ratefields') {
                    handleBlockDatesratesRates();
                    $(".rate-blocks li[class!=rate-block-title-row]").each(function() {
                        if ($(this).css('display') != 'none') {
                            $(this).addClass('vis');
                        }
                    });
                    $.each(subval, function(subsubkey, subsubval) {
                        var field = subsubkey.split("_");
                        if ($("input[name='rates[solo]']:checked").val() == 'yes') {
                            $(".rate-blocks li[class!=rate-block-title-row].vis:eq(" + (parseInt(field[0]) - 1) + ") input[type=text]:eq(" + (parseInt(field[1]) - 1) + ")").val(subsubval);
                        } else {
                            $(".rate-blocks li[class!=rate-block-title-row][class!=solo-row].vis:eq(" + (parseInt(field[0]) - 1) + ") input[type=text]:eq(" + (parseInt(field[1]) - 1) + ")").val(subsubval);
                        }
                    });
                }

            });
        } else if ($.isArray(val)) {
           if (key == 'days') {
                setDayBlocks();
                if ($('select[name=no_of_days]').val() > 1) {
                    $(".no-of-days").html('' + $('select[name=no_of_days]').val() + ' days');
                } else if ($('select[name=no_of_days]').val() == 1) {
                    $(".no-of-days").html('1 day');
                } else {
                    $(".no-of-days").html('½ day');
                }
           }
            $.each(val, function(subkey, subval) {
                if (key == 'country') {
                    if (!$("input[name='" + key + "[" + subval + "]']").length) {
                        if (!country_block_handled) {
                            handleBlockCountries();
                            country_block_handled = true;
                        }
                        $("#countries select").val(subval);
                        $("#countries input[type=s]").trigger('click');
                    } else {
                        var non_gamedrive_countries = ['ET','MG'];
                        if(non_gamedrive_countries.indexOf(subval) != -1) {
                            $("#beach_other-div").show();
                            $("#other-div").show();
                        }
                    }
                }
                if (key == 'days') {
                    $.each(subval, function(subsubkey, subsubval) {
                        if(subsubkey == 'day-accommodation_id') {
                            loadAccoDetails($(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find(".accom-detail-sub"), subsubval);
                            $(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.camping-no').attr('checked', true);
                        } else {
                            if ($(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.' + subsubkey).length) {
                                if ($(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.' + subsubkey).is("input[type=radio]") || $(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.' + subsubkey).is("input[type=checkbox]")) {
                                    if (subsubval == 1) {
                                        $(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.' + subsubkey).attr('checked', true);
                                        if (subsubkey == 'day-nodestination') {
                                            $(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.day-destination').addClass('disabled').attr('disabled', true);
                                            $(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.daydestination-photo-holder').hide();
                                        }
                                        if(subsubkey == 'camping-yes' || subsubkey == 'camping-no') {
                                            accommodationCampingChange($(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.'+subsubkey));
                                        }
                                    } else {
                                        if (subsubval != 0) {
                                            $(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.' + subsubkey + '[value=' + subsubval + ']').attr('checked', true);
                                        }
                                    }
                                } else {
                                    $(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.' + subsubkey).val(subsubval);
                                    if(subsubkey == 'daybyday-accom-name') {
                                        loadAccoForm($(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find(".accom-detail-sub"));
                                    }
                                    if (subsubkey == 'day-accommodation') {
                                        accommodationTypeChange($(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.' + subsubkey));
                                    }
                                }
                            }
                            if (subsubkey == 'day-selection') {
                                $(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.' + subsubkey).attr('existing-val', subsubval);
                            }
                            if (subsubkey == 'daybyday-park-shortname') {
                                $(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.accom-detail-loc').find('select').find('option:eq(0)').html('-- Select location to ' + subsubval + ' --');
                                if ($(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.accom-detail-loc').find('select').find('option').length == 7) {
                                    $(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.accom-detail-loc').find('select').find('option:eq(6)').html('Not used to explore ' + subsubval);
                                } else {
                                    $(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.accom-detail-loc').find('select').append('<option value="nan">Not used to explore ' + subsubval + '</option>');
                                }
                                if ($(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.accom-detail-loc').find('select').next().is('span')) {
                                    $(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.accom-detail-loc').find('select').next().html('(' + subsubval + ')');
                                } else {
                                    $(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.accom-detail-loc').find('select').after('<span>(' + subsubval + ')</span>');
                                }
                            }
                            if (subsubkey == 'daybyday-accom-nowebsite') {
                                if (subsubval == '1') {
                                    cantProvideWebsite($(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")"));
                                }
                            }
                            if (subsubkey == 'hide-accom-location') {
                                $(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.accom-detail-loc').hide();
                            }
                            if (subsubkey.indexOf('camping-') == 0 && subsubval == '1') {
                                $(".tour-form #daybyday > div > ul > li:eq(" + subkey + ")").find('.' + subsubkey).attr('checked', true).trigger('change');
                            }
                        }
                    });
                }
                if ($("input[name='" + key + "[" + subval + "]']").length) {
                    if ($("input[name='" + key + "[" + subval + "]']").is("input[type=radio]") || $("input[name='" + key + "[" + subval + "]']").is("input[type=checkbox]")) {
                        $("input[name='" + key + "[" + subval + "]']").attr('checked', true);
                    }
                }
            });
        } else {

            if ($("input[name=" + key + "]").length) {

                if (key == 'title') {
                    $("input[name=" + key + "]").data("inuse-addition",
                        (data.title_invalid=="1")?". Your tour was not online for the past six months so the tour title was made available to other operators":"");
                }

                if ($("input[name=" + key + "]").is("input[type=radio]") || $("input[name=" + key + "]").is("input[type=checkbox]")) {
                    $("input[name=" + key + "][value=" + val + "]").attr('checked', true);
                } else {
                    $("input[name=" + key + "]").val(val);
                }
            } else if ($("select[name=" + key + "]").length) {
                $("select[name=" + key + "]").val(val);
            } else if ($("textarea[name=" + key + "]").length) {
                $("textarea[name=" + key + "]").val(val);
            }

            if (key == 'status' && $(".admin-panel").length) {
                if (val == 'live' && data['approved'] == 0) {
                    val = 'pending';
                }
                $(".admin-panel").addClass(val);
            }
        }
    });

    var inputs_min = $("*[data-min]");
    var inputs_max = $("*[data-max]");
    var inputs = $.unique( $.merge(inputs_min, inputs_max) );
    $(inputs).each(function() {
        $(this).trigger('keyup');
    });

    destinationPhotos();
}

function triggerAtLoad() {
    debugFunctionCall('triggerAtLoad');

    // Trigger some elements on load
    $(".tour-form #focus input[name=focus]").first().trigger('change');
    $(".tour-form #group input[type=radio]").first().trigger('change');
    $(".tour-form #activities input[type=checkbox]").first().trigger('change');
    $("#title input[type=text]").trigger('blur').trigger('keyup');
    $("#description textarea").trigger('blur').trigger('keyup');
    $(".tour-form #datesrates input[type=radio]").trigger('change');
    $(".tour-form #datesrates input[name='rates[fixeddates]']").trigger('change');
}

function triggerAtError() {
    debugFunctionCall('triggerAtError');

    // Trigger some elements on load
    $(".tour-form #activities input[type=checkbox]").first().trigger('change');
}

function debugFunctionCall(function_name) {
    //console.log('Call: ' + function_name);
}

function destinationPhotos() {
    var run_at_load = at_load;
    $(".daybyday-photo-url").each(function() {
        // Get destination name
        var dest_name = $(this).closest('li[data-index]').find('.day-destination').val();
        var dest_input = $(this).closest('li[data-index]').find('.day-destination');
        var day_index = parseInt($(this).closest('li[data-index]').attr('data-index'));
        var day = $(this).closest('li[data-index]').attr('data-index');
        if (dest_name != '') {
            $.get( backend_url("safari/destinationlibrary?name=" + dest_name), function( data ) {
                if (typeof data.destination_id != 'undefined') {
                    if ($.inArray(data.destination_id, destination_libraries) < 0) {

                        $(dest_input).attr('data-id', data.destination_id);

                        destination_libraries[data.destination_id] = data.photos;
                        destination_countries[data.destination_id] = data.countries;

                        showDestinationPhotoLibrary(day_index);
                        checkSelectedCountries(data.countries, day);
                    }
                } else {
                    if (run_at_load) {
                        var photo_holder = $("#daybyday li[data-index='" + day + "'] .daydestination-photo-holder");
                        $(photo_holder).find(".daydestination-photo-holder-txt").show();
                        $(photo_holder).find(".daydestination-photo-holder-txt").text('We don\'t have a photo for this destination');
                    }
                }
            });

        }
    });
}

function getDestinationPhotoLibrary(day, dest_id) {
    if (typeof destination_libraries[dest_id] != 'undefined') {
        showDestinationPhotoLibrary(day);
        checkSelectedCountries(destination_countries[dest_id], day);

        showRouteMap();
    } else {
        $.get( backend_url("safari/destinationlibrary?id=" + dest_id), function( data ) {
            if (typeof data.destination_id != 'undefined' && data.destination_id == dest_id) {
                if ($.inArray(data.destination_id, destination_libraries) < 0) {
                    destination_libraries[data.destination_id] = data.photos;
                    destination_countries[data.destination_id] = data.countries;
                }

                showDestinationPhotoLibrary(day);
                checkSelectedCountries(data.countries, day);

                showRouteMap();
            }
        });
    }
}

function loadDestination(el, id) {
    var day = el.closest('li[data-index]');
    var day_nr = $(day).attr('data-index');
    $(day).find('.day-destination').attr('data-id', id);
    getDestinationPhotoLibrary(day_nr, id);

    showRouteMap();
}


function checkSelectedCountries(countries, day) {
    var good = false;
    if (countries.length) {
        $.each(countries, function (i, v) {
            if ($("#countries input[name='country[" + v + "]']").is(':checked')) {
                good = true;
            }
        });
    } else {
        good = true;
    }

    var dest = $("#daybyday li[data-index='" + day + "'] .day-destination");
    if(!good) {
        if ($("#daybyday li[data-index='" + day + "']").length && $("#daybyday li[data-index='" + day + "'] .day-destination").length) {
            showError(dest, 'This destination is not located in one of the selected <a href="javascript:void(0);" onclick="jumpTo(\'#countries\');">countries</a> for this tour.');
            return false;
        }
    } else {
        if ($("#daybyday li[data-index='" + day + "']").length && $("#daybyday li[data-index='" + day + "'] .day-destination").length) {
            hideError(dest, 'This destination is not located in one of the selected <a href="javascript:void(0);" onclick="jumpTo(\'#countries\');">countries</a> for this tour.');
        }
    }

    showRouteMap();

    return true;
}

function showDestinationPhotoLibrary(day) {

    if ($("#daybyday li[data-index='" + day + "']").length && $("#daybyday li[data-index='" + day + "'] .day-destination").length) {

        var dest = $("#daybyday li[data-index='" + day + "'] .day-destination");
        var photo_holder = $("#daybyday li[data-index='" + day + "'] .daydestination-photo-holder");
        var reset = true;

        if ($(dest).attr('data-id')) {

            var dest_id = $(dest).attr('data-id');

            if (dest_id > 0) {
                if (typeof destination_libraries[dest_id] != 'undefined' && destination_libraries[dest_id].length) {

                    reset = false;
                    $(photo_holder).slideDown();

                    var current_photo = parseInt($(photo_holder).find(".dayphoto").val());
                    if (current_photo <= 0) {

                        var loop = 0;
                        do {
                            var random_item = destination_libraries[dest_id][Math.floor(Math.random() * destination_libraries[dest_id].length)];
                            current_photo = random_item.id;
                            loop++;
                        } while (random_item.represents == 0 && loop < 20);
                    }

                    $(photo_holder).find('img').attr('src', '');

                    var found = false;
                    $.each(destination_libraries[dest_id], function (key, val) {
                        if (val.id == current_photo) {
                            if (!$(photo_holder).find('img').length) {
                                $(photo_holder).find('.daydestination-photo-holder-inner').prepend('<img src="' + val.url + '" alt="" />');
                            } else {
                                $(photo_holder).find('img').attr('src', val.url);
                            }

                            $(photo_holder).find(".dayphoto-url").val(val.url);
                            $(photo_holder).find(".dayphoto").val(val.id);

                            found = true;
                        }
                    });

                    if (!found && destination_libraries[dest_id].length) {

                        var loop = 0;
                        do {
                            var random_item = destination_libraries[dest_id][Math.floor(Math.random() * destination_libraries[dest_id].length)];
                            current_photo = random_item.id;
                        } while (random_item.represents == 0 && loop < 20);

                        $.each(destination_libraries[dest_id], function (key, val) {
                            if (val.id == current_photo) {
                                if (!$(photo_holder).find('img').length) {
                                    $(photo_holder).find('.daydestination-photo-holder-inner').prepend('<img src="' + val.url + '" alt="" />');
                                } else {
                                    $(photo_holder).find('img').attr('src', val.url);
                                }

                                $(photo_holder).find(".dayphoto-url").val(val.url);
                                $(photo_holder).find(".dayphoto").val(val.id);
                            }
                        });
                    }

                    $(photo_holder).find(".daydestination-photo-holder-txt").hide();
                    $(photo_holder).find(".daydestination-photo-holder-inner").slideDown();
                    $(photo_holder).find(".nextprev-photo").show();

                    if (destination_libraries[dest_id].length > 1) {
                        $(photo_holder).find(".nextprev-photo").show();
                        $(photo_holder).find(".nextprev-photo").off('click').on('click', function (e) {
                            e.preventDefault();

                            $(photo_holder).find('img').attr('src', '');

                            var direction = 'next';
                            if ($(this).hasClass('prev-photo')) {
                                direction = 'prev';
                            }

                            // Get destination ID
                            var dest_id = $(photo_holder).closest('li[data-index]').find('.day-destination').attr('data-id');
                            var current_index = 0;
                            $.each(destination_libraries[dest_id], function (key, val) {

                                if (val.id == $(photo_holder).find(".dayphoto").val()) {
                                    current_index = key;
                                }

                            });

                            if (direction == 'next') {
                                current_index++;
                            } else {
                                current_index--;
                            }

                            if (current_index < 0) {
                                current_index = destination_libraries[dest_id].length - 1;
                            } else if (current_index >= destination_libraries[dest_id].length) {
                                current_index = 0;
                            }

                            if (!$(photo_holder).find('img').length) {
                                $(photo_holder).find('.daydestination-photo-holder-inner').prepend('<img src="' + destination_libraries[dest_id][current_index].url + '" alt="" />');
                            } else {
                                $(photo_holder).find('img').attr('src', destination_libraries[dest_id][current_index].url);
                            }

                            $(photo_holder).find(".dayphoto-url").val(destination_libraries[dest_id][current_index].url);
                            $(photo_holder).find(".dayphoto").val(destination_libraries[dest_id][current_index].id);

                            return false;

                        });
                    } else {
                        $(photo_holder).find(".nextprev-photo").hide();
                    }
                }
            }
        }

        if (reset) {
            $(photo_holder).find(".daydestination-photo-holder-txt").show();
            if ($(dest).val() == '') {
                $(photo_holder).find(".daydestination-photo-holder-txt").text('Please select a destination first');
            } else {
                $(photo_holder).find(".daydestination-photo-holder-txt").text('We don\'t have a photo for this destination');
            }
            $(photo_holder).find(".daydestination-photo-holder-inner").slideUp();
            $(photo_holder).find(".nextprev-photo").hide();
            $(photo_holder).find(".dayphoto-url").val('');
            $(photo_holder).find(".dayphoto").val('');
        }

    }

}

var _curTitleMsg = "";
function handleTitleValidation(data, op_id) {

    var _data = $.parseJSON(current_data);
    var inuse = data.inuse;

    // determine error message addition if the current title was marked as invalid with the current days
    var add = ($('select[name=no_of_days]').val() != _data.no_of_days || $('input[name=title]').val() != _data.title)?"":$("input[name=title]").data("inuse-addition");

    if (!inuse) {
        _curTitleMsg = "";
        hideError($("input[name=title]+.limit-msg"), 'This tour title is not available because you have already uploaded another tour that uses the same title', 'title05');
        hideError($("input[name=title]+.limit-msg"), 'This tour title is not available because it is being used by another tour operator'+add, 'title05');
    } else {
        var showErrorMessage = "";
        if (inuse == op_id) {
            showErrorMessage = 'This tour title is not available because you have already uploaded another tour that uses the same title';
        } else {
            showErrorMessage = 'This tour title is not available because it is being used by another tour operator'+add;
        }

        var _showError = function() {
            if (inuse == op_id) {
            } else {
                showError($("input[name=title]+.limit-msg"), 'This tour title is not available because it is being used by another tour operator'+add, 'title05');
            }
        }

        if (_curTitleMsg!="" && _curTitleMsg!=showErrorMessage) {
            // message changed .. so first hide current en show new one after it finished hiding
            hideError($("input[name=title]+.limit-msg"), _curTitleMsg, 'title05', function () {
                showError($("input[name=title]+.limit-msg"), showErrorMessage, 'title05');
            });
        }
        else
            showError($("input[name=title]+.limit-msg"), showErrorMessage, 'title05');

        // keep current message so we can hide it later
        _curTitleMsg = showErrorMessage;
    }
}
function validateTitle(title) {

    var op_id = (typeof operator_id != 'undefined') ? operator_id : 0;
    if (op_id == 0 && $("select[name='operator_id']").length) {
        op_id = $("select[name='operator_id']").val();
    }
    $.post( backend_url("safari/validatetitle"), { id: safari_id, op_id: op_id, days: $('select[name=no_of_days]').val(), title: title }).done(handleTitleValidation);
}

/**
    Builds title preview based on selected days and give title
*/
function buildTitlePreview(firstLoad) {
    debugFunctionCall('buildTitlePreview');

    var titlePreview = '';
    if ($.isNumeric($('select[name=no_of_days]').val())) {
        titlePreview = $('select[name=no_of_days] option:selected').text();
    }
    var subTitlePreview = $('input[name=title]').val();
    subTitlePreview = UCWords(subTitlePreview);
    subTitlePreview = subTitlePreview.replace(new RegExp('  ', 'g'), ' ');
    subTitlePreview = subTitlePreview.replace(new RegExp('[\.!_\?¡¿¨@\*\^…¡¿#\{\}]', 'g'), '');
    if (subTitlePreview != $('input[name=title]').val()) {
        var startPos = $('input[name=title]').get(0).selectionStart, endPos = $('input[name=title]').get(0).selectionEnd;
        $('input[name=title]').val(subTitlePreview);
        $('input[name=title]').get(0).setSelectionRange(startPos, endPos);
    }
    var trimmed_subTitlePreview = $.trim(subTitlePreview);
    titlePreview += ' ' + trimmed_subTitlePreview.substring(0, 50);

    if (titlePreview == '') {
        titlePreview = '-';
    }
    $('#title .title-preview b').html(titlePreview);

    if ($(".thumbpreviews").length) {
        $(".thumbpreviews h1").html(titlePreview);
    }

    if (firstLoad == true) {

        if ($('select[name=no_of_days]').val() > 0) {
            $("select[name=no_of_days] option[value='']").remove();
            if ($('select[name=no_of_days]').val() > 1) {
                $(".multi-day-txt").show();
            } else {
                $(".multi-day-txt").hide();
            }
        }
        $('select[name=no_of_days]').bind('change', function() {
            $("select[name=no_of_days] option[value='']").remove();
            setSolved('title01');
            hideError($("input[name=title]+.limit-msg"), 'You\'ll have to select the number of days for this tour', 'title01');
            $(this).removeClass('error');

            if ($('select[name=no_of_days]').val() > 1) {
                $(".no-of-days").html('' + $('select[name=no_of_days]').val() + ' days');
            } else if ($('select[name=no_of_days]').val() == 1) {
                $(".no-of-days").html('1 day');
            } else {
                $(".no-of-days").html('½ day');
            }

            if ($('select[name=no_of_days]').val() > 1) {
                $(".multi-day-txt").show();
            } else {
                $(".multi-day-txt").hide();
            }

            if ($('select[name=no_of_days]').val() > 0) {
                var title = $("#title input[type=text]").val();
                if (title != '')
                    validateTitle(title);
            }

            buildTitlePreview(false);

            handleBlockDaybyday(false);
            handleBlockInclusions();

            $(".tour-form #focus input[name=focus]").first().trigger('change');

            updateAddADayDropdown();

            initTourformHelpMarks();

            showRouteMap();
        });
        $('input[name=title]').bind('keyup', function() {
            buildTitlePreview(false);
        });
    }
}

function fixShowingDaybydayErrors() {
    debugFunctionCall('fixShowingDaybydayErrors');

    var start_height = $(".overall-errors").height();
    $(".overall-errors > ul > li[data-day]").each(function() {
        var lbl = "Day " + $(this).attr('data-day').replace('-', ' to ') + ":";
        if (!$("#daybyday > div > ul > li:visible h3:contains('" + lbl + "')").length) {
            $(this).remove();
        }
    });
    var end_height = $(".overall-errors").height();
    var y = $(window).scrollTop();
    $(window).scrollTop(y- (start_height - end_height));
}

function handleBlockTitle() {
    debugFunctionCall('handleBlockTitle');

    $("#title input[type=text]").bind('keyup', function() {
        var title = $(this).val();
        title = title.replace(/(\r\n|\n|\r)/gm, " ").replace(/^\s+/g, "").replace(new RegExp('  ', 'g'), ' ');
        if (title != $(this).val()) {
            var startPos = $(this).get(0).selectionStart, endPos = $(this).get(0).selectionEnd;
            $(this).val(title);
            $(this).get(0).setSelectionRange(startPos, endPos);
        }
        if (_curTitleMsg!="") {
            hideError($("input[name=title]+.limit-msg"), _curTitleMsg, 'title05');
            _curTitleMsg = "";
        }
        showHideError(title.length > 50, $("input[name=title]+.limit-msg"), 'Your title exceeds the limit of 50 characters', 'title03');
        var testPunctuation = new RegExp('\([a-z0-9]{2,}[\.]\)\([^.\\-–—\(\)\\[\\]{}:;\'’"‘’“”„ 0-9]\)|\([\.]\)([^.\\-–—\(\)\\[\\]{}:;\'’"‘’“”„ 0-9]{2,}\)|\([,]\)\([^.\\-–—()\\[\\]{}:;\'’"‘’“”„ 0-9]\)', 'g');
        showHideError(testPunctuation.test(title), $("input[name=title]+.limit-msg"), 'Use punctuation marks correctly (<a href="'+backend_url('properpunctuation')+'" target="_blank">learn how</a>). There should always be a space after a comma (,).', 'title04');
        var testDay = new RegExp('\( day | days \)', 'gi');
        showHideError(testDay.test(" " + title + " "), $("input[name=title]+.limit-msg"), 'Don\'t mention the number of days in the text box (you can ignore this warning if you use the word ‘day’ for another purpose)');
        var testCurrencyWord = new RegExp('\( usd | eur | gbp | euro | euros | dollar | dollars | pound | pounds \)', 'gi');
        showHideError(testCurrencyWord.test(" " + title + " "), $("input[name=title]+.limit-msg"), 'Don\'t mention rates in the tour title (words such as USD, EUR, GBP or similar are not allowed)', 'title06');
        buildTitlePreview(false);
        if (title.length > 10) {
            hideError($("input[name=title]+.limit-msg"), 'Your title must be at least 10 characters', 'title02');
        }
    }).bind('blur', function() {
        var title = $(this).val();
        if ($(".overall-errors").length) {
            showHideError(title.length < 10, $("input[name=title]+.limit-msg"), 'Your title must be at least 10 characters', 'title02');
        } else {
            showHideError(title.length > 0 && title.length < 10, $("input[name=title]+.limit-msg"), 'Your title must be at least 10 characters', 'title02');
        }
        if ($('select[name=no_of_days]').val() > 0 && title != '') {
            validateTitle(title);
        }
    });
}

function handleBlockDescription() {
    debugFunctionCall('handleBlockDescription');

    $("#description textarea").bind('keyup', function() {
        var text = $(this).val();
        text = text.replace(/(\r\n|\n|\r)/gm, " ").replace(/^\s+/g, "").replace(new RegExp('  ', 'g'), ' ');
        if (text != $(this).val()) {
            var startPos = $(this).get(0).selectionStart, endPos = $(this).get(0).selectionEnd;
            $(this).val(text);
            $(this).get(0).setSelectionRange(startPos, endPos);
        }
        showHideError(text.length > 500, $("textarea[name=description]+.limit-msg"), 'Your short tour description exceeds the limit of 500 characters', 'description02');
        var testPunctuation = new RegExp('\([a-z0-9\-]{2,}[\.]\)\([^.\\-–—\(\)\\[\\]{}:;\'’"‘’“”„ 0-9]\)|\([\.]\)([^.\\-–—\(\)\\[\\]{}:;\'’"‘’“”„ 0-9]{2,}\)|\([,\?!]\)\([^.\\-–—()\\[\\]{}:;\'’"‘’“”„ 0-9]\)', 'g');
        showHideError(testPunctuation.test(text), $("textarea[name=description]+.limit-msg"), 'Use punctuation marks correctly (<a href="'+backend_url('properpunctuation')+'" target="_blank">learn how</a>). There should ALWAYS be a space after a comma (,) or end mark (?, !, or .).', 'description06');
        var testPunctuation = new RegExp('\([ ]\)\([,\?!\.]\)', 'g');
        showHideError(testPunctuation.test(text), $("textarea[name=description]+.limit-msg"), 'Use punctuation marks correctly (<a href="'+backend_url('properpunctuation')+'" target="_blank">learn how</a>). There should be NO space before a comma (,) or end mark (?, !, or .).', 'description05');
        var testAllcaps = new RegExp('\([A-Z]\){5}', 'g');
        showHideError(testAllcaps.test(text.replace('UNESCO', '')), $("textarea[name=description]+.limit-msg"), 'It is not allowed to write words in ALL CAPS. Abbreviations of 4 characters or less are allowed (e.g., NP, JNB, KATO).', 'description03');
        var testAtOrWWW = new RegExp('http|@|www\\.|\\.nl|\\.co|\\.net|\\.info|\\.org|\\.uk|\\.au|\\.nz|\\.ca|\\.za|\\.tz|\\.ke|\\.bw|\\.ug|\\.rw|\\.zm|\\.zw|\\.na|\\.mz|\\.mw|\\.de|\\.nl|\\.be|\\.it|\\.es|\\.in|\\.fr', 'gi');
        showHideError(testAtOrWWW.test(text), $("textarea[name=description]+.limit-msg"), 'It is not allowed to include links or email addresses', 'description04');
        var testFirstCapital = new RegExp('^\([a-z]\)');
        showHideError(testFirstCapital.test(text), $("textarea[name=description]+.limit-msg"), 'After typing a period (.) at the end of a sentence, the next sentence should start with a capital letter', 'description07');
        if (!testFirstCapital.test(text)) {
            var testCapital = new RegExp('[?!][ ][a-z]|( |^)(?!incl|excl|min|max|etc|ft|sq|mi|in|yd)[a-z0-9\-]{2,}[.]{1} [a-z]', 'g');
            showHideError(testCapital.test(text), $("textarea[name=description]+.limit-msg"), 'After&nbsp;typing a period (.) at the end of a sentence, the next sentence should start with a capital letter', 'description07');
            if (!testCapital.test(text) && text.length > 0) {
                var testStartCapital = new RegExp('^\([A-Z]\)');
                showHideError(!testStartCapital.test(text), $("textarea[name=description]+.limit-msg"), 'Always start your description with a capital letter', 'description08');
            } else {
                hideError($("textarea[name=description]+.limit-msg"), 'Always start your description with a capital letter', 'description08');
            }
        } else {
            hideError($("textarea[name=description]+.limit-msg"), 'Always start your description with a capital letter', 'description08');
        }
        if (text.length >= 250) {
            hideError($("textarea[name=description]+.limit-msg"), 'Your short tour description must be at least 250 characters', 'description01');
        }
    }).bind('blur', function() {
        var text = $(this).val();
        if ($(".overall-errors").length) {
            showHideError(text.length < 250, $("textarea[name=description]+.limit-msg"), 'Your short tour description must be at least 250 characters', 'description01');
        } else {
            showHideError(text.length > 0 && text.length < 250, $("textarea[name=description]+.limit-msg"), 'Your short tour description must be at least 250 characters', 'description01');
        }
    });
}

function handleBlockFocus() {
    debugFunctionCall('handleBlockFocus');

    $(".tour-form #focus input[name=focus]").bind('change', function() {
        setSolved('focus01');
        setSolved('focus03');
        var mainFocus = $(".tour-form #focus input[name=focus]:checked").val();
        $(".tour-form #focus .mountains").hide();
        if ($(".tour-form #focus input[name=focus]:checked").parent().next().hasClass('mountains')) {
            $(".tour-form #focus input[name=focus]:checked").parent().next().show('normal');
        }
        $(".tour-form #focus .mountains input[type=checkbox]").unbind('change').bind('change', function() {
            setSolved('focus03');
        });
        if (mainFocus == 'climb' || mainFocus == 'beach') {
            $("#activities").hide();
            $(".tour-form-jump a[href='#activities']").addClass('inactive');
        } else {
            $("#activities").show();
            $(".tour-form-jump a[href='#activities']").removeClass('inactive');
        }

        if (mainFocus == 'selfdrive' || mainFocus == 'guided_selfdrive') {
            $("#group").hide();
            $(".tour-form-jump a[href='#group']").addClass('inactive');
            $("#activities_selfdrive").removeClass('inactive').attr('checked', true);
            $("#transportation_selfdrive").removeClass('inactive').attr('checked', true);
            $(".gettingthere-airport_transfer-selfdrive").slideDown();
        } else {
            $("#group").show();
            $(".tour-form-jump a[href='#group']").removeClass('inactive');
            $("#activities_selfdrive").addClass('inactive').attr('checked', false);
            $("#transportation_selfdrive").addClass('inactive').attr('checked', false);
            $(".gettingthere-airport_transfer-selfdrive").slideUp();
        }

        $(".tour-form #daybyday .guidedself-gl").addClass('hidden');
        if (mainFocus == 'guided_selfdrive') {
            $("#description .special-h4").slideDown();
            $("#description .special-list").slideDown();
            $('#description .special-list+h4 span').html('Default Guidelines');
            $('#description .special-list+h4 a').css('display', 'inline-block');
            $(".tour-form #daybyday > div > ul > li:eq(0) .guidedself-gl").removeClass('hidden');
        } else {
            $("#description .special-h4").slideUp();
            $("#description .special-list").slideUp();
            $('#description .special-list+h4 span').html('Guidelines');
            $('#description .special-list+h4 a').css('display', 'none');
        }

        setDaybydayGuidelines();

        $("#activities_none").toggleClass('inactive', !(mainFocus == 'scenic'));
        $("#activities_gorilla").toggleClass('inactive', !(mainFocus == 'tracking_safari' || mainFocus == 'tracking' || mainFocus == 'overland' || mainFocus == 'tracking_climbing'));
        $("#activities_chimp").toggleClass('inactive', !(mainFocus == 'tracking_safari' || mainFocus == 'tracking' || mainFocus == 'overland' || mainFocus == 'tracking_climbing'));
        $("#activities_horse").toggleClass('inactive', !(mainFocus == 'horseback'));
        $("#transportation_horse").toggleClass('inactive', !(mainFocus == 'horseback'));
        $("#transportation_mountainbike").toggleClass('inactive', !(mainFocus == 'mountain_bike'));
        $("#transportation_canoe").toggleClass('inactive', !(mainFocus == 'canoe'));
        $("#activities_overland").toggleClass('inactive', !(mainFocus == 'overland'));
        $("#transportation_overland").toggleClass('inactive', !(mainFocus == 'overland'));
        $("#activities_horse").attr('checked', !$("#activities_horse").hasClass('inactive'));
        $("#transportation_canoe").attr('checked', !$("#transportation_canoe").hasClass('inactive'));
        $("#transportation_mountainbike").attr('checked', !$("#transportation_mountainbike").hasClass('inactive'));
        $("#activities_overland").attr('checked', !$("#activities_overland").hasClass('inactive'));
        $("#transportation_overland").attr('checked', !$("#transportation_overland").hasClass('inactive'));

        if ($("#activities_overland").is(":checked")) {
            $("#activities_gamedrive").attr('checked', true);
        }

        if (mainFocus == 'tracking') {
            $(".tour-form #activities input[type=checkbox]").each(function() {
                if (!$(this).hasClass('inactive')) {
                    if ($(this).attr('name') != 'activities[gorilla]' && $(this).attr('name') != 'activities[chimp]') {
                        $(this).addClass('inactive').addClass('inactive-for-tracking');
                        if (!$(this).attr('data-expl')) {
                            $(this).attr('data-expl', 'This is option is disabled because the main focus of this tour is \'Gorilla/chimp tracking only\'');
                        }
                    }
                }
            });
        } else {
            $(".tour-form #activities input[type=checkbox].inactive-for-tracking").removeClass('inactive');
        }

        if (mainFocus == 'climb_safari' || mainFocus == 'tracking_climbing') {
            $(".only-mountainclimb-safari").show();
        } else {
            $(".only-mountainclimb-safari").hide();
        }

        if (mainFocus == 'climb_safari' || mainFocus == 'climb' || mainFocus == 'tracking_climbing') {
            $("body").addClass('safari-mountain');
        } else {
            $("body").removeClass('safari-mountain');
        }

        $(".daybyday-accom-level").each(function() {
            if ($(this).parent().parent().find('.daybyday-accom-type').val() == 'camping' && mainFocus == 'climb') {
                $(this).find('option[value="midrange"]').remove();
                $(this).find('option[value="luxury"]').remove();
                $(this).find('option[value="luxuryplus"]').remove();
            } else {
                if ($(this).find('option[value="midrange"]').length == 0) {
                    $(this).append('<option value="midrange">Mid-range</option>');
                }
                if ($(this).parent().parent().find('.daybyday-accom-type').val() != 'camping' && $(this).parent().parent().find('.daybyday-accom-type').val() != 'mountainhut') {
                    if ($(this).find('option[value="luxury"]').length == 0) {
                        $(this).append('<option value="luxury">Luxury</option>');
                    }
                }
                if ($(this).parent().parent().find('.daybyday-accom-type').val() != 'camping' && $(this).parent().parent().find('.daybyday-accom-type').val() != 'mountainhut') {
                    if ($(this).find('option[value="luxuryplus"]').length == 0) {
                        $(this).append('<option value="luxuryplus">Luxury+</option>');
                    }
                }
            }
        });

        if ($(".tour-form #activities input[type=checkbox][name^=vehicle]:checked").length >= 1) {
            setSolved('activities08');
        }

        $(".tour-form #activities_none").trigger('change');
        $(".tour-form #transportation ul.list li:eq(0) input[type=checkbox]:first-child").trigger('change');


        if (mainFocus != 'overland') {
            showHideError(($('.tour-form #group input[type=radio]:checked').val() != 'group' && mainFocus == 'overland'), $("label[for=group-group]"), 'Shared group tour must be selected because \'Overland truck safari\' is the main focus of this tour', 'group01');

            $(".tour-form label[for='activities_gorilla']").html('Gorilla tracking <span>(at least one gorilla permit must be included)</span>');
            $(".tour-form label[for='activities_chimp']").html('Chimp tracking <span>(all chimp permits must be included)</span>');
            //$(".tour-form label[for='gorillapermits-excluded']").attr('title', 'You can\'t exclude gorilla tracking permits because you\'ve selected \'Gorilla tracking\' as wildlife viewing activity');
            $(".tour-form #gorillapermits-excluded").attr('data-expl', 'You can\'t exclude gorilla tracking permits because you\'ve selected \'Gorilla tracking\' as wildlife viewing activity');
            //$(".tour-form label[for='chimppermits-excluded']").attr('title', 'You can\'t exclude chimp tracking permits because you\'ve selected \'Chimp tracking\' as wildlife viewing activity');
            $(".tour-form #chimppermits-excluded").attr('data-expl', 'You can\'t exclude chimp tracking permits because you\'ve selected \'Chimp tracking\' as wildlife viewing activity');
        } else {
            var cur_no_of_days = parseInt($("select[name=no_of_days]").val());

            if (cur_no_of_days >= 8) {
                $(".tour-form label[for='activities_gorilla']").html('Gorilla tracking <span>(permits may be excluded)</span>');
                $(".tour-form label[for='activities_chimp']").html('Chimp tracking <span>(permits may be excluded)</span>');
                //$(".tour-form label[for='gorillapermits-excluded']").attr('title', 'You can’t exclude gorilla tracking permits because ‘Gorilla tracking’ is selected as wildlife viewing activity. We only allow gorilla permits to be excluded if tours have ‘Overland truck safari’ as main focus and are 8 days or longer.');
                $(".tour-form #gorillapermits-excluded").attr('data-expl', 'You can’t exclude gorilla tracking permits because ‘Gorilla tracking’ is selected as wildlife viewing activity. We only allow gorilla permits to be excluded if tours have ‘Overland truck safari’ as main focus and are 8 days or longer.');
                //$(".tour-form label[for='chimppermits-excluded']").attr('title', 'You can’t exclude chimp tracking permits because ‘Chimp tracking’ is selected as wildlife viewing activity. We only allow chimp permits to be excluded if tours have ‘Overland truck safari’ as main focus and are 8 days or longer.');
                $(".tour-form #chimppermits-excluded").attr('data-expl', 'You can’t exclude chimp tracking permits because ‘Chimp tracking’ is selected as wildlife viewing activity. We only allow chimp permits to be excluded if tours have ‘Overland truck safari’ as main focus and are 8 days or longer.');
            } else {
                $(".tour-form label[for='activities_gorilla']").html('Gorilla tracking <span>(permit must be included on tours <8 days)</span>');
                $(".tour-form label[for='activities_chimp']").html('Chimp tracking <span>(permits must be included on tours <8 days)</span>');
                //$(".tour-form label[for='gorillapermits-excluded']").attr('title', 'You can’t exclude gorilla tracking permits because ‘Gorilla tracking’ is selected as wildlife viewing activity. We only allow gorilla permits to be excluded if tours have ‘Overland truck safari’ as main focus and are 8 days or longer.');
                $(".tour-form #gorillapermits-excluded").attr('data-expl', 'You can’t exclude gorilla tracking permits because ‘Gorilla tracking’ is selected as wildlife viewing activity. We only allow gorilla permits to be excluded if tours have ‘Overland truck safari’ as main focus and are 8 days or longer.');
                //$(".tour-form label[for='chimppermits-excluded']").attr('title', 'You can’t exclude chimp tracking permits because ‘Chimp tracking’ is selected as wildlife viewing activity. We only allow chimp permits to be excluded if tours have ‘Overland truck safari’ as main focus and are 8 days or longer.');
                $(".tour-form #chimppermits-excluded").attr('data-expl', 'You can’t exclude chimp tracking permits because ‘Chimp tracking’ is selected as wildlife viewing activity. We only allow chimp permits to be excluded if tours have ‘Overland truck safari’ as main focus and are 8 days or longer.');
            }
        }

        if (mainFocus == 'walking' || mainFocus == 'canoe' || mainFocus == 'horseback' || mainFocus == 'beach' || mainFocus == 'tracking' || mainFocus == 'climb' || mainFocus == 'tracking_climbing' || mainFocus == 'mountain_bike') {
            $(".tour-form .group-span").html($(".tour-form .group-span").attr('data-val2'));
        } else {
            $(".tour-form .group-span").html($(".tour-form .group-span").attr('data-val1'));
        }

        handleBlockInclusions();
        initTourformHelpMarks();
    });

    $(".tour-form #focus input[name=focus]").first().trigger('change');
}

function handleBlockCountries() {
    debugFunctionCall('handleBlockCountries');

    $(".tour-form #countries input[type=checkbox]").unbind('change').bind('change', function() {
        if ($(".tour-form #countries .default-country:checked").length > 0) {
            setSolved('country01');
        }
        if($("#countries input#MG:checked, #countries input#ET:checked").length > 0) {
            $("#beach_other-div").show();
            $("#other-div").show();
        } else {
            $("#beach_other-div").hide();
            $("#other-div").hide();
        }

        if ($(".promo_newcountries_2018_newtour").length) {
            $(".promo_newcountries_2018_newtour").addClass('hide');
            //if ($(".tour-form #countries input[type=checkbox]:checked").length == 1) {
            if ($("#countries input:checked").length >= 1 && $("#countries input#ET:checked, #countries input#LS:checked, #countries input#MG:checked, #countries input#MW:checked, #countries input#MZ:checked, #countries input#RE:checked, #countries input#SC:checked, #countries input#SZ:checked").length == $("#countries input:checked").length) {
                $(".promo_newcountries_2018_newtour").removeClass('hide');
            }
            //}
        }

        if (!setting_existing_data) {
            $("#daybyday li[data-index]").each(function() {
                if ($(this).find('.daybyday-destination').length && $(this).find('.daybyday-destination').attr('data-id') && $(this).find('.daybyday-destination').attr('data-id') > 0) {
                    var dest_id = $(this).find('.daybyday-destination').attr('data-id');
                    if (typeof destination_countries[dest_id] != 'undefined') {
                        var day = $(this).attr('data-index');
                        if (!checkSelectedCountries(destination_countries[dest_id], day)) {
                            if (!$(this).hasClass('active')) {
                                $(this).find('h3').trigger('click');
                            }
                        }
                    }
                }
            });
        }
        coronaNotice();
    });
    $(".tour-form #countries ul+a").unbind('click').bind('click', function() {
        $(".tour-form #countries select").show();
        $(".tour-form #countries input[type=s]").show();
        $(".tour-form #countries input[type=s]+a").show();
        $(".tour-form #countries ul+a").css('visibility', 'hidden');
        return false;
    });
    $(".tour-form #countries input[type=s]+a").unbind('click').bind('click', function() {
        $(".tour-form #countries select").hide();
        $(".tour-form #countries input[type=s]").hide();
        $(".tour-form #countries input[type=s]+a").hide();
        $(".tour-form #countries ul+a").css('visibility', 'visible');
        return false;
    });
    $(".tour-form #countries input[type=s]").unbind('click').bind('click', function() {
        if ($(".tour-form #countries select").val() == 0) {
            alert('Please select a country from the drop down menu before clicking the ‘Add’ button. Or click the ‘Cancel’ link if you don’t want to add another country');
            return false;
        }
        // Find li with least items
        var items = 100;
        var nthli = 0;
        var counter = 0;
        $('.tour-form #countries > div > ul li').each(function() {
            if ($(this).find('input').length < items) {
                nthli = counter;
                items = $(this).find('input').length;
            }
            counter++;
        });
        $('.tour-form #countries > div > ul li:eq(' + nthli + ')').append('<input type="checkbox" checked name="country[' + $(".tour-form #countries select").val() + ']" id="' + $(".tour-form #countries select").val() + '"><label for="' + $(".tour-form #countries select").val() + '">' + $(".tour-form #countries select option:selected").text() + '</label> <a href="#" class="remove-new">remove</a><br />');
        $(".tour-form #countries select option[value=" + $(".tour-form #countries select").val() + "]").remove();
        $(this).removeClass('loading');
        $(".tour-form #countries select").hide();
        $(".tour-form #countries input[type=s]").hide();
        $(".tour-form #countries input[type=s]+a").hide();
        $(".tour-form #countries ul+a").css('visibility', 'visible');

        handleBlockCountries();
        $(".tour-form #countries input[type=checkbox]:eq(0)").trigger('change');

        $(".tour-form #countries a.remove-new").unbind('click').bind('click', function() {
            $(".tour-form #countries select").append('<option value="' + $(this).prev().prev().val() + '">' + $(this).prev().html() + '</option>');
            $(this).prev().prev().remove();
            $(this).prev().remove();
            $(this).next().remove();
            $(this).remove();

            var options = $(".tour-form #countries select option");
            var arr = options.map(function(_, o) { return { t: $(o).text(), v: o.value }; }).get();
            arr.sort(function(o1, o2) { return o1.t > o2.t ? 1 : o1.t < o2.t ? -1 : 0; });
            options.each(function(i, o) {
                o.value = arr[i].v;
                $(o).text(arr[i].t);
            });

            handleBlockCountries();
            $(".tour-form #countries input[type=checkbox]:eq(0)").trigger('change');

            return false;
        });

        return false;
    });


}

function handleBlockGroup() {
    debugFunctionCall('handleBlockGroup');
    $(".tour-form #group label select").bind('click', function(e) {
        e.preventDefault();
        $(".tour-form #group input[type=radio]").filter('[value="group"]').attr('checked', true);
        $(".tour-form #group input[type=checkbox]:eq(0)").removeAttr('checked');
        if ($(this).parent().prev().is("input[type=checkbox]")) {
            $(".tour-form #group input[type=checkbox]:eq(1)").attr('checked', true);
        }
        $(".tour-form #group input[type=radio]").trigger('change');
    });
    $(".tour-form #group input[type=radio]").bind('change', function() {
        setSolved('group02');

        if ($('.tour-form #group input[type=radio]:checked').val() == 'group') {
            setSolved('group01');
            if (!at_load) {
                $(".tour-form #customizable-no").attr('checked', true);
            }
            $(".tour-form #group input[type=checkbox]:eq(0)").removeAttr('checked');

            $(".tour-form #datesrates .solotraveler-title").html('Single travelers <span>(Can single travelers join this shared group tour?)</span>');
            $(".tour-form label[for='solo-no']").html('<b>No,</b> <span>single travelers can’t join this shared group tour</span>');
            $(".tour-form label[for='solo-yes']").html('<b>Yes,</b> <span>single travelers can join this shared group tour. (Please provide single traveler rates)</span>');
            $(".tour-form .singletraveler-gl1").slideDown();
        } else {
            if (!at_load) {
                $(".tour-form #customizable-yes").attr('checked', true);
            }
            $(".tour-form #group input[type=checkbox]:eq(1)").removeAttr('checked');

            $(".tour-form #datesrates .solotraveler-title").html('Solo travelers <span>(Can this tour be booked by solo travelers?)</span>');
            $(".tour-form label[for='solo-no']").html('<b>No,</b> <span>this tour is not available to solo travelers</span>');
            $(".tour-form label[for='solo-yes']").html('<b>Yes,</b> <span>this tour can be booked by solo travelers. (Please provide solo traveler rates)</span>');
            $(".tour-form .singletraveler-gl1").slideUp();

            var changed_av = false;
            $(".availability-options li").each(function() {
                if ($(this).find(".availability-date-picker-from").length && $(this).find(".availability-date-picker-from").val() != '' && $(this).find(".availability-date-picker-to").val() != '') {
                    if ($(this).find('select').val() > 1) {
                        $(this).find('select').val('0');
                        changed_av = true;
                    }
                }
            });

            if (changed_av) {
                fillAvailabilityCalendarVars();
                $(".date-range-picker-holder.hasDatepicker").datepicker("refresh");
            }
        }
        var mainFocus = $(".tour-form #focus input[name=focus]:checked").val();
        showHideError(($('.tour-form #group input[type=radio]:checked').val() != 'group' && mainFocus == 'overland'), $("label[for=group-group]"), 'Shared group tour must be selected because \'Overland truck safari\' is the main focus of this tour', 'group01');

        $(".tour-form #datesrates input[name='rates[fixeddates]']").trigger('change');

    });
    $(".tour-form #group input[type=checkbox]:eq(0)").bind('change', function() {
        if ($(this).is(":checked")) {
            $(".tour-form #group input[type=radio]").filter('[value="private"]').attr('checked', true);
            $(".tour-form #group input[type=radio]").trigger('change');
        }
        $(".tour-form #group input[type=checkbox]:eq(1)").removeAttr('checked');
    });
    $(".tour-form #group input[type=checkbox]:eq(1)").bind('change', function() {
        if ($(this).is(":checked")) {
            $(".tour-form #group input[type=radio]").filter('[value="group"]').attr('checked', true);
            $(".tour-form #group input[type=radio]").trigger('change');
        }
        $(".tour-form #group input[type=checkbox]:eq(0)").removeAttr('checked');
    });
    $(".tour-form #group select:eq(0)").bind('change', function() {
        setSolved('group02');
        if ($(this).val() > 0) {
            setSolved('group03');
        }
    });
    $(".tour-form #group select:eq(1)").bind('change', function() {
        setSolved('group02');
        if ($(this).val() > 0) {
            setSolved('group04');
        }
    });
}

function handleBlockActivities() {
    debugFunctionCall('handleBlockActivities');

    $(".tour-form #activities input[type=checkbox]").bind('change', function() {
        var mainFocus = $(".tour-form #focus input[name=focus]:checked").val();

        if ($(this).is(':checked') && $(this).attr('name') == 'activities[none]') {
            $(".tour-form #activities input[type=checkbox][name!='activities[none]']").attr('checked', false);
        } else if ($(this).is(':checked') && $(this).attr('name') != 'activities[none]') {
            $(".tour-form #activities input[type=checkbox][name='activities[none]']").attr('checked', false);
        }

        if ($(".overall-errors").length) {
            showHideError( ($(".tour-form #activities input[type=checkbox]:not(.inactive):checked").length == 0), $("#activities hr+ul"), 'At least one of the options must be selected', 'activities07');
        }

        if (!(!$(".tour-form #activities input[type=checkbox][name='activities[gamedrive]']").is(':checked') && (mainFocus == 'gamedrive' || mainFocus == 'beach_safari')) || ($(this).attr('name') == 'activities[gamedrive]')) {
            var focus = (mainFocus == 'beach_safari') ? 'Beach holiday & game drive safari' : 'Game drive safari';
            showHideError((!$(".tour-form #activities input[type=checkbox][name='activities[gamedrive]']").is(':checked') && (mainFocus == 'gamedrive' || mainFocus == 'beach_safari')), $("#activities hr+ul"), '\'Game drives\' must be selected because \''+focus+'\' is the main focus of this tour', 'activities01');
        }
        if (!(!$(".tour-form #activities input[type=checkbox][name='activities[gamedrive]']").is(':checked') && mainFocus == 'tracking_safari') || ($(this).attr('name') == 'activities[gamedrive]')) {
            showHideError((!$(".tour-form #activities input[type=checkbox][name='activities[gamedrive]']").is(':checked') && mainFocus == 'tracking_safari'), $("#activities hr+ul"), 'Game drives must be selected because \'Gorilla/Chimp tracking &amp; game drive safari\' is the main focus of this tour', 'activities09');
        }
        if (!(!$(".tour-form #activities input[type=checkbox][name='activities[gamedrive]']").is(':checked') && mainFocus == 'climb_safari') || ($(this).attr('name') == 'activities[gamedrive]')) {
            showHideError((!$(".tour-form #activities input[type=checkbox][name='activities[gamedrive]']").is(':checked') && mainFocus == 'climb_safari'), $("#activities hr+ul"), 'Game drives must be selected because \'Mountain Climbing &amp; game drive safari\' is the main focus of this tour', 'activities10');
        }
        if (!(!$(".tour-form #activities input[type=checkbox][name='activities[horse]']").is(':checked') && mainFocus == 'horseback') || ($(this).attr('name') == 'activities[horse]')) {
            showHideError((!$(".tour-form #activities input[type=checkbox][name='activities[horse]']").is(':checked') && mainFocus == 'horseback'), $("#activities hr+ul"), 'Horseback safaris must be selected because it is the main focus of this tour', 'activities04');
        }
        if (!(!$(".tour-form #activities input[type=checkbox][name='activities[birding]']").is(':checked') && mainFocus == 'birding') || ($(this).attr('name') == 'activities[birding]')) {
            showHideError((!$(".tour-form #activities input[type=checkbox][name='activities[birding]']").is(':checked') && mainFocus == 'birding'), $("#activities hr+ul"), 'Specialized birding must be selected because it is the main focus of this tour', 'activities06');
        }
        if (!(!$(".tour-form #activities input[type=checkbox][name='activities[walking]']").is(':checked') && mainFocus == 'walking') || ($(this).attr('name') == 'activities[walking]')) {
            showHideError((!$(".tour-form #activities input[type=checkbox][name='activities[walking]']").is(':checked') && mainFocus == 'walking'), $("#activities hr+ul"), 'Walking safaris must be selected because it is the main focus of this tour', 'activities02');
        }
        if (!(!$(".tour-form #activities input[type=checkbox][name='activities[canoe]']").is(':checked') && mainFocus == 'canoe') || ($(this).attr('name') == 'activities[canoe]')) {
            showHideError((!$(".tour-form #activities input[type=checkbox][name='activities[canoe]']").is(':checked') && mainFocus == 'canoe'), $("#activities hr+ul"), 'Canoe/Mokoro must be selected because it is the main focus of this tour', 'activities03');
        }

        showHideError( (!$(".tour-form #activities input[type=checkbox][name='activities[none]']").is(':checked') && $(".tour-form #activities input[type=checkbox][name='activities[gamedrive]']").is(':checked') && $(".tour-form #activities input[type=checkbox][name^='vehicle']:checked").length == 0 && $(".overall-errors").length), $("#activities hr+ul"), 'You\'ll have to select a game drive vehicle because \'Game drives\' is selected', 'activities08');
        var gorilla_check = new RegExp('\(goril|gorril\)', 'i');
        showHideError( (!$(".tour-form #activities input[type=checkbox][name='activities[gorilla]']").is(':checked') && (mainFocus == 'tracking' || mainFocus == 'tracking_safari' || mainFocus == 'tracking_climbing') && gorilla_check.test($(".tour-form #title input[type=text]").val())), $("#activities hr+ul"), 'Gorilla tracking must be selected because your tour title contains the word \'gorilla\'', 'activities12');
        showHideError( (!$(".tour-form #activities input[type=checkbox][name='activities[gorilla]']").is(':checked') && !(mainFocus == 'tracking' || mainFocus == 'tracking_safari' || mainFocus == 'tracking_climbing') && gorilla_check.test($(".tour-form #title input[type=text]").val())), $("#activities hr+ul"), 'Gorilla tracking must be selected because your tour title contains the word \'gorilla\'. In order to select gorilla tracking as a wildlife viewing activity, you\'ll first have to change the main focus of this tour to one of the two gorilla tracking options', 'activities14');
        var chimp_check = new RegExp('\(chimp\)', 'i');
        showHideError( (!$(".tour-form #activities input[type=checkbox][name='activities[chimp]']").is(':checked') && (mainFocus == 'tracking' || mainFocus == 'tracking_safari' || mainFocus == 'tracking_climbing') && chimp_check.test($(".tour-form #title input[type=text]").val())), $("#activities hr+ul"), 'Chimp tracking must be selected because your tour title contains the word \'chimp\'', 'activities13');
        showHideError( (!$(".tour-form #activities input[type=checkbox][name='activities[chimp]']").is(':checked') && !(mainFocus == 'tracking' || mainFocus == 'tracking_safari' || mainFocus == 'tracking_climbing') && chimp_check.test($(".tour-form #title input[type=text]").val())), $("#activities hr+ul"), 'Chimp tracking must be selected because your tour title contains the word \'chimp\'. In order to select chimp tracking as a wildlife viewing activity, you\'ll first have to change the main focus of this tour to one of the two chimp tracking options.', 'activities15');

        if ($(this).hasClass('inactive')) {
            return false;
        }
        if ($(this).attr('name').substring(0, 5) == 'activ') {
            if (!$(this).is(':checked') && $(this).attr('name') == 'activities[gamedrive]') {
                $(".tour-form #activities input[type=checkbox][name^='vehicle']").attr('checked', false);
            }
            if ($(".tour-form #activities input[type=checkbox]:checked").length > 0) {
                setSolved('activities07');
            }
        } else {
            if ($(this).is(':checked')) {
                setSolved('activities01');
                setSolved('activities09');
                setSolved('activities10');
                hideError($("#activities hr+ul"), 'Game drives must be selected because \''+focus+'\' is the main focus of this tour', 'activities01');
                hideError($("#activities hr+ul"), 'Game drives must be selected because \'Gorilla/Chimp tracking &amp; game drive safari\' is the main focus of this tour', 'activities09');
                hideError($("#activities hr+ul"), 'Game drives must be selected because \'Mountain Climbing &amp; game drive safari\' is the main focus of this tour', 'activities10');
                $(".tour-form #activities input[type=checkbox][name='activities[gamedrive]']").attr('checked', true);
            }
            setSolved('activities08');
        }
        showHideError( ($(".tour-form #activities input[type=checkbox][name^='vehicle']:checked").length >= 3) , $("#activities hr+ul"), 'You selected 3 or more vehicle types. Are you sure clients will use all of them on this tour? If so, you can ignore this warning.', 'activities99');
        showHideError( ($(".tour-form #activities input[type=checkbox][name^='activities']:checked").length >= 5) , $("#activities hr+ul"), 'You selected 5 or more activities. Are you sure all are included for the rate advertised? If so, you can ignore this warning.', 'activities98');

        handleBlockInclusions();
    });
}

function handleBlockTransportation() {
    debugFunctionCall('handleBlockTransportation');

    $(".tour-form #transportation input[type=checkbox]").bind('change', function() {
        setSolved('transportation04');

        var mainFocus = $(".tour-form #focus input[name=focus]:checked").val();
        showHideError((!$(".tour-form #transportation input[type=checkbox][name='transportation[airtransfer]']").is(':checked') && mainFocus == 'fly_in'), $("#transportation .guidelines+ul"), 'Air transfer must be selected because \'Fly-in safari\' is the main focus of this tour', 'transportation01');
        showHideError((!$(".tour-form #transportation input[type=checkbox][name='transportation[overland]']").is(':checked') && mainFocus == 'overland'), $("#transportation .guidelines+ul"), 'Overland safari truck must be selected because \'Overland truck safari\' is the main focus of this tour', 'transportation02');
        showHideError((!$(".tour-form #transportation input[type=checkbox][name='transportation[selfdrive]']").is(':checked') && (mainFocus == 'selfdrive' || mainFocus == 'guided_selfdrive')), $("#transportation .guidelines+ul"), 'Self drive must be selected because it is the main focus of this tour', 'transportation03');

        var countForWarning = 0;
        if ($(".tour-form #transportation input[type=checkbox][name='transportation[opensided]']").is(':checked')) {
            countForWarning++;
        }
        if ($(".tour-form #transportation input[type=checkbox][name='transportation[popup44]']").is(':checked')) {
            countForWarning++;
        }
        if ($(".tour-form #transportation input[type=checkbox][name='transportation[popupminivan]']").is(':checked')) {
            countForWarning++;
        }
        if ($(".tour-form #transportation input[type=checkbox][name='transportation[normal44]']").is(':checked')) {
            countForWarning++;
        }
        if ($(".tour-form #transportation input[type=checkbox][name='transportation[minivan]']").is(':checked')) {
            countForWarning++;
        }
        showHideError( (countForWarning >= 3) , $("#transportation .guidelines+ul"), 'You selected 3 or more vehicle types. Are you sure clients will use all of them on this tour? If so, you can ignore this warning.', 'transportation99');

    });
    $(".tour-form #transportation input[name='transportation[airtransfer]']").bind('change', function() {
        handleBlockInclusions();
        handleBlockNotes();
        if ($(".tour-form .fixedflightbudget-active").is(":visible")) {
            $('.tour-form input:radio[name="notes[306]"]').filter('[value="yes"]').attr('checked', true);
        }
        $(".tour-form #daybyday > div > ul > li:visible:gt(0):not(:last) textarea").trigger('keyup');
    });
}

function handleBlockGettingthere() {
    debugFunctionCall('handleBlockGettingthere');

    var cur_no_of_days = parseInt($("select[name=no_of_days]").val());
    if (cur_no_of_days > 1) {
        $(".tour-form .gettingthere-gl1").show();
    }

    $(".tour-form #gettingthere input[type=text]").bind('blur', function() {
        if ($(this).val() != '') {
            $(this).trigger('keyup');
        }
    });
    $(".tour-form #gettingthere input[type=text]").bind('keyup', function() {
        if ($(this).attr('id') == 'start-city') {
            setSolved('gettingthere01');
        } else {
            setSolved('gettingthere02');
        }
        var airport_regex = new RegExp('(airport)', 'i');
        showHideError(airport_regex.test($(this).val()), $(this), 'Please don\'t list airports. Instead, list one city name', 'gettingthere03');
        var citycountry_regex = new RegExp('(city|town|village|Botswana|Kenya|Malawi|Mozambique|Namibia|Rwanda|South Africa|Tanzania|Uganda|Zambia|Zimbabwe|Angola|Burundi|Congo|Ethiopia|Lesotho|Madagascar|Swaziland|Reunion|Seychelles|Swaziland|Reunion Island)', 'i');
        var capetown_regex = new RegExp('(cape town|sun city|stone town|zanzibar stone town|pemba town|victoria falls town|Ilha de Mozambique|Island of Mozambique)', 'i');
        showHideError((citycountry_regex.test($(this).val()) && !capetown_regex.test($(this).val())), $(this), 'Please list only the city name; don\'t add words such as \'city\', \'town\' or a country', 'gettingthere04');
        var or_regex = new RegExp('( or )|( [^a-z0-9 ]or )|( or[^a-z0-9 ] )|( [^a-z0-9 ]or[^a-z0-9 ] )|( and )|( [^a-z0-9 ]and )|( and[^a-z0-9 ] )|( [^a-z0-9 ]and[^a-z0-9 ] )|( and$)|( or$)', 'i');
        showHideError(or_regex.test($(this).val()), $(this), 'Please list only one city per text box (the words \'or\' \'and\' are not allowed)', 'gettingthere05');
        var newVal = UCWords($(this).val());
        if (newVal != $(this).val()) {
            var startPos = $(this).get(0).selectionStart, endPos = $(this).get(0).selectionEnd;
            $(this).val(newVal);
            $(this).get(0).setSelectionRange(startPos, endPos);
        }
    });
    $(".tour-form #gettingthere input[name='gettingthere[airport_transfer]']").bind('change', function() {
        setSolved('gettingthere06');
        setGuidelinesBasedOnGettingThere();
        handleBlockInclusions();
    });
    $(".tour-form #gettingthere input[name='gettingthere[accommodation_beforeafter]']").bind('change', function() {
        setSolved('gettingthere07');
        setGuidelinesBasedOnGettingThere();
        handleBlockInclusions();
    });
}

function setDayBlocks() {
    debugFunctionCall('setDayBlocks');

    $(".tour-form #daybyday .accom-field").hide();
    $(".tour-form #daybyday .title-field").hide();
    $(".tour-form #daybyday .daygrouphint").hide();
    $(".tour-form #daybyday .title-field+.limit-msg").hide();
    $(".tour-form #daybyday .daydescription-titlepreview").hide();
    var cloned = false;
    if ($.isNumeric($('select[name=no_of_days]').val())) {
        var days = $('select[name=no_of_days]').val();
        if (days == 0) {
            days = 1;
        }
        if (days == 1) {
            $(".tour-form #daybyday .accom-field").hide();
            $(".tour-form #daybyday .title-field").hide();
            $(".tour-form #daybyday .daydescription-titlepreview").hide();
            $(".tour-form #daybyday .warn").addClass('hide-import');
            $(".tour-form #daybyday .title-field+.limit-msg").hide();
            $(".tour-form #daybyday .title-field+.limit-msg+.error").remove();
            $(".tour-form #gettingthere .gettingthere-accomms").hide();
            $(".tour-form .guidelines-oneday").show();
        } else {
            $(".tour-form #daybyday .accom-field").show();
            $(".tour-form #daybyday .title-field").show();
            $(".tour-form #daybyday > div > ul > li:eq(0) .daygrouphint").show();
            $(".tour-form #daybyday > div > ul > li:eq(0) .daygrouphint a").unbind('click').bind('click', function() {
                $(this).parent().slideUp();
                $.post( window.location.pathname, { 'hide_daygrouphint': 1 }).done(function( data ) { });
                return false;
            });
            $(".tour-form #daybyday .warn").removeClass('hide-import');
            $(".tour-form #daybyday .title-field+.limit-msg").show();
            $(".tour-form #daybyday .daydescription-titlepreview").show();
            $(".tour-form #gettingthere .gettingthere-accomms").show();
            $(".tour-form .guidelines-oneday").hide();
        }
        if ($(".tour-form #daybyday > div > ul > li").length < days) {
            for (var i=0; i<$(".tour-form #daybyday > div > ul > li").length;i++) {
                $(".tour-form #daybyday > div > ul > li:eq(" + i + ")").show();
            }
            for (var i=$(".tour-form #daybyday > div > ul > li").length; i<days;i++) {
                cloneDayBlock($(".tour-form #daybyday > div > ul > li:last-child"), 'after');
            }
        } else if ($(".tour-form #daybyday > div > ul > li").length > days) {
            $(".tour-form #daybyday > div > ul > li").show();
            for (var i=days; i<$(".tour-form #daybyday > div > ul > li").length;i++) {
                $(".tour-form #daybyday > div > ul > li:eq(" + i + ")").hide();
            }
        } else if ($(".tour-form #daybyday > div > ul > li").length == days) {
            $(".tour-form #daybyday > div > ul > li").show();
        }
    }
    $(".tour-form #daybyday > div > ul > li:visible").each(function() {
        if ($(this).find('.day-accommodation').val() != '0') {
            $(this).find('.daybyday-accom-extra').show();
        }/* else {
            $(this).find('.daybyday-accom-extra').hide();
        }*/
        if ($(this).find('.is-camping input:checked').length == 0) {
            $(this).find('.is-camping input.camping-no').prop("checked", true).trigger('change');
        }
    });
    setDaybydayGuidelines();
    initAutocompleteAcco();
}

function cloneDayBlock(insertBeforeorAfter, before_or_after) {
    debugFunctionCall('cloneDayBlock');

    if ($(".tour-form #daybyday > div > ul > li:last-child").attr('data-index')) {
        var findElementIndex = $(".tour-form #daybyday > div > ul > li:last-child").attr('data-index');
    } else {
        var findElementIndex = 1;
    }
    if (before_or_after == 'after') {
        $(".tour-form #daybyday > div > ul > li:last-child").clone().insertAfter(insertBeforeorAfter);
        var elementIndex = insertBeforeorAfter.next().index();
    } else {
        $(".tour-form #daybyday > div > ul > li:last-child").clone().insertBefore(insertBeforeorAfter);
        var elementIndex = insertBeforeorAfter.prev().index();
    }

    $(".tour-form #daybyday > div > ul > li:gt(" + elementIndex + ")").each(function() {
        if ($(this).find('.day-selection').length) {
            $(this).find('.day-selection option').each(function() {
                var option_txt = $(this).text();
                var option_txt_parts = option_txt.split(' ');
                $(this).text(option_txt_parts[0] + ' ' + (parseInt(option_txt_parts[1]) + 1) + ' ' + option_txt_parts[2] + ' ' + (parseInt(option_txt_parts[3]) + 1) + ':');
            });
        }
    });

    var newElementIndex = $(".tour-form #daybyday > div > ul > li").length;
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") > div").hide();
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") h3").html('<span></span>Day ' + (elementIndex + 1) + ': ');
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") ul.error").remove();
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .daybyday-destination").removeClass('ui-autocomplete-input');
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .daybyday-accom-name").removeClass("ui-autocomplete-input");
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .is-camping input").prop("checked", false);
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ")").removeClass('active');
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ")").show();
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .daygrouphint").hide();
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .help").removeAttr('initialized');
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .guidedself-gl").addClass('hidden');
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") input[type=text]").val('');
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") textarea").val('');
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") input[type=checkbox]").attr('checked', false);
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .title-preview b").html('Day ' + (elementIndex + 1) + ': ');
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .daydescription-titlepreview b").html('Day ' + (elementIndex + 1) + ': ');
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .day-title+.limit-msg").html('You typed <b>0</b> characters and have <b>100</b> characters left (min. 10 max. 100 characters)');
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") textarea+.limit-msg").html('You typed <b>0</b> characters and have <b>1000</b> characters left (min. 250 max. 1000 characters)');
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ")").attr('data-index', $(".tour-form #daybyday > div > ul > li").length);
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ")").attr('data-index', $(".tour-form #daybyday > div > ul > li").length);
    var replaceElementIndex = $(".tour-form #daybyday > div > ul > li").length;
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ")").find('*').each(function() {
        if ($(this).attr('id')) {
            $(this).attr('id', $(this).attr('id').replace('-' + (findElementIndex), '-' + replaceElementIndex));
        }
        if ($(this).attr('name')) {
            $(this).attr('name', $(this).attr('name').replace('-' + (findElementIndex), '-' + replaceElementIndex));
        }
        if ($(this).attr('for')) {
            $(this).attr('for', $(this).attr('for').replace('-' + (findElementIndex), '-' + replaceElementIndex));
        }
    });
    limitedInputs();
    initAutocompleteDest();
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .day-title").bind('keyup', function() {
        daybydayTitleKeyup($(this));
    });
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .day-title").unbind('blur').bind('blur', function() {
        daybydayTitleBlur($(this));
    });
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .test-link").unbind('click').bind('click', function() {
        var url = $(this).closest('li[data-index]').find('.daybyday-accom-website').val();
        if (url.indexOf('http') === -1) {
            url = 'http://' + url;
        }
        $(this).attr('href', url);
    });
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .daybyday-destinationnone").unbind('change').bind('change', function() {
        if ($(this).is(":checked")) {
            $(this).parent().parent().find('.daybyday-destination').attr('disabled', true).val('').addClass('disabled');
            $(this).closest('li[data-index]').find('.daydestination-photo-holder').hide();
            $(this).parent().parent().find(".daydestination-photo-holder-txt").show();
            $(this).parent().parent().find(".daydestination-photo-holder-txt").text('Please select a destination first');
            $(this).parent().parent().find(".daydestination-photo-holder-inner").hide();
            $(this).parent().parent().find(".nextprev-photo").hide();
            var day_nr = $(this).parent().parent().parent().find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
            if ($(this).parent().parent().parent().find('.day-selection').val() == 1) {
                day_nr = day_nr.substring(0, day_nr.indexOf('-'));
            }
            setSolved('daydestination01-' + day_nr);
            setSolved('daydestination02-' + day_nr);
            setSolved('daydestination03-' + day_nr);
            setSolved('daydestination04-' + day_nr);
            setSolved('daydestination05-' + day_nr);
            setSolved('daydestination06-' + day_nr);
            setSolved('daydestination07-' + day_nr);
            if ($(this).parent().parent().find('.daybyday-destination').next().hasClass('error')) {
                $(this).parent().parent().find('.daybyday-destination').next().slideUp(function() { $(this).remove(); });
            }
        } else {
            $(this).parent().parent().find('.daybyday-destination').attr('disabled', false).removeClass('disabled');
            $(this).closest('li[data-index]').find('.daydestination-photo-holder').show();
        }
    });
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .is-camping input").unbind('change').bind('change', function() {
        accommodationCampingChange($(this));
    });
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .daybyday-accom-type").unbind('change').bind('change', function() {
        accommodationTypeChange($(this));
    });
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .daybyday-accom-name").bind('keyup', function() {
        daybydayAccommodationNameKeyup($(this));
    });
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .daybyday-accom-website").unbind('blur').bind('blur', function() {
        daybydayAccommodationWebsiteBlur($(this));
    });
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .daybyday-accom-nowebsite").unbind('change').bind('change', function() {
        var parent_el = $(this).parents(".daybyday-accom-extra-form");
        if ($(this).is(":checked")) {
            cantProvideWebsite(parent_el);
        } else {
            provideWebsite(parent_el);
        }
    });
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .daybyday-accom-level").unbind('change').bind('change', function() {
        accommodationComfortChange($(this));
    });
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .daybyday-accom-location").unbind('change').bind('change', function() {
        accommodationLocationChange($(this));
    });
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") textarea").bind('keyup', function() {
        daybydayDescriptionKeyup($(this));
    });
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") .daydescription-titlepreview a").unbind('click').bind('click', function() {
        jumpTo($(this).parent().parent());
        $(this).parent().parent().find('.daytitle').focus();
    });
    $(".tour-form #daybyday > div > ul > li:eq(" + elementIndex + ") textarea").unbind('blur').bind('blur', function() {
        daybydayDescriptionBlur($(this));
    });

    updateAddADayDropdown();
}

function cantProvideWebsite(parent_el) {
    parent_el.find('.daybyday-accom-website').val('');
    if (parent_el.find('.daybyday-accom-website').next().next().hasClass('error')) {
        parent_el.find('.daybyday-accom-website').next().next().remove();
    }
    parent_el.addClass('no-website');
    parent_el.find('.daybyday-accom-website').prop('disabled', true);
    parent_el.find('.warn-website').show();
    parent_el.find('.warn-website-list').hide();
    websiteWarningLogic();
    if (parent_el.find('.daybyday-accom-website').next().hasClass('error')) {
        parent_el.find('.daybyday-accom-website').next().remove();
    }
    parent_el.find('.accom-detail-web').hide();
}

function provideWebsite(parent_el) {
    parent_el.removeClass('no-website');
    parent_el.find('.daybyday-accom-website').prop('disabled', false);
    parent_el.find('.warn-website').hide();
    parent_el.find('.warn-website-list').show();
    parent_el.find('.daybyday-accom-website').show();
    parent_el.find('.accom-detail-web').show();
}

function hideWebsite(parent_el) {
    parent_el.find(".acco-website").hide();
    parent_el.find(".website-test").hide();
}

function showWebsite(parent_el) {
    parent_el.find(".acco-website").show();
    parent_el.find(".website-test").show();
}

var previous_day_count;
var removing_a_day = false;
function handleBlockDaybyday(firstLoad) {
    debugFunctionCall('handleBlockDaybyday');

    if (firstLoad == true) {
        setCampingPartiQuestion();
        initAutocompleteDest();
        $(".tour-form #daybyday > div > ul > li .day-title").bind('keyup', function() {
            daybydayTitleKeyup($(this));
        });
        $(".tour-form #daybyday > div > ul > li .day-title").unbind('blur').bind('blur', function() {
            daybydayTitleBlur($(this));
        });
        $(".tour-form #daybyday > div > ul > li .test-link").unbind('click').bind('click', function() {
            var url = $(this).closest('li[data-index]').find('.daybyday-accom-website').val();
            if (url.indexOf('http') === -1) {
                url = 'http://' + url;
            }
            $(this).attr('href', url);
        });
        $(".tour-form #daybyday > div > ul > li .daybyday-destinationnone").unbind('change').bind('change', function() {
            if ($(this).is(":checked")) {
                $(this).parent().parent().find('.daybyday-destination').attr('disabled', true).val('').addClass('disabled');
                $(this).closest('li[data-index]').find('.daydestination-photo-holder').hide();
                $(this).parent().parent().find(".daydestination-photo-holder-txt").show();
                $(this).parent().parent().find(".daydestination-photo-holder-txt").text('Please select a destination first');
                $(this).parent().parent().find(".daydestination-photo-holder-inner").hide();
                $(this).parent().parent().find(".nextprev-photo").hide();
                var day_nr = $(this).parent().parent().parent().find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
                if ($(this).parent().parent().parent().find('.day-selection').val() == 1) {
                    day_nr = day_nr.substring(0, day_nr.indexOf('-'));
                }
                setSolved('daydestination01-' + day_nr);
                setSolved('daydestination02-' + day_nr);
                setSolved('daydestination03-' + day_nr);
                setSolved('daydestination04-' + day_nr);
                setSolved('daydestination05-' + day_nr);
                setSolved('daydestination06-' + day_nr);
                setSolved('daydestination07-' + day_nr);
                if ($(this).parent().parent().find('.daybyday-destination').next().hasClass('error')) {
                    $(this).parent().parent().find('.daybyday-destination').next().slideUp(function() { $(this).remove();});
                }

                $(this).parent().parent().find('.day-destination').removeAttr('data-id');

                showDestinationPhotoLibrary(day_nr);
            } else {
                $(this).parent().parent().find('.daybyday-destination').attr('disabled', false).removeClass('disabled');
                $(this).closest('li[data-index]').find('.daydestination-photo-holder').show();
            }
        });
        $(".tour-form #daybyday > div > ul > li .is-camping input").unbind('change').bind('change', function() {
            accommodationCampingChange($(this));
        });
        $(".tour-form #daybyday > div > ul > li .daybyday-accom-type").unbind('change').bind('change', function() {
            accommodationTypeChange($(this));
        });
        $(".tour-form #daybyday > div > ul > li .daybyday-accom-name").bind('keyup', function() {
            daybydayAccommodationNameKeyup($(this));
        });
        $(".tour-form #daybyday > div > ul > li .daybyday-accom-website").unbind('blur').bind('blur', function() {
            daybydayAccommodationWebsiteBlur($(this));
        });
        $(".tour-form #daybyday > div > ul > li .daybyday-accom-nowebsite").unbind('change').bind('change', function() {
            var parent_el = $(this).parents(".daybyday-accom-extra-form");
            if ($(this).is(":checked")) {
                cantProvideWebsite(parent_el);
            } else {
                provideWebsite(parent_el);
            }
        });
        $(".tour-form #daybyday > div > ul > li .daybyday-accom-level").unbind('change').bind('change', function() {
            accommodationComfortChange($(this));
        });
        $(".tour-form #daybyday > div > ul > li .daybyday-accom-level").each(function() {
            accommodationComfortChange($(this));
        });
        $(".tour-form #daybyday > div > ul > li .daybyday-accom-location").unbind('change').bind('change', function() {
            accommodationLocationChange($(this));
        });
        $(".tour-form #daybyday > div > ul > li textarea").bind('keyup', function() {
            daybydayDescriptionKeyup($(this));
        });
        $(".tour-form #daybyday > div > ul > li .daydescription-titlepreview a").unbind('click').bind('click', function() {
            jumpTo($(this).parent().parent());
            $(this).parent().parent().find('.daytitle').focus();
            return false;
        });
        $(".tour-form #daybyday > div > ul > li textarea").unbind('blur').bind('blur', function() {
            daybydayDescriptionBlur($(this));
        });

        $(".tour-form .add-extra-day-link a").unbind('click').bind('click', function() {
            var y = $(window).scrollTop();
            var start_height = $(".tour-form #daybyday").height();
            $(".tour-form .add-extra-day-link").hide();
            $(".tour-form .add-extra-day-block").show();
            $(".tour-form #daybyday > div > ul > li > div").hide();
            $(".tour-form #daybyday > div > ul > li").removeClass('active');
            updateAddADayDropdown();
            var end_height = $(".tour-form #daybyday").height();
            $(window).scrollTop(y- (start_height - end_height));
            return false;
        });
        $(".tour-form .add-extra-day-block a").unbind('click').bind('click', function() {
            $(".tour-form .add-extra-day-block").hide();
            $(".tour-form .add-extra-day-link").show();
            return false;
        });
        $(".tour-form .add-extra-day-block input").unbind('click').bind('click', function() {
            if ($(".tour-form .add-extra-day-block select:eq(1)").val() <= 0) {
                alert('Please select a day from the drop down menu before clicking the ‘Add’ button. Or click the ‘Cancel’ link if you don’t want to add another day’');
            } else {
                if ($("select[name=no_of_days]").val() == '') {
                    var cur_no_of_days = 1;
                } else {
                    var cur_no_of_days = parseInt($("select[name=no_of_days]").val());
                }
                cur_no_of_days++;
                $("select[name=no_of_days]").val(cur_no_of_days);
                if ($(".tour-form .add-extra-day-block select:eq(0)").val() == 'after') {
                    cloneDayBlock($(".tour-form #daybyday > div > ul > li:eq(" + ($(".tour-form .add-extra-day-block select:eq(1)").val() - 1) + ")"), 'after');
                } else {
                    cloneDayBlock($(".tour-form #daybyday > div > ul > li:eq(" + ($(".tour-form .add-extra-day-block select:eq(1)").val() - 1) + ")"), 'before');
                }
                $(".tour-form #focus input[name=focus]").first().trigger('change');
                handleBlockDaybyday(false);
                initTourformHelpMarks();
                $(".tour-form .add-extra-day-block a").trigger('click');
            }
            return false;
        });
        $(".tour-form #daybyday input[name='route_map_status']").unbind('change').bind('change', function() {
            if($("#route_map_status-no").is(':checked')) {
                $('[data-role=route]').attr('data-state', 'unused');
            } else {
                $('[data-role=route]').attr('data-state', '');
            }
        });
    } else {
        setDayBlocks();
    }

    var counter = 1;
    var total = $(".tour-form #daybyday > div > ul > li:visible").length;
    $(".tour-form #daybyday > div > ul > li:visible").each(function() {
        var current_days = parseInt($(this).find('.day-selection').val());
        if (isNaN(current_days)) {
            if ($(this).find('.day-selection').attr('existing-val')) {
                current_days = $(this).find('.day-selection').attr('existing-val');
            } else {
                current_days = 1;
            }
        }
        if (counter == total) {
            // Last day
            $(this).find('.day-selection').find('option').remove();
            $(this).find('.day-selection').append('<option value="1">Day ' + counter + ' to ' + counter + ':</option>');
            var day_lbl = $(this).find('.day-selection').find('option:selected').text();
            if ($(this).find('.day-selection').val() == 1) {
                day_lbl = day_lbl.substring(0, day_lbl.indexOf(' to ')) + ":";
            }
            $(this).find('h3').html('<span></span>' + day_lbl + ' ' + $(this).find('.day-title').val());
            $(this).find('.title-preview b').html(day_lbl + ' ' + $(this).find('.day-title').val());
            $(this).find('.daydescription-titlepreview b').html(day_lbl + ' ' + $(this).find('.day-title').val());
            $(this).find('.warn').addClass('hide-import');

            $(this).find('.daydestination-photo-holder-inner h6').text(day_lbl.replace(":", ""));
            $(this).find('.daydestination-photo-holder-inner h5 span').text($(this).find('.day-title').val());
        } else if (counter > total) {
            $(this).hide();
        } else {
            $(this).find('.day-selection').find('option').remove();
            $(this).find('.day-selection').append('<option value="1">Day ' + counter + ' to ' + counter + ':</option>');
            var options_to = total;
            var found_multiple_days = false;
            var subcounter = 2;
            $(".tour-form #daybyday > div > ul > li:visible").each(function() {
                if (!found_multiple_days && subcounter > counter) {
                    if ($(this).find('.day-selection').val() > 1) {
                        var tmp_total = $(this).find('.day-selection').find('option').first().html().substring($(this).find('.day-selection').find('option').first().html().indexOf(' ') + 1);
                        tmp_total = tmp_total.substring(0, tmp_total.indexOf(' '));
                        options_to = tmp_total;
                        found_multiple_days = true;
                    }
                }
                subcounter++;
            });
            for (i=counter+1; i<options_to; i++) {
                var selected = '';
                if ( (i - counter + 1) == current_days ) {
                    //selected = ' selected ';
                }
                $(this).find('.day-selection').append('<option value="' + (i - counter + 1) + '"' + selected  + '>Day ' + counter + ' to ' + i + ':</option>');
                $(this).find('.day-selection').val(current_days);
            }
            var day_lbl = $(this).find('.day-selection').find('option:selected').text();
            if ($(this).find('.day-selection').val() == 1) {
                day_lbl = day_lbl.substring(0, day_lbl.indexOf(' to ')) + ":";
            }
            $(this).find('h3').html('<span></span>' + day_lbl + ' ' + $(this).find('.day-title').val());
            $(this).find('.title-preview b').html(day_lbl + ' ' + $(this).find('.day-title').val());
            $(this).find('.daydescription-titlepreview b').html(day_lbl + ' ' + $(this).find('.day-title').val());

            $(this).find('.daydestination-photo-holder-inner h6').text(day_lbl.replace(":", ""));
            $(this).find('.daydestination-photo-holder-inner h5 span').text($(this).find('.day-title').val());
        }

        var current_days = parseInt($(this).find('.day-selection').val());
        if (isNaN(current_days)) {
            current_days = 1;
        }
        $(this).find('.day-descr').html('');
        if (current_days >= 2) {
            $(this).find('.day-descr').html('(' + (current_days) + ' nights total)');
        }

        counter = parseInt(counter) + parseInt(current_days);
    });
    $(".tour-form #daybyday > div > ul > li h3").unbind('click').bind('click', function() {
        if ($(this).parent().hasClass('active')) {
            $(this).parent().find('> div').slideUp(300, function() {
                $(this).parent().removeClass('active')
            });
        } else {
            $(this).parent().find('> div').slideDown(300, function() {
                $(this).parent().addClass('active');
            });
        }
    });
    $(".tour-form #daybyday > div > ul > li a.remove-day").each(function() {
        if ($(this).parent().find('.day-selection').val() > 1) {
            $(this).html('<span>Remove these days</span>');
        } else {
            $(this).html('<span>Remove this day</span>');
        }
    });

    if ($(".tour-form #daybyday > div > ul > li:visible").length <= 1) {
        $(".tour-form #daybyday > div > ul > li a.remove-day").addClass('disabled');
    } else {
        $(".tour-form #daybyday > div > ul > li a.remove-day").removeClass('disabled');
    }

    $(".tour-form #daybyday > div > ul > li a.remove-day").unbind('click').bind('click', function() {
        if ($(this).hasClass('disabled') || removing_a_day || $(".tour-form #daybyday > div > ul > li:visible").length <= 1) {
            return false;
        }

        var day_obj = $(this).parent();

        removing_a_day = true;
        var days = parseInt($(this).parent().find('.day-selection').val());
        var cur_no_of_days = parseInt($("select[name=no_of_days]").val());

        var day_title = $(this).parent().find('>h3').text().toLowerCase().split(':');

        var str = 'a day';
        if (days > 1) {
            str = 'these days';
        }
        confirm('Are you sure you want to remove ' + day_title[0] + '? Removing ' + str + ' will make this a ' + (cur_no_of_days - days) + ' day tour, instead of an ' + cur_no_of_days + ' day tour.', function(result) {
            if (result) {
                var cur_no_of_days = parseInt($("select[name=no_of_days]").val());
                cur_no_of_days = cur_no_of_days - days;
                $("select[name=no_of_days]").val(cur_no_of_days);

                $(day_obj).remove();

                handleBlockDaybyday();
                updateAddADayDropdown();

                showRouteMap();

                removing_a_day = false;
            } else {
                removing_a_day = false;
            }
        });

        return false;
    });

    $(".tour-form #daybyday .day-selection").unbind('focus').bind('focus', function() {
        // Find next day-combination, remove combitions from this dropdown from that day-combination
        var currentDayIndex = $(this).parent().parent().index();
        var counter = 0;
        var nextDayCombination = 0;
        $(".tour-form #daybyday > div > ul > li:visible").each(function() {
            counter++;
            if (counter > currentDayIndex && $(this).find('.day-selection').val() > 1) {
                if (nextDayCombination == 0) {
                    nextDayCombination = counter;
                }
            }
        });
        if (nextDayCombination > 0) {
            $(this).find('option:gt(' + (nextDayCombination - currentDayIndex - 2) + ')').remove();
        }
        previous_day_count = this.value;
    }).unbind('change').bind('change', function() {

        var cloned = false;
        var new_day_count = this.value;

        if (previous_day_count < new_day_count) {

            var elm = $(this);

            var day_lbl = $(elm).find('option:selected').text();
            var days_array = day_lbl.replace('Day ', '').replace(':', '').split(' to ');
            if (new_day_count == 2) {
                var confirm_text = 'Are you sure you want to group ' + day_lbl.replace('Day', 'Days').replace(':', '').toLowerCase() + '? The tour info for day ' + days_array[1] + ' will be deleted.';
            } else {
                var confirm_text = 'Are you sure you want to group ' + day_lbl.replace('Day', 'Days').replace(':', '').toLowerCase() + '? The tour info for days ' + (parseInt(days_array[0]) + 1) + ' to ' + days_array[1] + ' will be deleted.';
            }
            confirm(confirm_text, function(result) {
                if (result) {

                    var diff_count = new_day_count - previous_day_count;
                    // Remove merged day-items
                    for (var i = 0; i < diff_count; i++) {
                        $(elm).parent().parent().next().remove();
                    }

                    var day_lbl = $(elm).find('option:selected').text();
                    if ($(elm).val() == 1) {
                        day_lbl = day_lbl.substring(0, day_lbl.indexOf(' to ')) + ":";
                    }
                    $(elm).parent().parent().find('h3').html('<span></span>' + day_lbl + ' ' + $(elm).parent().find('.day-title').val().substring(0, 100));
                    $(elm).parent().find('.day-descr').html('');
                    if ($(elm).val() >= 2) {
                        $(elm).parent().find('.day-descr').html('(' + ($(elm).val()) + ' nights total)');
                    }
                    var day_lbl = $(elm).find('option:selected').text();
                    if ($(elm).val() == 1) {
                        day_lbl = day_lbl.substring(0, day_lbl.indexOf(' to ')) + ":";
                    }

                    $(elm).parent().find(".title-preview b").html(day_lbl + ' ' + $(elm).parent().find(".day-title").val().substring(0, 100));
                    $(elm).parent().find(".daydescription-titlepreview b").html(day_lbl + ' ' + $(elm).parent().find(".day-title").val().substring(0, 100));

                    $(elm).closest('li[data-index]').find('.daydestination-photo-holder-inner h6').text(day_lbl.replace(":", ""));
                    $(elm).closest('li[data-index]').find('.daydestination-photo-holder-inner h5 span').text($(elm).parent().find(".day-title").val().substring(0, 100));

                    if ($(".overall-errors").length) {
                        fixShowingDaybydayErrors();
                    }
                    handleBlockDaybyday(false);
                    handleBlockInclusions();
                    handleBlockNotes();
                    initTourformHelpMarks();

                    updateAddADayDropdown();

                } else {
                    $(elm).val(previous_day_count);
                }
            });

        } else {
            if (previous_day_count > new_day_count) {
                var diff_count = previous_day_count - new_day_count;
                // Remove merged day-items
                for (var i = 0; i < diff_count; i++) {
                    cloneDayBlock($(this).parent().parent(), 'after');
                    cloned = true;
                }
            }

            var day_lbl = $(this).find('option:selected').text();
            if ($(this).val() == 1) {
                day_lbl = day_lbl.substring(0, day_lbl.indexOf(' to ')) + ":";
            }
            $(this).parent().parent().find('h3').html('<span></span>' + day_lbl + ' ' + $(this).parent().find('.day-title').val().substring(0, 100));
            $(this).parent().find('.day-descr').html('');
            if ($(this).val() >= 2) {
                $(this).parent().find('.day-descr').html('(' + ($(this).val()) + ' nights total)');
            }
            var day_lbl = $(this).find('option:selected').text();
            if ($(this).val() == 1) {
                day_lbl = day_lbl.substring(0, day_lbl.indexOf(' to ')) + ":";
            }

            $(this).parent().find(".title-preview b").html(day_lbl + ' ' + $(this).parent().find(".day-title").val().substring(0, 100));
            $(this).parent().find(".daydescription-titlepreview b").html(day_lbl + ' ' + $(this).parent().find(".day-title").val().substring(0, 100));

            $(this).closest('li[data-index]').find('.daydestination-photo-holder-inner h6').text(day_lbl.replace(":", ""));
            $(this).closest('li[data-index]').find('.daydestination-photo-holder-inner h5 span').text($(this).parent().find(".day-title").val().substring(0, 100));

            if ($(".overall-errors").length) {
                fixShowingDaybydayErrors();
            }
            handleBlockDaybyday(false);
            handleBlockInclusions();
            handleBlockNotes();
            initTourformHelpMarks();

            updateAddADayDropdown();
        }
    });

    if ($(".overall-errors").length) {
        fixShowingDaybydayErrors();
    }

    setGuidelinesBasedOnGettingThere();

    if ($(".tour-form #daybyday > div > ul > li:visible:last .last-day-destination input").is(":checked")) {
        $(".tour-form #daybyday > div > ul > li:visible:last .day-destination").addClass('disabled').attr('disabled', true);
        $(".tour-form #daybyday > div > ul > li:visible:last .daydestination-photo-holder").hide();
    }

    //if ($(".tour-form #daybyday > div > ul > li:visible").find('.day-description').next().length) {
    $(".tour-form #daybyday > div > ul > li:visible").find('.day-description').attr('data-min', 250);
    $(".tour-form #daybyday > div > ul > li:visible").find('.daydescription-length-guideline').html('The description should be at least 250 and max. 1000 characters long.');
    if ($(".tour-form #daybyday > div > ul > li:visible").find('.day-description').next().length) {
        $(".tour-form #daybyday > div > ul > li:visible").find('.day-description').next().html($(".tour-form #daybyday > div > ul > li:visible").find('.day-description').next().html().replace('min. 50 max.', 'min. 250 max.'));
    }
    $(".tour-form #daybyday > div > ul > li:visible").last().find('.day-description').attr('data-min', 50);
    if ($(".tour-form #daybyday > div > ul > li:visible").last().find('.day-description').next().length) {
        $(".tour-form #daybyday > div > ul > li:visible").last().find('.day-description').next().html($(".tour-form #daybyday > div > ul > li:visible").last().find('.day-description').next().html().replace('min. 250 max.', 'min. 50 max.'));
    }
    $(".tour-form #daybyday > div > ul > li:visible").last().find('.daydescription-length-guideline').html('The description should be at least 50 and max. 1000 characters long.');
    //}
    limitedInputs();
}

function updateAddADayDropdown() {
    debugFunctionCall('updateAddADayDropdown');

    $(".tour-form .add-extra-day-block select:eq(1) option:gt(0)").remove();
    var n = 0;
    $(".tour-form #daybyday > div > ul > li").each(function() {
        if ($(this).is(":visible")) {
            n++;
            var day_text = $(this).find('h3').text();
            if (day_text.length > 40) {
                day_text = day_text.substring(0, 40) + '...';
            }
            $(".tour-form .add-extra-day-block select:eq(1)").append('<option value="' + n + '">' + day_text + '</option>');
        }
    });
}

function accommodationCampingChange(thisObj) {
    var is_camping = (thisObj.val() == "yes");
    var acco_container = thisObj.parents(".accom-detail-sub");
    if(is_camping) {
        acco_container.find("select.accom-field").val("camping");
        if(acco_container.find(".daybyday-accom-extra-info").is(":visible"))
            loadAccoForm(acco_container);
        acco_container.find(".acco-name").slideUp();
        acco_container.find(".acco-type").slideUp();
        acco_container.find(".daybyday-accom-extra .daybyday-accom-extra-info").hide();
        acco_container.find(".daybyday-accom-extra .daybyday-accom-extra-form").show();
        acco_container.find(".daybyday-accom-extra").show();

        acco_container.find(".warn-budget-other").slideUp();
        acco_container.find(".accom-detail-sub").hide();
        acco_container.find(".daybyday-accom-type").prev().addClass('no-btm-margin');
        acco_container.find(".warn-budget-camping").slideDown();
        acco_container.find(".accom-detail-participation").hide();

        setCampingPartiQuestion();

        acco_container.find(".daybyday-accom-level").find("[value='luxury']").remove();
        acco_container.find(".daybyday-accom-level").find("[value='luxuryplus']").remove();

        accommodationComfortChange(thisObj.closest('li[data-index]').find('.daybyday-accom-level'));
        hideWebsite(acco_container);
    } else {
        loadAccoForm(acco_container);
        if (!setting_existing_data) {
            acco_container.find(".acco-type select.accom-field").val(0);
            acco_container.find(".acco-name input.daybyday-accom-name").val("");
        }
        acco_container.find(".acco-name").slideDown();
        acco_container.find(".acco-type").slideDown();
        acco_container.find('.warn-camping').slideUp();
        acco_container.find('.warn-camping-full').slideUp();

        var info_el = acco_container.find(".daybyday-accom-extra-info");
        if(info_el.find(".guidelines b").length && info_el.find(".guidelines b").text() == acco_container.find(".acco-name input").val()) {
            acco_container.find(".daybyday-accom-extra .daybyday-accom-extra-info").show();
            acco_container.find(".daybyday-accom-extra .daybyday-accom-extra-form").hide();
        } else {
            acco_container.find(".daybyday-accom-extra .daybyday-accom-extra-info").hide();
            acco_container.find(".daybyday-accom-extra .daybyday-accom-extra-form").show();
        }
        acco_container.find(".accom-detail-participation").hide();

        showWebsite(acco_container);
    }

    handleBlockNotes();

    setDaybydayGuidelines();
}

function accommodationTypeChange(thisObj) {
    debugFunctionCall('accommodationTypeChange');

    var type_val = thisObj.val();
    var thisObjParent = thisObj.parents(".daybyday-accom-extra-form");

    if (type_val != 'camping') {
        if (type_val != 'mountainhut') {
            if (thisObjParent.find(".daybyday-accom-level").find("[value='midrange']").length == 0) {
                thisObjParent.find(".daybyday-accom-level").append('<option value="midrange">Mid-range</option>');
            }
            if (thisObjParent.find(".daybyday-accom-level").find("[value='luxury']").length == 0) {
                thisObjParent.find(".daybyday-accom-level").append('<option value="luxury">Luxury</option>');
            }
            if (thisObjParent.find(".daybyday-accom-level").find("[value='luxuryplus']").length == 0) {
                thisObjParent.find(".daybyday-accom-level").append('<option value="luxuryplus">Luxury+</option>');
            }
        } else {
            thisObjParent.find(".daybyday-accom-level").find("[value='luxury']").remove();
            thisObjParent.find(".daybyday-accom-level").find("[value='luxuryplus']").remove();
        }
    }

    if (type_val == 'camping') {

    } else if (type_val == 'tentedcamp') {
        thisObjParent.find(".warn-camping").slideUp();
        thisObjParent.find(".warn-budget-camping").slideUp();
        thisObjParent.find(".accom-detail-sub").show();
        thisObjParent.find(".accom-detail-participation").hide();
        //thisObjParent.find(".accom-detail").slideDown('normal', function() {
            thisObjParent.find(".daybyday-accom-type").prev().addClass('no-btm-margin');
            thisObjParent.find(".warn-tented").slideDown().removeClass('add-margin');
            thisObjParent.find(".warn-budget-other").slideDown();
            setCampingPartiQuestion();
        //});
    } else if (type_val == '0') {
        thisObjParent.find(".warn-tented").slideUp();
        thisObjParent.find(".warn-camping").slideUp();
        thisObjParent.find(".warn-budget-camping").slideUp();
        thisObjParent.find(".warn-budget-other").slideDown();
        thisObjParent.find(".accom-detail-sub").hide();
        thisObjParent.find(".accom-detail-participation").hide();
        //thisObjParent.find(".daybyday-accom-type").prev().removeClass('no-btm-margin');
        //thisObjParent.find(".accom-detail").slideUp('normal', function() {
            //thisObjParent.find(".daybyday-accom-type").prev().removeClass('no-btm-margin');
            setCampingPartiQuestion();
        //});
    } else {
        thisObjParent.find(".warn-camping").slideUp();
        thisObjParent.find(".warn-budget-camping").slideUp();
        thisObjParent.find(".warn-tented").slideUp().removeClass('add-margin');
        thisObjParent.find(".accom-detail-sub").show();
        thisObjParent.find(".accom-detail-participation").hide();
        //thisObjParent.find(".accom-detail").slideDown('normal', function() {
            thisObjParent.find(".daybyday-accom-type").prev().addClass('no-btm-margin');
            thisObjParent.find(".warn-budget-other").slideDown();
            setCampingPartiQuestion();
        //});

        if (type_val == 'banda' || type_val == 'mountainhut') {
            if (thisObjParent.find('.daybyday-accom-level').val() == '0') {
                thisObjParent.find('.daybyday-accom-level').val('budget');
            }
        }
    }
    var day_nr = thisObjParent.parents("li").find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
    if (thisObjParent.parents("li").find('.day-selection').val() == 1) {
        day_nr = day_nr.substring(0, day_nr.indexOf('-'));
    }
    setSolved('dayaccommodation05-' + day_nr);
    hideError(thisObj, "", 'dayaccommodation05-' + day_nr);
    thisObj.removeClass('error');
    accommodationComfortChange(thisObjParent.find('.daybyday-accom-level'));
    handleBlockInclusions();
    handleBlockNotes();
}

function daybydayAccommodationWebsiteBlur(thisObj) {
    debugFunctionCall('daybydayAccommodationWebsiteBlur');

    var website = thisObj.val();
    var day_nr = thisObj.parent().parent().parent().find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
    if (thisObj.parent().parent().parent().find('.day-selection').val() == 1) {
        day_nr = day_nr.substring(0, day_nr.indexOf('-'));
    }
    if (website == '') {
        if ($(".overall-errors").length) {
            var error_to_solve = 'dayaccommodation06-' + day_nr;
            showError(thisObj.next(), 'You\'ll have to enter the website address of the accommodation', error_to_solve);
        }
    } else {
        var error_to_solve = 'dayaccommodation06-' + day_nr;
        hideError(thisObj.next(), 'You\'ll have to enter the website address of the accommodation', error_to_solve);
        showHideError((!(/^(http:\/\/www\.|https:\/\/www\.|http:\/\/|https:\/\/|www\.|)[a-z0-9]+([\-\.]{1}[a-z0-9]+)*\.[a-z]{2,5}(:[0-9]{1,5})?(\/|.*)?$/.test(website.toLowerCase())) && website.toLowerCase() != ''), thisObj, 'The website address is invalid', error_to_solve);
    }

    var cleanWebsite = website.replace('http://', '').replace('https://', '').replace('www.', '').replace(/ /g, '').replace(new RegExp('[\/]$', 'g'), '');
    var groupRegex = new RegExp('^\(' + $("#daybyday").data('forbidden_accommodation_websites') + '\)$', 'i');
    var wetuRegex = new RegExp('^\(wetu\.com\)', 'i');
    var error_to_solve = 'dayaccommodation07-' + day_nr;
    var error_to_solve_wetu = 'dayaccommodation10-' + day_nr;
    showHideError(groupRegex.test(cleanWebsite), thisObj.next(), 'Don\'t link to the homepage of a hotel group website. Instead, link to the overview page for this specific property', error_to_solve);
    showHideError(wetuRegex.test(cleanWebsite), thisObj.next(), 'A link to Wetu.com is not allowed, please provide the official website address of the accommodation', error_to_solve_wetu);

    if (!groupRegex.test(cleanWebsite) && !wetuRegex.test(cleanWebsite) && !(!(/^(http:\/\/www\.|https:\/\/www\.|http:\/\/|https:\/\/|www\.|)[a-z0-9]+([\-\.]{1}[a-z0-9]+)*\.[a-z]{2,5}(:[0-9]{1,5})?(\/|.*)?$/.test(website.toLowerCase())) && website.toLowerCase() != '')) {
        thisObj.removeClass('error');
    }
}

var ua = window.navigator.userAgent.toLowerCase();
var isIE = !!ua.match(/msie|trident\/7|edge/);
var isWinPhone = ua.indexOf('windows phone') !== -1;
var isIOS = !isWinPhone && !!ua.match(/ipad|iphone|ipod/);

function show_punctuation_errors(id, type) {
    if(isIOS) {
        $("#"+id).prev(".backdrop").find(".highlights").css({
            'padding-left': '+=3px',
            'padding-right': '+=3px'
        });
    }

    var new_text = highlightPunctuationText(id, type);

    $("#"+id).prev(".backdrop").find(".highlights").html(new_text);

    $("#"+id).on("input", function() {
        handlePunctuationInput($(this));
    });
    $("#"+id).on("scroll", function() {
        handlePunctuationScroll($(this));
    });

    return false;
}

function highlightPunctuationText(id, type) {
    var text = $("#"+id).val();
    if (isIE) {
        text = text.replace(/ /g, ' <wbr>');
    }

    var new_text = text.replace(/\n$/g, '\n\n')
        .replace(getRegex(type), '<mark>$&</mark>');

    return new_text;
}

function handlePunctuationInput(el) {
    var text = el.val();
    var highlightedText = highlightPunctuationText(el.attr("id"));
    el.parent().find(".backdrop .highlights").html(highlightedText);
}

function handlePunctuationScroll(el) {
    var scrollTop = el.scrollTop();
    el.parent().find(".backdrop").scrollTop(scrollTop);

    var scrollLeft = el.scrollLeft();
    el.parent().find(".backdrop").scrollLeft(scrollLeft);
}

function getRegex(key) {
    switch(key) {
        case 'punctuation1':
            return new RegExp('\([a-z0-9\-]{2,}[\.]\)\([^.\\-–—\(\)\\[\\]{}:;\'’"‘’“”„ 0-9]\)|\([\.]\)([^.\\-–—\(\)\\[\\]{}:;\'’"‘’“”„ 0-9]{2,}\)|\([,\?!]\)\([^.\\-–—()\\[\\]{}:;\'’"‘’“”„ 0-9]\)', 'g');
        case 'punctuation2':
            return new RegExp('\([ ]\)\([,\?!\.]\)', 'g');
        case 'allcaps':
            return new RegExp('\([A-Z]\){5}', 'g');
        case 'atorwww':
            return new RegExp('http|@|www\\.|\\.nl|\\.co|\\.net|\\.info|\\.org|\\.uk|\\.au|\\.nz|\\.ca|\\.za|\\.tz|\\.ke|\\.bw|\\.ug|\\.rw|\\.zm|\\.zw|\\.na|\\.mz|\\.mw|\\.de|\\.nl|\\.be|\\.it|\\.es|\\.in|\\.fr', 'gi');
        case 'firstcapital':
            return new RegExp('^\([a-z]\)');
        case 'testcapital':
            return new RegExp('[?!][ ][a-z]|( |^)(?!incl|excl|min|max|etc|ft|sq|mi|in|yd)[a-z0-9\-]{2,}[.]{1} [a-z]', 'g');
        case 'teststartcapital':
            return new RegExp('^\([A-Z]\)');

    }
}

function daybydayDescriptionKeyup(thisObj) {
    debugFunctionCall('daybydayDescriptionKeyup');

    var daynr = thisObj.parent().parent().find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
    if (thisObj.parents("li").find('.day-selection').val() == 1) {
        daynr = daynr.substring(0, daynr.indexOf('-'));
    }
    var text = thisObj.val();
    showHideError(text.length > 1000, $("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'The description exceeds the limit of 1000 characters', 'daydescription03-' + daynr);
    showHideError(getRegex('punctuation1').test(text.replace(/\n/g, ' ')), $("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'Use punctuation marks correctly (<a href="'+backend_url('properpunctuation')+'" target="_blank">learn how</a>). There should ALWAYS be a space after a comma (,) or end mark (?, !, or .). <a href="javascript:show_punctuation_errors(\''+thisObj.attr('id')+'\', \'punctuation1\');">Highlight problems</a>', 'daydescription08-' + daynr);
    showHideError(getRegex('punctuation2').test(text), $("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'Use punctuation marks correctly (<a href="'+backend_url('properpunctuation')+'" target="_blank">learn how</a>). There should be NO space before a comma (,) or end mark (?, !, or .). <a href="javascript:show_punctuation_errors(\''+thisObj.attr('id')+'\', \'punctuation2\');">Highlight problems</a>', 'daydescription07-' + daynr);
    showHideError(getRegex('allcaps').test(text.replace('UNESCO', '')), $("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'It is not allowed to write words in ALL CAPS. Abbreviations of 4 characters or less are allowed (e.g., NP, JNB, KATO). <a href="javascript:show_punctuation_errors(\''+thisObj.attr('id')+'\', \'allcaps\');">Highlight problems</a>', 'daydescription04-' + daynr);
    showHideError(getRegex('atorwww').test(text), $("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'It is not allowed to include links or email addresses', 'daydescription06-' + daynr);
    showHideError(getRegex('firstcapital').test(text), $("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'Always start a new sentence with a capital letter. <a href="javascript:show_punctuation_errors(\''+thisObj.attr('id')+'\', \'firstcapital\');">Highlight problems</a>', 'daydescription09-' + daynr);
    if (!getRegex('firstcapital').test(text)) {
        showHideError(getRegex('testcapital').test(text), $("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'After typing a period (.) at the end of a sentence, the next sentence should start with a capital letter. <a href="javascript:show_punctuation_errors(\''+thisObj.attr('id')+'\', \'testcapital\');">Highlight problems</a>', 'daydescription10-' + daynr);
    } else {
        hideError($("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'After typing a period (.) at the end of a sentence, the next sentence should start with a capital letter. <a href="javascript:show_punctuation_errors(\''+thisObj.attr('id')+'\', \'testcapital\');">Highlight problems</a>', 'daydescription10-' + daynr);
    }
    if (text.length >= thisObj.attr('data-min')) {
        var day_nr = thisObj.parent().parent().find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
        if (thisObj.parents("li").find('.day-selection').val() == 1) {
            day_nr = day_nr.substring(0, day_nr.indexOf('-'));
        }
        var error_to_solve = 'daydescription02-' + day_nr;
        hideError($("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'The description must be at least 250 characters', error_to_solve);
        hideError($("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'The description must be at least 50 characters', error_to_solve);
    }

    var testAtDayStart = new RegExp('\^Day( |\-)?([0-9]+)', 'gi');
    showHideError(testAtDayStart.test(text), $("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'There is no need to mention the day number as title at the top of the description. A title will be added automatically. You can ignore this warning if you use the day number for a different reason.', 'daydescription99-' + daynr);

    var testFlight = new RegExp(' (flight|flights|plane|airplane)([\.]| )', 'gi');
    var block_index = thisObj.parent().parent().index();
    var max_index = $(".tour-form #daybyday > div > ul > li:visible").length - 1;
    showHideError(testFlight.test(" " + text + " ") && !$("input[name='transportation[airtransfer]']").is(":checked") && block_index > 0 && block_index < max_index, $("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'We noticed you typed the word ‘flight’ or ‘plane’. Does this relate to a mandatory flight during the tour? If so, you must select ‘Air transfer’ in the ‘Transportation’ section above. If not, you can ignore this warning. ', 'daydescription98-' + daynr);
}

function daybydayDescriptionBlur(thisObj) {
    debugFunctionCall('daybydayDescriptionBlur');

    var daynr = thisObj.parent().parent().find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
    if (thisObj.parents("li").find('.day-selection').val() == 1) {
        daynr = daynr.substring(0, daynr.indexOf('-'));
    }
    var error_to_solve = 'daydescription02-' + daynr;
    var text = thisObj.val();
    if ($(".overall-errors").length) {
        if (text.length >= thisObj.attr('data-min')) {
            hideError($("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'The description must be at least 250 characters', error_to_solve);
            hideError($("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'The description must be at least 50 characters', error_to_solve);
        }
        if (thisObj.attr('data-min') == 250) {
            hideError($("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'The description must be at least 50 characters', error_to_solve);
        }
        if (thisObj.attr('data-min') == 50) {
            hideError($("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'The description must be at least 250 characters', error_to_solve);
        }
        showHideError(text.length < thisObj.attr('data-min'), $("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'The description must be at least ' + thisObj.attr('data-min') + ' characters', error_to_solve);
    } else {
        if (text.length >= thisObj.attr('data-min')) {
            hideError($("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'The description must be at least 250 characters', error_to_solve);
            hideError($("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'The description must be at least 50 characters', error_to_solve);
        }
        if (thisObj.attr('data-min') == 250) {
            hideError($("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'The description must be at least 50 characters', error_to_solve);
        }
        if (thisObj.attr('data-min') == 50) {
            hideError($("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'The description must be at least 250 characters', error_to_solve);
        }
        showHideError(text.length > 0 && text.length < thisObj.attr('data-min'), $("#" + thisObj.attr('id')).parent().next(".limit-msg"), 'The description must be at least ' + thisObj.attr('data-min') + ' characters', error_to_solve);
    }
    if (text.length > 0) {
        var error_to_solve = 'daydescription01-' + daynr;
        setSolved(error_to_solve);
    }
}

function daybydayTitleKeyup(thisObj) {
    debugFunctionCall('daybydayTitleKeyup');

    var daybydayblock = thisObj.closest('li[data-index]');

    var t = UCFirst(thisObj.val());
    if (t != thisObj.val()) {
        var startPos = thisObj.get(0).selectionStart, endPos = thisObj.get(0).selectionEnd;
        thisObj.val(t);
        thisObj.get(0).setSelectionRange(startPos, endPos);
    }

    var daynr = daybydayblock.find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
    if (daybydayblock.find('.day-selection').val() == 1) {
        daynr = daynr.substring(0, daynr.indexOf('-'));
    }
    showHideError(t.length > 100, thisObj.next(), 'The title exceeds the limit of 100 characters', 'daytitle05-' + daynr);

    var day_lbl = daybydayblock.find('.day-selection option:selected').text();
    if (daybydayblock.find('.day-selection').val() == 1) {
        day_lbl = day_lbl.substring(0, day_lbl.indexOf(' to ')) + ":";
    }
    daybydayblock.find(".title-preview b").html(day_lbl + ' ' + thisObj.val().substring(0, 100));
    daybydayblock.find(".daydescription-titlepreview b").html(day_lbl + ' ' + thisObj.val().substring(0, 100));
    daybydayblock.find('h3').html('<span></span>' + day_lbl + ' ' + thisObj.val().substring(0, 100));

    thisObj.closest('li[data-index]').find('.daydestination-photo-holder-inner h6').text(day_lbl.replace(":", ""));
    thisObj.closest('li[data-index]').find('.daydestination-photo-holder-inner h5 span').text(thisObj.val().substring(0, 100));

    var text = thisObj.val();
    var testAllcaps = new RegExp('\([A-Z]\){5}', 'g');
    var errorPos = (thisObj.next().hasClass('limit-msg')) ? thisObj.next() : thisObj;

    showHideError(testAllcaps.test(text.replace('UNESCO', '')), errorPos, 'It is not allowed to write words in ALL CAPS. Abbreviations of 4 characters or less are allowed (e.g., NP, JNB, KATO).');
    var testDay = new RegExp('\( day | days \)', 'gi');
    showHideError(testDay.test(" " + text + " "), errorPos, 'Don\'t mention the number of days in the text box (you can ignore this warning if you use the word ‘day’ for another purpose) ');
//     var testPunctuation = new RegExp(',\([^ ]\)', 'g');
    var testPunctuation = new RegExp('\([a-z0-9\-]{2,}[\.]\)\([^.\\-–—\(\)\\[\\]{}:;\'’"‘’“”„ 0-9]\)|\([\.]\)([^.\\-–—\(\)\\[\\]{}:;\'’"‘’“”„ 0-9]{2,}\)|\([,]\)\([^.\\-–—()\\[\\]{}:;\'’"‘’“”„ 0-9]\)', 'g');
    showHideError(testPunctuation.test(text), errorPos, 'Use punctuation marks correctly (<a href="'+backend_url('properpunctuation')+'" target="_blank">learn how</a>). There should always be a space after a comma (,).', 'daytitle06-' + daynr);
    if (t.length > 5) {
        hideError(thisObj.next(), 'The title must be at least 5 characters', 'daytitle04-' + daynr);
        $(this).removeClass('error');
    } else if (t.length > 0) {
        hideError(thisObj.next(), 'You must enter a title in the text box', 'daytitle01-' + daynr);
        $(this).removeClass('error');
    }
}

function daybydayTitleBlur(thisObj) {
    debugFunctionCall('daybydayTitleBlur');

    var daybydayblock = thisObj.closest('li[data-index]');

    var daynr = daybydayblock.find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
    if (daybydayblock.find('.day-selection').val() == 1) {
        daynr = daynr.substring(0, daynr.indexOf('-'));
    }
    var title = thisObj.val();
    if ($(".overall-errors").length) {
        showHideError(title.length > 0 && title.length < 5, thisObj.next(), 'The title must be at least 5 characters', 'daytitle05' + daynr);
        showHideError(title.length == 0, thisObj.next(), 'You must enter a title in the text box', 'daytitle01' + daynr);
    } else {
        showHideError(title.length > 0 && title.length < 5, thisObj.next(), 'The title must be at least 5 characters', 'daytitle05' + daynr);
    }
    if (title.length > 0) {
        var error_to_solve = 'daytitle01-' + daynr;
        setSolved(error_to_solve);
    }

    updateAddADayDropdown();
}

function daybydayAccommodationNameKeyup(thisObj) {
    debugFunctionCall('daybydayAccommodationNameKeyup');

    var daybydayblock = thisObj.closest('li[data-index]');

    var t = UCWords(thisObj.val());
    if (t != thisObj.val()) {
        var startPos = thisObj.get(0).selectionStart, endPos = thisObj.get(0).selectionEnd;
        thisObj.val(t);
        thisObj.get(0).setSelectionRange(startPos, endPos);
    }
    var daynr = daybydayblock.find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
    if (daybydayblock.find('.day-selection').val() == 1) {
        daynr = daynr.substring(0, daynr.indexOf('-'));
    }
    var or_regex = new RegExp('( or )|( [^a-z0-9 ]or )|( or[^a-z0-9 ] )|( [^a-z0-9 ]or[^a-z0-9 ] )|( and )|( [^a-z0-9 ]and )|( and[^a-z0-9 ] )|( [^a-z0-9 ]and[^a-z0-9 ] )', 'i');
    var error_to_solve = 'dayaccommodation02-' + daynr;
    showHideError(or_regex.test(thisObj.val()), thisObj.next(), 'Please list only one accommodation (the words \'or\' \'and\' are not allowed)', error_to_solve);
    if (t != '') {
        var error_to_solve = 'dayaccommodation01-' + daynr;
        setSolved(error_to_solve);
        thisObj.removeClass('error');
        hideError(thisObj.next(), 'You\'ll have to enter an accommodation name', error_to_solve);
    }
}

function accommodationComfortChange(thisObj) {
    debugFunctionCall('acommodationComfortChange');

    var daybydayblock = thisObj.closest('li[data-index]');

    var is_camping = thisObj.parents(".accom-detail-sub").find(".camping-yes").is(":checked");
    var daynr = daybydayblock.find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
    if (daybydayblock.find('.day-selection').val() == 1) {
        daynr = daynr.substring(0, daynr.indexOf('-'));
    }

    daybydayblock.find('.warn-camping-midrange').slideUp();
    daybydayblock.find('.camping-gl2').addClass('hidden');
    daybydayblock.find('.warn-camping-luxury').slideUp();
    daybydayblock.find('.warn-other-luxury').slideUp();
    daybydayblock.find('.warn-other-luxuryplus').slideUp();

    if (is_camping && thisObj.val() == 'midrange') {

        if (daybydayblock.index() == 0) {
            daybydayblock.find('.warn-camping-midrange').slideDown();
            daybydayblock.find('.camping-gl2').removeClass('hidden');
        } else {
            var found_already = false;
            for (var i = 0; i < daybydayblock.index(); i++) {
                if ($(".tour-form #daybyday > div > ul > li:eq(" + i + ")").find('.daybyday-accom-type').val() == 'camping' && $(".tour-form #daybyday > div > ul > li:eq(" + i + ")").find('.daybyday-accom-level').val() == 'midrange') {
                    found_already = true;
                }
            }
            if (!found_already) {
                daybydayblock.find('.warn-camping-midrange').slideDown();
                daybydayblock.find('.camping-gl2').removeClass('hidden');
            }
        }
    }
    if (is_camping && thisObj.val() == 'luxury') {
        if (daybydayblock.parent().index() == 0) {
            daybydayblock.find('.warn-camping-luxury').slideDown();
        } else {
            var found_already = false;
            for (var i = 0; i < daybydayblock.index(); i++) {
                if ($(".tour-form #daybyday > div > ul > li:eq(" + i + ")").find('.daybyday-accom-type').val() == 'camping' && $(".tour-form #daybyday > div > ul > li:eq(" + i + ")").find('.daybyday-accom-level').val() == 'luxury') {
                    found_already = true;
                }
            }
            if (!found_already) {
                daybydayblock.find('.warn-camping-luxury').slideDown();
            }
        }
    }
    if (!is_camping && thisObj.val() == 'luxury') {
        if (daybydayblock.parent().index() == 0) {
            daybydayblock.find('.warn-other-luxury').slideDown();
            daybydayblock.find('.warn-budget-other').slideUp();
        } else {
            var found_already = false;
            for (var i = 0; i < daybydayblock.index(); i++) {
                if ($(".tour-form #daybyday > div > ul > li:eq(" + i + ")").find('.daybyday-accom-type').val() != 'camping' && $(".tour-form #daybyday > div > ul > li:eq(" + i + ")").find('.daybyday-accom-level').val() == 'luxury') {
                    found_already = true;
                }
            }
            if (!found_already) {
                daybydayblock.find('.warn-other-luxury').slideDown();
                daybydayblock.find('.warn-budget-other').slideUp();
            } else {
                daybydayblock.find('.warn-budget-other').slideDown();
                daybydayblock.find('.warn-other-luxury').slideUp();
            }
        }
    }
    if (!is_camping && thisObj.val() == 'luxuryplus') {
        if (daybydayblock.index() == 0) {
            daybydayblock.find('.warn-other-luxuryplus').slideDown();
            daybydayblock.find('.warn-budget-other').slideUp();
        } else {
            var found_already = false;
            for (var i = 0; i < daybydayblock.index(); i++) {
                if ($(".tour-form #daybyday > div > ul > li:eq(" + i + ")").find('.daybyday-accom-type').val() != 'camping' && $(".tour-form #daybyday > div > ul > li:eq(" + i + ")").find('.daybyday-accom-level').val() == 'luxuryplus') {
                    found_already = true;
                }
            }
            if (!found_already) {
                daybydayblock.find('.warn-other-luxuryplus').slideDown();
                daybydayblock.find('.warn-budget-other').slideUp();
            } else {
                daybydayblock.find('.warn-budget-other').slideDown();
                daybydayblock.find('.warn-other-luxuryplus').slideUp();
            }
        }
    }
    if (!is_camping && thisObj.val() != 'luxury' && thisObj.val() != 'luxuryplus') {
        daybydayblock.find('.warn-budget-other').slideDown();
    }

    var error_to_solve = 'dayaccommodation03-' + daynr;
    setSolved(error_to_solve);
    thisObj.removeClass('error');
    hideError(thisObj, '');
}

function accommodationLocationChange(thisObj) {
    debugFunctionCall('accommodationLocationChange');

    var daybydayblock = thisObj.closest('li[data-index]');

    var daynr = daybydayblock.find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
    if (daybydayblock.find('.day-selection').val() == 1) {
        daynr = daynr.substring(0, daynr.indexOf('-'));
    }
    var error_to_solve = 'dayaccommodation08-' + daynr;
    setSolved(error_to_solve);
    var error_to_solve = 'dayaccommodation09-' + daynr;
    setSolved(error_to_solve);
    thisObj.removeClass('error');
    hideError(thisObj, '');
}

function handleBlockCustomization() {

    debugFunctionCall('handleBlockCustomization');

    $(".tour-form #customization input[type=radio]").unbind('change').bind('change', function() {
        setSolved('customizable01');
    });

}

function handleBlockDatesrates() {
    debugFunctionCall('handleBlockDatesrates');

    $(".tour-form #datesrates input[name='rates[fixeddates]']").unbind('change').bind('change', function() {


        if ($(".tour-form #datesrates input[name='rates[fixeddates]']:checked").length) {
            //if ($('.tour-form #group input[type=radio]:checked').val() == 'group' || $('.tour-form #group input[type=radio]:checked').val() == 'private' || !$('.tour-form #group').is(":visible")) {
                if ($('.tour-form #group input[type=radio]:checked').val() == 'group') {
                    $(".availability-title2").show();
                    $(".availability-title1").hide();
                    $(".availability-gl1").hide();
                    $(".availability-gl2").show();
                } else {
                    $(".availability-title2").hide();
                    $(".availability-title1").show();
                    $(".availability-gl1").show();
                    $(".availability-gl2").hide();
                }

                if ($(".tour-form #datesrates input[name='rates[fixeddates]']:checked").val() == 'no') {
                    $(".tour-form #datesrates .availability-block").slideDown('normal');

                    // always show the calender
                    $('.availability-option').show();


                    $(".availability-block-inner input[type=radio]").unbind('change').bind('change', function() {

                        setSolved('availability01');
                        hideError($('.availability-option'), '');

                        if ($(".availability-block-inner input[type=radio]:checked").val() == 'no') {
                            $('.availability-option').slideUp();
                        } else if ($(".availability-block-inner input[type=radio]:checked").val() == 'yes') {
                            if ($('.tour-form #group input[type=radio]:checked').val() == 'group') {
                                $(".availability-options-headers").addClass('with-availability');
                                $(".availability-options").addClass('with-availability');
                            } else {
                                $(".availability-options-headers").removeClass('with-availability');
                                $(".availability-options").removeClass('with-availability');
                            }
                            $('.availability-option').slideDown();
                        }
                    });
                } else {
                    $(".tour-form #datesrates .availability-block").slideUp();
                }
            //}
        }

        if ($(".tour-form #datesrates input[name='rates[fixeddates]']:checked").val() == 'yes') {
            $(".tour-form #datesrates .fixedyears-options input").hide();

            $(".tour-form #datesrates #fixeddates-options-hint").show();
            $(".tour-form #datesrates .fixeddates-options-headers").show();
            $(".tour-form #datesrates .fixeddates-options").addClass('with-availability');
            $(".tour-form #datesrates .fixeddates-options-headers").addClass('with-availability');

            $(".tour-form #datesrates .fixeddates-options-headers-help1").css('display', 'none');
            $(".tour-form #datesrates .fixeddates-options-headers-help2").css('display', 'inline-block');

            if ($('.tour-form #group input[type=radio]:checked').val() == 'private') {
                if ($('.tour-form #datesrates .fixeddates-options .availability:eq(0) option').length > 2) {
                    $('.tour-form #datesrates .fixeddates-options .availability').each(function() {
                        var current_val = $(this).find('select').val();

                        $(this).find('select').find('option').each(function() {
                            if ($(this).val() != 0) {
                                $(this).remove();
                            }
                            if ($(this).val() == 0) {
                                $(this).text('Not Available');
                            }
                        });

                        if (function_avail_uncertain) {
                            $(this).find('select').prepend('<option value="-1">Uncertain</option>');
                        }
                        $(this).find('select').prepend('<option value="99">Available</option>');
                        if (current_val == '0') {
                            $(this).find('select').val(0);
                        } else if (current_val == '-1') {
                            $(this).find('select').val(-1);
                        } else {
                            $(this).find('select').val(1);
                        }
                    });
                }

            } else {
                if ($('.tour-form #datesrates .fixeddates-options .availability:eq(0) option').length < 7) {
                    $('.tour-form #datesrates .fixeddates-options .availability').each(function() {
                        $(this).find('select').find('option').each(function() {
                            if ($(this).val() == 0) {
                                $(this).text('Not Available');
                            }
                        });
                        var current_val = $(this).find('select').val();
                        $(this).find('select').find('option[value="1"]').remove();
                        if ($("#solo-yes").is(":checked")) {
                            $(this).find('select').prepend('<option value="1">1 people</option>');
                        }
                        $(this).find('select').prepend('<option value="2">2 people</option>');
                        $(this).find('select').prepend('<option value="3">3 people</option>');
                        $(this).find('select').prepend('<option value="4">4 people</option>');
                        $(this).find('select').prepend('<option value="5">5 people</option>');
                        $(this).find('select').prepend('<option value="6">6 people</option>');
                        $(this).find('select').prepend('<option value="99">Available</option>');
                        if (current_val == 0) {
                            $(this).find('select').val(0);
                        } else {
                            $(this).find('select').val(99);
                        }
                    });
                }
                $(".tour-form #datesrates .fixeddates-options-headers-help1").css('display', 'inline-block');
                $(".tour-form #datesrates .fixeddates-options-headers-help2").css('display', 'none');
            }

            $(".tour-form #datesrates .fixeddates-options").slideDown();
            $(".tour-form #datesrates .season-dates").slideUp();
            if ($(".tour-form #datesrates label[for=fixeddates-yes] span").html().indexOf('please list') === -1) {
                $(".tour-form #datesrates label[for=fixeddates-yes] span").append(' (please list the dates below)');
            }
        } else if ($(".tour-form #datesrates input[name='rates[fixeddates]']:checked").val() == 'no') {
            $(".tour-form #datesrates #fixeddates-options-hint").hide();
            $(".tour-form #datesrates .fixeddates-options-headers").hide();
            $(".tour-form #datesrates .fixeddates-options").slideUp();
            $(".tour-form #datesrates .season-dates").slideDown('normal', function() {
                if ($(".tour-form #datesrates input[name='rates[fixedrates]']:checked").val() == 'no') {
                    $(".tour-form #datesrates .fixedyears-options input").show();
                }
            });

            $(".tour-form #datesrates label[for=fixeddates-yes] span").html($(".tour-form #datesrates label[for=fixeddates-yes] span").html().replace(' (please list the dates below)', ''));
        }

        handleBlockDatesratesRates();
        setSolved('departuredates01');
        hideError($('.fixeddates-options'), '');
    });
    $(".tour-form #datesrates input[name='rates[fixedrates]']").unbind('change').bind('change', function() {
        if ($(".tour-form #datesrates input[name='rates[fixedrates]']:checked").val() == 'yes') {
            $(".tour-form #datesrates .fixedrates-options").slideDown();
            $(".tour-form #datesrates .fixedyears-options input").hide();
            $(".tour-form #datesrates .fixedyears-options").slideUp();
            $(".tour-form #datesrates label[for=fixedrates-no] span").html($(".tour-form #datesrates label[for=fixedrates-no] span").html().replace(' (please select the years below)', ''));
            if ($(".tour-form #datesrates label[for=fixedrates-yes] span").html().indexOf('please select the') === -1) {
                $(".tour-form #datesrates label[for=fixedrates-yes] span").append(' (please select the dates below)');
            }
        } else if ($(".tour-form #datesrates input[name='rates[fixedrates]']:checked").val() == 'no') {
            $(".tour-form #datesrates .fixedrates-options").slideUp();
            $(".tour-form #datesrates .fixedyears-options").slideDown('normal', function() {
                $(".tour-form #datesrates .fixedyears-options input").show();
            });
            $(".tour-form #datesrates label[for=fixedrates-yes] span").html($(".tour-form #datesrates label[for=fixedrates-yes] span").html().replace(' (please select the dates below)', ''));
            if ($(".tour-form #datesrates label[for=fixedrates-no] span").html().indexOf('please select the') === -1) {
                $(".tour-form #datesrates label[for=fixedrates-no] span").append(' (please select the years below)');
            }
        } else {
            $(".tour-form #datesrates .fixedrates-options").slideUp();
            $(".tour-form #datesrates .fixedyears-options").slideUp();
            $(".tour-form #datesrates label[for=fixedrates-yes] span").html($(".tour-form #datesrates label[for=fixedrates-yes] span").html().replace(' (please select the dates below)', ''));
            $(".tour-form #datesrates label[for=fixedrates-no] span").html($(".tour-form #datesrates label[for=fixedrates-no] span").html().replace(' (please select the years below)', ''));
        }
        handleBlockDatesratesRates();
        setSolved('seasons01');
        hideError($('.fixedrates-options'), '');
    });
    $(".tour-form #datesrates .fixedyears-options input").unbind('change').bind('change', function() {
        handleBlockDatesratesRates();
    });
    $(".tour-form #datesrates .shortnotice-block input").unbind('change').bind('change', function() {
        setSolved('shortnotice01');
        hideError($('.shortnotice-options'), '');
        fillAvailabilityCalendarVars();
        handleShortnoticeBeAware();
        $(".date-range-picker-holder").datepicker("refresh");
    });
    $(".tour-form #datesrates .shortnotice-block select").unbind('change').bind('change', function() {
        $(".tour-form #datesrates .shortnotice-block input:eq(0)").trigger('click');
        setSolved('shortnotice01');
        setSolved('shortnotice02');
        hideError($('.shortnotice-options'), '');
        fillAvailabilityCalendarVars();
        handleShortnoticeBeAware();
        $(".date-range-picker-holder").datepicker("refresh");
    });

    $(".tour-form #datesrates .children-block input").unbind('change').bind('change', function() {
        setSolved('children01');
        hideError($('label[for=children-yes]'), '');
        if ($("#children-no").is(":checked")) {
            $(".children-hint").slideDown();
            $(".children-discount-block").slideUp();
            $(".tour-form #datesrates .children-block select").val('');
            $(".tour-form .children-discount-block input").removeAttr('checked');
            $(".tour-form .children-discount-block select").val('');
            $(".tour-form .children-discount-block label[for='children-free'] span").text('0 year');

            $(".rate-blocks").removeClass('childrenrates');
            $(".rate-blocks").removeClass('childrenrates-free');

        } else {
            $(".children-hint").slideUp();
            $(".children-discount-block").slideDown();

            var min_chimp_age = 15;
            if ($(".tour-form #countries input#TZ").is(":checked")) {
                min_chimp_age = 12;
            }

            handleChildrenDiscountQuestion();

            if ($(".tour-form #datesrates .children-block select").val() >= min_chimp_age) {
                setSolved('children03');
                hideError($('.children-options'), '');
            }
        }
    });

    $(".tour-form #datesrates .children-block select").unbind('change').bind('change', function() {
        $(".tour-form #datesrates .children-block input:eq(1)").trigger('click');

        handleChildrenDiscountQuestion();

        setSolved('children02');
        hideError($('label[for=children-yes]'), '');
    });

    $(".tour-form #datesrates .children-discount-block input").unbind('change').bind('change', function() {
        handleChildrenDiscountQuestion();
    });

    $(".tour-form #datesrates .children-discount-block select").unbind('click').bind('click', function() {
        if (!$(this).closest('label').prev().hasClass('inactive')) {
            $(this).closest('label').prev().attr('checked', true);
        }
    });

    $(".tour-form #datesrates .children-discount-block select").unbind('change').bind('change', function() {
        handleChildrenDiscountQuestion();
    });

    $(".tour-form #datesrates .maxgroupsize-block input").unbind('change').bind('change', function() {
        setSolved('maxgroupsize01');
        hideError($('.maxgroupsize-options'), '');
        handleBlockDatesratesRates();
    });

    $(".tour-form #datesrates .maxgroupsize-block select").unbind('change').bind('change', function() {
        $(".tour-form #datesrates .maxgroupsize-block input:eq(1)").trigger('click');
        setSolved('maxgroupsize01');
        setSolved('maxgroupsize02');
        hideError($('.maxgroupsize-options'), '');
        handleBlockDatesratesRates();
    });

    $(".tour-form #datesrates input[name='rates[solo]']").unbind('change').bind('change', function() {

        $("#lowerrates_disp_pers").text($("#solo-no").is(":checked")?"2-6":"1-6");

        if ($(".tour-form #datesrates input[name='rates[solo]']:checked").val() == 'yes') {
            if ($('.tour-form #group input[type=radio]:checked').val() == 'group') {
                if ($('.tour-form #datesrates .fixeddates-options .availability:eq(0) option').length == 7) {
                    $('.tour-form #datesrates .fixeddates-options .availability').each(function() {
                        $(this).find('select').find('option:eq(5)').after("<option value='1'>1 people</option>");
                    });
                }
                if ($('.tour-form #datesrates .availability-options .availability:eq(0) option').length == 8) {
                    $('.tour-form #datesrates .availability-options .availability').each(function() {
                        $(this).find('select').find('option:eq(6)').after("<option value='1'>1 people</option>");
                    });
                }
            }
        } else {
            if ($('.tour-form #group input[type=radio]:checked').val() == 'group') {
                if ($('.tour-form #datesrates .fixeddates-options .availability:eq(0) option').length == 8) {
                    $('.tour-form #datesrates .fixeddates-options .availability').each(function() {
                        var set_to_zero = false;
                        if ($(this).find('select').val() == '1') {
                            set_to_zero = true;
                        }
                        $(this).find('select').find('option[value="1"]').remove();
                        if (set_to_zero) {
                            $(this).find('select').val(0);
                        }
                    });
                }
                if ($('.tour-form #datesrates .availability-options .availability:eq(0) option').length == 9) {
                    $('.tour-form #datesrates .availability-options .availability').each(function() {
                        var set_to_zero = false;
                        if ($(this).find('select').val() == '1') {
                            set_to_zero = true;
                        }
                        $(this).find('select').find('option[value="1"]').remove();
                        if (set_to_zero) {
                            $(this).find('select').val(0);
                        }
                    });
                }
            }
        }
        handleBlockDatesratesRates();
        setSolved('solotraveler01');
        hideError($('.singlesupplement'), '');
    });
    $(".tour-form #datesrates input[name='rates[lowerrates]']").unbind('change').bind('change', function() {
        if ($(".tour-form #datesrates input[name='rates[lowerrates]']:checked").val() == 'yes') {
            $(".ratespergroup-hint").slideUp();
            // $(".tour-form #datesrates .lowerrates-options").slideDown();
            // if ($(".tour-form #datesrates label[for=lowerrates-yes] span").html().indexOf('select all that') === -1) {
            //     $(".tour-form #datesrates label[for=lowerrates-yes] span").append(' (select all that apply)');
            // }
        } else {
            $(".ratespergroup-hint").slideDown();
            // $(".tour-form #datesrates .lowerrates-options").slideUp();
            // $(".tour-form #datesrates label[for=lowerrates-yes] span").html($(".tour-form #datesrates label[for=lowerrates-yes] span").html().replace(' (select all that apply)', ''));
        }
        handleBlockDatesratesRates();
        setSolved('lowerrates01');
        hideError($('.lowerrates-options'), '');
    });
    // $(".tour-form #datesrates .lowerrates-options input[type=checkbox]").unbind('change').bind('change', function() {
    //     handleBlockDatesratesRates();
    //     setSolved('lowerrates02');
    //     hideError($('.lowerrates-options'), '');
    // });
    $(".tour-form #datesrates .fixeddates-options .add-row a").unbind('click').bind('click', function() {
        $(".tour-form #datesrates .fixeddates-options li:nth-last-child(2)").clone().insertAfter(".tour-form #datesrates .fixeddates-options li:nth-last-child(2)");
        $(".tour-form #datesrates .fixeddates-options li:nth-last-child(2) span").eq(0).html(($(".tour-form #datesrates .fixeddates-options li").length - 1) + ".");
        $(".tour-form #datesrates .fixeddates-options li:nth-last-child(2) span.expired").remove();
        $(".tour-form #datesrates .fixeddates-options li:nth-last-child(2)").removeClass('expired');
        $(".tour-form #datesrates .fixeddates-options li:nth-last-child(2) a").removeClass('inactive');
        $(".tour-form #datesrates .fixeddates-options li:nth-last-child(2) input").removeClass('hasDatepicker').removeAttr('id').removeAttr('data-val').val('');
        $(".tour-form #datesrates .fixeddates-options li:nth-last-child(2)").removeClass('disabled');
        if ($(".tour-form #datesrates .fixeddates-options li").length > 2) {
            $(".tour-form #datesrates .fixeddates-options li .remove-new").removeClass('inactive');
        }

        handleBlockDatesratesActions();
        handleBlockDatesratesRates();
        return false;
    });
    $(".tour-form #datesrates .fixedrates-options .add-row a").unbind('click').bind('click', function() {
        $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2)").clone().insertAfter(".tour-form #datesrates .fixedrates-options li:nth-last-child(2)");
        $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2) a").removeClass('inactive');
        $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2) input").removeClass('hasDatepicker').removeAttr('id').removeAttr('data-val').val('');
        $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2)").removeClass('with-gap');
        $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2) .gap").remove();
        $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2)").removeClass('disabled');
        $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2)").removeClass('expired');
        $(".tour-form #datesrates .fixedrates-options li:nth-last-child(2) span.expired").remove();
        if ($(".tour-form #datesrates .fixedrates-options li").length > 2) {
            $(".tour-form #datesrates .fixedrates-options li .remove-new").removeClass('inactive');
        }

        handleBlockDatesratesActions();
        handleBlockDatesratesRates();
        return false;
    });

    $(".tour-form #datesrates .availability-options .add-row a").unbind('click').bind('click', function() {
        $(".tour-form #datesrates .availability-options li:nth-last-child(2)").clone().insertAfter(".tour-form #datesrates .availability-options li:nth-last-child(2)");
        $(".tour-form #datesrates .availability-options li:nth-last-child(2) a").removeClass('inactive');
        $(".tour-form #datesrates .availability-options li:nth-last-child(2) input").removeClass('hasDatepicker').removeAttr('id').removeAttr('data-val').val('');
        $(".tour-form #datesrates .availability-options li:nth-last-child(2)").removeClass('disabled');
        $(".tour-form #datesrates .availability-options li:nth-last-child(2)").removeClass('expired');
        $(".tour-form #datesrates .availability-options li:nth-last-child(2) span.expired").remove();
        if ($(".tour-form #datesrates .availability-options li").length > 2) {
            $(".tour-form #datesrates .availability-options li .remove-new").removeClass('inactive');
        }

        handleBlockDatesratesActions();
        handleBlockDatesratesRates();
        return false;
    });

    $(".tour-form #datesrates input[name='rates[localpay]']").unbind('change').bind('change', function() {
        if ($(".tour-form #datesrates input[name='rates[localpay]']:checked").val() == 'yes') {
            $(".tour-form #datesrates .local-currency-check").hide();
            $(".tour-form #datesrates #local-currency").show();
            $(".tour-form #datesrates #local-currency+label").show();
            showhideLocalPayments();
            $(".tour-form #datesrates .rate-blocks").addClass('with-local');
            $(".tour-form #datesrates .local-currency-div").hide();
            $(".tour-form #datesrates .local-currency-label").css('display', 'inline-block');
            $(".tour-form #datesrates .local-currency-select").show();
            $(".tour-form #datesrates .local-currency-div").slideDown();
            $(".rate-block-local-currency").html($(".tour-form #datesrates select[name='rates[local_currency]']").val())
        } else {
            showhideLocalPayments();
            $(".tour-form #datesrates #local-currency").hide();
            $(".tour-form #datesrates #local-currency+label").hide();
            $(".tour-form #datesrates .local-currency-div").slideUp();
            $(".tour-form #datesrates .local-currency-label").css('display', 'none');
            $(".tour-form #datesrates .local-currency-select").hide();
            $(".tour-form #datesrates .rate-blocks").removeClass('with-local');
        }
        setSolved('localpayment01');
        hideError($('label[for=localpay-yes]'), '');
    });
    $(".tour-form #datesrates #currency").unbind('change').bind('change', function() {
        $(".rate-block-currency").html($(this).val());
        showhideLocalPayments();
    });
    $(".tour-form #datesrates select[name='rates[local_currency]']").unbind('change').bind('change', function() {
        $(".rate-block-local-currency").html($(this).val());
        showhideLocalPayments();
    });

    if (!$(".date-range-picker-holder").hasClass('.hasDatepicker')) {
        initAvailabilityCalendar();
    }

    handleBlockDatesratesActions();
}

function handleChildrenDiscountQuestion() {

    var min_freeage = 0;
    var min_lowerrateage = 0;

    if ($(".tour-form #datesrates .children-block select").val() == '') {
        $(".tour-form .children-discount-block select").val('');
        $(".tour-form .children-discount-block label[for='children-free'] span").text('0 year');
    } else {
        $(".tour-form .children-discount-block label[for='children-free'] span").text($(".tour-form #datesrates .children-block select option:selected").text());
        min_freeage = min_lowerrateage = $(".tour-form #datesrates .children-block select option:selected").val();
    }

    // Build free-age selectbox
    $(".tour-form #datesrates select[name='rates[childrenfreeage]'] option").each(function() {
        if ($(this).val() != '' && parseInt($(this).val()) < parseInt(min_freeage)) {
            $(this).remove();
        }
    });
    for (var j = 17; j >= parseInt(min_freeage); j--) {
        if ($(".tour-form #datesrates select[name='rates[childrenfreeage]'] option[value='" + j + "']").length == 0) {
            $(".tour-form #datesrates select[name='rates[childrenfreeage]'] option:first").after('<option value="' + j + '">' + j + ' ' + (j < 2 ? 'year' : 'years') + '</option>');
        }
    }

    if ($(".tour-form #children-free").is(":checked")) {
        if ($(".tour-form #datesrates select[name='rates[childrenfreeage]']").val() != '') {
            if (parseInt($(".tour-form #datesrates select[name='rates[childrenfreeage]']").val()) >= min_lowerrateage) {
                min_lowerrateage = parseInt($(".tour-form #datesrates select[name='rates[childrenfreeage]']").val()) + 1;
            }
        }
    }

    if (min_lowerrateage == 18) {
        $(".tour-form .children-discount-block label[for='children-discount'] span").text('17 years');
        $(".tour-form #children-discount").removeAttr('checked');
        $(".tour-form #children-discount").addClass('inactive');
        $(".tour-form select[name='rates[childrendiscountage]']").prop('disabled', 'disabled');
    } else {
        $(".tour-form .children-discount-block label[for='children-discount'] span").text(min_lowerrateage + ' ' + (min_lowerrateage < 2 ? 'year' : 'years'));
        $(".tour-form #children-discount").removeClass('inactive');
        $(".tour-form select[name='rates[childrendiscountage]']").prop('disabled', false);
    }

    // Build lowerrate-age selectbox
    $(".tour-form #datesrates select[name='rates[childrendiscountage]'] option").each(function() {
        if ($(this).val() != '' && parseInt($(this).val()) < parseInt(min_lowerrateage)) {
            $(this).remove();
        }
    });
    for (var j = 17; j >= parseInt(min_lowerrateage); j--) {
        if ($(".tour-form #datesrates select[name='rates[childrendiscountage]'] option[value='" + j + "']").length == 0) {
            $(".tour-form #datesrates select[name='rates[childrendiscountage]'] option:first").after('<option value="' + j + '">' + j + ' ' + (j < 2 ? 'year' : 'years') + '</option>');
        }
    }

    if (min_lowerrateage < 18 && $(".tour-form #children-discount").is(":checked") && $(".tour-form #datesrates select[name='rates[childrendiscountage]']").val() != '') {
        $(".rate-blocks").addClass('childrenrates');
        $(".rate-blocks .rate-block-age-adult").text('Age ' + (parseInt($(".tour-form #datesrates select[name='rates[childrendiscountage]']").val()) + 1) + '+');
        if (min_lowerrateage == parseInt($(".tour-form #datesrates select[name='rates[childrendiscountage]']").val())) {
            $(".rate-blocks .rate-block-age-children").text('Age ' + parseInt($(".tour-form #datesrates select[name='rates[childrendiscountage]']").val()));
        } else {
            $(".rate-blocks .rate-block-age-children").text('Age ' + min_lowerrateage + ' to ' + parseInt($(".tour-form #datesrates select[name='rates[childrendiscountage]']").val()));
        }

        if ($("#children-free").is(":checked") && $("select[name='rates[childrenfreeage]']").val() != '') {
            $(".rate-blocks").addClass('childrenrates-free');
            if ((min_lowerrateage - 1) != parseInt(min_freeage)) {
                $(".rate-blocks .rate-block-age-children-free").text('Age ' + min_freeage + ' to ' + (min_lowerrateage - 1));
            } else {
                $(".rate-blocks .rate-block-age-children-free").text('Age ' + min_freeage);
            }
        } else {
            $(".rate-blocks").removeClass('childrenrates-free');
        }

    } else {
        if ($("#children-free").is(":checked") && $("select[name='rates[childrenfreeage]']").val() != '') {
            $(".rate-blocks").removeClass('childrenrates');
            $(".rate-blocks").addClass('childrenrates-free');
            $(".rate-blocks .rate-block-age-adult").text('Age ' + (parseInt($("select[name='rates[childrenfreeage]']").val()) + 1) + '+');
            if ((min_lowerrateage - 1) != parseInt(min_freeage)) {
                $(".rate-blocks .rate-block-age-children-free").text('Age ' + min_freeage + ' to ' + (min_lowerrateage - 1));
            } else {
                $(".rate-blocks .rate-block-age-children-free").text('Age ' + min_freeage);
            }
        } else {
            $(".rate-blocks").removeClass('childrenrates');
            $(".rate-blocks").removeClass('childrenrates-free');
        }
    }

}

function handleShortnoticeBeAware() {
    var show_hide = 'hide';

    if ($(".tour-form #shortnotice-no").is(":checked")) {

        var notice_t = {
            '4 days': '3%',
            '5 days': '4%',
            '6 days': '5%',
            '1 weeks': '6%',
            '2 weeks': '12%',
            '3 weeks': '17%',
            '4 weeks': '22%',
            '5 weeks': '27%',
            '6 weeks': '32%',
            '7 weeks': '37%',
            '8 weeks': '41%',
            '3 months': '56%',
            '4 months': '65%',
            '5 months': '73%',
            '6 months': '81%'
        };

        if ($.inArray($(".tour-form select[name='rates[shortnoticeperiod]']").val(), Object.keys(notice_t)) >= 0) {
            if ($(".tour-form select[name='rates[shortnoticeperiod]']").val() == '1 weeks') {
                $(".tour-form .shortnotice-hint").find('span span').text('1 week');
            } else {
                $(".tour-form .shortnotice-hint").find('span span').text($(".tour-form select[name='rates[shortnoticeperiod]']").val());
            }
            $(".tour-form .shortnotice-hint").find('span strong').text(notice_t[$(".tour-form select[name='rates[shortnoticeperiod]']").val()]);
            show_hide = 'show';
        }
    }

    if (show_hide == 'show') {
        $(".tour-form .shortnotice-hint").slideDown();
    } else {
        $(".tour-form .shortnotice-hint").slideUp();
    }
}

var rates_type = '';
function handleBlockDatesratesRates() {
    if (at_load) {
        if (!setting_existing_data) {
            return false;
        }
    }
    debugFunctionCall('handleBlockDatesratesRates');

    var fixedDates = ($(".tour-form #datesrates input[name='rates[fixeddates]']:checked").val() == 'yes') ? true : false;
    var seasonDates = ($(".tour-form #datesrates input[name='rates[fixedrates]']:checked").val() == 'yes' && fixedDates == false) ? true : false;
    var yearDates = ($(".tour-form #datesrates input[name='rates[fixedrates]']:checked").val() == 'no' && fixedDates == false) ? true : false;
    var soloTraveler = ($(".tour-form #datesrates input[name='rates[solo]']:checked").val() == 'yes') ? true : false;
    var singleSupplement = (soloTraveler) ? true : false;
    var maxGroupSize = 0;
    if ($(".lowerrates_version").val() == 2018) {
        var lowerRatesMorePeople = ($(".tour-form #datesrates input[name='rates[lowerrates]']:checked").val() == 'yes') ? 4 : false;
        if ($(".tour-form #datesrates #maxgroupsize-yes").is(":checked")) {
            maxGroupSize = $(".tour-form #datesrates select[name='rates[maxgroupsizeformat]']").val();
        }
    } else {
        var lowerRatesMorePeople = ($(".tour-form #datesrates input[name='rates[lowerrates]']:checked").val() == 'yes' && $(".tour-form #datesrates .lowerrates-options input[type=checkbox]:checked").length > 0) ? $(".tour-form #datesrates .lowerrates-options input[type=checkbox]:checked").length : false;
    }

    var new_rates_type = rates_type;
    if (fixedDates == true) {
        new_rates_type = 'fixed_dates';
    } else if (seasonDates == true) {
        new_rates_type = 'season_dates';
    } else if (yearDates == true) {
        new_rates_type = 'year_dates';
    } else {
        new_rates_type = 'year_around';
    }

    var resetRates = false;
    if (new_rates_type != rates_type && rates_type != '') {
        resetRates = true;
    }
    if (resetRates || rates_type == '') {
        $(".rate-block-local-currency").html($(".tour-form #datesrates select[name='rates[local_currency]']").val());
    }
    rates_type = new_rates_type;

    if (fixedDates || seasonDates || yearDates) {
        setSolved('rates08');
        setSolved('rates09');
    }

    if ($(".tour-form #datesrates .rate-blocks li.solo-row").length) {
        if (soloTraveler && singleSupplement) {
            // Show solo rate
            $(".tour-form #datesrates .rate-blocks li.solo-row").show();
        } else {
            // Don't show solo rate
            $(".tour-form #datesrates .rate-blocks li.solo-row").hide();
        }
    }

    if (lowerRatesMorePeople) {
        lowerRatesMorePeople = lowerRatesMorePeople + 2;
        $(".tour-form #datesrates .rate-blocks ul.rate-block").each(function() {
            $(this).find('li:gt(2)').hide();
            var this_row = $(this);
            if (!(maxGroupSize > 0 && maxGroupSize < 2)) {
                $(this_row).find('li:eq(2)').show();
            }
            if (!(maxGroupSize > 0 && maxGroupSize < 3)) {
                $(this_row).find('li:eq(3)').show();
            }
            if (!(maxGroupSize > 0 && maxGroupSize < 4)) {
                $(this_row).find('li:eq(4)').show();
            }
            if (!(maxGroupSize > 0 && maxGroupSize < 5)) {
                $(this_row).find('li:eq(5)').show();
            }
            if (!(maxGroupSize > 0 && maxGroupSize < 6)) {
                $(this_row).find('li:eq(6)').show();
            }

            $(this).find(".rate-block-pp").show();
            if ($(".tour-form #datesrates input[name='rates[localpay]']:checked").val() == 'yes') {
                $(this).find(".rate-block-local-pp").show();
            }

            if ($('.tour-form #group input[type=radio]:checked').val() == 'group') {
                $(this).find('li[data-persons=1]').find('.rate-block-label').html('Single traveler <em class="multi-day-txt">(1 room)</em>');
            } else {
                $(this).find('li[data-persons=1]').find('.rate-block-label').html('Solo traveler <em class="multi-day-txt">(1 room)</em>');
            }
            $(this).find('li[data-persons=2]').find('.rate-block-label').html('2 <span>people <em class="multi-day-txt">(1 room)</em></span>');

            if ($('select[name=no_of_days]').val() > 1) {
                $(".multi-day-txt").show();
            } else {
                $(".multi-day-txt").hide();
            }
        });
    } else {
        $(".tour-form #datesrates .rate-blocks ul.rate-block").each(function() {
            $(this).find("li:gt(2)").hide();
            $(this).find(".rate-block-pp").hide();
            $(this).find(".rate-block-local-pp").hide();
            if ($('.tour-form #group input[type=radio]:checked').val() == 'group') {
                $(this).find('li[data-persons=1]').find('.rate-block-label').html('Single traveler');
            } else {
                $(this).find('li[data-persons=1]').find('.rate-block-label').html('Solo traveler');
            }
            $(this).find('li[data-persons=2]').find('.rate-block-label').html('Per person sharing');
        });
    }

    var new_rows = false;
    if (fixedDates || seasonDates || yearDates) {
        // Amount of UL's to show
        var amountofULs = 0;
        if (fixedDates) {
            amountofULs = $(".tour-form #datesrates .fixeddates-options input[data-val]").length;
        }
        if (seasonDates) {
            amountofULs = $(".tour-form #datesrates .fixedrates-options input.date-picker-from[data-val]").parent().find('input.date-picker-to[data-val]').length;
        }
        if (yearDates) {
            amountofULs = $(".tour-form #datesrates .fixedyears-options input:checked").length;
        }
        $(".tour-form #datesrates .rate-blocks ul.rate-block").show().removeClass('disabled');
        $(".tour-form #datesrates .rate-blocks ul.rate-block").find('input').unbind('click');
        if ($(".tour-form #datesrates .rate-blocks ul.rate-block").length == amountofULs) {
            // Do nothing
            $(".tour-form #datesrates .rate-blocks ul.rate-block").show();
        } else if ($(".tour-form #datesrates .rate-blocks ul.rate-block").length < amountofULs) {
            // Add blocks
            var to_add = amountofULs - $(".tour-form #datesrates .rate-blocks ul.rate-block").length;

            var clone_pos = 'after';
            if (yearDates && $(".fixedyears-options").length && $(".fixedyears-options").attr('data-insertbefore') && to_add == 1) {
                clone_pos = 'before';
            }
            if ($(".fixedyears-options").length) {
                $(".fixedyears-options").removeAttr('data-insertbefore')
            }

            do {
                $(".tour-form #datesrates .rate-blocks").find("ul.rate-block").first().clone().insertAfter($(".tour-form #datesrates ul.rate-block").last());
                $(".tour-form #datesrates .rate-blocks").find("ul.rate-block").last().removeClass('with-gap');
                $(".tour-form #datesrates .rate-blocks").find("ul.rate-block").last().find('.gap').remove();

                if (clone_pos == 'before') {
                    $(".tour-form #datesrates .rate-blocks").find("ul.rate-block").first().find('input[type=text]').val('');
                } else {
                    $(".tour-form #datesrates .rate-blocks").find("ul.rate-block").last().find('input[type=text]').val('');
                }
                to_add--;
            } while (to_add > 0);
            new_rows = true;
        } else if ($(".tour-form #datesrates .rate-blocks ul.rate-block").length > amountofULs) {
            var to_remove = $(".tour-form #datesrates .rate-blocks ul.rate-block").length - amountofULs;
            // Remove blocks
            $(".tour-form #datesrates .rate-blocks ul.rate-block:gt(" + (parseInt(amountofULs) - 1) + ")").remove();
        }
        if (amountofULs == 0) {
            $(".tour-form #datesrates .rate-blocks ul.rate-block").hide();
        }
    }

    if (resetRates) {
        $(".tour-form #datesrates .rate-blocks ul.rate-block input[type=text]").val('');
    }


    if (setting_existing_data) {
        return;
    }

    if (fixedDates || seasonDates || yearDates) {
        var count = 0;
        $(".tour-form #datesrates .rate-blocks ul.rate-block").removeClass('expired').removeClass('dates').removeClass('seasons').removeClass('years');
        if ($(".tour-form #datesrates .rate-blocks ul.rate-block:visible").length) {
            $(".tour-form #datesrates .rate-blocks ul.rate-block:visible").each(function() {
                var today = new Date();
                var expired_anchor_text = "Expired, please remove above";
                if (fixedDates) {
                    var date_str = $(".tour-form #datesrates .fixeddates-options input[data-val]:eq(" + count + ")").attr('data-val');
                    if (date_str < moment(today).format('YYYY-MM-DD')) {
                        $(this).addClass('expired');
                        $(this).parent().addClass('expired');
                    }
                    $(this).parent().addClass('dates');
                    $(this).find('.rate-block-title').html('' + monthNames[getDatestrPart(date_str, 'month')] + ' ' + getDatestrPart(date_str, 'day') + ', ' + getDatestrPart(date_str, 'year'));
                } else if (seasonDates) {
                    var date_str1 = $(".tour-form #datesrates .fixedrates-options input.date-picker-from[data-val]:eq(" + count + ")").attr('data-val');
                    var date_str2 = $(".tour-form #datesrates .fixedrates-options input.date-picker-to[data-val]:eq(" + count + ")").attr('data-val');
                    if (date_str2 < moment(today).format('YYYY-MM-DD')) {
                        $(this).addClass('expired');
                        $(this).parent().addClass('expired');
                    }
                    $(this).parent().addClass('seasons');
                    $(this).find('.rate-block-title').html('<span style="font-weight:normal;">Start dates from</span> ' + fullMonthNames[getDatestrPart(date_str1, 'month')] + ' ' + getDatestrPart(date_str1, 'day') + ', ' + getDatestrPart(date_str1, 'year') + ' <span style="font-weight:normal;">to</span> ' + fullMonthNames[getDatestrPart(date_str2, 'month')] + ' ' + getDatestrPart(date_str2, 'day') + ', ' + getDatestrPart(date_str2, 'year'));
                } else if (yearDates) {
                    var expired_anchor_text = "Expired, please unselect above";
                    var year_str1 = $(".tour-form #datesrates .fixedyears-options input:checked:eq(" + count + ")").attr('data-val');
                    var year_str2 = $(".tour-form #datesrates .fixedyears-options input:checked:eq(" + count + ")").attr('data-val');
                    if (year_str2 < moment(today).format('YYYY')) {
                        $(this).addClass('expired');
                        $(this).parent().addClass('expired');
                    }
                    $(this).find('.rate-block-title').html('<span style="font-weight:normal;">Start dates from</span> ' + fullMonthNames[1] + ' 1, ' + year_str1 + ' <span style="font-weight:normal;">to</span> ' + fullMonthNames[12] + ' 31, ' + year_str2);
                    $(this).parent().addClass('years');
                }
                count++;
            });
        }
        $(".tour-form #datesrates .rate-blocks .rate-block").each(function() {
            if (!$(this).hasClass('expired')) {
                $(this).find(".rate-block-subtitle").html('Rates are per person for');
                if ($('select[name=no_of_days]').val() > 1) {
                    $(this).find(".no-of-days").html('' + $('select[name=no_of_days]').val() + ' days');
                } else if ($('select[name=no_of_days]').val() == 1) {
                    $(this).find(".no-of-days").html('1 day');
                } else {
                    $(this).find(".no-of-days").html('½ day');
                }
            } else {
                $(this).find(".rate-block-subtitle").html("<img src='/images/error-small.gif' alt='' />");
                var expired_anchor_text = "Expired, please remove above";
                if ($(this).hasClass('years')) {
                    var expired_anchor_text = "Expired, please unselect above";
                }
                $(this).find('.no-of-days').html('<a class="remove-notice-link" onclick="jumpTo(\'#datesrates\');return false;" href="#datesrates">' + expired_anchor_text + '</a>');
            }
        });
    } else {
        $(".tour-form #datesrates .rate-blocks ul.rate-block:eq(0)").show().addClass('disabled');
        $(".tour-form #datesrates .rate-blocks ul.rate-block:eq(0)").find('input').unbind('click').bind('click', function() {
            alert('You can\'t provide a rate yet. Please first complete the other questions in the \'Dates & Rates\' section.');
        })
        $(".tour-form #datesrates .rate-blocks ul.rate-block:gt(0)").remove();
        $(".tour-form #datesrates .rate-blocks ul.rate-block:eq(0) .rate-block-title").html('Rate for this tour');
        $(".tour-form #datesrates .rate-blocks .rate-block-subtitle").html('pp for');
    }


    var counter = 0;
    if (fixedDates || seasonDates || yearDates) {
        if (resetRates || new_rows || $(".tour-form .rate-blocks").find('.rate-block-title-row a').length < ($(".tour-form .rate-blocks .rate-block").length - 1)) {
            $(".tour-form .rate-blocks .rate-block").each(function() {
                var this_row = $(this);
                $(this).find('.rate-block-title-row a[href="#"]').remove();
                $(this).find('.rate-block-title-row div.copy').remove();
                if (counter > 0 || (seasonDates && $(".tour-form .rate-blocks .rate-block").length >= 3)) {
                    var expired_anchor_text = "Expired, please remove above";
                    if (fixedDates) {
                        $(this).find('.rate-block-title-row').append('<a href="#">Copy rates from previous date</a>');
                    } else if (seasonDates) {
                        if ($(".tour-form .rate-blocks .rate-block").length >= 3) {
                            var options = '<option value="0">Copy from date range</option>';
                            var options_counter = 0;
                            $(".tour-form .rate-blocks .rate-block").each(function() {
                                options_counter++;
                                if ($(this).find('b.rate-block-title').text() != $(this_row).find('b.rate-block-title').text()) {
                                    options += '<option value="' + options_counter + '">' + $(this).find('b.rate-block-title').text() + '</option>';
                                }
                            });
                            $(this).find('.rate-block-title-row').append('<div class="copy"> - <select>' + options + '</select></div>');
                        } else {
                            $(this).find('.rate-block-title-row').append('<a href="#">Copy rates from previous date range</a>');
                        }
                    } else {
                        $(this).find('.rate-block-title-row').append('<a href="#">Copy rates from previous year</a>');
                        var expired_anchor_text = "Expired, please unselect above";
                    }
                    if ($(this).hasClass('expired')) {
                        $(this).find('.rate-block-subtitle').html("<img src='/images/error-small.gif' alt='' />");
                        $(this).find('.no-of-days').html('<a class="remove-notice-link" href="#datesrates">' + expired_anchor_text + '</a>');
                    } else {
                        $(this).find('.rate-block-subtitle').html('Rates are per person for');
                        if ($('select[name=no_of_days]').val() > 1) {
                            $(this).find(".no-of-days").html('' + $('select[name=no_of_days]').val() + ' days');
                        } else if ($('select[name=no_of_days]').val() == 1) {
                            $(this).find(".no-of-days").html('1 day');
                        } else {
                            $(this).find(".no-of-days").html('½ day');
                        }
                    }
                }
                counter++;
            });
            $(".tour-form .rate-blocks .rate-block-title-row a").bind('click', function() {
                if ($(this).attr('href') == '#datesrates') {
                    var href = $(this).attr('href');
                    jumpTo(href);
                    return;
                }
                var row_index = $(this).parent().parent().index();
                var field_index = 0;
                $(this).parent().parent().find('input[type=text]').each(function() {
                    if ($(".tour-form .rate-blocks > ul:eq(" + (row_index - 1) + ")").hasClass('rate-block')) {
                        $(this).val($(".tour-form .rate-blocks > ul:eq(" + (row_index - 1) + ") input[type=text]:eq(" + field_index + ")").val());
                    } else {
                        $(this).val($(".tour-form .rate-blocks > ul:eq(" + (row_index - 2) + ") input[type=text]:eq(" + field_index + ")").val());
                    }
                    if ($(this).val() != '') {
                        $(this).removeClass('error');
                    }
                    if ($(".error-rates01").length) {
                        if ($(this).parent().parent().find('input[type=text][value=""]:visible').length == 0) {
                            hideError($(this).parent().parent(), $(".error-rates01").html().split(': ').pop());
                        }
                        if ($(this).parent().parent().parent().find('input[type=text][value=""]:visible').length == 0) {
                            setSolved('rates01');
                        }
                    }
                    field_index++;
                });
                return false;
            });
            $(".tour-form .rate-blocks .rate-block-title-row select").bind('change', function() {
                var row_index = $(this).val() - 1;
                var field_index = 0;
                $(this).parent().parent().parent().find('input[type=text]').each(function() {
                    if ($(".tour-form .rate-blocks > ul:eq(" + (row_index) + ")").hasClass('rate-block')) {
                        $(this).val($(".tour-form .rate-blocks > ul:eq(" + (row_index) + ") input[type=text]:eq(" + field_index + ")").val());
                    } else {
                        $(this).val($(".tour-form .rate-blocks > ul:eq(" + (row_index - 1) + ") input[type=text]:eq(" + field_index + ")").val());
                    }
                    if ($(this).val() != '') {
                        $(this).removeClass('error');
                    }
                    if ($(".error-rates01").length) {
                        if ($(this).parent().parent().find('input[type=text][value=""]:visible').length == 0) {
                            hideError($(this).parent().parent(), $(".error-rates01").html().split(': ').pop());
                        }
                        if ($(this).parent().parent().parent().find('input[type=text][value=""]:visible').length == 0) {
                            setSolved('rates01');
                        }
                    }
                    field_index++;
                });
                $(this).val(0);
                return false;
            });
        }
    } else {
        $(".tour-form .rate-blocks .rate-block-title-row a[href='#']").remove();
    }

    $(".tour-form #datesrates .rate-blocks li[data-persons] > input[type=text].rate-block-val").unbind('blur').bind('blur', function() {
        handleBlockPaymentPerEnquiry();
        if ($(this).parent().parent().find('li:visible').find('> input[type=text].rate-block-val:visible').length >= 2) {
            var rates = [-1, -1, -1, -1, -1, -1, -1, -1];
            $(this).parent().parent().find('li:visible').find('> input[type=text].rate-block-val:visible').each(function() {
                 if ($(this).parent().hasClass('solo-row')) {
                     if ($(this).val() != '') {
                         rates[0] = Math.round($(this).val());
                     }
                 } else {
                     var people = $(this).parent().find('.rate-block-label').html().substring(0, 1);
                     if ($(this).val() != '') {
                         rates[people - 1] = Math.round($(this).val());
                     }
                 }
            });

            var mainFocus = $(".tour-form #focus input[name=focus]:checked").val();
            showHideError( ( (rates[0] > -1 && rates[1] > -1 && rates[0] < rates[1]) && !(mainFocus == 'tracking_safari' || mainFocus == 'tracking' || mainFocus == 'tracking_climbing') ), $(this).parent().parent(), 'The solo traveler rate may not be lower than the rate for 2 people sharing. The solo traveler rate should include both the regular rate and the single supplement.', 'rates03');
            // showHideError( ( (rates[2] > -1 && rates[0] > -1 && rates[2] > rates[0]) && !(mainFocus == 'tracking_safari' || mainFocus == 'tracking' || mainFocus == 'tracking_climbing') ), $(this).parent().parent(), 'The rate for 3 people may not be higher than the rate for solo travelers.', 'rates04');
            // showHideError( ( (rates[3] > -1 && rates[1] > -1 && rates[3] > rates[1]) && !(mainFocus == 'tracking_safari' || mainFocus == 'tracking' || mainFocus == 'tracking_climbing') ), $(this).parent().parent(), 'The rate for 4 people may not be higher than the rate for 2 people.', 'rates05');
            // showHideError( ( (rates[4] > -1 && rates[2] > -1 && rates[4] > rates[2]) && !(mainFocus == 'tracking_safari' || mainFocus == 'tracking' || mainFocus == 'tracking_climbing') ), $(this).parent().parent(), 'The rate for 5 people may not be higher than the rate for 3 people.', 'rates06');
        }
    });
    $(".tour-form #datesrates .rate-blocks input[type=text].rate-block-local-val").unbind('blur').bind('blur', function() {
        handleBlockPaymentPerEnquiry();
    });

    if (fixedDates) {
        $(".tour-form #datesrates .add-extra").text('+ Add start dates');
        $(".tour-form #datesrates .add-extra").show();
    }
    if (seasonDates) {
        $(".tour-form #datesrates .add-extra").text('+ Add date range');
        $(".tour-form #datesrates .add-extra").show();
    }
    if (yearDates) {
        if ($(".fixedyears-options input[type=checkbox]:not(:checked)").length) {
            var y = false;
            $(".fixedyears-options input[type=checkbox]:not(:checked)").each(function() {
                if (!$(this).parent().hasClass('expired') && y == false) {
                    y = $(this).attr('data-val');
                }
            });
            if (y) {
                $(".tour-form #datesrates .add-extra").text('+ Add ' + y + ' rates');
                $(".tour-form #datesrates .add-extra").show();
            } else {
                $(".tour-form #datesrates .add-extra").hide();
            }
        } else {
            $(".tour-form #datesrates .add-extra").hide();
        }
    }
    $(".tour-form #datesrates .add-extra").unbind('click').bind('click', function(e) {
        e.preventDefault();
        if (yearDates) {
            var y = false;
            $(".fixedyears-options input[type=checkbox]:not(:checked)").each(function() {
                if (!$(this).parent().hasClass('expired') && y == false) {
                    y = $(this).attr('data-val');
                    if ($(this).parent().index() == 0) {
                        $(".fixedyears-options").attr('data-insertbefore', 1);
                    }
                    $(this).trigger('click')
                }
            });
        } else {
            jumpTo('#fixeddates-yes');
        }
    });

    if (!soloTraveler) {
        if ($('.tour-form #group input[type=radio]:checked').val() == 'group') {
            $(".tour-form .solotraveler-hint span").html('Please be aware that <strong>16%</strong> of all quote requests are for single travelers. By blocking these quote requests, you will miss out on this business.');
        } else {
            $(".tour-form .solotraveler-hint span").html('Please be aware that <strong>16%</strong> of all quote requests are for solo travelers. By blocking these quote requests, you will miss out on this business.');
        }
        if ($(".tour-form #datesrates input[name='rates[solo]']:checked").length) {
            $(".tour-form .solotraveler-hint").slideDown();
        } else {
            $(".tour-form .solotraveler-hint").slideUp();
        }
    } else {
        $(".tour-form .solotraveler-hint").slideUp();
    }
    //

    if ($(".tour-form #datesrates .maxgroupsize-block input:eq(0)").is(":checked")) {
        $(".tour-form .maxgroupsize-hint").slideUp();
    } else {
        if ($(".tour-form .maxgroupsize-block select").val() == '2') {
            $(".tour-form .maxgroupsize-hint span").html('Please be aware that <strong>27%</strong> of all quote requests are for three or more travelers. By blocking these quote requests, you will miss out on this business.');
            $(".tour-form .maxgroupsize-hint").slideDown();
        } else if ($(".tour-form .maxgroupsize-block select").val() == '3') {
            $(".tour-form .maxgroupsize-hint span").html('Please be aware that <strong>19%</strong> of all quote requests are for four or more travelers. By blocking these quote requests, you will miss out on this business.');
            $(".tour-form .maxgroupsize-hint").slideDown();
        } else if ($(".tour-form .maxgroupsize-block select").val() == '4') {
            $(".tour-form .maxgroupsize-hint span").html('Please be aware that <strong>9%</strong> of all quote requests are for five or more travelers. By blocking these quote requests, you will miss out on this business.');
            $(".tour-form .maxgroupsize-hint").slideDown();
        } else if ($(".tour-form .maxgroupsize-block select").val() == '5') {
            $(".tour-form .maxgroupsize-hint span").html('Please be aware that <strong>6%</strong> of all quote requests are for six or more travelers. By blocking these quote requests, you will miss out on this business.');
            $(".tour-form .maxgroupsize-hint").slideDown();
        } else {
            $(".tour-form .maxgroupsize-hint").slideUp();
        }
    }

    limitedInputs();
    handleBlockPaymentPerEnquiry();
    handleBlocks();
    fillAvailabilityCalendarVars();
    $(".date-range-picker-holder").datepicker("refresh");
}

function handleBlockInclusions() {
    debugFunctionCall('handleBlockInclusions');

    $(".tour-form #inclusions input[type=radio]").unbind('click').bind('click', function() {
        var all_checked = true;
        $(".tour-form #inclusions ul li:visible").each(function() {
            if ($(this).find('input[type=radio]').length) {
                var amount_selected = $(this).find('input[type=radio]:checked').length;
                if (amount_selected == 0) {
                    all_checked = false;
                }
            }
        });
        if (all_checked) {
            setSolved('inclusions01');
        }
        if ($(this).hasClass('inactive')) {
            return false;
        }
    });

    $(".incl-vehiclerent-extra select").unbind('change').bind('change', function() {
        if (parseInt($(".incl-vehiclerent-extra select:eq(0)").val()) < parseInt($(".incl-vehiclerent-extra select:eq(1)").val())) {
            setSolved('inclusions02');
        }
    });

    var campingAvailable = false;
    $(".tour-form #daybyday li[data-index]:visible input.camping-yes").each(function() {
        if ($(this).is(":checked")) {
            campingAvailable = true;
        }
    });
    $(".incl-sleepingbag").toggle(campingAvailable);
    $(".incl-bathtowels").toggle(campingAvailable);
    $(".incl-campingeq").toggle(campingAvailable);

    var selfdrive = false;
    if ($(".tour-form #focus input[name=focus]:checked").val() == 'guided_selfdrive' || $(".tour-form #focus input[name=focus]:checked").val() == 'selfdrive') {
        selfdrive = true;
    }
    $(".incl-vehiclerent").toggle(selfdrive);
    $(".tour-form #inclusions input[name='notes[312]']").unbind('change').bind('change', function() {
        if ($(".tour-form #inclusions input[name='notes[312]']:checked").val() == 'excluded') {
            if (!$(".incl-vehiclerent-extra").is(":visible")) {
                $(".incl-vehiclerent-extra").show().css('color', 'red').animate({'opacity': '0.3'}, 350).animate({'opacity': '1.0'}, 350).animate({'opacity': '0.3'}, 350).animate({'opacity': '1.0'}).animate({'color': '#535353'});
            } else {
                $(".incl-vehiclerent-extra").show();
            }
        } else {
            $(".incl-vehiclerent-extra").hide();
        }
    });
    $(".tour-form #inclusions input[name='notes[312]']").trigger('change');

    var climbing = false;
    if ($(".tour-form #focus input[name=focus]:checked").val() == 'climb_safari' || $(".tour-form #focus input[name=focus]:checked").val() == 'climb') {
        climbing = true;
    }
    if (climbing) {
        $(".incl-porterage").show();
        $(".incl-rescue").show();
        $(".incl-climbinggear").show();
    } else {
        $(".incl-porterage").hide();
        $(".incl-rescue").hide();
        $(".incl-climbinggear").hide();
    }
    
    var balloon = false;
    if ($(".tour-form #activities input[name='activities[balloon]']").is(":checked") && $(".tour-form #activities").is(":visible")) {
        balloon = true;
    }
    if (balloon) {
        $(".incl-balloon").show();
    } else {
        $(".incl-balloon").hide();
    }

    $(".tour-form #inclusions li").removeClass('third');
    $(".tour-form #inclusions li:visible").filter(':visible').each(function(i) {
        var modulus = (i + 1) % 3;
        if (modulus === 0) {
            $(this).addClass('third');
        }
    });

    $(".incl-proguide").show();

    if ($(".tour-form #activities input[name='activities[none]']").is(":checked") && $(".tour-form #activities").is(":visible")) {
        $(".incl-parkfees_both").show();
        $(".incl-proguide_both").show();
        $(".incl-proguide").hide();
        $(".incl-parkfees").hide();
    } else {
        $(".incl-parkfees_both").hide();
        $(".incl-proguide_both").hide();
        $(".incl-proguide").show();
        $(".incl-parkfees").show();
    }

    if (selfdrive) {
        $(".incl-proguide").hide();
    }

    var no_of_days = parseInt($("select[name=no_of_days]").val());

    $(".incl-gorillapermits").toggle($(".tour-form #activities input[name='activities[gorilla]']").is(":checked") && $(".tour-form #activities").is(":visible") && ($(".tour-form #focus input[name=focus]:checked").val() != 'overland' || no_of_days < 8));
    $(".incl-chimppermits").toggle($(".tour-form #activities input[name='activities[chimp]']").is(":checked") && $(".tour-form #activities").is(":visible") && ($(".tour-form #focus input[name=focus]:checked").val() != 'overland' || no_of_days < 8));

    $(".incl-gorillapermits-exc").toggle($(".tour-form #activities input[name='activities[gorilla]']").is(":checked") && $(".tour-form #activities").is(":visible") && $(".tour-form #focus input[name=focus]:checked").val() == 'overland' && no_of_days >= 8);
    $(".incl-chimppermits-exc").toggle($(".tour-form #activities input[name='activities[chimp]']").is(":checked") && $(".tour-form #activities").is(":visible") && $(".tour-form #focus input[name=focus]:checked").val() == 'overland' && no_of_days >= 8);

    if (no_of_days <= 1) {
        $(".incl-allacco").hide();
    }

    if (!$(".tour-form #gettingthere input[name='gettingthere[airport_transfer]']:checked").length) {
        $(".incl-roundtrip-inc").hide();
        $(".incl-roundtrip-exc").hide();
    } else {
        if ($(".tour-form #gettingthere input[name='gettingthere[airport_transfer]']:checked").val() == 'yes') {
            $(".incl-roundtrip-inc").show();
            $(".incl-roundtrip-exc").hide();
        } else {
            $(".incl-roundtrip-inc").hide();
            $(".incl-roundtrip-exc").show();
        }
    }

    $(".incl-allflights").toggle($(".tour-form #transportation input[name='transportation[airtransfer]']").is(":checked"));
}

function handleBlockNotes() {
    debugFunctionCall('handleBlockNotes');

    var noncampingAvailable = false;
    var day_blocks = $(".tour-form #daybyday li[data-index]:visible input.camping-no").length;
    var day_block_index = 0;
    $(".tour-form #daybyday li[data-index]:visible input.camping-no").each(function() {
        day_block_index++;
        if ($(this).is(":checked") && day_block_index != day_blocks) {
            noncampingAvailable = true;
        }
    });

    $(".tour-form #notes input[type=radio].inactive").unbind('click').bind('click', function() {
        return false;
    });

    if (!$(".tour-form #transportation input[name='transportation[airtransfer]']:checked").length) {
        $(".fixedflightbudget-inactive").show();
        $(".fixedflightbudget-active").hide();
    } else {
        $(".fixedflightbudget-inactive").hide();
        $(".fixedflightbudget-active").show();
    }

    $(".note-fullalter").toggle(noncampingAvailable);
}

function showhideLocalPayments() {
    debugFunctionCall('showhideLocalPayments');

    var show = false;
    if ($(".tour-form #datesrates input[name='rates[localpay]']:checked").val() == 'yes') {
        show = true;
    }
    var currency = $(".tour-form #datesrates select[name='rates[local_currency]']").val();

    if (show == false) {
        $(".rate-block-local-label").hide();
        $(".rate-block-local-currency").hide();
        $(".rate-block-local-val").hide();
        $(".rate-block-local-pp").hide();
    } else {
        $(".rate-block-local-label").css('display', 'inline-block');
        $(".rate-block-local-currency").css('display', 'inline-block').html(currency);
        $(".rate-block-local-val").show();
        if ($(".tour-form #datesrates input[name='rates[lowerrates]']:checked").val() == 'yes') {
            $(".rate-block-local-pp").show();
        } else {
            $(".rate-block-local-pp").hide();
        }
    }

    handleBlockPaymentPerEnquiry();
}

var disabledDays1 = [];
function disableUsedDays(date) {
    debugFunctionCall('disableUsedDays');

    if (disabledDays1.length == 0) {
        $(".tour-form #datesrates .fixeddates-options input[type=text]").each(function() {
            if ($(this).attr('data-val')) {
                disabledDays1.push(getDatestrPart($(this).attr('data-val'), 'month') + '-' + getDatestrPart($(this).attr('data-val'), 'day') + '-' + getDatestrPart($(this).attr('data-val'), 'year'));
            }
        });
    }
    var m = date.getMonth(), d = date.getDate(), y = date.getFullYear();
    if ($.inArray((m+1) + '-' + d + '-' + y, disabledDays1) != -1) {
        return [false];
    } else {
        return [true];
    }
}

var disabledDays2 = [];
function disableUsedDays2(date) {
    debugFunctionCall('disableUsedDays2');

//     var disabledDays = [];

    if (disabledDays2.length == 0) {
        $(".tour-form #datesrates .fixedrates-options li").each(function() {
            if ($(this).find('.date-picker-from').length && $(this).find('.date-picker-to').length && $(this).find('.date-picker-from').val() != '' && $(this).find('.date-picker-to').val() != '' && !$(this).find('.date-picker-from').hasClass('currentOpened')) {
                var firstdate = new Date($(this).find('.date-picker-from').val());
                var lastdate = new Date($(this).find('.date-picker-to').val());

                var currentDate = firstdate;
                var thism = currentDate.getMonth(), thisd = currentDate.getDate(), thisy = currentDate.getFullYear();
                var endDate = lastdate;
                while (currentDate <= endDate) {
                    var thism = currentDate.getMonth(), thisd = currentDate.getDate(), thisy = currentDate.getFullYear();
                    var datem = date.getMonth(), dated = date.getDate(), datey = date.getFullYear();
                    disabledDays2.push((thism+1) + '-' + thisd + '-' + thisy);
                    currentDate.setDate(currentDate.getDate() + 1);
                }
            }
        });
    }

    var m = date.getMonth(), d = date.getDate(), y = date.getFullYear();
    if ($.inArray((m+1) + '-' + d + '-' + y, disabledDays2) != -1) {
        return [false];
    } else {
        return [true];
    }
    return [true];
}

var disabledDays3 = [];
var firstDates3 = [];
function disableUsedDays3(date) {
    debugFunctionCall('disableUsedDays3');

    if (firstDates3.length == 0) {
        $(".tour-form #datesrates .fixedrates-options li").each(function() {
            if ($(this).find('.date-picker-from').val() != '' && $(this).find('.date-picker-to').val() != '') {
                var firstdate = new Date($(this).find('.date-picker-from').attr('data-val'));
                var lastdate = new Date($(this).find('.date-picker-to').attr('data-val'));

                var currentDate = firstdate;
                var endDate = lastdate;
                firstDates3.push(firstdate);
                while (currentDate >= endDate) {
                    var thism = currentDate.getMonth(), thisd = currentDate.getDate(), thisy = currentDate.getFullYear();
                    disabledDays3.push((thism+1) + '-' + thisd + '-' + thisy);
                    currentDate.setDate(currentDate.getDate() + 1);
                }
            }
        });
    }

    var returnVal = true;
    var picker = $(this);
    $.each(firstDates3, function(key, val) {
        var startDate = new Date(picker.parent().find('.date-picker-from').attr('data-val'));
        var endDate = new Date(picker.parent().find('.date-picker-to').attr('data-val'));
        if (val <= date && val > startDate) {
            returnVal = false;
        }
        var thism = date.getMonth(), thisd = date.getDate(), thisy = date.getFullYear();
        var date_ymd = (thism+1) + '-' + thisd + '-' + thisy;
        var thism = val.getMonth(), thisd = val.getDate(), thisy = val.getFullYear();
        var val_ymd = (thism+1) + '-' + thisd + '-' + thisy;
        if (date_ymd == val_ymd) {
            returnVal = false;
        }
    });

    var m = date.getMonth(), d = date.getDate(), y = date.getFullYear();
    if ($.inArray((m+1) + '-' + d + '-' + y, disabledDays3) != -1) {
        returnVal = false;
    }

    return [returnVal];
}

function sortFixedDates(last_val) {
    debugFunctionCall('sortFixedDates');

    var items = [];
    var unsorted_items = [];
    var item_availability = [];
    var handle_availability = false;

    if ($(".tour-form #datesrates .fixeddates-options").hasClass('with-availability')) {
        handle_availability = true;
    }
    $( ".tour-form #datesrates .fixeddates-options .date-picker" ).each(function() {
        if ($(this).attr('data-val')) {
            items.push($(this).attr('data-val'));
            unsorted_items.push($(this).attr('data-val'));
        } else {
            items.push('9999-12-31');
            unsorted_items.push('9999-12-31');
        }

        if (handle_availability) {
            item_availability.push($(this).parent().find('.availability select').val());
        }
    });
    var unsorted = items.join(',');
    items.sort();
    var sorted = items.join(',');

    var rate_row_indexes = [];
    if (sorted != unsorted) {
        $(".tour-form #datesrates .fixeddates-options").before('<div class="busy"><img src="/images/loader.gif" />Rearranging dates...</div>');
        $(".tour-form #datesrates .busy").css('margin-top', parseInt(($(".fixeddates-options").height() / 2) - 20) + 'px');
        $( ".tour-form #datesrates .fixeddates-options").animate({"opacity": 0.1}, 'slow', function() {
            $.each(sorted.split(','), function(key, val) {
                var index = $.inArray(val, unsorted_items);
                rate_row_indexes.push(index);

                if (val == '9999-12-31') {
                    $(".tour-form #datesrates .fixeddates-options .date-picker").eq(key).val('').removeAttr('data-val');
                } else {
                    $(".tour-form #datesrates .fixeddates-options .date-picker").eq(key).val(monthNames[getDatestrPart(val, 'month')] + ' ' + getDatestrPart(val, 'day') + ', ' + getDatestrPart(val, 'year') + ' (' + ISOdayNames[getDatestrPart(val, 'weekday')] + ')').attr('data-val', val);
                }

                if (handle_availability) {
                    $(".tour-form #datesrates .fixeddates-options .availability select").eq(key).val(item_availability[index]);
                }
            });
            var rate_blocks = $(".tour-form .rate-blocks .rate-block").clone(true);
            rate_row_indexes.reverse();
            $(".tour-form .rate-blocks .rate-block").remove();

            $.each(rate_row_indexes, function(key, val) {
                if (val === -1) {
                    $(rate_blocks).first().clone().prependTo($(".tour-form .rate-blocks"));
                    $(".tour-form .rate-blocks").last().find('input[type=text]').val('');
                } else {
                    if (!$(rate_blocks).eq(val).length) {
                        $(rate_blocks).first().clone().prependTo($(".tour-form .rate-blocks"));
                        $(".tour-form .rate-blocks .rate-block").first().find('input[type=text]').val('');
                    } else {
                        $(rate_blocks).eq(val).clone().prependTo($(".tour-form .rate-blocks"));
                    }
                }
            });
            $(".tour-form .rate-blocks .rate-block-title-row a").unbind('click').bind('click', function() {
                var row_index = $(this).parent().parent().index();
                var field_index = 0;
                $(this).parent().parent().find('input[type=text]').each(function() {
                    $(this).val($(".tour-form .rate-blocks .rate-block:eq(" + (row_index - 1) + ") input[type=text]:eq(" + field_index + ")").val());
                    field_index++;
                });
                return false;
            });

            setTimeout(function() {
                $(".tour-form #datesrates .busy").remove();
                $( ".tour-form #datesrates .fixeddates-options").animate({"opacity": 100}, 'slow', function() {
                    $( ".tour-form #datesrates .fixeddates-options .date-picker[data-val='"+last_val+"']").parent().animate({'opacity': '0.3'}, 350).animate({'opacity': '1.0'}, 350).animate({'opacity': '0.3'}, 350).animate({'opacity': '1.0'});
                });
            }, 2000);
            handleBlockDatesratesRates();
        });
    } else {
        handleBlockDatesratesRates();
    }
}

function sortSeasonDates(last_val) {
    debugFunctionCall('sortSeasonDates');

    var items = [];
    var unsorted_items = [];
    $( ".tour-form #datesrates .fixedrates-options li" ).each(function() {
        if ($(this).find('.date-picker-from').attr('data-val') || $(this).find('.date-picker-to').attr('data-val')) {
            var df = $(this).find('.date-picker-from').attr('data-val');
            var dt = $(this).find('.date-picker-to').attr('data-val');
            items.push(df + '|' + dt);
            unsorted_items.push(df + '|' + dt);
        } else {
            items.push('9999-12-31|9999-12-31');
            unsorted_items.push('9999-12-31|9999-12-31');
        }
    });
    var unsorted = items.join(',');
    items.sort();
    var sorted = items.join(',');

    var rate_row_indexes = [];
    if (sorted != unsorted) {
        $(".tour-form #datesrates .fixedrates-options").before('<div class="busy"><img src="/images/loader.gif" />Rearranging dates...</div>');
        $(".tour-form #datesrates .busy").css('margin-top', parseInt(($(".fixedrates-options").height() / 2) - 20) + 'px');
        $( ".tour-form #datesrates .fixedrates-options").animate({"opacity": 0.1}, 'slow', function() {
            $.each(sorted.split(','), function(key, val) {
                var index = $.inArray(val, unsorted_items);
                rate_row_indexes.push(index);

                var from_to = val.split('|');
                if (from_to[0] == '9999-12-31') {
                    $(".tour-form #datesrates .fixedrates-options li").eq(key).find('.date-picker-from').val('').removeAttr('data-val');
                } else {
                    $(".tour-form #datesrates .fixedrates-options li").eq(key).find('.date-picker-from').val(monthNames[getDatestrPart(from_to[0], 'month')] + ' ' + getDatestrPart(from_to[0], 'day') + ', ' + getDatestrPart(from_to[0], 'year')).attr('data-val', from_to[0]);
                }
                if (from_to[1] == '9999-12-31') {
                    $(".tour-form #datesrates .fixedrates-options li").eq(key).find('.date-picker-to').val('').removeAttr('data-val');
                } else {
                    $(".tour-form #datesrates .fixedrates-options li").eq(key).find('.date-picker-to').val(monthNames[getDatestrPart(from_to[1], 'month')] + ' ' + getDatestrPart(from_to[1], 'day') + ', ' + getDatestrPart(from_to[1], 'year')).attr('data-val', from_to[1]);
                }
            });
            var rate_blocks = $(".tour-form .rate-blocks .rate-block").clone(true);
            rate_row_indexes.reverse();
            $(".tour-form .rate-blocks .rate-block").remove();
            $.each(rate_row_indexes, function(key, val) {
                if (val === -1) {
                    $(rate_blocks).first().clone().prependTo($(".tour-form .rate-blocks"));
                    $(".tour-form .rate-blocks").last().find('input[type=text]').val('');
                } else {
                    if (!$(rate_blocks).eq(val).length) {
                        $(rate_blocks).first().clone().prependTo($(".tour-form .rate-blocks"));
                        $(".tour-form .rate-blocks .rate-block").first().find('input[type=text]').val('');
                    } else {
                        $(rate_blocks).eq(val).clone().prependTo($(".tour-form .rate-blocks"));
                    }
                }
            });
            $(".tour-form .rate-blocks .rate-block-title-row a").unbind('click').bind('click', function() {
                var row_index = $(this).parent().parent().index();
                var field_index = 0;
                $(this).parent().parent().find('input[type=text]').each(function() {
                    $(this).val($(".tour-form .rate-blocks .rate-block:eq(" + (row_index - 1) + ") input[type=text]:eq(" + field_index + ")").val());
                    field_index++;
                });
                return false;
            });

            setTimeout(function() {
                $(".tour-form #datesrates .busy").remove();
                $( ".tour-form #datesrates .fixedrates-options").animate({"opacity": 100}, 'slow', function() {
                    $( ".tour-form #datesrates .fixedrates-options .date-picker[data-val='"+last_val+"']").parent().animate({'opacity': '0.3'}, 350).animate({'opacity': '1.0'}, 350).animate({'opacity': '0.3'}, 350).animate({'opacity': '1.0'});
                });
                showSeasonGaps();
            }, 2000);
            handleBlockDatesratesRates();
        });
    } else {
        showSeasonGaps();
        handleBlockDatesratesRates();
    }
}

function showSeasonGaps() {
    debugFunctionCall('showSeasonGaps');

    $( ".tour-form #datesrates .fixedrates-options li").removeClass('with-gap');
    $( ".tour-form #datesrates .fixedrates-options li .gap").remove();
    $( ".tour-form #datesrates .fixedrates-options li:gt(0)").each(function() {
        if ($(this).find('.date-picker-from').attr('data-val') && $(this).find('.date-picker-to').attr('data-val')) {
            var current_from = new Date($(this).find('.date-picker-from').attr('data-val')).getTime() / 1000;
            var prev_to = new Date($(this).prev().find('.date-picker-to').attr('data-val')).getTime() / 1000;
            var days_diff = Math.round((current_from - prev_to) / 86400);
            if (days_diff != 1) {
                p_to = moment($(this).prev().find('.date-picker-to').attr('data-val')).add(1, 'day');
                c_from = moment($(this).find('.date-picker-from').attr('data-val')).subtract(1, 'day');

                p_to = p_to.format('YYYY-MM-DD');
                c_from = c_from.format('YYYY-MM-DD');

                if (p_to == c_from) {
                    $(this).prepend('<div class="gap">There is a gap between your seasons. We\'ll consider your tour to be unavailable on ' + monthNames[getDatestrPart(p_to, 'month')] + ' ' + getDatestrPart(p_to, 'day') + ', ' + getDatestrPart(p_to, 'year') + '</div>');
                } else {
                    $(this).prepend('<div class="gap">There is a gap between your seasons. We\'ll consider your tour to be unavailable from ' + monthNames[getDatestrPart(p_to, 'month')] + ' ' + getDatestrPart(p_to, 'day') + ', ' + getDatestrPart(p_to, 'year') + ' to ' + monthNames[getDatestrPart(c_from, 'month')] + ' ' + getDatestrPart(c_from, 'day') + ', ' + getDatestrPart(c_from, 'year') + '</div>');
                }
                $(this).addClass('with-gap');
            }
        }
    });
}

var currently_removing = false;
function handleBlockDatesratesActions() {
    if (setting_existing_data) {
        return false;
    }
    debugFunctionCall('handleBlockDatesratesActions');

    $(".tour-form #datesrates .remove-new").unbind('click').bind('click', function() {
        if (!$(this).hasClass('inactive') && !$(this).parent().hasClass('disabled')) {
            var index_to_remove = $(this).parent().index();
            if (currently_removing) {
                return false;
            }
            if ($(this).parent().parent().find("li").length > 2) {
                currently_removing = true;
                $(this).parent().slideUp('normal', function() {
                    var availability_option = ($(this).closest('.availability-options').length);
                    $(this).remove();

                    if (!availability_option) {
                        $(".tour-form #datesrates .fixedrates-options li").removeClass('disabled');
                        if ($(".tour-form .rate-blocks .rate-block").length > 1) {
                            $(".tour-form .rate-blocks .rate-block:eq(" + index_to_remove + ")").remove();
                        } else {
                            $(".tour-form .rate-blocks .rate-block:eq(0)").find('input').val('');
                        }
                        var c = 1;
                        $(".tour-form #datesrates .fixeddates-options li").each(function() {
                            if ($(this).find('span').length) {
                                $(this).find('span').eq(0).html(c + ".");
                                c++;
                            }
                        });
                    }
                    var c = 1;
                    $(".tour-form #datesrates .fixeddates-options li").each(function() {
                        if ($(this).find('span').length) {
                            $(this).find('span').eq(0).html(c + ".");
                            c++;
                        }
                    });
                    if ($(".tour-form #datesrates .fixeddates-options li").length <= 2) {
                        $(".tour-form #datesrates .fixeddates-options li:eq(0) .remove-new").addClass('inactive');
                    }
                    if ($(".tour-form #datesrates .fixedrates-options li").length <= 2) {
                        $(".tour-form #datesrates .fixedrates-options li:eq(0) .remove-new").addClass('inactive');
                    }
                    if ($(".tour-form #datesrates .availability-options li").length <= 2) {
                        $(".tour-form #datesrates .availability-options li:eq(0) .remove-new").addClass('inactive');
                    }

                    if (!availability_option) {
                        handleBlockDatesratesRates();
                        showSeasonGaps();
                    }

                    currently_removing = false;
                });
            }
        }
        showSeasonGaps();

        return false;
    });
    $( ".tour-form #datesrates .fixeddates-options .date-picker" ).datepicker({
        dateFormat: "M d, yy (DD)",
        maxDate: new Date(new Date().getFullYear()+3,11,31),
        minDate: "0",
        firstDay: 1,
        numberOfMonths: [1, 2],
        beforeShowDay: disableUsedDays,
        beforeShow: function() {
            disabledDays1 = [];
            $("#ui-datepicker-div").addClass('ll-skin-cangas');
            if ($(this).parent().prev().find('input').length) {
                // Find most recent previous to-date
                var currentRow = $(this).parent().index();
                var defaultDate = '';
                if (currentRow > 0) {
                    for (var i = 0; i < currentRow; i++) {
                        if ($(this).parent().parent().find('li').eq(i).find('input').val() != '') {
                            defaultDate = $(this).parent().parent().find('li').eq(i).find('input').val();
                        }
                    }
                }
                if (defaultDate != '') {
                    $( this ).datepicker( "option", "defaultDate", defaultDate);
                }
            }
        },
        onSelect: function(dateText) {
            var thisDate_str = dateTexttoDate(dateText);
            $(this).attr('data-val', thisDate_str);
            $(this).parent().find('span.expired').remove();
            $(this).parent().removeClass('expired');

            sortFixedDates(thisDate_str);
            setSolved('departuredates02');
            setSolved('departuredates03');
            hideError($('.fixeddates-options'), '');
            handleBlocks();
        }
    });
    $( ".tour-form #datesrates .fixedrates-options .date-picker-from" ).datepicker({
        dateFormat: "M d, yy",
        maxDate: new Date(new Date().getFullYear()+3,11,31),
        minDate: new Date(new Date().getFullYear(),0,1),
        firstDay: 1,
        numberOfMonths: [1, 2],
        beforeShowDay: disableUsedDays2,
        onSelect: function(dateText) {
            var thisDate_str = dateTexttoDate(dateText);
            $(this).attr('data-val', thisDate_str);
            $(this).parent().find('span.expired').remove();
            $(this).parent().removeClass('expired');

            var this_from_picker = $(this);
            if (this_from_picker.parent().find('.date-picker-to').val() == '') {
                setTimeout(function() {
                    this_from_picker.parent().find('.date-picker-to').datepicker('show');
                }, 200);
            }
            setSolved('seasons03');
            hideError($('.fixedrates-options'), '');
            handleBlockDatesratesRates();
            showSeasonGaps();

            var current_line = $(this).parent();
            var current_line_index = $(this).parent().index();
            var from = $(current_line).find('.date-picker-from').val();
            var to = $(current_line).find('.date-picker-to').val();
            $(this).parent().parent().find('li').removeClass('disabled');
            if ((from != '' && to == '') || (to != '' && from == '')) {
                $(this).parent().parent().find('li').each(function() {
                    if ($(this).find('input').length && $(this).index() != current_line_index) {
                        $(this).addClass('disabled');
                    }
                });
            }
            handleBlocks();
        },
        beforeShow: function() {
            $('.date-picker-from').removeClass('currentOpened');
            disabledDays2 = [];
            $(this).addClass('currentOpened');
            $("#ui-datepicker-div").addClass('ll-skin-cangas');
            if ($(this).parent().prev().find('input').length) {
                // Find most recent previous to-date
                var currentRow = $(this).parent().index();
                var defaultDate = '';
                if (currentRow > 0) {
                    for (var i = 0; i < currentRow; i++) {
                        if ($(this).parent().parent().find('li').eq(i).find('input').last().val() != '') {
                            defaultDate = $(this).parent().parent().find('li').eq(i).find('input').last().val();
                        }
                    }
                }
                if (defaultDate != '') {
                    $( this ).datepicker( "option", "defaultDate", defaultDate);

                    if ($(this).parent().find('.date-picker-to').val() != '') {
                        var minDate = new Date(defaultDate);
                        minDate.setDate(minDate.getDate() + 1);
                        $(this).datepicker("option", "minDate", minDate);
                    }
                } else {
                    $( this ).datepicker( "option", "minDate", new Date(new Date().getFullYear(),0,1));
                }
            } else {
                $( this ).datepicker( "option", "minDate", new Date(new Date().getFullYear(),0,1));
            }
            if ($(this).parent().find('.date-picker-to').val()) {
                var maxDate = new Date($(this).parent().find('.date-picker-to').val());
                maxDate.setDate(maxDate.getDate() - 1);
                $(this).datepicker("option", "maxDate", maxDate);
            } else {
                $(this).datepicker("option", "maxDate", new Date(new Date().getFullYear()+3,11,31));
            }

            // Detect if there is a 'unfinished' season
            var current_line = $(this).parent().index();
            var unfinished = 0;
            $(this).parent().parent().find('li').each(function() {
                if ($(this).find('input').length && $(this).index() != current_line) {
                    var from = $(this).find('.date-picker-from').val();
                    var to = $(this).find('.date-picker-to').val();
                    if ((from != '' && to == '') || (to != '' && from == '')) {
                        unfinished++;
                    }
                }
            });
            if (unfinished > 0) {
                if (!$(this).attr('data-alert')) {
                    $(this).attr('data-alert', 1);
                    alert('This option is disabled because you are editing another date range. It will be enabled again once you\'ve selected a start AND end date for the other date range');
                }
                try {
                    $(this).datepicker("close");
                } catch(err) {}
                return false;
            } else {
                $(this).parent().parent().find('input').removeAttr('data-alert')
            }
        }
    });
    $( ".tour-form #datesrates .fixedrates-options .date-picker-to" ).datepicker({
        dateFormat: "M d, yy",
        maxDate: new Date(new Date().getFullYear()+3,11,31),
        minDate: new Date(new Date().getFullYear(),0,1),
        firstDay: 1,
        numberOfMonths: [1, 2],
        beforeShowDay: disableUsedDays3,
        onSelect: function(dateText) {
            firstInactive = false;
            var thisDate_str = dateTexttoDate(dateText);
            $(this).attr('data-val', thisDate_str);
            $(this).parent().find('span.expired').remove();
            $(this).parent().removeClass('expired');

            var this_to_picker = $(this);
            if (this_to_picker.parent().find('.date-picker-from').val() == '') {
                setTimeout(function() {
                    this_to_picker.parent().find('.date-picker-from').datepicker('show');
                }, 200);
            }

            var current_line = $(this).parent();
            var current_line_index = $(this).parent().index();
            var from = $(current_line).find('.date-picker-from').val();
            var to = $(current_line).find('.date-picker-to').val();

            if (from != '' && to != '') {
                sortSeasonDates(thisDate_str);
            }
            setSolved('seasons02');
            setSolved('seasons04');
            setSolved('seasons05');
            hideError($('.fixedrates-options'), '');
            $(this).parent().parent().find('li').removeClass('disabled');
            if ((from != '' && to == '') || (to != '' && from == '')) {
                $(this).parent().parent().find('li').each(function() {
                    if ($(this).find('input').length && $(this).index() != current_line_index) {
                        $(this).addClass('disabled');
                    }
                });
            }
            handleBlocks();
        },
        beforeShow: function() {
            disabledDays3 = [];
            firstDates3 = [];
            firstActive = false;
            firstInactive = false;
            $("#ui-datepicker-div").addClass('ll-skin-cangas');
            if ($(this).parent().find('.date-picker-from').val()) {
                var minDate = new Date($(this).parent().find('.date-picker-from').val());
                minDate.setDate(minDate.getDate() + 1);
                var today = new Date(new Date().getFullYear(),0,1);
                if (minDate < today) {
                    $(this).datepicker("option", "minDate", new Date(new Date().getFullYear(),0,1));
                } else {
                    $(this).datepicker("option", "minDate", minDate);
                    $(this).datepicker("option", "defaultDate", minDate);
                }
            } else {

                if ($(this).parent().prev().find('input').length) {
                    // Find most recent previous to-date
                    var currentRow = $(this).parent().index();
                    var defaultDate = '';
                    if (currentRow > 0) {
                        for (var i = 0; i < currentRow; i++) {
                            if ($(this).parent().parent().find('li').eq(i).find('input').last().val() != '') {
                                defaultDate = $(this).parent().parent().find('li').eq(i).find('input').last().val()
                            }
                        }
                    }
                    if (defaultDate != '') {
                        $( this ).datepicker( "option", "defaultDate", defaultDate);
                        var minDate = new Date(defaultDate);
                        minDate.setDate(minDate.getDate() + 2);
                        $(this).datepicker("option", "minDate", minDate);
                    }
                }
            }
            // Detect if there is a 'unfinished' season
            var current_line = $(this).parent().index();
            var unfinished = 0;
            $(this).parent().parent().find('li').each(function() {
                if ($(this).find('input').length && $(this).index() != current_line) {
                    var from = $(this).find('.date-picker-from').val();
                    var to = $(this).find('.date-picker-to').val();
                    if ((from != '' && to == '') || (to != '' && from == '')) {
                        unfinished++;
                    }
                }
            });
            if (unfinished > 0) {
                if (!$(this).attr('data-alert')) {
                    $(this).attr('data-alert', 1);
                    alert('This option is disabled because you are editing another date range. It will be enabled again once you\'ve selected a start AND end date for the other date range');
                }
                try {
                    $(this).datepicker("close");
                } catch(err) {}
                return false;
            } else {
                $(this).parent().parent().find('input').removeAttr('data-alert')
            }
        }
    });

}

function setGuidelinesBasedOnGettingThere() {
    debugFunctionCall('setGuidelinesBasedOnGettingThere');

    var total = $(".tour-form #daybyday > div > ul > li:visible").length;
    $(".tour-form #daybyday > div > ul > li .last-day-destination").addClass('hidden');
    $(".tour-form #daybyday > div > ul > li .day-destination").attr('disabled', false).removeClass('disabled');
    $(".tour-form #daybyday > div > ul > li .firstday-gl").addClass('hidden');
    $(".tour-form #daybyday > div > ul > li .lastday-gl").addClass('hidden');
    $(".tour-form #daybyday > div > ul > li .lastday-gl2").addClass('hidden');
    $(".tour-form #daybyday > div > ul > li .lastday-gl3").addClass('hidden');
    $(".tour-form #daybyday > div > ul > li .lastday-gl4").addClass('hidden');
    $(".tour-form #daybyday > div > ul > li .lastday-gl5").addClass('hidden');
    $(".tour-form #daybyday > div > ul > li .dayaccommodation-title").html('Included accommodation');
    $(".tour-form #daybyday > div > ul > li .lastday-gl5").addClass('hidden');
    $(".tour-form #daybyday > div > ul > li .accom-field .special-list li").addClass('hidden');
    if (total >= 2) {
        $(".tour-form #daybyday > div > ul > li:eq(" + (total - 1) + ") .last-day-destination").removeClass('hidden');
        if ($(".tour-form #daybyday > div > ul > li:eq(" + (total - 1) + ") .last-day-destination input").is('checked')) {
            $(".tour-form #daybyday > div > ul > li:eq(" + (total - 1) + ") .day-destination").attr('disabled', true).addClass('disabled');
            $(".tour-form #daybyday > div > ul > li:eq(" + (total - 1) + ") .daydestination-photo-holder").hide();
        } else {
            $(".tour-form #daybyday > div > ul > li:eq(" + (total - 1) + ") .day-destination").attr('disabled', false).removeClass('disabled');
            $(".tour-form #daybyday > div > ul > li:eq(" + (total - 1) + ") .daydestination-photo-holder").show();
        }
    }
    $(".tour-form #daybyday > div > ul > li:eq(" + (total - 1) + ") .lastday-gl").removeClass('hidden');
    if (total > 1) {
        $(".tour-form #daybyday > div > ul > li:eq(" + (total - 1) + ") .lastday-gl2").removeClass('hidden');
        $(".tour-form #daybyday > div > ul > li:eq(" + (total - 1) + ") .accom-field").hide();
    }
    if($("input[name='gettingthere[airport_transfer]']:checked").val() != "yes" ) {
        $(".tour-form #daybyday > div > ul > li:eq(0) .firstday-gl").removeClass('hidden');
        $(".tour-form #daybyday > div > ul > li:eq(" + (total - 1) + ") .lastday-gl5").removeClass('hidden');
    } else {
        $(".tour-form #daybyday > div > ul > li:eq(0) .firstday-gl").addClass('hidden');
        $(".tour-form #daybyday > div > ul > li:eq(" + (total - 1) + ") .lastday-gl5").addClass('hidden');
    }
    

    setDaybydayGuidelines();

    var cur_no_of_days = parseInt($("select[name=no_of_days]").val());
    if (cur_no_of_days > 1) {
        $(".tour-form .gettingthere-gl1").show();
    } else {
        $(".tour-form .gettingthere-gl1").hide();
    }
}

function setDaybydayGuidelines() {
    debugFunctionCall('setDaybydayGuidelines');

    $("#daybyday .guidelines").each(function() {
        if ($(this).find('.special-list li').length) {
            var visible = $(this).find('.special-list li').length - $(this).find('.special-list li.hidden').length;
            if (visible > 0) {
                $(this).find('.special-list').show().addClass('vis');
                $(this).find('.special-h4').show();
                $(this).find('.special-list+h4 span').html('Default Guidelines');
                $(this).find('.special-list+h4 a').show();
            } else {
                $(this).find('.special-list').hide().removeClass('vis');
                $(this).find('.special-h4').hide();
                $(this).find('.special-list+h4 span').html('Guidelines');
                $(this).find('.special-list+h4 a').hide();
            }
        }
    });

    if ($("select[name=no_of_days]").val() == '' || parseInt($("select[name=no_of_days]").val()) == 0 || parseInt($("select[name=no_of_days]").val()) == 1) {
        $(".tour-form .guidelines-accom-oneday").show();
    } else {
        $(".tour-form .guidelines-accom-oneday").hide();
    }

    if ($("select[name=no_of_days]").val() != '' && parseInt($("select[name=no_of_days]").val()) > 1) {
        $(".tour-form .guidelines-accom-lastday").hide();
        var total = $(".tour-form #daybyday > div > ul > li:visible").length;

        $(".tour-form .guidelines-accom-lastday:eq(" + (total - 1) + ")").show();
        $(".tour-form .guidelines-accom-lastday:eq(" + (total - 1) + ")").parent().find(".daybyday-accom-extra-info").find(".guidelines").html("");
    } else {
        $(".tour-form .guidelines-accom-lastday").hide();
    }
}

function setCampingPartiQuestion() {
    debugFunctionCall('setCampingPartiQuestion');

    var found = 0;
    var found2 = 0;
    var is_camping;
    $(".accom-detail-participation").hide();
    $("#daybyday").find('.camping-gl1').hide().addClass('hidden');
    $(".tour-form #daybyday > div > ul > li:visible").each(function() {

        var daybydayblock = $(this);;

        is_camping = daybydayblock.find(".camping-yes").is(":checked");
        if (is_camping) {
            if(found == 0)
                daybydayblock.find(".accom-detail-participation").show();
            if (found2 == 0) {
                daybydayblock.find('.warn-camping').slideUp();
                daybydayblock.find('.warn-camping-full').slideDown();
            } else {
                daybydayblock.find('.warn-camping').slideDown();
                daybydayblock.find('.warn-camping-full').slideUp();
            }
            var radio_name = daybydayblock.find(".accom-detail-participation").find('input[type=radio]').first().attr('name');
            if ($('input[name=' + radio_name + ']:checked').val() == 'yes') {
                daybydayblock.find('.camping-gl1').slideDown().removeClass('hidden');
            } else {
                daybydayblock.find('.camping-gl1').slideUp().addClass('hidden');
            }

            daybydayblock.find(".accom-detail-participation").find('input[type=radio]').bind('change', function() {
                var radio_name = $(this).parent().find('input[type=radio]').first().attr('name');
                if ($('input[name=' + radio_name + ']:checked').val() == 'yes') {
                    daybydayblock.find('.camping-gl1').slideDown().removeClass('hidden');
                } else {
                    daybydayblock.find('.camping-gl1').slideUp().addClass('hidden');
                }

                var thisObj = daybydayblock.find(".accom-detail-participation").find(".daybyday-accom-part").last().next();
                var daynr = daybydayblock.find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
                if (daybydayblock.find('.day-selection').val() == 1) {
                    daynr = daynr.substring(0, daynr.indexOf('-'));
                }
                var error_to_solve = 'dayaccommodation04-' + daynr;
                hideError(thisObj, 'You\'ll have to select whether it is a participation tour or not', error_to_solve);
                setSolved(error_to_solve);
                setDaybydayGuidelines();
            });
            found++;
            found2++;
        }
        if (daybydayblock.find('.daybyday-accom-type:visible').val() == 'tentedcamp') {
            if (found2 == 0) {
                daybydayblock.find('.warn-tented').slideUp();
                daybydayblock.find('.warn-tented-full').slideDown();
            } else {
                daybydayblock.find('.warn-tented').slideDown();
                daybydayblock.find('.warn-tented-full').slideUp();
            }
            found2++;
        }
    });
    setDaybydayGuidelines();
}

function showFormErrors(content) {
    debugFunctionCall('showFormErrors');

    if (!$(".tour-form .overall-errors").length) {
        if ($(".tour-form .old-form-attention").length) {
            $(".tour-form .old-form-attention").after('<div class="overall-errors" id="overall-errors"><h3>We’re sorry! We need you to correct or provide the following information:</h3><h5>Click the links below or scroll down the page to navigate to the sections that need to be fixed.</h5><ul>' + content + '</ul></div>');
        } else {
            if ($(".admin-panel").length) {
                $(".admin-panel").after('<div class="overall-errors" id="overall-errors"><h3>We’re sorry! We need you to correct or provide the following information:</h3><h5>Click the links below or scroll down the page to navigate to the sections that need to be fixed.</h5><ul>' + content + '</ul></div>');
            } else {
                $(".tour-form").prepend('<div class="overall-errors" id="overall-errors"><h3>We’re sorry! We need you to correct or provide the following information:</h3><h5>Click the links below or scroll down the page to navigate to the sections that need to be fixed.</h5><ul>' + content + '</ul></div>');
            }
        }
    } else {
        $(".tour-form .overall-errors > ul").html(content);
    }

    if ($("#new_safari_id").length) {
        safari_id = $("#new_safari_id").val();
        if (safari_id > 0) {
            $(".tour-form").attr('action', backend_url('safari/edit/' + safari_id));
        }
    }

    if ($(".tour-form-jump ul li").first().find('a').attr('href') != '#overall-errors') {
        $(".jump-admin").hide();
        $(".jump-errors").show();
        $(".jump-top").hide();

        handleErrors();

        // First time overall-errors shown. If admin, then show 'Save with errors' button
        if ($(".admin-panel").length) {
            $(".admin-panel input[type=s]").removeClass('loading');
            $(".admin-btm-buttons input[type=s]").removeClass('loading');
            if (!$(".admin-panel").find('#save-with-errors-pseudo').length && safari_id != '') {
                $(".admin-panel > div:eq(0)").before('<div><input type="checkbox" name="save-with-errors-pseudo" value="1" id="save-with-errors-pseudo"><label for="save-with-errors-pseudo">Skip form validation</label></div>');
                $(".admin-btm-buttons").append('<div style="position:relative;top:-20px;clear:both;"><input type="checkbox" name="save-with-errors" value="1" id="save-with-errors"><label for="save-with-errors">Skip form validation</label></div>');

                $("#save-with-errors").bind('change', function() {
                    if ($("#save-with-errors").is(":checked") && !$("#save-with-errors-pseudo").is(":checked")) {
                        $("#save-with-errors-pseudo").attr('checked', true);
                    } else if (!$("#save-with-errors").is(":checked") && $("#save-with-errors-pseudo").is(":checked")) {
                        $("#save-with-errors-pseudo").removeAttr('checked');
                    }
                });
                $("#save-with-errors-pseudo").bind('change', function() {
                    if ($("#save-with-errors").is(":checked") && !$("#save-with-errors-pseudo").is(":checked")) {
                        $("#save-with-errors").removeAttr('checked');
                    } else if (!$("#save-with-errors").is(":checked") && $("#save-with-errors-pseudo").is(":checked")) {
                        $("#save-with-errors").attr('checked', true);
                    }
                });
            }
        }

        $(".tour-form-jump li a").unbind('click').bind('click', function() {
            var href = $(this).attr('href');
            jumpTo(href);
            return false;
        });
    }

    $(".tour-form .overall-errors a").unbind('click').bind('click', function() {
        var href = $(this).attr('href');
        if (href == '#daybyday') {
            if ($(this).parent().attr('data-day')) {
                var dayNr = $(this).parent().attr('data-day');
                $("#daybyday > div > ul > li").each(function() {
                    if ($(this).find('h3').length && $(this).find('h3').html().replace(' to ', '-').indexOf('Day ' + dayNr + ':') !== -1) {
                        jumpTo($(this));
                        return false;
                    }
                });
            }
            return false;
        } else if (href == '#datesrates' && $(this).hasClass('rates')) {
            jumpTo(".rates-title");
            return false;
        } else if (href == '#datesrates' && $(this).parent().attr('data-field') == 'departuredates') {
            jumpTo(".departuredates-title");
            return false;
        } else if (href == '#datesrates' && $(this).parent().attr('data-field') == 'solotraveler') {
            jumpTo(".solotraveler-title");
            return false;
        } else if (href == '#datesrates' && $(this).parent().attr('data-field') == 'lowerrates') {
            jumpTo(".lowerrates-title");
            return false;
        } else if (href == '#datesrates' && $(this).parent().attr('data-field') == 'localpayment') {
            jumpTo(".localpayment-title");
            return false;
        } else {
            if ($(this).parent().attr('data-field') && $("." + $(this).parent().attr('data-field') + "-title").length) {
                jumpTo("." + $(this).parent().attr('data-field') + "-title");
                return false;
            }
            jumpTo(href);
            return false;
        }
    });

    $(".tour-form #s input[type=s]").removeClass('loading');
    setTimeout(function() {
        $(".tour-form .admin-btm-buttons .sb-button").removeClass('loading');
        $(".tour-form .admin-panel .sb-button").removeClass('loading');
    }, 1000);
    jumpTo('#overall-errors');
    triggerAtError();
}

function prepareForm(className, type) {
    debugFunctionCall('prepareForm');

    var country_payment_perc = $("." + className + " #country_payment_perc").val();
    var country_payment_default = $("." + className + " #country_payment_default").val();

    // Show all active day-by-day blocks
    $("." + className + " #daybyday > div > ul > li:visible > div").show();

    // Give all visible day-by-day block fields a name before posting/saving
    var day = 1;
    $("." + className + " #daybyday > div > ul > li:visible > div").each(function() {
        $(this).find('.day-selection').attr('name', 'daybyday[' + day + '][days]');
        $(this).find('.day-title').attr('name', 'daybyday[' + day + '][title]');
        $(this).find('.day-photo').attr('name', 'daybyday[' + day + '][photo_id]');
        $(this).find('.daybyday-destination').attr('name', 'daybyday[' + day + '][destination]');
        if ($(this).find('.daybyday-destinationnone').is(":visible") && $(this).find('.daybyday-destinationnone').is(":checked")) {
            $(this).find('.daybyday-destinationnone').attr('name', 'daybyday[' + day + '][nodestination]');
        }
        $(this).find('.daybyday-accom-type').attr('name', 'daybyday[' + day + '][type]');
        $(this).find('.daybyday-accom-id').attr('name', 'daybyday[' + day + '][id]');
        $(this).find('.daybyday-accom-name').attr('name', 'daybyday[' + day + '][name]');
        $(this).find('.daybyday-accom-website').attr('name', 'daybyday[' + day + '][website]');
        $(this).find('.daybyday-accom-nowebsite').attr('name', 'daybyday[' + day + '][nowebsite]');
        $(this).find('.daybyday-accom-level').attr('name', 'daybyday[' + day + '][level]');
        $(this).find('.daybyday-accom-location').attr('name', 'daybyday[' + day + '][location]');
        $(this).find('.daybyday-accom-part').attr('name', 'daybyday[' + day + '][campassist]');
        $(this).find('textarea').attr('name', 'daybyday[' + day + '][description]');
        $(this).find('input[type=radio].camping-no, input[type=radio].camping-yes').attr('name', 'daybyday[' + day + '][camping]');
        $(this).find('input[type=checkbox]').each(function() {
            if (!$(this).hasClass('daybyday-accom-nowebsite') && !$(this).hasClass('daybyday-destinationnone')) {
                $(this).attr('name', 'daybyday[' + day + '][includes][' + $(this).attr('data-val') + ']');
            }
        });
        day++;
    });

    var date = 1;
    $("." + className + " #datesrates .fixeddates-options input[type=text]").each(function() {
        if ($(this).attr('data-val') && $(this).attr('data-val') != '') {
            $(this).attr('name', 'fixeddates[' + date + ']').val($(this).attr('data-val'));
        }
        if ($("." + className + " #datesrates .fixeddates-options").hasClass('with-availability')) {
            $(this).parent().find('select').attr('name', 'fixeddatesavailability[' + date + ']').val($(this).parent().find('select').val());
        }
        date++;
    });
    var date = 1;
    $("." + className + " #datesrates .fixedrates-options li").each(function() {
        if ($(this).find('.date-picker-from').length) {
            var from = $(this).find('.date-picker-from').first().attr('data-val');
            var to = $(this).find('.date-picker-to').first().attr('data-val');

            if (from || to) {
                $(this).find('.date-picker-from').first().attr('name', 'seasons[' + date + '][from]').val(from);
                $(this).find('.date-picker-to').first().attr('name', 'seasons[' + date + '][to]').val(to);
            }
        }
        date++;
    });
    var date = 1;
    if ($("." + className + " #fixeddates-no").is(":checked")) {
        $("." + className + " #datesrates .availability-options li").each(function() {
            if ($(this).find('.availability-date-picker-from').length) {
                var from = $(this).find('.availability-date-picker-from').first().data('val');
                var to = $(this).find('.availability-date-picker-to').first().data('val');

                if (from || to) {
                    $(this).find('.availability-date-picker-from').first().attr('name', 'availability[' + date + '][from]').val(from);
                    $(this).find('.availability-date-picker-to').first().attr('name', 'availability[' + date + '][to]').val(to);
                    $(this).find('select').first().attr('name', 'availability[' + date + '][persons]');
                    $(this).find('select').first().next().attr('name', 'availability[' + date + '][internal_note]');
                }
            }
            date++;
        });
    }
    var rate = 1;
    $("." + className + " #datesrates .rate-blocks ul.rate-block:visible").each(function() {
        var people = 1;
        $(this).find('li').each(function() {
            if (!$(this).hasClass('rate-block-title-row') && $(this).find('input').length) {
                if ($(this).hasClass('solo-row')) {
                    $(this).find('.rate-block-val').first().attr('name', 'rates[' + rate + '][solo][rate]');
                    $(this).find('.rate-block-local-val').first().attr('name', 'rates[' + rate + '][solo][local]');
                } else {
                    var people = $(this).find('.rate-block-label').html().substring(0, 1);
                    if (isNaN(people)) {
                        people = 2;
                    }
                    $(this).find('.rate-block-val').first().attr('name', 'rates[' + rate + '][' + people + '][rate]');
                    $(this).find('.rate-block-local-val').first().attr('name', 'rates[' + rate + '][' + people + '][local]');

                    $(this).find('.rate-block-children:visible .rate-block-val').first().attr('name', 'rates[' + rate + '][' + people + 'child][rate]');
                    $(this).find('.rate-block-children:visible .rate-block-local-val').first().attr('name', 'rates[' + rate + '][' + people + 'child][local]');
                }
            }
        });
        rate++;
    })
    $("." + className + " .PhotosList input[type=hidden]").each(function() {
        var input_name = String($(this).attr('name'));
        if (input_name.indexOf('photos_ids[]') !== -1) {
            $("." + className + " #gallery").append('<input type="text" style="visibility: hidden;" name="' + $(this).attr('name') + '" value="' + $(this).val() + '" />');
        }
    });
    var photo_id = $("." + className + " #photo_id").val();
    $("." + className + " *[name]").each(function() {
        // Remove all fields that are not visible (should not be saved)
        if (!$(this).is(":visible") || $(this).hasClass('inactive')) {
            if ($(this).attr('name').indexOf('availability[') < 0 && $(this).attr('name').indexOf('[photo_id]') < 0 && !$(this).hasClass("daybyday-accom-id") && !$(this).hasClass("daybyday-accom-type") && $(this).attr('name').indexOf('route_map_status') < 0) {
                $(this).remove();
            }
        }

        if ($(this).attr('id') == 'quotepercentage' && $(this).is(":disabled")) {
            $(this).removeAttr('disabled');
        }
    });
    $("." + className + " #inclusions li:visible").each(function() {
        if (!$(this).find('input[type=radio]:checked').length) {
            if ($(this).find('input[type=radio]').length > 0) {
                if (!$("." + className + " #inclusions input[type=hidden][name='notes[nan]']").length) {
                    $("." + className + " #inclusions").append("<input type='text' name='notes[nan]' value='1' />");
                }
            }
        }
    });

    if (type == 'validate') {
        $("." + className + "").hide();
    }

    $("." + className + " #s").prepend('<input type="hidden" name="' + type + '" value="1" />');
    $("." + className + " #s").prepend('<input type="hidden" name="_token" value="' + token + '" />');
    $("." + className + " #s").prepend('<input type="hidden" name="photo_id" value="' + photo_id + '" />');
    $("." + className + " #s").prepend('<input type="hidden" id="country_payment_perc" name="country_payment_perc" value="" />');
    $("." + className + " #s").prepend('<input type="hidden" id="country_payment_default" name="country_payment_default" value="" />');
    $("." + className + " #country_payment_perc").val(country_payment_perc);
    $("." + className + " #country_payment_default").val(country_payment_default);
}

function handleBlockPhoto() {
    debugFunctionCall('handleBlockThumbnailPhotos');

    $("#photo_id_preview").on('load', function() {
        setSolved('photo01');
    });
}

function handleBlockThumbnailPhotos() {
    debugFunctionCall('handleBlockThumbnailPhotos');

    $(".select_thumb").unbind('click').click(function() {
        var countries = [];
        var checked_countries = $("#countries input[type=checkbox]:checked");
        for (var i=0;i<checked_countries.length;i++) {
            countries.push(checked_countries[i].getAttribute('data-id'));
        }
        if (countries.length == 0) {
            alert("Please first select one or more countries from the 'Countries' section in this form.");
        } else {
            openShadowbox(870, 600, backend_url('safari/thumbnail-first?c=' + countries.join(','))); return false;
        }
        return false;
    });
    $(".upload_thumb").unbind('click').click(function() { openShadowbox(675, 400, backend_url('safari/thumbnail-upload')); return false; });
    $(".change_photo").unbind('click').click(function() { openShadowbox(820, 600, backend_url('safari/photo-first/photo_number/'+$(this).attr('href')+'/change')); return false; });
    $(".select_photo").unbind('click').click(function() { openShadowbox(820, 600, backend_url('safari/photo-first/photo_number/'+$(this).attr('id'))); return false; });
    $(".upload_photo").unbind('click').click(function() { openShadowbox(675, 400, backend_url('safari/photo-upload/photo_number/replaceme')); return false; });
    updatePhotosForShadowbox();
    moveUpDown();
    setMoveUpDown();
    removePhoto();
    handlePhotoDescriptions();

    $("#preview_gallery").unbind('click').click(function() {
        previewGallery();
    });
}

var handleBlockPaymentPerEnquiry_ready = false;
function handleBlockPaymentPerEnquiry(firstLoad) {
    debugFunctionCall('handleBlockPaymentPerEnquiry');

    if (!$("#paymentperenquiry").length) {
        return;
    }
    if (typeof(firstLoad) == 'undefined') {
        if (!handleBlockPaymentPerEnquiry_ready) {
            return;
        }
    } else if (firstLoad == true) {
        handleBlockPaymentPerEnquiry_ready = true;
    }

    if ($billing!=null) {
        debugFunctionCall('billing.updatePayPerc');
        $billing.updatePayPerc();
    }
}

function handleBlocks() {
    debugFunctionCall('handleBlocks');

    var fixedDates = ($(".tour-form #datesrates input[name='rates[fixeddates]']:checked").val() == 'yes') ? true : false;
    var seasonDates = ($(".tour-form #datesrates input[name='rates[fixedrates]']:checked").val() == 'yes' && fixedDates == false) ? true : false;
    var yearDates = ($(".tour-form #datesrates input[name='rates[fixedrates]']:checked").val() == 'no' && fixedDates == false) ? true : false;

    var lastday_next_year = new Date(new Date().getFullYear(), 11, 31);
    var lastday_next_year_str = lastday_next_year.getDate() + ' ' + fullMonthNames[lastday_next_year.getMonth() + 1] + ' ' + (lastday_next_year.getFullYear() + 1);

    var s_msg = '';
    if (fixedDates) {
        var highest = '';
        $(".tour-form .fixeddates-options input[type=text]").each(function() {
            if (typeof $(this).attr("data-val") != 'undefined' && $(this).attr("data-val") != '') {
                if (highest == '' || $(this).attr("data-val") > highest) {
                    highest = $(this).attr("data-val");
                }
            }
        });
        if (highest != '') {
            s_msg = 'We\'ll consider this <b>tour to be unavailable after ' + getDatestrPart(highest, 'day') + ' ' + fullMonthNames[getDatestrPart(highest, 'month')] + ' ' + getDatestrPart(highest, 'year') + '</b> because it is the last start date provided. New start dates can be added up to ' + lastday_next_year_str + '. We recommend adding a recurring calendar reminder in the first half of each year to update your start dates for the next year.';
        }
    } else if (seasonDates) {
        var highest = '';
        $(".tour-form .fixedrates-options li").each(function() {
            if (typeof $(this).find('.date-picker-from').attr('data-val') != 'undefined' && typeof $(this).find('.date-picker-to').attr('data-val') != 'undefined' && $(this).find('.date-picker-from').attr('data-val') != '' && $(this).find('.date-picker-to').attr('data-val') != '') {
                if (highest == '' || $(this).find('.date-picker-to').attr("data-val") > highest) {
                    highest = $(this).find('.date-picker-to').attr("data-val");
                }
            }
        });
        if (highest != '') {
            s_msg = 'We\'ll consider this <b>tour to be unavailable after ' + getDatestrPart(highest, 'day') + ' ' + fullMonthNames[getDatestrPart(highest, 'month')] + ' ' + getDatestrPart(highest, 'year') + '</b> because it is the last day of the last date range for which you provided rates. New date ranges can be added up to ' + lastday_next_year_str + '. We recommend adding a recurring calendar reminder in the first half of each year to update your dates for the next year.';
        }
    } else if (yearDates) {
        var highest = '';
        if ($(".tour-form .fixedyears-options input:checked").length) {
            highest = $(".tour-form .fixedyears-options input:checked").last().attr('data-val');
        }
        if (highest != '') {
            var date = new Date(highest, 11, 31);
            s_msg = 'We\'ll consider this <b>tour to be unavailable after ' + date.getDate() + ' ' + fullMonthNames[date.getMonth() + 1] + ' ' + date.getFullYear() + '</b> because it is the last day of the last year for which you provided rates. New rates can be added up to ' + lastday_next_year_str + '. We recommend adding a recurring calendar reminder in the first half of each year to update your rates for the next year.';
        }
    }

    if (s_msg == '' && $(".s-notes li").length == 2) {
        $(".s-notes li:eq(0)").remove();
    } else if (s_msg != '') {
        if ($(".s-notes li").length == 2) {
            $(".s-notes li:eq(0)").html(s_msg);
        } else {
            $(".s-notes").prepend("<li>" + s_msg + "</li>");
        }
    }
}

function addLoadLayer() {
    return;
    if (loaded_parts < 3) {
        // Not everything is loaded (form + both auto complete ajax files
        $("body").append('<div class="load-layer"><div><img src="/images/loader.gif" /> Loading, please wait...</div></div>');
        $(".load-layer div").css('margin-top', ($(window).height() / 2) - ($(".load-layer div").height() / 2));
        $(".load-layer").fadeIn('fast');
    }
}

function removeLoadLayer() {
    debugFunctionCall('removeLoadLayer');

    if (loaded_parts >= 3) {
        // Form + both auto complete ajax files are load
        if($(".load-layer").is(":visible")) {

            var end_time = new Date().getTime();
            var time = end_time - start_time;

            if (typeof ga === 'function') {
                var ga_label = undefined;
                if (safari_id != '') {
                    ga_label = safari_id;
                }

                ga('send', 'event', 'Tour form', 'load time (ms)', ga_label, Math.round(time), {
                    nonInteraction: true
                });
            }

            $(".load-layer").stop().fadeOut("normal", function () {
                handleBlockPaymentPerEnquiry(true);
                websiteWarningLogic();

                showRouteMap();

                $(".rate-block-local-val[value='']:visible").val('0');

            });
        }
    }
}

function handles() {
    debugFunctionCall('handles');

    addSaveLayer();
    $(".save-form").remove();

    var $orginal = $('.tour-form');
    var $cloned = $orginal.clone();

    var $originalSelects = $orginal.find('select');
    $cloned.find('select').each(function(index, item) {
        $(item).val( $originalSelects.eq(index).val() );
    });
    var $originalTextareas = $orginal.find('textarea');
    $cloned.find('textarea').each(function(index, item) {
        $(item).val($originalTextareas.eq(index).val());
    });
    $cloned.insertAfter(".tour-form");
    $(".tour-form+.tour-form").addClass('save-form');

    prepareForm("save-form", "validate");

    if ($('.bottom-s-btn').length && $(".admin-panel").length && $("#save-with-errors").length && $("#save-with-errors").is(":checked")) {
        return true;
    }

    var formValid = false;

    var http = new XMLHttpRequest();
    if ($('.tour-form').attr('action') && $('.tour-form').attr('action') != '') {
        var url = $('.tour-form').attr('action');
    } else {
        var url = backend_url(window.location.pathname);
    }
    if (url.indexOf('validate') === -1) {
        if (url.indexOf("?") === -1)
            url += '/validate';
        else
            url = url.replace("?",'/validate?');
    }

    try {
        var params = $( ".save-form" ).serialize();
        http.open("POST", url, false);

        http.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
        //http.setRequestHeader("Content-length", params.length);
        http.setRequestHeader('X-Requested-With','XMLHttpRequest');
        //http.setRequestHeader("Connection", "close");

        http.onreadystatechange = function() {
            if (http.status == 403) {
                $(".save-form").remove();
                $(".tour-form").find("input[name=status]").remove();
                $(".tour-form").find("input[name=approved]").remove();
                removeSaveLayer();
                $(".bottom-s-btn").removeClass('loading');
                window.onbeforeunload = null;
                openShadowbox(650, 480, backend_url('login?popup=1'));
                return false;
            } else {
                if (http.readyState == 4 && http.status == 200) {
                    var data = http.responseText;
                    if (data == 'ok') {
                        formValid = true;
                    } else {
                        if (data.indexOf('login-wrapper') !== -1) {
                            $(".save-form").remove();
                            $(".tour-form").find("input[name=status]").remove();
                            $(".tour-form").find("input[name=approved]").remove();
                            removeSaveLayer();
                            $(".bottom-s-btn").removeClass('loading');
                            window.onbeforeunload = null;
                            openShadowbox(650, 480, backend_url('login?popup=1'));
                            return false;
                        } else {
                            $(".save-form").remove();
                            $(".tour-form").find("input[name=status]").remove();
                            $(".tour-form").find("input[name=approved]").remove();
                            removeSaveLayer();
                            showFormErrors(data);
                        }
                    }
                } else {
                    formValid = true;
                    // Error
                    if (typeof(ga) == "function") {
                        ga('send',
                            'event',
                            'Ajax error (non jQuery)',
                            url,
                            this.statusText + ' | ' + http.readyState + ' | ' + http.status,
                            {'nonInteraction': 1}
                        );
                    }
                }
            }
        }
        http.send(params);
    } catch(e) {
        formValid = true;
        if (typeof(ga) == "function") {
            ga( 'send',
            	'event',
                'Catched ajax error (non jQuery)',
                url,
                e.message + ' | ' + (e.number & 0xFFFF) + ' | ' + e.name,
                { 'nonInteraction': 1 }
            );
        }

    }

    return formValid;
}

var handleErrorsRunning = false;
function handleErrors() {

    if (handleErrorsRunning) {
        return;
    }
    debugFunctionCall('handleErrors');

    handleErrorsRunning = true;
    $(".overall-errors > ul > li").each(function() {
        var this_li = $(this);
        if ($(this).find('li').length) {
            var solved = 0;
            $(this).find('li').each(function() {
                if ($(this).hasClass('solved')) {
                    solved++;
                }
            });
            if (solved == $(this_li).find('li').length) {
                $(this_li).addClass('solved');
            }
        }
    });
    $(".overall-errors .solved").each(function() {
        if ($(this).find('.solved-icon').length == 0) {
            if ($(this).find("> ul").length) {
                $(this).find("> ul").before('<span class="solved-icon">Solved</span>');
            } else {
                $(this).append('<span class="solved-icon">Solved</span>');
            }
        }
    });
    $("body").removeClass('has-errors');
    $("fieldset").removeClass('error');
    $("h3").removeClass('error');
    $("li").removeClass('error');
    $("h5").removeClass('error');
    $("input").removeClass('error');
    $("textarea").removeClass('error');
    $(".overall-errors a").each(function() {
        var field = '';
        if ($(this).parent().is("li") && $(this).parent().attr('data-field')) {
            field = $(this).parent().attr('data-field');
        }
        if (field == '' && $(this).parent().parent().is("li") && $(this).parent().attr('data-field')) {
            field = $(this).parent().attr('data-field');
        }
        if (field == '') {
            $(this).parent().find('li').each(function() {
                if ($(this).attr('data-field') && !$(this).hasClass('solved')) {
                    field += $(this).attr('data-field') + ',';
                }
            });
        }
        var daybyday = false;
        if ($(this).attr('href') == '#daybyday') {
            daybyday = true;
        }
        if (!$(this).parent().hasClass('solved')) {
            $("body").addClass('has-errors');
            var id = $(this).attr('href');
            $(id).addClass('error');

            if ($(this).attr('href') == '#daybyday') {
                var day = '';
                if ($(this).parent().is("li") && $(this).parent().attr('data-val')) {
                    day = $(this).parent().attr('data-val');
                }
                if ($(this).parent().parent().is("li") && $(this).parent().parent().attr('data-val')) {
                    day = $(this).parent().parent().attr('data-val');
                }
                if (day != '') {
                    $("#daybyday > div ul li").each(function() {
                        if ($(this).find('h3').length && ($(this).find('h3').html().indexOf('Day ' + day + ':') !== -1 || $(this).find('h3').html().indexOf('Day ' + day.replace('-', ' to ') + ':') !== -1)) {
                            $(this).addClass('active');
                            $(this).addClass('error');
                            $(this).find('h3+a+div').show();
                            var day_block = $(this);

                            if (field != '') {
                                field = $.trim(field);
                                if (field != '') {
                                    var fields = field.split(',');
                                    $.each(fields, function(k, single_field) {
                                        if (single_field != '') {

                                            var single_field_error = single_field;
                                            $(day_block).find("." + single_field).addClass('error');
                                            $(day_block).find("." + single_field + "-title").addClass('error');
                                            if ($(day_block).find("." + single_field).length) {
                                                $(day_block).find("." + single_field).trigger('keyup');
                                                $(day_block).find("." + single_field).trigger('blur');
                                            }
                                            var thisObj = $(day_block).find("." + single_field);

                                            if($(day_block).find(".daybyday-accom-id").val() == "" || $(day_block).find(".daybyday-accom-id").val() == 0) {
                                                if (single_field == 'dayaccommodation' || single_field == 'dayaccommodation05') {
                                                    single_field_error = 'dayaccommodation';
                                                    var is_camping = $(this).find(".camping-yes").is(":checked");
                                                    if ((!is_camping && ($(day_block).find("." + single_field_error).val() == '0') || (!is_camping && $.isNumeric($(day_block).find("input.daybyday-accom-id").val()) && $(day_block).find("input.daybyday-accom-id").val() > 0))) {
                                                        var error_to_solve = 'dayaccommodation05-' + day;
                                                        var thisObj = $(day_block).find(".dayaccommodation");
                                                        showError(thisObj, 'You\'ll have to list an accommodation', error_to_solve);
                                                        single_field_error = 'dayaccommodation';
                                                    }
                                                }
                                                if (single_field == 'dayaccommodation01') {
                                                    $(day_block).find(".daybyday-accom-name").addClass('error');
                                                    var error_to_solve = 'dayaccommodation01-' + day;
                                                    var thisObj = $(day_block).find(".daybyday-accom-name");
                                                    showError(thisObj.next(), 'You\'ll have to enter an accommodation name', error_to_solve);
                                                    single_field_error = 'dayaccommodation';

                                                } else if (single_field == 'dayaccommodation02') {
                                                    $(day_block).find(".daybyday-accom-name").addClass('error');
                                                    var error_to_solve = 'dayaccommodation02-' + day;
                                                    var thisObj = $(day_block).find(".daybyday-accom-name");
                                                    showError(thisObj.next(), 'Please list only one accommodation (the words \'or\' \'and\' are not allowed)', error_to_solve);
                                                    single_field_error = 'dayaccommodation';

                                                } else if (single_field == 'dayaccommodation03') {
                                                    $(day_block).find(".daybyday-accom-level").addClass('error');
                                                    var error_to_solve = 'dayaccommodation08-' + day;
                                                    var thisObj = $(day_block).find(".daybyday-accom-level");
                                                    showError(thisObj, 'You\'ll have to select a comfort level', error_to_solve);
                                                    single_field_error = 'dayaccommodation';

                                                } else if (single_field == 'dayaccommodation04') {
                                                    $(day_block).find(".daybyday-accom-name").addClass('error');
                                                    var error_to_solve = 'dayaccommodation04-' + day;
                                                    var thisObj = $(day_block).find(".daybyday-accom-part").last().next();
                                                    showError(thisObj, 'You\'ll have to select whether it is a participation tour or not', error_to_solve);
                                                    single_field_error = 'dayaccommodation';

                                                } else if (single_field == 'dayaccommodation06') {
                                                    $(day_block).find(".daybyday-accom-website").addClass('error');
                                                    var error_to_solve = 'dayaccommodation06-' + day;
                                                    var thisObj = $(day_block).find(".daybyday-accom-website");
                                                    if (thisObj.val() == '') {
                                                        showError(thisObj.next(), 'You\'ll have to enter the website address of the accommodation', error_to_solve);
                                                    } else {
                                                        showError(thisObj.next(), 'The website address is invalid', error_to_solve);
                                                    }
                                                    single_field_error = 'dayaccommodation';

                                                } else if (single_field == 'dayaccommodation07') {
                                                    $(day_block).find(".daybyday-accom-website").addClass('error');
                                                    var error_to_solve = 'dayaccommodation07-' + day;
                                                    var thisObj = $(day_block).find(".daybyday-accom-website");
                                                    showError(thisObj.next(), 'Don\'t link to the homepage of a hotel group website. Instead, link to the overview page for this specific property', error_to_solve);
                                                    single_field_error = 'dayaccommodation';

                                                } else if (single_field == 'dayaccommodation08') {
                                                    $(day_block).find(".daybyday-accom-location").addClass('error');
                                                    var error_to_solve = 'dayaccommodation08-' + day;
                                                    var thisObj = $(day_block).find(".daybyday-accom-location");
                                                    showError(thisObj, 'You\'ll have to select the location relative to the park', error_to_solve);
                                                    single_field_error = 'dayaccommodation';

                                                } else if (single_field == 'dayaccommodation09') {
                                                    $(day_block).find(".daybyday-accom-location").addClass('error');
                                                    var error_to_solve = 'dayaccommodation09-' + day;
                                                    var thisObj = $(day_block).find(".daybyday-accom-location");
                                                    showError(thisObj, 'You\'ll have to select the location relative to the park', error_to_solve);
                                                    single_field_error = 'dayaccommodation';
                                                }
                                                $(day_block).find("." + single_field).addClass('error');
                                                $(day_block).find("." + single_field_error + "-title").addClass('error');

                                            }
                                        }
                                    });
                                }
                            }
                        }
                    });
                }
            } else if ($(this).attr('href') == '#datesrates') {
                if ($(this).parent().attr('data-field')) {
                    $("#datesrates").find("." + $(this).parent().attr('data-field') + "-title").addClass('error');
                    if ($(this).parent().attr('data-field') == 'departuredates') {
                        showError($('.fixeddates-options'), $(this).parent().html().split(': ').pop());
                    } else if ($(this).parent().attr('data-field') == 'seasons') {
                        showError($('.fixedrates-options'), $(this).parent().html().split(': ').pop());
                    } else if ($(this).parent().attr('data-field') == 'availability') {
                        showError($('.availability-option'), $(this).parent().html().split(': ').pop());
                    } else if ($(this).parent().attr('data-field') == 'shortnotice') {
                        showError($('.shortnotice-options'), $(this).parent().html().split(': ').pop());
                    } else if ($(this).parent().attr('data-field') == 'maxgroupsize') {
                        showError($('.maxgroupsize-options'), $(this).parent().html().split(': ').pop());
                    } else if ($(this).parent().attr('data-field') == 'solotraveler') {
                        showError($('label[for=solo-yes]'), $(this).parent().html().split(': ').pop());
                    } else if ($(this).parent().attr('data-field') == 'children') {
                        showError($('label[for=children-yes]'), $(this).parent().html().split(': ').pop());
                    } else if ($(this).parent().attr('data-field') == 'lowerrates') {
                        showError($('.lowerrates-options'), $(this).parent().html().split(': ').pop());
                    } else if ($(this).parent().attr('data-field') == 'localpayment') {
                        showError($('label[for=localpay-yes]'), $(this).parent().html().split(': ').pop());
                    }
                } else {
                    $("#datesrates").find(".rates-title").addClass('error');
                }
                var mask = '/^[0-9]+$/';
                $('.rate-blocks input[type=text]').each(function() {
                    if ($(this).is(":visible")) {
                        if ($(this).val() == '') {
                            $(this).addClass('error');
                            $(this).unbind('keyup').bind('keyup', function() {
                                $(this).removeClass('error');
                                if ($(".error-rates01").length) {
                                    if ($(this).parent().parent().find('input[type=text][value=""]:visible').length == 0) {
                                        hideError($(this).parent().parent(), $(".error-rates01").html().split(': ').pop());
                                    }
                                    if ($(this).parent().parent().parent().find('input[type=text][value=""]:visible').length == 0) {
                                        setSolved('rates01');
                                    }
                                }
                            });
                        }
                    }
                });
                if ($(".error-rates01").length) {
                    $(".rate-block").each(function() {
                        if ($(this).find('input[type=text][value=""]:visible').length) {
                            showError($(this), $(".error-rates01").html().split(': ').pop());
                        }
                    });
                }
            } else if ($(this).attr('href') == '#title') {
                if ($(".error-title01").length && !$(".error-title01").hasClass('solved')) {
                    showError($("input[name=title]+.limit-msg"), $(".error-title01").html());
                    $("#title select").addClass('error');
                }
                if (!$("#title input[name=title]").is(":focus")) {
                    $("#title input[name=title]").trigger('blur');
                }
                if ($(this).parent().find('li[class^=error-title01]').length >= 1) {
                    if ($(this).parent().find('li[class^=error-title01]').find('.solved').length == $(this).parent().find('li[class^=error-title01]').length) {
                        $("#title input[type=text]").removeClass('error');
                    } else {
                        $("#title input[type=text]").addClass('error');
                    }
                } else {
                    $("#title input[type=text]").removeClass('error');
                }
            } else {
                if (!$(id).find('h2').next().is("ul")) {
                    $(id).find('h2').after('<ul></ul>');
                } else {
                    $(id).find('h2').next().html('');
                }

                $(this).parent().clone().appendTo($(id).find('h2+ul'));
                $(id).find('h2+ul li:first-child').find('a').remove();
                $(id).find('h2+ul li:first-child').html($(id).find('h2+ul li:first-child').html().replace('fix the ', 'fix this section').replace('section section', 'section'));

                // Array of section error that don't have to be displayed
                var hidden_section_errors = ["error-title02", "error-title03", "error-title04", "error-title05", "error-description01",
                        "error-description02", "error-description03", "error-description04", "error-description05", "error-description06", "error-description07", "error-description08",
                        "error-activities01", "error-activities02", "error-activities03", "error-activities04", "error-activities05", "error-activities06", "error-activities07", "error-activities08", "error-activities09", "error-activities10", "error-activities11"];
                $(id).find('h2+ul li').each(function() {
                    var hide = false;
                    var current_line = $(this);
                    $.each(hidden_section_errors, function(key, section_errors) {
                        if ($(current_line).hasClass(section_errors)) {
                            hide = true;
                        }
                    });
                    if (hide) {
                        $(current_line).hide();
                    }
                });

                $(id).find('h2+ul').show();
                if ($(id).find('h2+ul li:visible').length == 0) {
                    $(id).find('h2+ul').hide();
                }

                if (field != '') {
                    field = $.trim(field);
                    if (field != '') {
                        var fields = field.split(',');
                        $.each(fields, function(k, single_field) {
                            if (single_field != '') {
                                $("." + single_field).addClass('error');
                                $("." + single_field + "-title").addClass('error');
                                if ($("." + single_field).length && !$("." + single_field).hasClass('ui-autocomplete-input')) {
                                    if (!$("." + single_field).is(":focus")) {
                                        $("." + single_field).trigger('blur');
                                    }
                                }
                            }
                        });
                    }
                }
            }
        } else {
            var id = $(this).attr('href');
            $(id).removeClass('error');
            if ($(id).find('h2').next().is("ul")) {
                $(id).find('h2').next().slideUp();
            }
            if ($(this).attr('href') == '#daybyday' && field != '') {
                var day = '';
                if ($(this).parent().is("li") && $(this).parent().attr('data-val')) {
                    day = $(this).parent().attr('data-val');
                }
                if ($(this).parent().parent().is("li") && $(this).parent().parent().attr('data-val')) {
                    day = $(this).parent().parent().attr('data-val');
                }
                if (day != '') {
                    $("#daybyday > div ul li").each(function() {
                        if ($(this).find('h3').length && ($(this).find('h3').html().indexOf('Day ' + day + ':') !== -1 || $(this).find('h3').html().indexOf('Day ' + day.replace('-', ' to ') + ':') !== -1)) {
                            var day_block = $(this);

                            if (field != '') {
                                field = $.trim(field);
                                if (field != '') {
                                    var fields = field.split(',');
                                    $.each(fields, function(k, single_field) {
                                        if (single_field != '') {
                                            $(day_block).find("." + single_field).removeClass('error');
                                            $(day_block).find("." + single_field + "-title").removeClass('error');
                                        }
                                    });
                                }
                            }
                        }
                    });
                }
            } else {
                if (field != '') {
                    field = $.trim(field);
                    if (field != '') {
                        var fields = field.split(',');
                        $.each(fields, function(k, single_field) {
                            if (single_field != '') {
                                $("." + single_field).removeClass('error');
                                $("." + single_field + "-title").removeClass('error');
                            }
                        });
                    }
                }
            }
        }

        if (field != '' && !daybyday) {
            field = $.trim(field);
            if (field != '') {
                var fields = field.split(',');
                $.each(fields, function(k, single_field) {
                    if (single_field != '') {
                        if ($(".error-" + single_field).length && $(".error-" + single_field).hasClass('solved')) {
                            $("." + single_field).removeClass('error');
                            $("." + single_field + "-title").removeClass('error');
                        }
                    }
                });
            }
        }
    });

    handleErrorsRunning = false;
}

function handlePreview(new_status) {
    debugFunctionCall('handlePreview');

    $(".preview-form").remove();

    var $orginal = $('.tour-form');
    var $cloned = $orginal.clone();

    var $originalSelects = $orginal.find('select');
    $cloned.find('select').each(function(index, item) {
         $(item).val( $originalSelects.eq(index).val() );
    });
    var $originalTextareas = $orginal.find('textarea');
    $cloned.find('textarea').each(function(index, item) {
        $(item).val($originalTextareas.eq(index).val());
    });

    $cloned.insertAfter(".tour-form");
    $(".tour-form+.tour-form").addClass('preview-form');

    if (last_routemap_path != '') {
        $( ".preview-form" ).append('<input type="text" style="visibility: hidden;" name="preview_routemap" value="' + last_routemap_path + '" />');
    }

    prepareForm("preview-form", "preview");

    if (safari_id != '') {
        $( ".preview-form" ).append('<input type="text" style="visibility: hidden;" name="preview_safari_id" value="' + safari_id + '" />');
    }
    if (typeof(operator_id) != 'undefined') {
        $( ".preview-form" ).append('<input type="text" style="visibility: hidden;" name="operator_id" value="' + operator_id + '" />');
    }

    $( ".preview-form" ).attr('action', $('.tour-form').attr('data-val'));
    $( ".preview-form" ).attr('target', '_blank');
    $( ".preview-form .bottom-s-btn" ).trigger('click');

    $( ".preview-form" ).remove();

    setTimeout(function() {
        $(".preview").removeClass('loading').removeClass('busy');
    }, 5000);
}

function replaceWords(str, reps) {
    for (var find in reps){
        str = str.replace(new RegExp('\\b' + find + '\\b','g'), reps[find]);
    }
    return str;
}

function UCWords(str) {
    str = str.toLowerCase();
    str = str.replace(/(^([a-zA-Z\p{M}]))|([^a-zA-Z\u00C0-\u017F\'\’][a-zA-Z\p{M}])/g,
        function($1){
            return $1.toUpperCase();
        }
    );
    var reps = {
        'Np': 'NP',
        'Gr': 'GR',
        'Nr': 'NR',
        'Ca': 'CA',
        'Wr': 'WR',
        'Fr': 'FR',
        'Tp': 'TP',
        'Pp': 'PP',
        'Ep': 'EP',
        'Wc': 'WC',
        'Ws': 'WS',
        'Sr': 'SR',
        'Dr': 'DR',
        'Drc': 'DRC',
        'A' : 'a',
        'An': 'an',
        'As': 'as',
        'But': 'but',
        'And': 'and',
        'Of': 'of',
        'For': 'for',
        'Nor': 'nor',
        'The': 'the',
        'Per': 'per',
        'Vs': 'vs',
        'To': 'to',
        'At': 'at',
        'By': 'by',
        'Is': 'is',
        'On': 'on',
        'Or': 'or',
        'In': 'in',
        'So': 'so',
        'Atop': 'atop',
        'Down': 'down',
        'From': 'from',
        'Into': 'into',
        'Like': 'like',
        //'Mid': 'mid',
        'Near': 'near',
        'Next': 'next',
        'Off': 'off',
        'Onto': 'onto',
        'Out': 'out',
        'Over': 'over',
        'Pace': 'pace',
        'Past': 'past',
        'Plus': 'plus',
        'Pro': 'pro',
        'Than': 'than',
        'Till': 'till',
        'Unto': 'unto',
        'Up': 'up',
        'Upon': 'upon',
        'Via': 'via',
        'Vice': 'vice',
        'With': 'with',
        '4X4': '4x4',
        'Safaris': 'Safari',
        'Tours': 'Tour',
        'Trips': 'Trip'
    };
    str = replaceWords(str, reps);

    str = str.replace(/[a-zA-Z_0-9\u00C0-\u017F]+[.!?]?(\s?)$/, function($1) {
        return $1.charAt(0).toUpperCase() + $1.slice(1);
    });

    return UCFirst(str);
}

function UCFirst(string) {
    return string.charAt(0).toUpperCase() + string.slice(1);
}

function initAutocomplete() {
    debugFunctionCall('initAutocomplete');

    $.ajax({url: backend_url("autocomplete/cities")}).done(function(data) {
        loaded_parts++;
        removeLoadLayer();
		if($("#start-city").length > 0){
			$("#start-city").autocomplete({
	    		source: function(request, response) {
	    	        var matcher = new RegExp("\\b" + $.ui.autocomplete.escapeRegex(request.term), "i");
	    	        response($.grep(data, function(value) {
	    	            return matcher.test(value.name)
	    	                || matcher.test(value.aliases);
	    	        }).slice(0,6));
	    	    },
	    		minLength: 1,
	    		autoFocus: true,
	    		delay: 0,
	    		select: function( event, ui ) {
	    		    $("#start-city").val(ui.item.value);
	    		    showRouteMap();
                }
	    	}).data("ui-autocomplete")._renderItem = function( ul, item ) {
				return $( "<li></li>" )
					.data( "item.autocomplete", item )
		        	.append( "<a>"+ item.label + "</a>" )
		        	.appendTo( ul );
	        };
		}
		if($("#end-city").length > 0){
			$("#end-city").autocomplete({
	    		source: function(request, response) {
	    	        var matcher = new RegExp("\\b" + $.ui.autocomplete.escapeRegex(request.term), "i");
	    	        response($.grep(data, function(value) {
	    	            return matcher.test(value.name)
	    	                || matcher.test(value.aliases);
	    	        }).slice(0,6));
	    	    },
	    		minLength: 1,
	    		autoFocus: true,
	    		delay: 0,
	    		select: function( event, ui ) {
                    $("#end").val(ui.item.value);
                    showRouteMap();
                }
	    	}).data("ui-autocomplete")._renderItem = function( ul, item ) {
				return $( "<li></li>" )
					.data( "item.autocomplete", item )
		        	.append( "<a>"+ item.label + "</a>" )
		        	.appendTo( ul );
	        };
		}

		$("#start-city, #end-city").on('blur', function() {
		    showRouteMap();
        });
    });
}

var acco_data = false;
var acco_data_loading = false;
//accom-detail-loc
function initAutocompleteAcco() {
    debugFunctionCall('initAutocompleteAcco');

    if (acco_data_loading == true) {
        return;
    }
    if (acco_data == false) {
        acco_data_loading = true;
        $.ajax({url: backend_url("autocomplete/accommodations")} ).done(function(data) {
            loaded_parts++;
            removeLoadLayer();
            acco_data = data;
            acco_data_loading = false;
            initAutocompleteAccoFinish();
        });
    } else {
        initAutocompleteAccoFinish();
    }
}

var acco_details_loading = false;
function initAutocompleteAccoFinish() {
    debugFunctionCall('initAutocompleteAccoFinish');

    $(".daybyday-accom-name").each(function() {
        var parent_el = $(this).parents(".accom-detail-sub");
        var is_camping = $(this).find(".camping-yes").is(":checked");
        if (!$(this).hasClass('ui-autocomplete-input')) {
            $(this).autocomplete({
                source: function(request, response) {
                    // old way
                    // var matcher = new RegExp("\\b" + $.ui.autocomplete.escapeRegex(request.term.replace("&","")), "i");
                    // response($.grep(acco_data, function (value) {
                    //     return matcher.test(value.name)
                    //         || matcher.test(value.aliases);
                    // }).slice(0, 20));
                    
                    // new way
                    var matcher1 = new RegExp("" + $.ui.autocomplete.escapeRegex(request.term.replace("&","")) + "", "i");
                    var matcher2 = new RegExp("\\b" + $.ui.autocomplete.escapeRegex(request.term.replace("&","")), "i");

                    var values = $.grep(acco_data, function (value) { // strict on name
                        return matcher1.test(value.name);
                    }).slice(0, 20);

                    if(values.length < 20) {
                        var added = [];
                        $.each(values, function(k, v) {
                            added.push(v.id);
                        });

                        var to_add = 20 - added.length;

                        var values1 = $.grep(acco_data, function (value) { // loose on name
                            return matcher2.test(value.name);
                        }).slice(0, added.length + to_add);

                        $.each(values1, function(k, v) {
                            if($.inArray(v.id, added) == -1) {
                                if(to_add == 0) {
                                    return false;
                                } else {
                                    values.push(v);
                                    added.push(v.id);
                                    to_add--;
                                }
                            }
                        });

                        if(values.length < 20) {
                            var values2 = $.grep(acco_data, function (value) { // loose on aliases
                                return matcher2.test(value.aliases);
                            }).slice(0, added.length + to_add);

                            $.each(values2, function (k, v) {
                                if ($.inArray(v.id, added) == -1) {
                                    if (to_add == 0) {
                                        return false;
                                    } else {
                                        values.push(v);
                                        added.push(v.id);
                                        to_add--;
                                    }
                                }
                            });

                            if(values.length < 20) {
                                var values3 = $.grep(acco_data, function (value) { // loose on label (park)
                                    return matcher2.test(value.park);
                                }).slice(0, added.length + to_add);

                                $.each(values3, function (k, v) {
                                    if ($.inArray(v.id, added) == -1) {
                                        if (to_add == 0) {
                                            return false;
                                        } else {
                                            values.push(v);
                                            added.push(v.id);
                                            to_add--;
                                        }
                                    }
                                });
                            }
                        }
                    }
                    response(values);
                },
                minLength: 1,
                autoFocus: true,
                delay: 0,
                select: function( event, ui ) {
                    loadAccoDetails(parent_el, ui.item.id);
                }
            }).data("ui-autocomplete")._renderItem = function( ul, item ) {
                return $( "<li></li>" )
                    .data( "item.autocomplete", item )
                    .append( "<a>"+ item.label + "</a>" )
                    .appendTo( ul );
            };

            $(this).bind('blur keyup', function(event) {
                var current_val = $(this).val();
                var info_visible = parent_el.find(".daybyday-accom-extra-info").is(":visible");
                if($.trim($(this).val()) == "" ||
                    (info_visible && !acco_details_loading && ($.trim(current_val) != parent_el.find(".daybyday-accom-extra-info").find("b").text() && $.trim(current_val) != parent_el.find(".daybyday-accom-extra-info").find("span.inactive-acco-name").text()))) {
                    loadAccoForm(parent_el);
                    return false;
                }
                if($.trim($(this).val()) == parent_el.find(".daybyday-accom-extra-info").find("b").text())
                    return false;

                var matcher = new RegExp("\\b" + $.ui.autocomplete.escapeRegex(current_val.replace("&","")), "i");
                var matches = $.grep(acco_data, function(value) {
                    return matcher.test(value.name)
                        || matcher.test(value.aliases);
                });
                var has_match = false;
                if (matches.length) {
                    $.each(matches, function (key, val) {
                        if($.trim(current_val) != "") {
                            if (val.value.toLowerCase() == current_val.toLowerCase() ||
                                (event.type == "blur" && val.aliases && val.aliases.toLowerCase().indexOf(',' + current_val.toLowerCase() + ',') > -1)) {
                                has_match = true;
                                loadAccoDetails(parent_el, val.id);
                            }
                        }
                    });
                }
                if((info_visible && !has_match) || is_camping) {
                    loadAccoForm(parent_el);
                }
                return false;
            });

            if(parent_el.find(".daybyday-accom-id").val() == "") {
                var current_val = $(this).val();
                if(current_val != "") {
                    var matcher = new RegExp("\\b" + $.ui.autocomplete.escapeRegex(current_val.replace("&","")), "i");
                    var matches = $.grep(acco_data, function (value) {
                        return matcher.test(value.name)
                            || matcher.test(value.aliases);
                    });
                    var has_match = false;
                    if (matches.length) {
                        $.each(matches, function (key, val) {
                            if (val.value.toLowerCase() == current_val.toLowerCase() ||
                                (val.aliases && val.aliases.toLowerCase().indexOf(',' + current_val.toLowerCase() + ',') > -1)) {
                                has_match = true;
                                loadAccoDetails(parent_el, val.id);
                            }
                        });
                    }
                }
                if (!has_match) {
                    loadAccoForm(parent_el);
                }
            }
        }
    });
}

function loadAccoDetails(el, id) {

    if(!$.isNumeric(id) || id == 0) {
        loadAccoForm(el);
        return false;
    }

    acco_details_loading = true;

    var animate = false;
    if(!el.find(".daybyday-accom-extra-info").is(":visible")) {
        el.find(".daybyday-accom-extra").fadeTo(0, 0);
        el.find(".daybyday-accom-extra-info").show();
        el.find(".daybyday-accom-extra-form").hide();
        animate = true;
    }

    // load acco details
    $.ajax({
        url: backend_url('safari/getaccommodationinfo'),
        type: 'POST',
        data: { 'id': id },
        error: function(){
            el.find(".daybyday-accom-extra-info").hide();
            el.find(".daybyday-accom-extra-form").show();
            el.find(".daybyday-accom-extra").fadeIn();
        },
        success: function(data){
            if (typeof data.location == 'undefined') {
                loadAccoForm(el);
            } else {
                var location = "";
                if(data["location"]) {
                    location += data["location"];
                    location += " (";
                } else {
                    location = "In or near ";
                }
                location += data["park"];
                if(data["location"]) {
                    location += ")";
                }
                if (data["accommodation_location_id"] == 5)
                    location = "In or near " + data["park"];
                el.find(".daybyday-accom-name").val(data["name"]);
                el.find(".daybyday-accom-type").val(data["type_val"]);
                if(data["status"] == "inactive") {
                    el.find(".daybyday-accom-extra-info .guidelines").addClass("inactive");
                    data["accommodation_id"] = 0;
                    data["accommodation_type_val"] = "";
                } else {
                    el.find(".daybyday-accom-extra-info .guidelines").removeClass("inactive");
                }
                el.find(".daybyday-accom-extra-info .guidelines").html(
                    "<input type='hidden' id='" + el.find(".daybyday-accom-name").attr('id').replace('accom-name', 'accom-id') + "' class='daybyday-accom-id' value='" + data["accommodation_id"] + "' />" +
                    "<input type='hidden' id='" + el.find(".daybyday-accom-name").attr('id').replace('accom-name', 'accom-type') + "' class='daybyday-accom-type' value='" + data["accommodation_type_val"] + "' />");

                el.find(".daybyday-accom-extra-info .guidelines").append(
                    "<div id='" + el.find(".daybyday-accom-name").attr('id').replace('accom-name', 'accom-map') + "' class='accom-map'>&nbsp;</div>" +
                    "<b>" + data["name"] + "</b>" +
                    "<ul style='float: left;width: 485px;'>" +
                    ((data["class"] != null && data["type"] != null) ? ("<li>" + data["class"] + " " + data["type"] + "</li>") : "") +
                    "<li>" + location + "</li>" +
                    "<li>" + data["country"] + " <img src='https://cfstatic.AfricaGoTrips.com/images/flags/" + data['flag'] + ".png' border='0' alt='" + data["country"] + "' /></li>" +
                    ((data["website"]) ? "<li style='white-space: nowrap; overflow: hidden; text-overflow: ellipsis;'><a href='" + data["website"] + "' target='_blank'>" + data["website"] + "</a></li>" : "") +
                    "</ul><div style='clear: both;'></div>"
                );
                if(data["status"] == "inactive") {
                    el.find(".daybyday-accom-extra-info .guidelines").append("<br /><span><strong>Your tour cannot be saved with this accommodation option</strong><br />According to our data, <span class='inactive-acco-name'>" + data["name"] + "</span> is no longer operational. Please select a suitable alternative so that you can save this tour.<br />If you feel that this is incorrect, and you can still book this accommodation, <a href='javascript:void(0);' class='accomm-suggest-correction'>please let us know</a>.</span>");
                } else {
                    el.find(".daybyday-accom-extra-info .guidelines").append("<a href='javascript:void(0);' style='display:inline-block;padding: 20px 0 3px;' class='accomm-suggest-correction'>Suggest a correction</a>");
                }

                el.find(".is-camping .camping-no").trigger("click");
                setCampingPartiQuestion();


                var lat = data["geo_coords_lat"];
                var lon = data["geo_coords_lon"];

                if (lat && lon) {
                    map = new google.maps.Map(document.getElementById(el.find(".daybyday-accom-name").attr('id').replace('accom-name', 'accom-map')), {
                        center: {lat: parseFloat(lat), lng: parseFloat(lon)},
                        zoom: 10
                    });

                    var latlng = new google.maps.LatLng(lat, lon);
                    marker1 = new google.maps.Marker({
                        map: map,
                        position: latlng,
                        center: latlng,
                        map: map
                    });
                }
                if (animate) {
                    el.find(".daybyday-accom-extra").fadeTo(250, 1);
                }


                var day_nr = el.parents("li").find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
                if (el.parents("li").find('.day-selection').val() == 1) {
                    day_nr = day_nr.substring(0, day_nr.indexOf('-'));
                }
                if(data["status"] == "inactive") {
                    removeSolved('dayaccommodation05-' + day_nr);
                } else {
                    setSolved('dayaccommodation05-' + day_nr);
                    hideError(el, "", 'dayaccommodation05-' + day_nr);
                }

                $(".accomm-suggest-correction").unbind('click').bind('click', function(e) {
                    e.preventDefault();

                    if ($(".problem-box").hasClass('open')) {
                        $(".problem-box").removeClass('open');
                    }
                    $(".problem-box .open-button").trigger('click');

                    $(".problem-box input[name='issue'][value='accommodation']").attr('checked', true);
                    
                    var acco_name = $(this).closest(".accom-detail-sub").find(".daybyday-accom-name").val();
                    $(".problem-box textarea[name='Message']").val("** Regarding: " + acco_name + "\n\n");
                });

                acco_details_loading = false;
                return false;
            }
        }
    });
}

function loadAccoForm(el) {
    el.find(".daybyday-accom-extra").fadeTo(0, 0);
    if(el.find(".daybyday-accom-extra-info").is(":visible")) {
        el.find("select").val(0);
        el.find("input:not(.daybyday-accom-name):not([type=radio])").val("");
    }
    accommodationTypeChange(el.find(".daybyday-accom-type"));
    el.find(".daybyday-accom-extra-info").find(".guidelines").html("");
    el.find(".daybyday-accom-extra-info").hide();
    el.find(".daybyday-accom-extra-form").show();
    el.find(".daybyday-accom-extra").show();
    el.find(".daybyday-accom-extra").fadeTo(250, 1);
}


var dest_data = false;
var dest_data_loading = false;
function initAutocompleteDest() {
    debugFunctionCall('initAutocompleteDest');

    if (dest_data_loading == true) {
        return;
    }
    if (dest_data == false) {
        dest_data_loading = true;
    	$.ajax({url: backend_url("autocomplete/destinations")} ).done(function(data) {
            loaded_parts++;
            removeLoadLayer();
            dest_data = data;
            dest_data_loading = false;
            initAutocompleteDestFinish();
    	});
    } else {
        initAutocompleteDestFinish();
    }
}

function initAutocompleteDestFinish() {
    debugFunctionCall('initAutocompleteDestFinish');

    $(".daybyday-destination").each(function() {
        if (!$(this).hasClass('ui-autocomplete-input')) {
    		$(this).autocomplete({
        		source: function(request, response) {
        	        var matcher = new RegExp("\\b" + $.ui.autocomplete.escapeRegex(request.term), "i");
        	        response($.grep(dest_data, function(value) {
        	            return matcher.test(value.name)
        	                || matcher.test(value.aliases)
        	                || matcher.test(value.overrules);
        	        }).slice(0,6));
        	    },
        		minLength: 1,
        		autoFocus: true,
        		delay: 0,
        		select: function( event, ui ) {
            		$(event.target).parent().parent().find('.accom-detail-loc').attr('data-val', ui.item.label.indexOf('Park or Reserve'));
            		if (ui.item.label.indexOf('Park or Reserve') !== -1) {
                		$(event.target).parent().parent().find('.accom-detail-loc').show();
                		$(event.target).parent().parent().find('.accom-detail-loc').find('select').find('option:eq(0)').html('-- Select location to ' + ui.item.shortname + ' --');
                		if ($(event.target).parent().parent().find('.accom-detail-loc').find('select').find('option').length < 7) {
                    		$(event.target).parent().parent().find('.accom-detail-loc').find('select').append('<option value="nan">Not used to explore ' + ui.item.shortname + '</option>');
                		} else {
                    		$(event.target).parent().parent().find('.accom-detail-loc').find('select').find('option:eq(6)').html('Not used to explore ' + ui.item.shortname);
                		}
                		if ($(event.target).parent().parent().find('.accom-detail-loc').find('select').next().is('span')) {
                    		$(event.target).parent().parent().find('.accom-detail-loc').find('select').next().html('(' + ui.item.shortname + ')');
                		} else {
                    		$(event.target).parent().parent().find('.accom-detail-loc').find('select').after('<span>(' + ui.item.shortname + ')</span>');
                		}
            		} else {
                		$(event.target).parent().parent().find('.accom-detail-loc').hide();
                		if ($(event.target).parent().parent().find('.accom-detail-loc').find('select').find('option').length < 7) {
                    		$(event.target).parent().parent().find('.accom-detail-loc').find('select').append('<option value="nan">Not relevant (not used to explore a park)</option>');
                		} else {
                    		$(event.target).parent().parent().find('.accom-detail-loc').find('select').find('option:eq(6)').html('Not relevant (not used to explore a park)');
                		}
                		$(event.target).parent().parent().find('.accom-detail-loc').find('select').find('option:eq(0)').html('-- Select location relative to the park --');
                		if ($(event.target).parent().parent().find('.accom-detail-loc').find('select').next().is('span')) {
                    		$(event.target).parent().parent().find('.accom-detail-loc').find('select').next().remove();
                		}
            		}

                    if (ui.item.id > 0) {
                        loadDestination($(event.target), ui.item.id);
                    }
                }
        	}).data("ui-autocomplete")._renderItem = function( ul, item ) {
    			return $( "<li></li>" )
    				.data( "item.autocomplete", item )
    	        	.append( "<a>"+ item.label + "</a>" )
    	        	.appendTo( ul );
            }

            $(this).bind('blur', function(event) {
                $(this).trigger('keyup');

                var notvalid_regex = new RegExp('^(Home|Back home|Departure|Arrival|Destination|Next destination|End of tour|End|Europe|Airport|International Airport|Onward flight|Onward journey|Summit|Unwind)$', 'i');
                showHideError(notvalid_regex.test($.trim($(this).val())), $(this), '\'' + $.trim($(this).val()) + '\' is not a valid destination', 'daydestination08');

                if (!notvalid_regex.test($.trim($(this).val())) && $(".overall-errors").length) {
                    var daynr = $(event.target).parent().parent().find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
                    if ($(event.target).parent().parent().find('.day-selection').val() == 1) {
                        daynr = daynr.substring(0, daynr.indexOf('-'));
                    }

                    var error_to_solve = 'daydestination08-' + daynr;
                    setSolved(error_to_solve);
                }
                
                showRouteMap();
            });
            $(this).bind('keyup', function(event) {
        		$(event.target).parent().parent().find('.accom-detail-loc').hide();

        		var current_val = $.trim($(this).val());
        		var matcher = new RegExp("\\b" + $.ui.autocomplete.escapeRegex(current_val), "i");
    	        var matches = $.grep(dest_data, function(value) {
    	            return matcher.test(value.name)
    	                || matcher.test(value.aliases)
                        || matcher.test(value.overrules);
    	        });

    	        $(".dest-autochanged").slideUp(function() {
    	            $(".dest-autochanged").remove();
                });

    	        var has_match = false;
    	        var el = $(this);
    	        if (matches.length && current_val != '') {
        	        $.each(matches, function(key, val) {
            	        if (val.value.toLowerCase() == current_val.toLowerCase() || val.aliases.toLowerCase().indexOf(',' + current_val.toLowerCase() + ',') > -1 || val.overrules.toLowerCase().indexOf(',' + current_val.toLowerCase() + ',') > -1) {
            	            if (!el.is(":focus") && val.value.toLowerCase() != current_val.toLowerCase()) {
                                var msg_txt = "We have automatically changed '" + current_val + "' to '" + val.name + "'.<br />Please <a href=\"javascript:void(0);\">suggest a correction</a> if you believe this change is not correct.";

                                if (el.next().hasClass('error')) {
                                    el.next().after('<div class="dest-autochanged hint warning arrow top"><img src="/images/hint-lightbulb.png" alt="">' + msg_txt + '</div>');
                                } else {
                                    el.after('<div class="dest-autochanged hint warning arrow top"><img src="/images/hint-lightbulb.png" alt="">' + msg_txt + '</div>');
                                }

                                el.val(val.name);

                                $(".dest-autochanged a").off('click').on('click', function(e) {
                                    e.preventDefault();

                                    if ($(".problem-box").hasClass('open')) {
                                        $(".problem-box").removeClass('open');
                                    }
                                    $(".problem-box .open-button").trigger('click');

                                    $(".problem-box input[name='issue'][value='other']").attr('checked', true);
                                });
                            }

                	        has_match = true;
                	        if (val.label.indexOf('Park or Reserve') !== -1) {
                        		$(event.target).parent().parent().find('.accom-detail-loc').show();
                        		$(event.target).parent().parent().find('.accom-detail-loc').find('select').find('option:eq(0)').html('-- Select location to ' + val.shortname + ' --');
                        		if ($(event.target).parent().parent().find('.accom-detail-loc').find('select').find('option').length < 7) {
                            		$(event.target).parent().parent().find('.accom-detail-loc').find('select').append('<option value="nan">Not used to explore ' + val.shortname + '</option>');
                        		} else {
                            		$(event.target).parent().parent().find('.accom-detail-loc').find('select').find('option:eq(6)').html('Not used to explore ' + val.shortname);
                        		}
                        		if ($(event.target).parent().parent().find('.accom-detail-loc').find('select').next().is('span')) {
                            		$(event.target).parent().parent().find('.accom-detail-loc').find('select').next().html('(' + val.shortname + ')');
                        		} else {
                            		$(event.target).parent().parent().find('.accom-detail-loc').find('select').after('<span>(' + val.shortname + ')</span>');
                        		}
                            } else {
                        		$(event.target).parent().parent().find('.accom-detail-loc').find('select').find('option:eq(0)').html('-- Select location relative to the park --');
                        		if ($(event.target).parent().parent().find('.accom-detail-loc').find('select').find('option').length < 7) {
                            		$(event.target).parent().parent().find('.accom-detail-loc').find('select').append('<option value="nan">Not relevant (not used to explore a park)</option>');
                        		} else {
                            		$(event.target).parent().parent().find('.accom-detail-loc').find('select').find('option:eq(6)').html('Not relevant (not used to explore a park)');
                        		}
                        		if ($(event.target).parent().parent().find('.accom-detail-loc').find('select').next().is('span')) {
                            		$(event.target).parent().parent().find('.accom-detail-loc').find('select').next().remove();
                        		}
                            }

                            if (val.id > 0) {
                                loadDestination($(event.target), val.id);
                            }
            	        }
        	        });
    	        }

    	        if (!has_match) {
            		$(event.target).parent().parent().find('.accom-detail-loc').show();
            		$(event.target).parent().parent().find('.accom-detail-loc').find('select').find('option:eq(0)').html('-- Select location relative to the park --');
            		if ($(event.target).parent().parent().find('.accom-detail-loc').find('select').find('option').length < 7) {
                		$(event.target).parent().parent().find('.accom-detail-loc').find('select').append('<option value="nan">Not relevant (not used to explore a park)</option>');
            		} else {
                		$(event.target).parent().parent().find('.accom-detail-loc').find('select').find('option:eq(6)').html('Not relevant (not used to explore a park)');
            		}
            		if ($(event.target).parent().parent().find('.accom-detail-loc').find('select').next().is('span')) {
                		$(event.target).parent().parent().find('.accom-detail-loc').find('select').next().remove();
            		}

                    var day = $(event.target).closest('li[data-index]');
                    var day_nr = $(day).attr('data-index');
                    $(day).find('.day-destination').removeAttr('data-id');
                    showDestinationPhotoLibrary(day_nr);

                    var dest = $("#daybyday li[data-index='" + day_nr + "'] .day-destination");
                    hideError(dest, 'This destination is not located in one of the selected <a href="javascript:void(0);" onclick="jumpTo(\'#countries\');">countries</a> for this tour.');
    	        }

                var accommodation = $(this).val();
                accommodation = UCWords(accommodation);
                accommodation = accommodation.replace(new RegExp('  ', 'g'), ' ');
                accommodation = accommodation.replace(new RegExp('[\.!_\?¡¿¨@\*\^…¡¿#\{\}]', 'g'), '');
        		if (accommodation != $(this).val()) {
                    var startPos = $(this).get(0).selectionStart, endPos = $(this).get(0).selectionEnd;
            		$(this).val(accommodation);
                    $(this).get(0).setSelectionRange(startPos, endPos);
        		}

                var daynr = $(event.target).parent().parent().find('.day-selection').find('option:selected').text().replace('Day ', '').replace(':', '').replace(' to ', '-');
                if ($(event.target).parent().parent().find('.day-selection').val() == 1) {
                    daynr = daynr.substring(0, daynr.indexOf('-'));
                }
                var error_to_solve = 'daydestination01-' + daynr;
                if ($(".overall-errors").length) {
                    var showError = accommodation.length == 0;
                    if ($(event.target).parent().find('.daybyday-destinationnone').is(':visible') && $(event.target).parent().find('.daybyday-destinationnone').is(':checked')) {
                        showError = false;
                    }
                    showHideError(showError, $(this), 'You\'ll have to provide a destination', error_to_solve);
                    if (!showError) {
                        $(this).removeClass('error');
                    }
                } else {
                    setSolved(error_to_solve);
                }

                var citycountry_regex = new RegExp('( Botswana | Kenya | Malawi | Mozambique | Namibia | Rwanda | South Africa | Tanzania | Uganda | Zambia | Zimbabwe | Angola | Burundi | Congo | Lesotho | Swaziland | Seychelles | Reunion | Mauritius | Madagascar | Ethiopia | Comoros | Mayotte )', 'i');
                var citycountry_exclude = new RegExp('(Great Zimbabwe|Mount Kenya|Mt. Kenya Summit|Bomas of Kenya|Island of Mozambique|Lake Malawi|Equator point Uganda|Ilha de Mozambique|Fairmont Mount Kenya Golf Course|Congo Nile Trail|Uganda Wildlife Education Center)', 'i');
                showHideError(citycountry_regex.test(' ' + $(this).val() + ' ') && !citycountry_exclude.test($(this).val()), $(this), 'Please don\'t list countries', 'daydestination02');
                var activity_regex = new RegExp('( |^)(viewing|drive|drives|tracking|explore|visit|walking|trip|tour)( |$)', 'i');
                showHideError(activity_regex.test($(this).val()), $(this), 'Please don\'t list activities or add words that include an activity (for example, don\'t say: \'Visit to Cultural Village\', instead say \'Cultural Village\'. Don\'t say \'Game viewing in Kruger\', instead say \'Kruger\'. Don\'t say \'Zanzibar spice tour\', instead say \'Zanzibar Spice Market\'. etc.)', 'daydestination03');
                var accomm_regex = new RegExp('( |^)(camp|lodge|hut|hotel|restcamp|bushcamp|camping|villa|resort|huts|banda|bandas|homestay|guesthouse|guest house)( |$)', 'i');
                showHideError(accomm_regex.test($(this).val()), $(this), 'Please don\'t list accommodations', 'daydestination04');
                var orand_regex = new RegExp('( or | and | or$| and$)', 'i');
                showHideError(orand_regex.test($(this).val()), $(this), 'Please list only one destination. Don\'t list optional destinations (the words \'or\' \'and\' are not allowed)', 'daydestination05');
                var to_regex = new RegExp('( to )', 'i');
                showHideError(to_regex.test($(this).val()), $(this), 'Please don\'t list transfers (the word \'to\' is not allowed)', 'daydestination06');
                var citycountry_regex = new RegExp('( city| town)', 'i');
                var capetown_regex = new RegExp('(cape town|sun city|stone town|zanzibar stone town|pemba town|victoria falls town|Ilha de Mozambique|Island of Mozambique)', 'i');
                showHideError((citycountry_regex.test($(this).val()) && !capetown_regex.test($(this).val())), $(this), 'Please list only the official city name; don\'t add extra words such as \'city\' or \'town\' ', 'daydestination07');

                if ($(this).next().children(".daydestination08").length) {
                    var notvalid_regex = new RegExp('^(Home|Back home|Departure|Arrival|Destination|Next destination|End of tour|End|Europe|Airport|International Airport|Onward flight|Onward journey|Summit|Unwind)$', 'i');
                    showHideError(notvalid_regex.test($.trim($(this).val())), $(this), '\'' + $.trim($(this).val()) + '\' is not a valid destination', 'daydestination08');
                    if (!notvalid_regex.test($.trim($(this).val())) && $(".overall-errors").length) {
                        var error_to_solve = 'daydestination08-' + daynr;
                        setSolved(error_to_solve);
                    }
                }
            });
        }
    });
}

function initTourformHelpMarks() {
    debugFunctionCall('initTourformHelpMarks');

    $(".tour-form #inclusions input[type=radio].inactive").each(function() {
        $(this).next().addClass('help');
        $(this).next().attr('data-content', $(this).attr('data-expl'));
    });
    $(".tour-form #notes input[type=radio].inactive").each(function() {
        $(this).next().addClass('help');
        $(this).next().attr('data-content', $(this).attr('data-expl'));
    });
    $(".tour-form #activities input[type=checkbox]:not('.inactive')").each(function() {
        $(this).next().removeClass('help').removeAttr('initialized').removeAttr('data-content').removeAttr('title');
        $(this).next().unbind('click');
    });
    $(".tour-form #activities input[type=checkbox].inactive").each(function() {
        $(this).next().addClass('help');
        $(this).next().attr('data-content', $(this).attr('data-expl'));
    });
    $(".tour-form #transportation input[type=checkbox]:not('.inactive')").each(function() {
        $(this).next().removeClass('help').removeAttr('initialized').removeAttr('data-content').removeAttr('title');
        $(this).next().unbind('click');
    });
    $(".tour-form #transportation input[type=checkbox].inactive").each(function() {
        $(this).next().addClass('help');
        $(this).next().attr('data-content', $(this).attr('data-expl'));
    });
    $(".help").balloon();
}

var last_routemap_path = '';
var last_routemap_path_get = '';
function showRouteMap() {

    if (loaded_parts < 3) {
        return false;
    }

    if (!$(".routemap").length) {
        return false;
    }

    var startCity = false;
    var endCity = false;

    var routemap_path = backend_url('/safari/route?generate=1');
    if ($("#start-city").length && $("#start-city").val() != '') {
        routemap_path += '&start=' + encodeURI($("#start-city").val());
        startCity = $("#start-city").val();
    }
    if ($("#end-city").length && $("#end-city").val() != '') {
        routemap_path += '&end=' + encodeURI($("#end-city").val());
        endCity = $("#end-city").val();
    }

    // Route info table
    var routemap_info = '';
    var days = '';
    var invalid_day = false;
    var prevCountryName = "";
    var dbd = $(".tour-form #daybyday > div > ul > li:visible");
    var countries = [];
    var invalid_days = [];

    dbd.each(function(index) {

        var destinationId = $(this).find('.daydestination').attr('data-id');

        var d = $(this).find('h3').text().split(': ');
        var final_day = '';
        if (d.length >= 2) {
            var fd = d[0].replace('Day ', '').replace(' to ', '-');
            var fd = fd.split('-');

            if (fd.length == 1) {
                final_day = fd[0] + '-' + fd[0];
            } else {
                final_day = fd[0] + '-' + fd[1];
            }
        }

        if ($(this).find('.daydestination').length && $(this).find('.daydestination').attr('data-id') && $(this).find('.daydestination').attr('data-id') > 0) {
            final_day += '-' + $(this).find('.daydestination').attr('data-id');

            if (days == '') {
                days += final_day;
            } else {
                days += ',' + final_day;
            }
        } else if ($(this).find('.day-nodestination').length && $(this).find('.day-nodestination').is(":checked")) {
            final_day += '-no';

            if (days == '') {
                days += final_day;
            } else {
                days += ',' + final_day;
            }
        } else {
            invalid_day = true;
            invalid_days.push($(this).find('.daydestination').val());
            final_day += '-' + $(this).find('.daydestination').val();

            if (days == '') {
                days += final_day;
            } else {
                days += ',' + final_day;
            }
        }

    });


    var countries = [];
    var country_codes = [];
    $(".tour-form #countries input[type=checkbox]:checked").each(function() {
        var c = $(this).next().text().toLowerCase().replace(' ', '-');
        if (c == 'congo (drc)') {
            c = 'dr-congo';
        }
        countries.push(c);
        country_codes.push($(this).attr('id'));
    });

    countries = countries.join(',');
    country_codes = country_codes.join(',');

    if (days != '') {
        routemap_path += '&days=' + days;
    }
    if (country_codes.length) {
        routemap_path += '&country_codes=' + country_codes;
    }

    if (routemap_path != last_routemap_path) {
        if($('[data-role=route]').attr('data-initialized') == 'true') {
            $('[data-role=route]').attr('data-initialized', 'false');
        }

        var reset_checkbox = (last_routemap_path != '');
        last_routemap_path = routemap_path;
        $(".route").removeClass('no-route');

        $.getJSON(routemap_path.replace('generate=1', 'getposandroute=1'), function(data) {

            $(".route .warning").remove();

            if (typeof data == 'undefined' || data == '' || data == null || data.pos == false || typeof data.missing == 'string') {

                if (typeof data.missing == 'string' && data.missing.indexOf(' and ') < 0) {
                    var msg = 'We cannot generate a route map because we don\'t know the location of ' + data.missing + '. This destination is used in either the Getting There or Day-by-Day sections above and can be changed there if you wish. Destination locations are added on a regular basis, so we will probably be able to generate a route map that will show all the destinations of this tour, in the near future.';
                } else if (typeof data.missing == 'string') {
                    var msg = 'We cannot generate a route map because we don\'t know the locations of ' + data.missing + '. These destinations are used in either the Getting There or Day-by-Day sections above and can be changed there if you wish. Destination locations are added on a regular basis, so we will probably be able to generate a route map that will show all the destinations of this tour, in the near future.';
                } else {
                    var msg = 'We cannot generate a route map because we don\'t know the locations of some of the used destinations. These destinations are used in either the Getting There or Day-by-Day sections above and can be changed there if you wish. Destination locations are added on a regular basis, so we will probably be able to generate a route map that will show all the destinations of this tour, in the near future.';
                }
                $(".route").prepend("<div class='hint warning'>" + msg + "</div>");
                $('[data-role=route]').attr('data-initialized', 'true');
                $("#routemap_info").hide();
                $(".route").addClass('no-route');
                $("#route_map_status-yes").prop('checked', true);
                $("[for=route_map_status]").hide();
                $(".routemap").hide();
                $("#route_map_status").hide();
                $('[data-role=route]').attr('data-state', '');

            } else {

                if (last_routemap_path_get != '' && last_routemap_path_get == last_routemap_path) {
                    return;
                }

                routemapPosition = data.pos.africa_posorg;

                var arrowDisplay = '';
                if (["top-left", "bottom-left"].indexOf(routemapPosition) > -1) {
                    arrowDisplay = 'mirrored';
                }

                routemap_info = '';

                $.each(data.route, function (key, val) {
                    if (val.type != null && val.type == 'country') {
                        routemap_info += '<tr class="country"><td colspan="2">' + val.text + '</td></tr>';
                    } else {
                        if (val.last != null || (data.route.length - 1) == key) {
                            routemap_info += '<tr class="last"><td>' + val.label + '</td>><td>' + val.text + '</td></tr>';
                        } else {
                            routemap_info += '<tr><td>' + val.label + '</td>><td>' + val.text + '</td></tr>';
                        }
                    }
                })

                $(".route").removeClass('no-route');
                $("[for=route_map_status]").show();
                $("#route_map_status").show();

                $(".routemap .warning").remove();
                $(".route__africa").remove();


                $(".routemap .inner .run").replaceWith('<span></span>');

                last_routemap_path_get = last_routemap_path;

                // $.get(last_routemap_path, function (data) {

                $('#routemap_info').html('' + routemap_info + '');
                $("#routemap_info").show();
                $(".routemap").show();
                $(".routemap .inner span").replaceWith("<img data-src='" + last_routemap_path + "' class='svg' data-role='routemap-img' alt='' />");
                $(".routemap .inner").append('<div class="route__africa route__africa--' + routemapPosition + '">\n' +
                    '    <img src="/images/map-africa-small.svg" class="svg route__africa-svg" data-active="' + countries + '" />\n' +
                    '    <img src="/images/arrow.svg" data-nocache="1" class="svg arrow-svg ' + arrowDisplay + '" />\n' +
                    '</div>');

                svg.init();

                $('[data-role=route]').attr('data-initialized', 'true');
                $('[data-role=routemap-img]').one('load', function () { // the first argument could also be 'load error abort' if you wanted to *always* execute the callback
                });
                if (reset_checkbox) {
                    $("#route_map_status-yes").prop('checked', true);
                    $('[data-role=route]').attr('data-state', '');
                } else {
                    if ($(".tour-form #daybyday #route_map_status-no").is(':checked')) {
                        $('[data-role=route]').attr('data-state', 'unused');
                    } else {
                        $('[data-role=route]').attr('data-state', '');
                    }
                }
                $("[for=route_map_status]").show();
                $("#route_map_status").show();

                //}, 'xml');

            }

        });

    }

}

function updatePhotosForShadowbox() {
    debugFunctionCall('updatePhotosForShadowbox');

    var output = "";
	$("#photos .PhotoListRow").each(function() {
		var sb_photo = $(this).find(".ImgBdr").attr("src");
		if(sb_photo != undefined) {
			output += '<a ';
			if(output == '<a ') output += 'id="first_photo" ';
			output += 'href="'+$.trim(sb_photo.replace("/s/","/xxl/").replace("/xl/","/xxl/"))+'" rel="shadowbox[gallery]" title="<b>'+$(this).find(".PhotoListFild").val()+'</b><br />';
			if($.trim($(this).find("[name='photos_locations[]']").val()) != "") {
				output += $(this).find("[name='photos_locations[]']").val() + ', ';
			}
			if($.trim($(this).find("[name='photos_countries[]']").val()) != "") {
				output += $(this).find("[name='photos_countries[]']").val() + '. ';
			}
			if($.trim($(this).find("[name='photos_photographers[]']").val()) != "") {
				output += 'Photo by ';
				if($.trim($(this).find("[name='photos_urls[]']").val()) != "") {
					output += "<a href='" + $(this).find("[name='photos_urls[]']").val() + "'>";
				}
				output += $(this).find("[name='photos_photographers[]']").val();
				if($.trim($(this).find("[name='photos_urls[]']").val()) != "") {
					output += '</a>';
				}
				output += ', ';
			}
			output += '&copy; All rights reserved" class="nodisplay"></a>';
		}
	});
	$("#photos_for_shadowbox").html(output);
}

function setPhotosNumbering() {
    debugFunctionCall('setPhotosNumbering');

    var i = 1;
    $("#photos .PhotoListRow").each(function(){
        $(this).find(".Title").html("Photo " + i + ": ");
        $(this).find(".Listtxt").find("input[type=hidden]:first").val(i);
        $(this).find(".Listtxt").find("input[type=hidden]:first").attr('id', 'photo_' + i + '_number');
        $(this).find(".Listtxt input[type=hidden]:eq(1)").attr('id','photo_' + i + '_id');
        $(this).find(".Listtxt").find("input[type=text]:first").attr('id', 'photo_desc_' + i);
        $(this).find(".Listtxt span:eq(2)").attr('id','photo_desc_'+i+'_char_count_span');
        i = i+1;
    });
}

function moveUpDown() {
    debugFunctionCall('moveUpDown');

    var first_order = "";
    var last_order = "";
    var order1 = "";
    var order2 = "";
    $(".moveUp,.moveDown").unbind('click');
    $(".moveUp,.moveDown").click(function() {
        var row = $(this).parents("ul:first");
        if ($(this).is(".moveUp")) {
            first_order = $("#photos ul.addedPhotoRow:first").find("input[name='photo_number[]']").val();
            order1 = $(this).parent().parent().find("input[name='photo_number[]']").val();
            order2 = $(this).parents("ul:first").prev().find("input[name='photo_number[]']").val();
            if(first_order != order1) {
                $(this).parent().parent().find("input[name='photo_number[]']").val(order2);
                $(this).parents("ul:first").prev().find("input[name='photo_number[]']").val(order1);
                row.fadeOut(100,
                    function() {
                        row.insertBefore(row.prev());
                        row.fadeIn(100);
                        setPhotosNumbering();
                        setMoveUpDown();
                        handlePhotoDescriptions();
                    }
                );
            }
        } else if($(this).is(".moveDown")) {
            last_order = $("#photos ul.addedPhotoRow:last").find("input[name='photo_number[]']").val();
            order1 = $(this).parent().parent().find("input[name='photo_number[]']").val();
            order2 = $(this).parents("ul:first").next().find("input[name='photo_number[]']").val();
            if(last_order != order1) {
                $(this).parent().parent().find("input[name='photo_number[]']").val(order2);
                $(this).parents("ul:first").next().find("input[name='photo_number[]']").val(order1);
                row.fadeOut(100,
                    function() {
                        row.insertAfter(row.next());
                        row.fadeIn(100);
                        setPhotosNumbering();
                        setMoveUpDown();
                        handlePhotoDescriptions();
                    }
                );
            }
        }
        return false;
    });
}

function previewGallery() {
    debugFunctionCall('previewGallery');

    if(!$(this).hasClass("loading")) {
        $(this).addClass("loading");
    }
    updatePhotosForShadowbox();
    if($("#first_photo").length > 0) {
        $("#sb-body").css('background-color','#000000');
        $("#sb-loading").css('background-color','#000000');
        $("#sb-loading-inner > span").css('background-image','url(/images/load-black.gif)');

  		Shadowbox.clearCache();
  		Shadowbox.init({ skipSetup: true }); Shadowbox.setup();
  		Shadowbox.open({
  			player: "img",
  			gallery: "gallery",
  			content: $("#first_photo").attr("href"),
  			width: 'auto',
  			height: 'auto'
  		});
    } else {
        showError($(".PhotosList #photos ul:nth-last-child(2)"), "Please first select one or more photos");
    }
    $(this).removeClass("loading");
    return false;
}

function handleCustomTourPhotoDrag() {
    if (!$(".thumbpreviews").length) {
        return
    }

    if ($("input[name=photo_desktop_pos_y]").val() == '') {
        setTourPhotoPosition();
    }

    $( "#photo_id_preview_thumb1" ).css('top', $("input[name=photo_desktop_pos_y]").val() + 'px');
    $( "#photo_id_preview_thumb2" ).css('top', $("input[name=photo_mobile_pos_y]").val() + 'px');

    if ($(".thumbpreview1").length) {
        $( "#photo_id_preview_thumb1" ).css('cursor', 'move');
        $( "#photo_id_preview_thumb1" ).draggable({ axis: "y",
            stop: function(event, ui) {
                if (ui.position.top > 0) {
                    ui.position.top = 0;
                    $( "#photo_id_preview_thumb1" ).css('top', '0px');
                }

                $("input[name=photo_desktop_pos_y]").val(parseInt($( "#photo_id_preview_thumb1" ).css('top')));
            },
            drag: function(event, ui) {
                var max_min = $(".thumbpreview1").height() - $( "#photo_id_preview_thumb1" ).height();
                if (ui.position.top > 0) {
                    ui.position.top  = 0;
                } else if (ui.position.top < max_min) {
                    ui.position.top = max_min;
                }
            }
        });
    }
    if ($(".thumbpreview2").length) {
        $( "#photo_id_preview_thumb2" ).css('cursor', 'move');
        $( "#photo_id_preview_thumb2" ).draggable({ axis: "y",
            stop: function(event, ui) {
                if (ui.position.top > 0) {
                    ui.position.top = 0;
                    $( "#photo_id_preview_thumb2" ).css('top', '0px');
                }

                $("input[name=photo_mobile_pos_y]").val(parseInt($( "#photo_id_preview_thumb2" ).css('top')));
            },
            drag: function(event, ui) {
                var max_min = $(".thumbpreview2").height() - $( "#photo_id_preview_thumb2" ).height();
                if (ui.position.top > 0) {
                    ui.position.top  = 0;
                } else if (ui.position.top < max_min) {
                    ui.position.top = max_min;
                }
            }
        });
    }
}

function setTourPhotoPosition() {
    if (!$(".thumbpreviews").length) {
        return
    }

    $("input[name=photo_desktop_pos_y]").val(Math.round(($(".thumbpreview1").height() - $( "#photo_id_preview_thumb1" ).height()) / 2));
    $("input[name=photo_mobile_pos_y]").val(Math.round(($(".thumbpreview2").height() - $( "#photo_id_preview_thumb2" ).height()) / 2));
}

function setMoveUpDown() {
    debugFunctionCall('setMoveUpDown');

    hideError($("#photos ul.error").prev(), "Please first select one or more photos");
    if($(".moveUpDisable").length > 0) {
        $(".moveUpDisable").removeClass("moveUpDisable").addClass("moveUp");
    }
    if($(".moveDownDisable").length > 0) {
        $(".moveDownDisable").removeClass("moveDownDisable").addClass("moveDown");
    }
    $("#photos ul.addedPhotoRow:first").find(".moveUp, .moveUpDisable").removeClass("moveUp").addClass("moveUpDisable");
    $("#photos ul.addedPhotoRow:last").find(".moveDown, .moveDownDisable").removeClass("moveDown").addClass("moveDownDisable");
}

function initPhotoLinks() {
    debugFunctionCall('initPhotoLinks');

    handleBlockThumbnailPhotos();
}

function countInputChars(obj, maxchars) {
    debugFunctionCall('countInputChars');

    var char_span_id = $(obj).attr('id')+'_char_count_span';

    var char_entered = parseInt($(obj).val().length);
    var char_left = (maxchars)-(char_entered);
    $("#" + char_span_id).html(char_left);
}

function addMorePhoto() {
    debugFunctionCall('addMorePhoto');

    if ($("#photos").find('.PhotoListRow').length >= 50) {
        return false;
    }
    if($("#photos").find(".PhotoListRow:last").length > 0) {
        var temp_number = parseInt($("#photos").find(".PhotoListRow:last").find("input[name='photo_number[]']").val()) + 1;
        var html_temp = $("#photos_add_skeleton").clone().show().html();
        var html = html_temp.replace(/replaceme/g, temp_number);
        $(html).insertAfter($("#photos").find(".PhotoListRow:last"));
        setPhotosNumbering();
    }
    initPhotoLinks();
    return false;
}

function removePhoto() {
    debugFunctionCall('removePhoto');

    $(".removePhoto").unbind('click').click(function() {
        var obj = $(this).parent().parent().parent();
        obj.fadeOut(500,
            function() {
                var addNewRow = false;
                if ($("#photos").find('.PhotoListRow img').length == 50) {
                    addNewRow = true;
                }
                obj.remove();
                setPhotosNumbering();
                setMoveUpDown();
                handlePhotoDescriptions();
                if (addNewRow) {
                    addMorePhoto();
                }
            }
        );
    });
}

function handlePhotoDescriptions() {
    debugFunctionCall('handlePhotoDescriptions');

    $(".PhotoListFild").unbind('keyup').bind('keyup', function() {
        countInputChars($(this), '100');
    });
    $(".PhotoListFild").trigger('keyup');
}

function countPhotoDesc() {
    debugFunctionCall('countPhotoDesc');

    limitedInputs();
}

function websiteWarningLogic() {
    debugFunctionCall('websiteWarningLogic');

    var counter = 0;

    $(".tour-form #daybyday > div > ul > li:visible").each(function() {
        if ($(this).find('.no-website').length) {
            if (counter == 0) {
                $(this).find('.warn-website:eq(0)').hide();
                $(this).find('.warn-website:eq(1)').show();
            } else {
                $(this).find('.warn-website:eq(1)').hide();
                $(this).find('.warn-website:eq(0)').show();
            }
            counter++;

            $(".tour-form #daybyday > div > ul .warn-website a").unbind('click').bind('click', function() {
                $(this).attr('href', 'https://www.google.com/search?hl=en&q=' + encodeURI($(this).parent().parent().parent().find('.daybyday-accom-name').val()) );
            });
        }
    });
}